Package: ChIPanalyser
Type: Package
Title: ChIPanalyser: Predicting Transcription Factor Binding Sites
Authors@R: c(
    person(c("Patrick", "CN"), "Martin", role=c("cre", "aut"), email="pcnmartin@gmail.com"),
    person(c("Nicolea","Radu"), "Zabet", role="aut"))
Version: 1.33.0
Date: 2017-09-01
Author: Patrick C.N.Martin & Nicolae Radu Zabet
Maintainer: Patrick C.N. Martin <pcnmartin@gmail.com>
Citation: Zabet NR, Adryan B (2015) Estimating binding properties of
        transcription factors from genome-wide binding profiles.
        Nucleic Acids Res., 43, 84–94.
Description: ChIPanalyser is a package to predict and understand TF binding
    by utilizing a statistical thermodynamic model. The model incorporates 4
    main factors thought to drive TF binding: Chromatin State, Binding energy,
    Number of bound molecules and a scaling factor modulating TF binding
    affinity. Taken together, ChIPanalyser produces ChIP-like profiles that
    closely mimic the patterns seens in real ChIP-seq data. 
License: GPL-3
Collate: 2AllS4Class_ProfileParameters.R 3AllGenerics.R 4AllMethods.R
        AllInitialize.R AllShowMethods.R computeChIPProfile.R
        computeOccupancy.R computeOptimal.R computePWMScore.R
        computeGenomeWide.R parallelInternalFunctionsDev.R
        GenomicProfileGenericFunctions.R plotOccupancy.R
        plotOptimalHeatMapDev.R DataPreprocessingDev.R
        DataPreprocessingGenericFunctionsDev.R
        profileAccuracyEstimateDev.R GAAnalysis.R GAGeneric.R
Depends: R (>= 3.5.0),GenomicRanges, Biostrings, BSgenome, RcppRoll,
        parallel
Imports: methods, IRanges,
        S4Vectors,grDevices,graphics,stats,utils,rtracklayer,ROCR,
        BiocManager,GenomeInfoDb,RColorBrewer
Suggests: BSgenome.Dmelanogaster.UCSC.dm6,knitr, RUnit, BiocGenerics
Encoding: UTF-8
LazyData: true
biocViews: Software, BiologicalQuestion, WorkflowStep, Transcription,
        Sequencing, ChipOnChip, Coverage, Alignment, ChIPSeq,
        SequenceMatching, DataImport ,PeakDetection
VignetteBuilder: knitr
RoxygenNote: 7.2.1
git_url: https://git.bioconductor.org/packages/ChIPanalyser
git_branch: devel
git_last_commit: 873269e
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
NeedsCompilation: no
Packaged: 2025-11-04 22:00:35 UTC; biocbuild

import("GenomicRanges","Biostrings", "BSgenome","RcppRoll","parallel",
    "rtracklayer","BiocManager","GenomeInfoDb")

importFrom("grDevices", "colorRampPalette", "heat.colors","as.raster","rainbow")
importFrom("RColorBrewer","brewer.pal")
importFrom("graphics", "axis", "box", "contour", "image", "lines",
    "par", "plot", "polygon", "rect", "text", "title","segments","legend",
    "rasterImage")
importFrom("methods", "new", "validObject","is")
importFrom("stats", "cor", "dgamma","sd","na.omit","median","ks.test",
    "quantile","runif")
importFrom("utils", "read.table","write.table")
importFrom("IRanges","IRanges")
importFrom("rtracklayer","import")
importFrom("S4Vectors","queryHits")
importFrom("ROCR","prediction","performance")
importFrom("GenomeInfoDb","seqlevels","dropSeqlevels")
importFrom("methods", "slot", "slot<-", "slotNames")



exportPattern("^[[:alpha:]]+")
exportMethods(
    "averageExpPWMScore",
    "backgroundSignal",
    "backgroundSignal<-",
    "boundMolecules",
    "boundMolecules<-",
    "BPFrequency",
    "BPFrequency<-",
    "chipMean",
    "chipMean<-",
    "chipSd",
    "chipSd<-",
    "chipSmooth",
    "chipSmooth<-",
    "DNASequenceLength",
    "drop",
    "initialize",
    "lambdaPWM",
    "lambdaPWM<-",
    "loci",
    "lociWidth",
    "lociWidth<-",
    "maxPWMScore",
    "maxSignal",
    "maxSignal<-",
    "minPWMScore",
    "naturalLog",
    "naturalLog<-",
    "noiseFilter",
    "noiseFilter<-",
    "noOfSites",
    "noOfSites<-",
    "PFMFormat",
    "PFMFormat<-",
    "ploidy",
    "ploidy<-",
    "PositionFrequencyMatrix",
    "PositionFrequencyMatrix<-",
    "PositionWeightMatrix",
    "PositionWeightMatrix<-",
    "profiles",
    "PWMpseudocount",
    "PWMpseudocount<-",
    "PWMThreshold",
    "PWMThreshold<-",
    "removeBackground",
    "removeBackground<-",
    "scores",
    "show",
    "stepSize",
    "stepSize<-",
    "strandRule",
    "strandRule<-",
    "whichstrand",
    "whichstrand<-"
)
exportClasses(
    "loci",
     "genomicProfiles",
     "genomicProfilesInternal",
     "parameterOptions",
     "ChIPScore",
     "GRList",
     "nos"
)

# ChIPanalyser

## ChIPanalyser
ChIPanalyser: Predicting Transcription Factor Binding Sites

## Authors
Patrick C.N. Martin <pcnmartin@gmail.com>

and

Dr. Nicolae Radu Zabet <r.zabet@qmul.ac.uk>

## Description
Based on a statistical thermodynamic framework, ChIPanalyser
tries to produce ChIP-seq like profile.
The model relies on four consideration:
TF binding sites can be scored using a Position weight Matrix,
DNA accessibility plays a role in Transcription Factor binding,
binding profiles are dependant on	the number of transcription
factors bound to DNA and finally binding energy
(another way of describing PWM's) or binding specificity should be
modulated (hence the introduction of a binding specificity modulator).
The end result of ChIPanalyser is to produce profiles simulating
real ChIP-seq profile and provide accuracy measurements
of these predicted profiles after being compared to real ChIP-seq data.
The ultimate goal is to produce ChIP-seq like profiles predicting ChIP-seq
like profile to circumvent the need to produce costly ChIP-seq experiments.



## References

Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.

## ----loading_ChIPanalyser, eval = TRUE, echo = TRUE---------------------------
library(ChIPanalyser)
# Input data 
data(ChIPanalyserData)
# PFM Matrix 
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")



## ----bsgenome, eval = TRUE, echo = TRUE---------------------------------------
library(BSgenome.Dmelanogaster.UCSC.dm6)

DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)


## ----GA_params, eval = TRUE, echo = TRUE--------------------------------------
# Number of individuals per generation 
pop <- 10 

# Number of generations 
gen <- 2

# Mutation Probability 
mut <- 0.3

# Children - Number of ofspring passed to the next generation 
child <- 2 

# Method - Goodness of fit metric used to optimise the Genetic algorithm 
method <- "MSE"


## ----GA_params_recom, class.source = 'fold-hide' ,eval = FALSE, echo = TRUE----
# # Number of individuals per generation
# pop <- 100
# 
# # Number of generations
# gen <- 50
# 
# # Mutation Probability
# mut <- 0.3
# 
# # Children - Number of ofspring passed to the next generation
# child <- 10
# 
# # Method - Goodness of fit metric used to optimise the Genetic algorithm
# method <- "MSE"
# 

## ----opti_params, eval = FALSE, echo = TRUE-----------------------------------
# # Parameters to optimised
# params <- c("N","lambda","PWMThreshold", paste0("CS",seq(1:11)))

## ----opti_params2,eval = TRUE,echo= TRUE--------------------------------------
params_custom <- vector("list", 14)
names(params_custom) <- c("N","lambda","PWMThreshold", paste0("CS",seq(1:11)))

# vector in the format of min value, max value and number of values 
params_custom$N <- c(1,1000000,5)

params_custom$lambda <- c(1,5,5)

# Bound between 0 and 1 
params_custom$PWMThreshold <- c(0.1,0.9,5)

# Bound between 0 and 1 
CS <- c(0,1,5)
CS_loc <- grep("CS",names(params_custom))
for(i in CS_loc){
    params_custom[[i]] <- CS
}

## ----gpp, eval = TRUE, echo = TRUE--------------------------------------------
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR", BPFrequency=DNASequenceSet)


## ----generateStartingPopulation, class.source = 'fold-hide', eval = TRUE, echo = TRUE----
start_pop <- generateStartingPopulation(pop, params_custom)

## ----preprocess, eval = TRUE, echo = TRUE-------------------------------------
chipProfile <- processingChIP(chip,loci = top)

# Splitting data into training and testing
# We recommend setting dist to 20/80. However, here we only have 4 loci. 
splitdata <- splitData(chipProfile,dist = c(50,50),as.proportion = TRUE)

trainingSet <- splitdata$trainingSet
testingSet <- splitdata$testingSet

## ----evolve, eval = TRUE, echo = TRUE-----------------------------------------
evo <- evolve(population = pop,
    DNASequenceSet = DNASequenceSet,
    ChIPScore = trainingSet,
    genomicProfiles = GPP,
    parameters = params_custom,
    mutationProbability = mut,
    generations = gen,
    offsprings = child,
    chromatinState = cs,
    method = method,
    filename = "This_TF_is_Best_TF",
    checkpoint = FALSE,
    cores= 1)


## ----getFit, echo = TRUE, eval = TRUE-----------------------------------------
SuperFit <- getHighestFitnessSolutions(evo$population, 
    child = 1, 
    method = method)
single<-evo[["population"]][SuperFit]

## ----singleRun, eval = TRUE, echo = TRUE--------------------------------------
# Set chromatin states for single run - create CS Granges with affinity scores
cs_single <- setChromatinStates(single,cs)[[1]]

superFit <- singleRun(indiv = single,
    DNAAffinity = cs_single,
    genomicProfiles = GPP,
    DNASequenceSet = DNASequenceSet,
    ChIPScore = testingSet,
    fitness = "all")


## ----plotOccup, eval = TRUE, echo = TRUE,fig.height= 8, fig.width=15,fig.show=TRUE----

par(mfrow = c(2,1))
plotOccupancyProfile(predictedProfile = superFit$ChIP,
    ChIPScore = testingSet,
    chromatinState = cs_single,
    occupancy = superFit$occupancy,
    goodnessOfFit = superFit$gof,
    geneRef = geneRef,
    addLegend = TRUE)

###############################################################################
#########################     All s4 class ####################################
###############################################################################

## Class Union for Genomic Profile internal
setClassUnion("GRList",c("CompressedGRangesList","list","GRanges"))
setClassUnion("nos",c("numeric","character"))

# apparently PFM does not come up so we will try this
# this works dont know why though 
# do not touch this
utils::globalVariables("PFM")

## Genomic Profile Parameters
setClass("genomicProfilesInternal",
    slots = c(PWM = "matrix",
    PFM = "matrix",
    PFMFormat = "character",
    BPFrequency = "vector",
    minPWMScore = "vector",
    maxPWMScore = "vector",
    profiles = "GRList",
    DNASequenceLength = "vector",
    averageExpPWMScore = "vector",
    ZeroBackground = "vector",
    drop="vector",
    tags="character"),

    prototype = prototype(PFMFormat="raw",
    BPFrequency = rep(0.25,4),
    tags="empty"),

    validity= function(object){

    if(length(object@PFM) < 1 &
        length(object@PWM) > 0 &
        all(object@PWM >= 0)){
    stop("Genomic Profile Parameters Validation:
    PWM does not seem to be a Position Weight Matrix.")
    }


    if(all(object@PFMFormat %in% c("raw","transfac","JASPAR","sequences","matrix"))
    ==FALSE ){
        stop("Genomic Profile Parameters Validation:
        PFM file is not one of the following formats:
        raw,transfac,JASPAR,sequences or matrix.")
    }



    return(TRUE)
    }
)


#setClass("ChIPScore",contains="VIRTUAL")
setClass("parameterOptions",

    slots = c(ploidy = "numeric",
    boundMolecules = "vector",
    backgroundSignal ="numeric",
    maxSignal = "numeric",
    lociWidth ="numeric",
    chipMean = "numeric",
    chipSd = "numeric",
    chipSmooth = "vector",
    stepSize = "numeric",
    removeBackground = "numeric",
    noiseFilter="character",
    PWMThreshold="numeric",
    strandRule="character",
    whichstrand="character",
    lambdaPWM="vector",
    naturalLog="logical",
    noOfSites="nos",
    PWMpseudocount="numeric",
    paramTag="character"),

    prototype = prototype(ploidy = 2 ,
    boundMolecules = 1000 ,
    backgroundSignal = 0 ,
    maxSignal = 1 ,
    lociWidth = 20000,
    chipMean = 200 ,
    chipSd = 200 ,
    chipSmooth = 250 ,
    stepSize = 10 ,
    removeBackground = 0,
    noiseFilter="zero",
    naturalLog=TRUE,
    PWMThreshold=0.7,
    strandRule="max",
    whichstrand="+-",
    PWMpseudocount=1,
    lambdaPWM=1,
    noOfSites="all",
    paramTag="empty"),

    validity = function(object){
    if(object@ploidy < 0){
    stop("Occupancy Profile Parameters: Ploidy must be positive.")
    }
    if(any(object@boundMolecules < 0)){
    stop("Occupancy Profile Parameters:
    Bound Molecules must be positive.")
    }
    if(object@backgroundSignal < 0){
    stop("Occupancy Profile Parameters:
    backgroundSignal must be positive")
    }
    if(object@maxSignal < 0 |object@maxSignal < object@backgroundSignal ){
    stop("Occupancy Profile Parameters:
    maxSignal must be positive and greater then backgroundSignal")
    }
    if(object@lociWidth < 0){
    stop("Occupancy Profile Parameters: lociWidth  must be positive.")
    }
    if(object@chipMean < 0){
    stop("Occupancy Profile Parameters: ChIP Mean must be positive.")
    }
    if(object@chipSd < 0){
    stop("Occupancy Profile Parameters: ChIP SD must be positive.")
    }
    if(object@chipSmooth <= 0){
    stop("Occupancy Profile Parameters: ChIP chipSmooth must be positive
    or equal to zero.")
    }
    if(object@stepSize < 0){
    stop("Occupancy Profile Parameters: Step Size must be positive.")
    }
    if(class(object@removeBackground)!="numeric"){
    stop("removeBackground Must be numeric")
    }
    if(any(object@lambdaPWM < 0)){
    stop("Genomic Profile Parameters Validation:
    Lambda must be positive.")
    }
    if(object@PWMpseudocount < 0 ){
    stop("Genomic Profile Parameters: psuedocount must be positive")
    }
    if(object@PWMThreshold < 0 | object@PWMThreshold >= 1){
    stop("Genomic Profile Parameters Validation:
    PWMThreshold must be between 0 and 1")
    }
    if(!is.logical(object@naturalLog)){
    stop("Genomic Profile Parameters: naturalLog should either be
    TRUE or FALSE")
    }
    if(all(object@strandRule %in% c("max","mean","sum")) == FALSE){
    stop("Genomic Profile Paramters:
    strandRule should be one of the following:
    max, mean, or sum")
    }
    if(all(object@whichstrand %in% c("+","-","+-","-+")) == FALSE){
    stop("Genomic Profile Paramters:
    whichstrand sould be one of the following:
    +, -, +-, or -+")
    }
    if(all(object@noiseFilter %in% c("zero","mean","median","sigmoid")) == FALSE){
    stop("Genomic Profile Paramters:
    noiseFilter sould be one of the following:
    zero, mean,median, or sigmoid")
    }
    return(TRUE)
    }
)

setClassUnion("loci",c("GRanges","NULL"))
setClass("ChIPScore",
     contains="parameterOptions",
    slots=c(scores="list",
            loci="loci" ),
       validity=function(object){

        if(class(object@scores)!="list"){
           stop("Internal Error: ChIPScore score is not a list")
        }

        if(!is.null(object@loci)& class(object@loci)!="GRanges"){
           stop("Internal Error: loci is not empty but it ain't no GRanges")
        }

        return(TRUE)
    }
)


setClass("genomicProfiles",
         contains=c("genomicProfilesInternal","parameterOptions")
)



.genomicProfilesInternalContructor <- function(
    PWM=NULL ,
    PFM=NULL ,
    PFMFormat="raw",
    BPFrequency = rep(0.25,4)
    ){
    if(!is.null(PWM)| !is.null(PFM)){
       tags <- "PWM_stage"
    } else{
       tags <- "empty"
    }
    return(new("genomicProfilesInternal",
        PWM = PWM,
        PFM = PFM,
        PFMFormat =PFMFormat,
        BPFrequency = BPFrequency,
        tags = tags
        ))


}

genomicProfiles <- function(..., parameterOptions=NULL,genomicProfiles=NULL,ChIPScore=NULL){
      args<-list(...)


    ## seperating argumants for each S4

    PO<-c("ploidy","boundMolecules","backgroundSignal","maxSignal","lociWidth",
              "chipMean","chipSd","chipSmooth","stepSize","removeBackground","noiseFilter",
               "naturalLog","noOfSites","PWMThreshold","strandRule","whichstrand",
               "PWMpseudocount","lambdaPWM")
    GP<-c("PWM","PFM","PFMFormat","BPFrequency")
    POargs<-args[names(args) %in% PO]
    GPargs<-args[names(args) %in% GP]
    ## creating argument parsing vector
    GPLocal<-match(GP,names(GPargs))
    POLocal<-match(PO,names(POargs))
    localEnvir<-environment()
    ## assigning values to variable for argument parsing

    mapply(function(GPLocal,GP,localEnvir,GPargs){
         if(is.na(GPLocal)){
         assign(GP,NULL,envir=localEnvir)
       }else{
         assign(GP,GPargs[[GPLocal]],envir=localEnvir)
       }},GPLocal,GP,MoreArgs=list(localEnvir,GPargs))

    mapply(function(POLocal,PO,localEnvir,POargs){
        if(is.na(POLocal)){
          assign(PO,NULL,envir=localEnvir)
        }else{
          assign(PO,POargs[[POLocal]],envir=localEnvir)
        }},POLocal,PO,MoreArgs=list(localEnvir,POargs))
     # tag change
     if(!is.null(PWM)| !is.null(PFM)){
         tags <- "PWM_stage"
      } else{
         tags <- "empty"
      }
       return(new("genomicProfiles",ploidy = ploidy ,
       boundMolecules = boundMolecules ,
       backgroundSignal = backgroundSignal ,
       maxSignal = maxSignal ,
       lociWidth = lociWidth,
       chipMean = chipMean ,
       chipSd = chipSd ,
       chipSmooth = chipSmooth ,
       stepSize = stepSize ,
       removeBackground = removeBackground,
       noiseFilter = noiseFilter,
       naturalLog = naturalLog,
       noOfSites = noOfSites,
       PWMThreshold = PWMThreshold,
       strandRule = strandRule,
       whichstrand = whichstrand,
       PWMpseudocount = PWMpseudocount,
       lambdaPWM = lambdaPWM,
       PWM = PWM,
       PFM = PFM,
       PFMFormat =PFMFormat,
       BPFrequency = BPFrequency,
       tags= tags))
}




parameterOptions <- function(
  ploidy = 2 ,
  boundMolecules = 1000 ,
  backgroundSignal = 0 ,
  maxSignal = 1 ,
  lociWidth = 20000,
  chipMean = 200 ,
  chipSd = 200 ,
  chipSmooth = 250 ,
  stepSize = 10 ,
  removeBackground = 0,
  noiseFilter="zero",
  naturalLog=TRUE,
  noOfSites = "all",
  PWMThreshold=0.7,
  strandRule="max",
  whichstrand="+-",
  PWMpseudocount=1,
  lambdaPWM=1){

     ## step check


    PO<-new("parameterOptions",
        ploidy = ploidy ,
        boundMolecules = boundMolecules ,
        backgroundSignal = backgroundSignal ,
        maxSignal = maxSignal ,
        lociWidth = lociWidth,
        chipMean = chipMean ,
        chipSd = chipSd ,
        chipSmooth = chipSmooth ,
        stepSize = stepSize ,
        removeBackground = removeBackground,
        noiseFilter = noiseFilter,
        naturalLog = naturalLog,
        noOfSites = noOfSites,
        PWMThreshold = PWMThreshold,
        strandRule = strandRule,
        whichstrand = whichstrand,
        PWMpseudocount = PWMpseudocount,
        lambdaPWM = lambdaPWM
        )
    return(PO)
}

.ChIPScore <-function(scores=NULL,loci=NULL,maxSignal=NULL,
                      backgroundSignal=NULL,lociWidth=NULL,paramTag="empty"){
    return(new("ChIPScore",
        scores=scores,
        loci=loci,
        maxSignal=maxSignal,
        backgroundSignal=backgroundSignal,
        lociWidth=lociWidth,
        paramTag=paramTag))
}

############################################
##### Pre-processing Generic Functions #####
############################################

## checking file format of input data
.formatCheck<-function(profile,type){

    if(type=="ChIP"){
      if(!is.null(colnames(profile))){
          cols<-c(grep("chr",colnames(profile),ignore.case=TRUE),
                grep("start",colnames(profile),ignore.case=TRUE),
                grep("end", colnames(profile),ignore.case=TRUE),
                grep("score", colnames(profile), ignore.case=TRUE))


          profile<-GRanges(seqnames = profile[,cols[1]],
                         ranges = IRanges(profile[,cols[2]],profile[,cols[3]]),
                         score = profile[,cols[4]])
          seqlevelsStyle(profile) <- "UCSC"
      } else{
          if(!all(grepl("chr", profile[,1]))){
            profile[,1]<-paste("chr",profile[,1])
          }
          profile<-GRanges(seqnames=as.character(profile[,1]),
                         ranges= IRanges(profile[,2],profile[,3]),
                         score=profile[,4])
          seqlevelsStyle(profile) <- "UCSC"
    }


  }else{
    if(!is.null(colnames(profile))){
        cols<-c(grep("chr",colnames(profile),ignore.case=TRUE),
              grep("start",colnames(profile),ignore.case=TRUE),
              grep("end", colnames(profile),ignore.case=TRUE))
        if(!all(grepl("chr",cols[1]))){
         cols[1]<-paste("chr",cols[1])
        }

        profile<-GRanges(seqnames = profile[,cols[1]],
                       ranges = IRanges(profile[,cols[2]],profile[,cols[3]]))
    } else{
        if(!all(grepl("chr", profile[,1]))){
          profile[,1]<-paste("chr",profile[,1])
        }
        profile<-GRanges(seqnames=as.character(profile[,1]),
                       ranges= IRanges(profile[,2],profile[,3]))

    }

  }
  return(profile)
}


## profiles smoothing
.vectorSmooth <- function(x, smooth=NULL,norm=FALSE) {

			  ## checking if all values are 0
				## Otherwise it tends to crash
				## RcppRoll doesnt work well with just zeroes

				if(!all(x==0)){
					  # smoothing the vector
					  if(!is.null(smooth)){
							  result<-x
						  	if((smooth %% 2) == 0){
							  		smooth = smooth - 1
						  	}
							  mid = round(smooth/2,0) + 1
							  d = smooth - mid
							  localSmoothing <- roll_mean(x,smooth,align="center")
							  result[mid:(length(x)-d)]<-localSmoothing
					  }
						#normalising the vector
						# norm only works if it NOT all zeroes
						# 0/0 ain't possible fam
						if(norm) {
					      originalMax <- max(x)
				        result <- originalMax*result/max(result)
			      }
				} else{
					  result<-x
				}



    return(result)
}

## extracting peak data
.peakParametersExt<-function(peaks){
	  res<-c(mean(width(peaks)),sd(width(peaks)))
		return(res)
}


## getting sweet profile at lowest level

.scoreReplace <- function(idx,loci, profile){
    loci <-loci[idx]
    score <- rep(0, width(loci))
    overLaps<- profile[queryHits(findOverlaps(profile,loci))]
    overLaps<-overLaps[order(start(overLaps))]


    start <- start(overLaps)-start(loci)
    end <- end(overLaps)-start(loci)

    if(length(overLaps)>0){
    #cutting ends

        if(any(start <1)){
            start[which(start<1)] <-1
        }
        if(end[length(end)]>width(loci)){
            end[length(end)] <- width(loci)
        }


        ranges<-mapply(function(x,y){x:y},start,end,SIMPLIFY=F)
        ChIP<-overLaps$score
        idx<-seq_along(ranges)
        localEnvir<-environment()

        lapply(idx,function(idx){score[ranges[[idx]]]<-ChIP[idx]
                                    assign("score",score,envir=localEnvir)})

    }


    return(score)

}

# sigmoid weighting
.sigmoidWeight<-function(scores,midpoint=1,maxPoint=2, steepness=1){

    scores<-scores*((maxPoint)/(1+exp(-steepness*(scores-midpoint))))
    return(scores)
}


### Getting dem sweet sweet profiles at highest level

.internalChIPExtraction<-function(profile,loci,peaks=NULL,chromatinState=NULL,
                                  reduce=NULL,parameterOptions=NULL,noiseFilter,
                                  cores=cores){


    ## Extracting top values
    maxSignal <- maxSignal(parameterOptions)
    chipSmooth <- chipSmooth(parameterOptions)
    ## first round of reduction
    if(!is.null(peaks) & !is.null(chromatinState)){

        localRanges<-loci[unique(queryHits(findOverlaps(loci,peaks)))]
        localRanges<-localRanges[unique(queryHits(findOverlaps(localRanges,chromatinState)))]

    } else if(!is.null(peaks) & is.null(chromatinState)){

        localRanges<-loci[unique(queryHits(findOverlaps(loci,peaks)))]

    } else if(!is.null(chromatinState) & is.null(peaks)){

        localRanges<-loci[unique(queryHits(findOverlaps(loci,chromatinState)))]

    } else{
        localRanges<-loci
    }

    #split the remaining loci into list just for parallel
    buffer<-.splitRanges(localRanges,cores)
    cores<-buffer$cores
    localRanges<-buffer$rangeSet

    ExtractedProfiles <- unlist(parallel::mclapply(localRanges,FUN=.extractionChIP,
                                   profile=profile,noiseFilter=noiseFilter,
                                   mc.cores=cores),recursive=FALSE)


    if(!is.null(maxSignal) & noiseFilter!="sigmoid"){

        ExtractedProfiles <-parallel::mclapply(ExtractedProfiles,function(x,maxSignal){
                                  x/maxSignal}, maxSignal,mc.cores=cores)
    } else if(!is.null(maxSignal) & noiseFilter =="sigmoid"){
        maxSignal<-max(sapply(ExtractedProfiles,max))
        ExtractedProfiles <-parallel::mclapply(ExtractedProfiles,function(x,maxSignal){
                                  x/maxSignal}, maxSignal,mc.cores=cores)
    }

    ## Reducing if needed
    if(!is.null(reduce)){
        if(reduce > length(ExtractedProfiles)){
           reduce<-length(ExtractedProfiles)
        }

        topScore<-sapply(ExtractedProfiles,max)
        ExtractedProfiles <- ExtractedProfiles[head(order(topScore,decreasing=TRUE),reduce)]

        GenomicRange <-names(ExtractedProfiles)
        #Final setSequence Build
        chr<-sapply(strsplit(GenomicRange,":"),"[[",1)
        start<-sapply(strsplit(sapply(strsplit(GenomicRange,":"),"[[",2),"\\.."),"[[",1)
        end<-sapply(strsplit(sapply(strsplit(GenomicRange,":"),"[[",2),"\\.."),"[[",2)
        loci<-GRanges(seqnames=chr,ranges=IRanges(as.numeric(start), as.numeric(end)))
    }
    # mem drop
    gc()



    # Smoothing dem profiles
    # Smooooooooth operator
    # https://www.youtube.com/watch?v=4TYv2PhG89A

    if(!is.null(chipSmooth)){
       ExtractedProfiles <- parallel::mclapply(ExtractedProfiles,.vectorSmooth,
                                               chipSmooth,TRUE,mc.cores=cores)
    }

    # Replacing NA because vector smooth sucks
    areThereNAs<-which(sapply(ExtractedProfiles,function(x){sum(is.na(x))})>0)
    if(length(areThereNAs) >0){
      for( i in areThereNAs){
          ExtractedProfiles[[i]]<- rep(0, length(ExtractedProfiles[[i]]))
        }
    }



    if(is.null(reduce)){
        return(ExtractedProfiles)
    } else{
        return(list(ExtractedProfiles,loci))
    }


}

computeOptimal <- function(genomicProfiles,DNASequenceSet,ChIPScore, chromatinState = NULL,
    parameterOptions = NULL,optimalMethod = "all",rank=FALSE,returnAll=TRUE,
    peakMethod="moving_kernel",cores=1){
    #validity checking


    if(!.is.genomicProfiles(genomicProfiles)){
    stop(paste0(deparse(substitute(genomicProfiles)),
    " is not a Genomic Profile Paramter object."))
    }

    if(!is.null(parameterOptions)){
        genomicProfiles<-.updateGenomicProfiles(genomicProfiles,parameterOptions)
    }

    ## Need to set a check for optimal method otherwise shit will fuck up
    if(!any(optimalMethod %in% c("pearson","spearman","kendall","ks","geometric","fscore","all"))){
        stop("Optimal method should be one of the following :
        pearson,spearman,kendall,ks,geometric,fscore  or all")
    }

    #Setting Parameters for computation
    if(all(BPFrequency(genomicProfiles)==0.25)){
    BPFrequency(genomicProfiles)<-.computeBPFrequency(
        DNASequenceSet)
    }


    if(!is.null(ChIPScore)){

           loci<-loci(ChIPScore)

    } else {
      ## change that message but essentially for compute opimntal you need to used that thing
        stop(paste("Please provide a set of loci to be analysed \n",
                   "If you have used processingChIP, you can parse that object \n"))
    }

    peakMethod <- peakMethod
    #Setting default Paramters if not provided by user
    if(length(lambdaPWM(genomicProfiles))<2){
    lambdaPWM(genomicProfiles) <- seq(0.25,5,by=0.25)
    }
    if(length(boundMolecules(genomicProfiles))<2){
    boundMolecules(genomicProfiles) <- c(1, 10, 20, 50, 100,
        200, 500,1000,2000, 5000,10000,20000,50000, 100000,
        200000, 500000, 1000000)
    }

    ## Changing cores if necessary

    if(length(loci)<cores){
        cores<-length(loci)
        warning("Number of cores requested higher than number of loci provided - some cores will be dropped")
      }

    message("Computing Genome Wide PWM Score")
    gw <- computeGenomeWideScores(genomicProfiles=genomicProfiles,
        DNASequenceSet = DNASequenceSet,
        chromatinState = chromatinState,cores=cores,
        verbose = FALSE)

    message("Computing PWM Score at Loci & Extracting Sites Above Threshold")
    pwm <- computePWMScore(DNASequenceSet = DNASequenceSet,
        genomicProfiles = gw, loci = loci,
        chromatinState = chromatinState,cores=cores, verbose = FALSE)

    message("Computing Occupancy")
    occup <- computeOccupancy(genomicProfiles = pwm,verbose = FALSE)
    # purge unused variable
   .cleanUpAfterYourself(gw,pwm)

    message("Computing ChIP-seq-like Profile")
    chip <- computeChIPProfile(loci = loci,
        genomicProfiles = occup,
        parameterOptions = parameterOptions,
        norm = TRUE ,method=peakMethod, peakSignificantThreshold= NULL,
        cores=cores,verbose = FALSE)

    message("Computing Accuracy of Profile")
    accu <- profileAccuracyEstimate(ChIPScore = ChIPScore,
        genomicProfiles = chip,
        parameterOptions = parameterOptions,method="all",cores=cores)

    #browser()
    #Extracting Optimal matrix from Profile AccuracyEstimate

    opti<-.optimalExtraction(accu,rank=FALSE)
    if(returnAll){
       return(list("Optimal"=opti,"Occupancy"=occup,"ChIPProfiles"=chip,"goodnessOfFit"=accu))
    }else{
       return(opti)
    }



}

#######################################################################
# Functions
#######################################################################

computePWMScore <- function(genomicProfiles,DNASequenceSet,
    loci = NULL,chromatinState = NULL,parameterOptions=NULL,cores=1,verbose = TRUE){

    # Validity checking
    # this needs to be re done but low priority at this point

    if(!.is.genomicProfiles(genomicProfiles)){
    stop(paste0(deparse(substitute(genomicProfiles)),
    " is not a Genomic Profile Paramter object.
    Please set a Genomic Profile Parameters Object."))
    }

    if(class(DNASequenceSet) != "BSgenome" &
    class(DNASequenceSet)!="DNAStringSet"){
    stop(paste0(deparse(substitute(DNASequenceSet)),
    " is not a BSgenome Object or a DNAStringSet"))
    }
    if(class(DNASequenceSet) == "BSgenome"){
    DNASequenceSet<-getSeq(DNASequenceSet)
    }
    if(class(chromatinState) != "GRanges" & !is.null(chromatinState)){
    stop(paste0(deparse(substitute(chromatinState)),
    " must be a GRanges Object."))
    }

    if(!is.null(parameterOptions)){
        genomicProfiles<-.updateGenomicProfiles(genomicProfiles,parameterOptions)
    }


    # Loci check from chipscore
    if(!is.null(loci)){
        if(class(loci)=="ChIPScore"){
           loci<-loci(loci)
        } else if(class(loci)=="Granges") {
           loci <-loci
        }
    } else {
        stop(paste("Please provide a set of loci to be analysed \n",
                   "If you have used processingChIP, you can parse that object \n",
                   "Otherwise, you can provide your own loci as a GRanges. "))
    }
    if(length(loci)<cores){
      cores<-length(loci)
      warning("Number of cores requested higher than number of loci provided - some cores will be dropped")
    }
    #Extracting genomic Profile Parameters
    PWMThreshold <- PWMThreshold(genomicProfiles)
    minPWMScore <- minPWMScore(genomicProfiles)
    maxPWMScore <- maxPWMScore(genomicProfiles)
    PWM <- PositionWeightMatrix(genomicProfiles)
    strand <- whichstrand(genomicProfiles)
    strandRule <- strandRule(genomicProfiles)


    #Calculating Threshhold Value
    PWMThresholdLocal <- minPWMScore + PWMThreshold*(maxPWMScore-minPWMScore)

    #Processing chromatinState
    if(!is.null(chromatinState)){
        if(length(chromatinState$DNAaffinity)<1){
            chromatinState$DNAaffinity <- rep(1, length(chromatinState))
        }
    }

    ### loci split

    if(length(loci)>=cores & cores>1){
        #message("Multi Core Sequence Split")
        loci<-loci[which(width(loci)>2*ncol(PWM))]
        buffer <- .splitRanges(loci,cores)
        localSequence<-buffer$rangeSet
        cores<-buffer$cores
        if(verbose){
            message("PWM Scores Extraction")
        }
        
        ## Computing PWM Score above threshold
        Scores<-parallel::mclapply(localSequence,.internalPWMScoreExt,
            DNASequenceSet=DNASequenceSet,
            chromatinState=chromatinState,
            PWM=PWM,PWMThresholdLocal=PWMThresholdLocal,minPWMScore=minPWMScore,
            maxPWMScore=maxPWMScore,strand=strand,strandRule=strandRule,mc.cores=cores)

        AccessibleSequence<-Scores


    } else {
        if(verbose){
            message("PWM Scores Extraction")
        }
        localSequence<-loci[which(width(loci)>2*ncol(PWM)+1)]
        ## Computing PWM Score above threshold
        Scores<-.internalPWMScoreExt(localSequence,
            DNASequenceSet=DNASequenceSet,
            chromatinState=chromatinState,
            PWM=PWM,PWMThresholdLocal=PWMThresholdLocal,minPWMScore=minPWMScore,
            maxPWMScore=maxPWMScore,strand=strand,strandRule=strandRule)
        AccessibleSequence<-Scores


    }

    ## Re-assigning names
     AccessibleSequence<-unlist(AccessibleSequence)
    .profiles(genomicProfiles)<-AccessibleSequence

     lociDrop<-names(AccessibleSequence)[which(sapply(AccessibleSequence,length)==0)]
     if(length(lociDrop)!=0){
        .drop(genomicProfiles) <- lociDrop
     } else if(length(lociDrop)==length(profiles(genomicProfiles))){
        warning("All selected Loci dropped under current parameter selection - Returning NULL")
        return(NULL)
     } else {
        .drop(genomicProfiles) <-"No loci dropped"
     }
     .tags(genomicProfiles)<-"PWMScore"
     .paramTag(genomicProfiles)<-"PWMScore"

    return(genomicProfiles)

}

## Test Units ##

## Loading test data##

library("ChIPanalyser")

data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome

if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
}
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)


# S4 Class testing

#test_genomicProfileParametersBuild <- function(){
  #  GPP <- genomicProfileParameters()
  #  checkTrue(class(GPP)=="genomicProfileParameters",
#    #"Class Build genomicProfileParameters: OK")
#}

#test_occupancyProfileParametersBuild <- function(){
#    OPP <- occupancyProfileParameters()
#    checkTrue(class(OPP)=="occupancyProfileParameters",
#    "Class Build occupancyProfileParameters: OK")
#}

# PFM to PWM in genomicProfileParameters object

#test_GPPInternal <- function(){
#    load(file.path(path.package("ChIPanalyser"), "unitTests",
#    "GPPWithPFM.rda"))
#    GPP <- genomicProfileParameters(PFM=PFM,BPFrequency=DNASequenceSet)
#    checkIdentical(PositionFrequencyMatrix(GPPWithPFM),
#    PositionFrequencyMatrix(GPP))
#    checkIdentical(PositionWeightMatrix(GPPWithPFM),
#    PositionWeightMatrix(GPP))
#    checkEquals(BPFrequency(GPPWithPFM),BPFrequency(GPP))
#}

# Testing Genome Wide scoring No Access

#test_GenomeWideScoreNoAccess <- function(){
  #  load(file.path(path.package("ChIPanalyser"), "unitTests",
  #  "genomeWideScoringNoAccess.rda"))
  #  GPP <- genomicProfileParameters(PFM=PFM,BPFrequency=DNASequenceSet)
  #  GW <- computeGenomeWidePWMScore(DNASequenceSet,GPP)
  #  checkTrue(class(GW)=="genomicProfileParameters",
  #  "Class Check genomicProfileParameters: OK")
  #  #checkEquals(maxPWMScore(genomeWideScoringNoAccess),maxPWMScore(GW))
  #  #checkEquals(minPWMScore(genomeWideScoringNoAccess),minPWMScore(GW))
    #checkEquals(averageExpPWMScore(genomeWideScoringNoAccess),
    #averageExpPWMScore(GW))

#}


# Testing Genome Wide Scoring with Access

#test_GenomeWideScoreAccess <- function(){
#    load(file.path(path.package("ChIPanalyser"), "unitTests",
#    "genomeWideScoringAccess.rda"))
#    GPP <- genomicProfileParameters(PFM=PFM,BPFrequency=DNASequenceSet)
#    GW <- computeGenomeWidePWMScore(DNASequenceSet,GPP,Access,GenomeWide=FALSE)
#    checkTrue(class(GW)=="genomicProfileParameters",
#    "Class Check genomicProfileParameters: OK")
    #checkEquals(maxPWMScore(genomeWideScoringAccess),maxPWMScore(GW))
    #checkEquals(minPWMScore(genomeWideScoringAcess),minPWMScore(GW))
    #checkEquals(averageExpPWMScore(genomeWideScoringAccess),
    #averageExpPWMScore(GW))

#}


# Testing Sites above Threshold No Access

#test_SitesAboveThresholdNoAccess <- function(){
#    load(file.path(path.package("ChIPanalyser"), "unitTests",
#    "PWMScoreNoAccess.rda"))
#    GPP <- genomicProfileParameters(PFM=PFM,BPFrequency=DNASequenceSet)
#    GW <- computeGenomeWidePWMScore(DNASequenceSet,GPP)
#    SAT <- computePWMScore(DNASequenceSet,GPP,top)
#    checkTrue(class(SAT)=="genomicProfileParameters")

    #checkTrue(is(AllSitesAboveThreshold(SAT), "GRangesList"),
    #"Class Check genomicProfileParameters: OK")
    #checkEquals(AllSitesAboveThreshold(SAT)$PWMScores,
    #AllSitesAboveThreshold(PWMScoresNoAccess)[[1]]$PWMScores)
    #checkEquals(start(AllSitesAboveThreshold(SAT)[[1]]),
    #AllSitesAboveThreshold(PWMScoresNoAccess)[[1]]$PWMScores)
#}

# Testing sites above Threshold with Access
#test_SitesAboveThresholdAccess <- function(){
#    load(file.path(path.package("ChIPanalyser"), "unitTests",
#    "PWMScoreAccess.rda"))
#    GPP <- genomicProfileParameters(PFM=PFM,BPFrequency=DNASequenceSet)
#    GW <- computeGenomeWidePWMScore(DNASequenceSet,GPP,Access,GenomeWide=FALSE)
#    SAT <- computePWMScore(DNASequenceSet,GPP,top,Access)
#    checkTrue(class(SAT)=="genomicProfileParameters")

    #checkTrue(is(AllSitesAboveThreshold(SAT), "GRangesList"),
    #"Class Check genomicProfileParameters: OK")
    #checkEquals(AllSitesAboveThreshold(SAT)[[1]]$PWMScores,
    #AllSitesAboveThreshold(PWMScoresAccess)[[1]]$PWMScores)
    #checkEquals(start(AllSitesAboveThreshold(SAT)[[1]]),
    #start(AllSitesAboveThreshold(PWMScoresAccess)[[1]]))
#}

# Testing Occupancy with No access

#test_OccupancyNoAccess <- function(){
#    load(file.path(path.package("ChIPanalyser"), "unitTests",
#    "OccupancyNoAccess.rda"))
#    GPP <- genomicProfileParameters(PFM=PFM,BPFrequency=DNASequenceSet)
#    GW <- computeGenomeWidePWMScore(DNASequenceSet,GPP)
#    SAT <- computePWMScore(DNASequenceSet,GPP,top)
#    OPP <- occupancyProfileParameters()
#    Occup <- computeOccupancy(SAT,OPP)
#    checkTrue(class(Occup)=="genomicProfileParameters")

    #checkEquals(AllSitesAboveThreshold(Occup)[[1]]$Occupancy,
    #AllSitesAboveThreshold(OccupancyNoAccess)[[1]]$Occupancy)

#}

# Testing Occupancy with Access
#test_OccupancyAccess <- function(){
#    load(file.path(path.package("ChIPanalyser"), "unitTests",
#    "OccupancyAccess.rda"))
#    GPP <- genomicProfileParameters(PFM=PFM,BPFrequency=DNASequenceSet)
#    GW <- computeGenomeWidePWMScore(DNASequenceSet,GPP)
#    SAT <- computePWMScore(DNASequenceSet,GPP,top)
#    OPP <- occupancyProfileParameters()
#    Occup <- computeOccupancy(SAT,OPP)
#    checkTrue(class(Occup)=="genomicProfileParameters")

    #checkEquals(AllSitesAboveThreshold(Occup)[[1]]$Occupancy,
    #AllSitesAboveThreshold(OccupancyAccess)[[1]]$Occupancy)

#}

################################################################################
########################## GA Generic Functions ################################
################################################################################

### Because for some reason i can't make it work otherwise...
### well i could use weird idex systems but this is just cleaner
.initiateGASolutions<-function(solutions){
    strict<-all(sapply(solutions,function(x){all(sapply(x,is.null))}))
    solutions<-lapply(solutions,.initiateSol,strict=strict)
    return(solutions)
}
## Possible soltion generation
## solution is a named list with each of four parameters that should be generated
## if strict is T then this list is an empty named list
## if strict is F then this list is a named list containing min value, max value, number of samples
## for each paramters that needs to be generated


.initiateSol<-function(solutions,strict=TRUE){
    param<-names(solutions)
   
    if(strict){
        solutions<-mapply(.setStrictSoltions,solutions,param,SIMPLIFY = FALSE)
    } else {
        solutions<-mapply(.setfluxRangeSolutions,solutions,param,SIMPLIFY = FALSE)

    }
    return(solutions)
}


## setting Strict Solutions
.setStrictSoltions<-function(solutions,param){
    getName<-param
    #Setting default solutions values
    if(grepl("boundMolecules",getName,ignore.case=T)|
        grepl("Bound molecules",getName, ignore.case=T)|
        grepl("N",getName,ignore.case=T)){
            solutions <- c(1, 10, 20, 50, 100,
                200, 500,1000,1500,2000,2500,3000,4000,5000,10000,20000,50000, 100000,
                200000)
    } else if(grepl("ScalingFactor",getName,ignore.case=T)|
        grepl("Scaling Factor",getName,ignore.case=T)|
        grepl("lambda",getName,ignore.case=T)){
            solutions <- c(0.25, 0.5, 0.75, 1, 1.25, 1.5, 1.75, 2, 2.5, 3, 3.5 ,4 ,4.5, 5)
    } else if(grepl("CS",getName,ignore.case=T)|
        grepl("DNAAccessibility",getName,ignore.case=T)|
        grepl("DNAAffinity",getName,ignore.case=T)){
            solutions <- seq(0,1,by=0.2)
    } else if(grepl("PWMThreshold",getName,ignore.case=T)|
        grepl("PWM Threshold",getName,ignore.case=T)){
            solutions<-seq(0,0.99,by=0.2)
    } else{
        warning("Unused list element in setStrictSoltuons input list")
    }
    return(solutions)
}


## Generating solutions based on range fluctuation
### need to chancge this to seqence instead of runif
## this is to be able to reuse the same soltuon multiple times
.setfluxRangeSolutions<-function(solutions,param){

    getName<-param
    #Setting default solutions values
    if(grepl("boundMolecules",getName,ignore.case=T)|
        grepl("Bound molecules",getName, ignore.case=T)|
        grepl("^N$",getName,ignore.case=T)){
            # getting random values between
            solutions <- round(seq(solutions[1],solutions[2],l = solutions[3]))
    } else if(grepl("ScalingFactor",getName,ignore.case=T)|
        grepl("Scaling Factor",getName,ignore.case=T)|
        grepl("lambda",getName,ignore.case=T)){
            solutions <- round(seq(solutions[1],solutions[2],l = solutions[3]),2)
    } else if(grepl("CS",getName,ignore.case=T)|
        grepl("DNAAccessibility",getName,ignore.case=T)|
        grepl("DNAAffinity",getName,ignore.case=T)){
            solutions <- round(seq(solutions[1],solutions[2],l = solutions[3]),2)
    } else if(grepl("PWMThreshold",getName,ignore.case=T)|
        grepl("PWM Threshold",getName,ignore.case=T)){
            solutions <- round(seq(solutions[1],solutions[2],l = solutions[3]),2)
    } else{
        warning("Unused list element in setStrictSoltuons input list")
    }
    return(solutions)
}

## Creating a population based in random selection of starting solutions
.generateRandomGASolution<-function(population){
    if(is.list(population[[1]])){
    samples<-lapply(population,function(x){res<-lapply(x,sample,size=1)
                                           res$fitness<-NA
                                           res$computed<-FALSE
                                           res$gen<-1
                                           return(res)})
    } else if(is.matrix(population[[1]])) {
    samples<-lapply(population,function(x){res<-as.list(apply(x,2,sample,size=1))
                                           res$fitness<-NA
                                           res$computed<-FALSE
                                           res$gen<-1
                                           return(res)})
    }
    names(samples)<-names(population)
    return(samples)
}


## Geneate starting lambda values

.lambdas <-  function(population,parameters,names=NULL){
    ## first lets build the list squeleton with the appropriate values
    pop<-vector("list",population)

    if(!is.null(names)){names(pop)<-names}

    if(!is.list(parameters)){
        pop<-lapply(pop,function(x){x<-vector("list",length(parameters))
                                names(x)<-parameters
                                return(x)})
    } else{
        pop<-lapply(pop,function(x){x<-parameters})
    }

    # Then lets assign values to each parameter
    pop<-.initiateGASolutions(pop)

    return(pop)
}


## Second option not as light weight but easier to handle
## essentially making less logical comparaisons
.collapseParam <- function(pop){

    if(is.data.frame(pop)){
        popbuf<-pop[,which(colnames(pop)!="fitness" & colnames(pop)!="computed" &
                           colnames(pop)!="gen")]
        param<-apply(popbuf,1,paste0,collapse='',sep='_')


    } else {
        pop<-do.call("rbind",pop)
        popbuf<-pop[,which(colnames(pop)!="fitness" & colnames(pop)!="computed" &
                           colnames(pop)!="gen")]
        param<-apply(popbuf,1,paste0,collapse='',sep='_')

    }
    return(param)
}

## check if solution have already been computed
.IndexOfExistingSolution<-function(currentSolution,database){
    DBbuffer<-.collapseParam(as.data.frame(database))
    PopBuffer<-.collapseParam(currentSolution)

    #idx<-cbind("DB"=which(DBbuffer %in% PopBuffer),"Pop"=which(PopBuffer %in% DBbuffer))
    DBinPop <- match(DBbuffer,PopBuffer)
    PopinDB <- match(PopBuffer, DBbuffer)

    idx<-list("DB"=DBinPop,"Pop"=PopinDB)
    return(idx)
}

## generation tracking
.fittyMacFitFace<-function(population,method,fit,generation){
  ## extracting fitness and filtering fitness
  Fit<-sapply(population,function(x){x$fitness})
  indexFit<-which(!is.na(Fit))

  ## population template
  bufferPopulation<-population[indexFit]

  ## extracting top solutions
  wellFit <- getHighestFitnessSolutions(bufferPopulation,child=1,method=method)
  FitPopulation<-bufferPopulation[wellFit]

  fit[[generation]]<-FitPopulation[[1]]$fitness
  return(fit)
}


## building database of pre computed solutions
.buildDatabase<-function(population,database,new=FALSE, generation=1){
    if(new==FALSE){

       #if(length(population)!=10)browser()
        idx<-.IndexOfExistingSolution(population,database)


        # Population that needs to be computed
        # Not present in database
        PopinDB<-which(is.na(idx[[2]]))

        ToBeComputedPop <-population[PopinDB]

            # Population that is present in database
            # reassign score
            #DbinPop<- idx[[1]][which(!is.na(idx[[1]]))]
            popbuffer <- idx[[2]][which(!is.na(idx[[2]]))]
            ComputedPop <- population[which(!is.na(idx[[2]]))]




            for(i in seq_along(ComputedPop)){
                ComputedPop[[i]][["fitness"]]<-unlist(database[popbuffer[i],"fitness"])
                ComputedPop[[i]][["computed"]]<-TRUE
                ComputedPop[[i]][["gen"]]<-generation

            }

        return(list("DataBase"=as.data.frame(database),"ComputedPop"=ComputedPop,
                    "ToBeComputedPop"=ToBeComputedPop))
    } else {
        #population <- lapply(population,unlist)
        population<-as.data.frame(do.call("rbind", population))
       
        population$gen<-rep(generation,nrow(population))
        database<-rbind(database,population)
       
        return(database)
    }


}

## Alright lets get to mutation stuff shall we.

.mutate <- function(population,parameters){
    ## generate tempalte of values
    pop<-vector("list",1)
    if(!is.list(parameters)){
        pop<-lapply(pop,function(x){x<-vector("list",length(parameters))
                                names(x)<-parameters
                                return(x)})
    } else{
        pop<-lapply(pop,function(x){x<-parameters})
    }
    solutions<-.initiateGASolutions(pop)
    
    ## mutating individuals
    # where and what to mutate
    mutation<-sample(seq_along(solutions[[1]]),size=1)

    # mutating individuals
    population[[mutation]]<-sample(solutions[[1]][[mutation]][which(solutions[[1]][[mutation]]!=population[[mutation]])],size=1)

    # setting fitness and computed status to default values
    population$fitness<-NA
    population$computed<-FALSE

    # returning New population even if it is called old population
    return(population)
}


### let us do some cross over shit
## radu solutions seems to be very much
## based on random mixing but what iff we take highest
## nope that wont work
## you don't know which parameters is the strongets
## could actually try and do this though (it would super heavy computationanly)
## thats not how you spell that word dipshit

.crossover<-function(ga1, ga2, extent="random"){

    ## selecting the extent of the crossover
    if(extent=="random"){
        # generating random crossover extent
        extent<-sample(seq(from=1,to=(length(ga1)-1)),size=1)

        #selection of cross over regions i guess
        crossoverSol <- sample(seq_along(ga1),size=extent)


    } else {
        # selecting cross over regions with provided extent
        if(extent<(1/length(ga1))){stop("Extent argument out of bounds - Limited by Number of parameters")}
        crossoverSol <- sample(seq_along(ga1),size=floor(length(ga1)*extent))

    }

    #crossing over some stuff on both solutions
    ## using loops because you suck at R
    for(ga in crossoverSol){
        ga1[[ga]]<-ga2[[ga]]
    }

    # New solution with cross over
    ga1$fitness<-NA
    ga1$computed<-FALSE

    return(ga1)
}


## Alright final step

### Generating a new population

.generateNewPopulation <- function(population,parameters,mutationProbability=0.3,offsprings=1,method="geometric",gen=2){
    ## Generate template for new population
    NewPop<-vector("list",length(population))

    ## extracting fitness and filtering fitness
    Fit<-sapply(population,function(x){x$fitness})
    indexFit<-which(!is.na(Fit) & !duplicated(population))

    ## population template
    bufferPopulation<-population[indexFit]

    ## setting number of offsprings
    if(offsprings > floor(length(bufferPopulation)/2) | offsprings <= 0){
        offsprings <- floor(length(bufferPopulation)/2)
    }

    ## extracting top solutions
    wellFit <- getHighestFitnessSolutions(bufferPopulation,child=offsprings,method=method)
    FitPopulation<-bufferPopulation[wellFit]

    ## keeping highest ranking individuals
    for(i in seq_along(wellFit)){
        NewPop[[i]]<-FitPopulation[[i]]
    }

    ## selecting the other solutions that will be use
    indexGAReuse <- seq(length(wellFit)+1,length(NewPop))

    reuseGA <- sample(seq_along(FitPopulation),size=length(indexGAReuse),replace=TRUE)

    # this is just assinging new values for each indiv
    # random sampling of the fit population
    # I feel like there could be a local minimum problem here
    # it's Either mutate OR crossover
    # Should we include possibility of both
    for(j in seq_along(indexGAReuse)){
        localPopulation<-FitPopulation[[reuseGA[j]]]
        ## Taking reused population and mutating it
        if(runif(1)<=mutationProbability){
            
            localPopulation<-.mutate(localPopulation,parameters)
        } else {
             
            localPopulation<-.crossover(localPopulation,NewPop[[sample(seq_along(wellFit),size=1)]])
            #localPopulation<-.crossover(localPopulation,NewPop[[sample(seq_len(j),size=1)]])
        }
        NewPop[[indexGAReuse[j]]]<-localPopulation
    }

    ## return New population
    ## It will probably be easy not to check if in database now.
    # that can just be part of the analysis function
    ## not sure how much of a good idea this is
    ## this might not be released for ChIPanalyser so we can do that later

    return(NewPop)

}







## Single individual Run
## computing the fitness of an individual

.individualSurvival <- function(indiv,DNAAffinity,
    genomicProfiles,DNASequenceSet,ChIPScore,fitness="geometric",lambdaDB=NULL){
    ##### you will definitly need some checks here
    if(!indiv$computed ){

        # Setting lambda from GA population
        lambdaPWM(genomicProfiles)<-unlist(indiv[
            grepl("ScalingFactor",names(indiv),ignore.case=T)|
            grepl("Scaling Factor",names(indiv),ignore.case=T)|
            grepl("lambda",names(indiv),ignore.case=T)])

        # Setting PWMThreshold from GA population
        #PWMThreshold(genomicProfiles)<-unlist(indiv[
            #grepl("PWMThreshold",names(indiv),ignore.case=T)|
            #grepl("PWM Threshhold",names(indiv),ignore.case=T)])
        # Setting Number of bound molecules from GA population

        boundMolecules(genomicProfiles)<- unlist(indiv[
            grepl("boundMolecules",names(indiv),ignore.case=T)|
            grepl("Bound molecules",names(indiv),ignore.case=T)|
            grepl("^N$",names(indiv),ignore.case=T)])

        if(is.null(lambdaDB)){
        ### compitng prediction from GA population
        ## genome wide scoring
        genomeWide <- computeGenomeWideScores(genomicProfiles,DNASequenceSet
            ,DNAAffinity,verbose=FALSE)
        } else{

        lambda<-as.vector(as.matrix(lambdaDB[which(lambdaDB[,1]==lambdaPWM(genomicProfiles)),]))
        genomeWide <- genomicProfiles
        .maxPWMScore(genomeWide)<-lambda[2]
        .minPWMScore(genomeWide)<-lambda[3]
        .averageExpPWMScore(genomeWide)<-lambda[4]
        .DNASequenceLength(genomeWide) <- lambda[5]
        }


        ## compute PWMscores

        ## check naming of pwmscore its a bit shit also you need to find a more elegant way to deal with it
        pwmScores <- computePWMScore(genomeWide,DNASequenceSet,ChIPScore,DNAAffinity, verbose=FALSE)
        if(is.null(pwmScores)){
            return(indiv)
        }


        ## compute occupancy
        occup <- computeOccupancy(pwmScores,verbose=FALSE)

        ## computing ChIP profiles
        chip <- computeChIPProfile(occup,ChIPScore,verbose=FALSE)

        ## setting the right method
        if(length(grep(fitness,c("fscore","AUC","recall","precision","accuracy","MCC"),ignore.case=TRUE))>0){
            internalMethod<-"fscore"
        } else {
            internalMethod <- fitness
        }

        ## Goodness of fit

        GoF <- profileAccuracyEstimate(chip,ChIPScore,method=internalMethod)

        ## extract top scores

        #topScore <- GoF[[1]][[1]][[1]][paste0(fitness,"Mean")]
        topScore <- profiles(GoF)[[1]][[1]][paste0(fitness,"Mean")]
        ## updating indiv
        indiv$fitness <- topScore
        indiv$computed <- TRUE


    }
    # return idividual with updated fitness
    return(indiv)

}




### extracting values from databse
.populationFitness<- function(database,parameters){
    ## extract values
    database<-as.data.frame(database)
    fitness <- unlist(database$fitness)
    param <- .collapseParam(database)

    ## splitting parameters
    param<-strsplit(param,"_")

    ## building matrix
    optimal<-.lambdas(1,parameters)[[1]]
    ## this will need to be more robust to ensure that you have name flexibility
    mat<-matrix(0,ncol=length(optimal[["N"]]),nrow=length(optimal[["lambda"]]))
    colnames(mat)<-optimal[["N"]]
    rownames(mat)<-optimal[["lambda"]]
    ## replacing values in matrix
    for(i in seq_along(fitness)){
       if(!is.na(fitness[i])){
            rows<-which(rownames(mat)==param[[i]][2])
            cols<-which(colnames(mat)==param[[i]][1])
            mat[rows,cols]<-fitness[i]
       } else{
            rows<-which(rownames(mat)==param[[i]][2])
            cols<-which(colnames(mat)==param[[i]][1])
            mat[rows,cols]<-0
       }
    }

    return(mat)
}


## chunk data for training a validation 

getTrainingData <- function(ChIPscore,loci = 1){
    train <- ChIPscore
    .scores(train) <- scores(train)[loci]
    .loci(train) <- loci(train)[loci]
   ## quick check to make sure it's not empty
    if(length(scores(train))<1){
        stop("Empty training set!")
    }
    return(train)
}

getTestingData <- function(ChIPscore,loci = 1){
    validation <- ChIPscore
    .scores(validation) <- scores(validation)[loci]
    .loci(validation) <- loci(validation)[loci]
    
    if(length(scores(validation))<1){
        stop("Empty validation set!")
    }
    return(validation)
}

splitData <- function(ChIPscore, dist = c(80,20), as.proportion = TRUE){
    locs <- length(scores(ChIPscore))
    if(locs <= 1){
        stop("Cannot split less than 2 loci!")
    }
    if(as.proportion){
        train <- floor(locs*(dist[1]/100))
        if(train < 1)stop("Training set proportion too small!")
        test <- floor(locs*(dist[1]/100)) + floor(locs*(dist[2]/100))
        if(test < 1)stop("Validation set proportion too small!")

        trainSet <- getTrainingData(ChIPscore, loci = seq(1,train))
        testSet <- getTestingData(ChIPscore,  loci = seq(train +1 , test))
    }else {
        if(length(dist) != 4){
            stop("Please Provide start/stop loci index for training and testing")
        }
        trainSet <- getTrainingData(ChIPscore, loci = seq(dist[1],dist[2]))
        testSet <- getTestingData(ChIPscore,  loci = seq(dist[3], dist[4]))
    }
   

    return(list("trainingSet" = trainSet, "testingSet" = testSet))

}

.revert_to_class <- function(database){
    database <- as.data.frame(apply(database, 2, unlist))
    numerics <- which(!colnames(database) %in% 
        c("computed"))
    for(i in numerics){
        database[,i] <- as.numeric(as.character(database[,i]))
    }
    database$computed <- as.logical(database$computed)
    return(database)
}

## ----eval=TRUE, warnings = FALSE, echo=TRUE,message=FALSE---------------------

library(ChIPanalyser)

#Load data
data(ChIPanalyserData)


# Loading DNASequenceSet from BSgenome object
# We recommend using the latest version of the genome 
# Please ensure that all your data is aligned to the same version of the genome

library(BSgenome.Dmelanogaster.UCSC.dm6)

DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)



#Loading Position Frequency Matrix

PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")

#Checking if correctly loaded
ls()


## ----eval=TRUE, warnings = FALSE----------------------------------------------
chip <- processingChIP(profile = chip,
                      loci = top,
                      cores = 1)
chip

## ----eval =TRUE---------------------------------------------------------------
# PFMs are automatically converted to PWM when build genomicProfiles
GP <- genomicProfiles(PFM = PFM, PFMFormat = "JASPAR")
GP

## ----eval=FALSE---------------------------------------------------------------
# GP <- genomicProfiles(PWM=PositionWeightMatrix)

## ----eval=TRUE,warnings=FALSE-------------------------------------------------
## surpress dependency warnings
optimal <- suppressWarnings(computeOptimal(genomicProfiles = GP,
                        DNASequenceSet = DNASequenceSet,
                        ChIPScore = chip,
                        chromatinState = Access))

## ----eval=TRUE, echo=TRUE-----------------------------------------------------
 ## Lambda Values
 seq(0.25,5,by=0.25)

 ## Bound Molecule Values
 c(1, 10, 20, 50, 100,
    200, 500,1000,2000, 5000,10000,20000,50000, 100000,
    200000, 500000, 1000000)

## ----eval =T------------------------------------------------------------------
optimalParam <- optimal$Optimal
optimalParam$OptimalParameters

## ----eval=TRUE, warnings = FALSE, fig.width=10, fig.height=8------------------
# Plotting Optimal heat maps
par(oma=c(0,0,3,0))
layout(matrix(1:8,ncol=4, byrow=T),width=c(6,1.5,6,1.5),height=c(1,1))
plotOptimalHeatMaps(optimalParam,layout=FALSE)


## ----eval=TRUE----------------------------------------------------------------
optimalParam <- searchSites(optimal,lambdaPWM = 1.25,BoundMolecules = 10000)

## ----eval=TRUE,fig.width=15, fig.height=8-------------------------------------
plotOccupancyProfile(predictedProfile = optimalParam$ChIPProfiles,
                     ChIPScore = chip,
                     chromatinState = Access,
                     occupancy = optimalParam$Occupancy,
                     goodnessOfFit = optimalParam$goodnessOfFit,
                     geneRef = geneRef)

## ----eval =TRUE---------------------------------------------------------------
## Suggested Parameters to start with.
parameterOptions()

## Changing parameters
PO <- parameterOptions(noiseFilter="sigmoid",chipSd=150,chipMean=150,lociWidth=30000)

## ----eval=FALSE---------------------------------------------------------------
# ## Top 50 loci based on ChIP score
# processingChIP(profile = "/path/to/ChIP",
#                loci = NULL,
#                reduce = 50,
#                parameterOptions = PO)
# 
# ## Top 50 loci ALSO containing peaks
# processingChIP(profile = "/path/to/ChIP",
#                loci = NULL,
#                reduce = 50,
#                peaks = "/path/to/peaks",
#                parameterOptions=PO)
# 
# ## Top 50 loci containing BOTH peaks and Accessible DNA
# processingChIP(profile = "/path/to/ChIP",
#                loci = NULL,
#                reduce = 50,
#                peaks = "/path/to/peaks",
#                chromatinState = "/path/to/chromatinState",
#                parameterOptions = PO)
# 

## ----eval=TRUE----------------------------------------------------------------
str(genomicProfiles())

GP <- genomicProfiles(PFM=PFM, PFMFormat="JASPAR", BPFrequency=DNASequenceSet)
GP

## ----eval=FALSE---------------------------------------------------------------
# ## Parsing pre computed parameters (processingChIP function)
# GP <- genomicProfiles(PFM = PFM,
#                      PFMFormat = "JASPAR",
#                      BPFrequency = DNASequenceSet,
#                      ChIPScore = ChIPScore)
# 
# ## Parsing pre assigned function (parameterOptions)
# parameterOptions <- parameterOptions(lambdaPWM = c(1,2,3),
#                                      boundMolecules = c(5,50,500))
# GP <- genomicProfiles(PFM = PFM,
#                      PFMFormat = "JASPAR",
#                      BPFrequency = DNASequenceSet,
#                      parameterOptions = parameterOptions)
# 
# ## Direct parameter assignement
# 
# GP <- genomicProfiles(PFM = PFM,
#                      PFMFormat = "JASPAR",
#                      BPFrequency = DNASequenceSet,
#                      lambdaPWM = c(1,2,3),
#                      boundMolecules = c(4,500,8000))

## ----eval=FALSE---------------------------------------------------------------
# ## Setting custom parameters
# OP <- parameterOptions(lambdaPWM = seq(1,10,by=0.5),
#                       boundMolecules = seq(1,100000, length.out=20))
# 
# ## Computing ONLY Optimal Parameters and MSE as goodness Of Fit metric
# optimal <- computeOptimal(genomicProfiles = GP,
#                          DNASequenceSet = DNASequenceSet,
#                          ChIPScore = chip,
#                          chromatinState = Access,
#                          parameterOptions = OP,
#                          optimalMethod = "MSE",
#                          returnAll = FALSE)
# 
# ### Computing ONLY Optimal Parameters and using Rank slection method
# optimal <- computeOptimal(genomicProfiles = GP,
#                          DNASequenceSet = DNASequenceSet,
#                          ChIPScore = chip,
#                          chromatinState = Access,
#                          parameterOptions = OP,
#                          optimalMethod = "all",
#                          rank=TRUE)
# 

## ----eval=FALSE---------------------------------------------------------------
# ## Extracted Optimal Parameters
# optimalParam <- optimal$Optimal
# 
# ## Plotting heat maps
# plotOptimalHeatMaps(optimalParam,overlay=TRUE)

## ----eval=TRUE,warnings=FALSE-------------------------------------------------

## Creating genomic Profiles object with PFMs and associated parameters
GP <- genomicProfiles(PFM = PFM,
                      PFMFormat = "JASPAR",
                      BPFrequency = DNASequenceSet,
                      lambdaPWM = 1, 
                      boundMolecules = 58794)

## Computing Genome Wide Score required
GW <- computeGenomeWideScores(genomicProfiles = GP,
                              DNASequenceSet = DNASequenceSet,
                              chromatinState = Access)
GW
## Computing PWM score above threshold
pwm <- computePWMScore(genomicProfiles = GW,
                       DNASequenceSet = DNASequenceSet,
                       loci = chip,
                       chromatinState = Access)
pwm
## Computing Occupancy of sites above threshold

occup <- computeOccupancy(genomicProfiles = pwm)
occup
## Compute ChIP seq like profiles

pred <- computeChIPProfile(genomicProfiles = occup,
                          loci = chip)
pred
## Compute goodness Of Fit of model
accu <- profileAccuracyEstimate(genomicProfiles = pred,
                                ChIPScore = chip)
accu


## ----eval=TRUE,fig.width=12, fig.height=4.5-----------------------------------

plotOccupancyProfile(predictedProfile=pred,
                     ChIPScore=chip,
                     chromatinState=Access,
                     occupancy=occup,
                     goodnessOfFit=accu,
                     geneRef=geneRef)

## ----eval=TRUE,echo=TRUE------------------------------------------------------
parameterOptions()

## ----eval=T, echo=T-----------------------------------------------------------
str(genomicProfiles())

## ----eval=F, echo=T-----------------------------------------------------------
#     ## Accessors and Setters for parameterOptions and genomicProfiles
#     avrageExpPWMScore(obj)
#     backgroundSignal(obj)
#     backgroundSignal(obj)<-value
#     boundMolecules(obj)
#     boundMolecules(obj)<-value
#     BPFrequency(obj)
#     BPFrequency(obj)<-value
#     chipMean(obj)
#     chipMean(obj)<-value
#     chipSd(obj)
#     chipSd(obj)<-value
#     chipSmooth(obj)
#     chipSmooth(obj)<-value
#     DNASequenceLength(obj)
#     drop(obj)
#     lambdaPWM(obj)
#     lambdaPWM(obj)<-value
#     lociWidth(obj)
#     lociWidth(obj)<-value
#     maxPWMScore(obj)
#     maxSignal(obj)
#     maxSignal(obj)<-value
#     minPWMScore(obj)
#     naturalLog(obj)
#     naturalLog(obj)<-value
#     noiseFilter(obj)
#     noiseFilter(obj)<-value
#     noOfSites(obj)
#     noOfSites(obj)<-value
#     PFMFormat(obj)
#     PFMFormat(obj)<-value
#     ploidy(obj)
#     ploidy(obj)<-value
#     PositionFrequencyMatrix(obj)
#     PositionFrequencyMatrix(obj)<-value
#     PositionWeightMatrix(obj)
#     PositionWeightMatrix(obj)<-value
#     profiles(obj)
#     PWMpseudocount(obj)
#     PWMpseudocount(obj)<-value
#     PWMThreshold(obj)
#     PWMThreshold(obj)<-value
#     removeBackground(obj)
#     removeBackground(obj)<-value
#     stepSize(obj)
#     stepSize(obj)<-value
#     strandRule(obj)
#     strandRule(obj)<-value
#     whichstrand(obj)
#     whichstrand(obj)<-value
#     ## ChIPScore slots accessors
#     loci(obj)
#     scores(obj)

## ----eval=T-------------------------------------------------------------------
sessionInfo()

### Computes the PWM matrix from the PFM matrix
### PFM: the PFM matrix from file
### pseudocount=1: the pseudocount used to compute the PWM
### BPFrequency=rep(0.25,4): a vector with the genome wide
###frequencies of the four nucleotides.
### naturalLog=FALSE: if this is TRUE the method uses the natural logarithm
####when computing the PWM (Berg and von Hippel, 1987),
####otherwise the method uses logarithm in base 2 (Stormo, 2000)
### noOfSites=NULL: the number of DNA sequences used to compute the PFM.
###If NULL it will be computed based on the PFM
### return: a 4 row matrix of the PWM, with rows: A, C, G, T
.computePWM <- function(PFM, pseudocount, BPFrequency,naturalLog,noOfSites){
    if(min(PFM) < 0){
    #the provided PFM is the actual PWM
        PWM <- PFM
    } else{
    #get the sum on each colum (it should be equal)
        if(noOfSites == 0){
            noOfSites <- max(apply(PFM,2,sum))
    }
    #normalise the pfm
    for(i in seq_len(ncol(PFM))){
        PFM[,i] <- PFM[,i]/max(apply(PFM,2,sum))
    }

    #generate the pwm based on the pfm
    PWM <- .computePWMFromPFM(PFM,max(noOfSites), pseudocount,
        BPFrequency,naturalLog)
    }


    return(PWM);
}



### Computed the PWM matrix using the PFM matrix
### PFM: the PFM matrix
### noOfSites: the total number of sites used to compute the PFM matrix
### pseudocount=1: the pseudocount used to compute the PWM
### BPFrequency=rep(0.25,4): a vector with the genome wide
###frequencies of the four nucleotides .
### naturalLog=FALSE: if this is TRUE the method uses the natural
###logarithm  when computing the PWM (Berg and von Hippel, 1987),
###otherwise logarithm  in base 2 is used (Stormo, 2000)
### return: a 4 row matrix of the PWM, with rows: A, C, G, T
.computePWMFromPFM <- function(PFM,noOfSites, pseudocount,
    BPFrequency,naturalLog){
    PWM <- matrix(0,nrow = nrow(PFM),ncol = nrow(PFM))
    PWM <- PFM
    for(i in seq_len(nrow(PFM))){
        for(j in seq_len(ncol(PFM))){
            PWM[i,j] <- (PFM[i,j]*noOfSites+BPFrequency[i]*pseudocount)/
                (noOfSites+pseudocount)
            if(naturalLog){
                PWM[i,j] <- log(PWM[i,j]/BPFrequency[i])
            } else{
                PWM[i,j] <- log2(PWM[i,j]/BPFrequency[i])
            }
        }
    }
    return(PWM)
}

### Attempts to parse a file and extract the PFM. It uses the
###following formats: RAW, TRANSFAC, Jaspar or constructs one from sequences.
###For the correct formats see
###http://www.benoslab.pitt.edu/stamp/help.html#input
### filename: the file storing the motif
### format="raw": the format of the PWM: raw, transfac, jaspar,
###seqs (list of binding sequences)
### return: a PFM matrix, with rows: A, C, G, T
.parsePFM <- function(filename, format){
    PFM <- NULL
    if(format == "raw"){
        PFM <- .parseRawPFM(filename)
    }
    if(format == "transfac"){
        PFM <- .parseTransfacPFM(filename)
    }
    if(format == "JASPAR"){
        PFM <- .parseJASPARPFM(filename)
    }
    if(format == "sequences"){
        PFM <- .parsePFMFromFile(filename)
    }
    #transpose the PFM/PWM if required
    if(nrow(PFM) != 4){
        if(ncol(PFM) == 4){
            PFM <- t(PFM);
        } else{
        stop("Could not load PFM/PWM of 4 rows or columns. Wrong PFM/PWM")
        }
    }
    return(PFM)
}


### Extracts the PFM matrix from a raw PSSM style file.
###It also works for MEME output
### filename: the file containing the motif
### return: the PFM matrix
.parseRawPFM <- function(filename){
    buffer <- read.table(filename,row.names = NULL,stringsAsFactors = FALSE)
    if(ncol(buffer) == 4){
        PFM <- t(buffer)
        rownames(PFM) <- c("A","C","G","T")
    } else{
        PFM <- NULL
    }
    return(PFM)
}


### Extracts the PFM matrix from a transfac style file.
### filename: the file containing the motif
### return: a 4 row PFM matrix, with rows: A, C, G, T
.parseTransfacPFM <- function(filename){
    buffer <- read.table(filename,row.names = NULL,stringsAsFactors = FALSE)
    if(ncol(buffer) > 4){
        PFM <- t(buffer[,2:5])
        if(is.character(PFM[,1])){
        PFM <- PFM[,2:ncol(PFM)]
        }
        rownames(PFM)=c("A","C","G","T")
    } else{
    PFM <- NULL
    }
    return(PFM)
}

### Extracts the PFM matrix from a jaspar style file
### filename: the file containing the motif
### return: a 4 row PFM matrix, with rows: A, C, G, T
.parseJASPARPFM <- function(filename){
    buffer <- readLines(filename)
    error <- FALSE
    for(i in seq_along(buffer)){
        if(!error){
            buffer[i] <- sub("[","",buffer[i],fixed=TRUE)
            buffer[i] <- sub("]","",buffer[i],fixed=TRUE)
            cells <- strsplit(buffer[i]," +",fixed=FALSE)[[1]]

            if(length(cells) > 1){
                values <- as.numeric(cells[2:(length(cells))])
                if(i == 1){
                    PFM <- values
                } else{
                    PFM <- rbind(PFM,values)
                }

            } else{
                error <- TRUE
            }
        }
    }
    if(error){
        PFM <- NULL
    } else {
        rownames(PFM) <- c("A","C","G","T")
    }
    return(PFM)
}




### Reads a list of sequences from a file and produces the PFM mtrix;
### fileame: the filename with the sequences
### return: a 4 row PFM matrix, with rows: A, C, G, T
.parsePFMFromFile <- function(fileame){
    sequences <- readDNAStringSet(fileame)
    if(!is.null(sequences) & length(sequences) > 0){
        PFMExtended <- consensusMatrix(sequences,as.prob = TRUE,
            baseOnly = TRUE)
        PFM <- PFMExtended[1:4,]
    } else{
        PFM <- NULL
    }
    return(PFM)
}

### generates a list of all PWM scores that are above a certain threshold
### PWMScore: a list a PWM scores vectors for each DNA segments
### PWMThreshold: the PWM score threshold
### minPWMScore: the min PWM score
### maxPWMScore: the max PWM score
### return: a list consisting of a vector with the indexes of the PWM
###scores higher than a threshold for each chromosome (or locus)
.getIndexOfPWMThresholded <- function(PWMScore, PWMThreshold){
    indexes <- vector("list",length(PWMScore))
    names(indexes) <- names(PWMScore)
    for(i in seq_along(PWMScore)){
        indexes[[i]] <- which(PWMScore[[i]] > PWMThreshold)
    }
    return(indexes)
}




.scoreDNAStringSet <- function(PWM,DNASequenceSet, strand="+",
    strandRule="max"){
    scoreSet <- vector("list", length(DNASequenceSet))
    IndexPositive <- vector("list",length(DNASequenceSet))
    IndexNegative <- vector("list",length(DNASequenceSet))
    names(scoreSet) <- names(DNASequenceSet)
    for(i in 1:length(DNASequenceSet)){
        sequenceLength <- (length(DNASequenceSet[[i]]) - ncol(PWM) + 1)
        scorePositive <- NULL
        scoreNegative <- NULL

        if(length(grep("+",strand))){
        ## Warnings from BioStrings Package
        scorePositive <- PWMscoreStartingAt(PWM,DNASequenceSet[[i]],
            starting.at = seq_len(sequenceLength))
        }

        if(length(grep("-",strand))){
            scoreNegative <- rev(PWMscoreStartingAt(PWM,
                reverseComplement(DNASequenceSet[[i]]),
                starting.at = seq_len(sequenceLength)))
        }

        if(is.null(scorePositive) & is.null(scoreNegative)){
            # no strand is specified so consider the positive strand
            scoreSet[[i]] <- PWMscoreStartingAt(PWM,DNASequenceSet[[i]],
                starting.at = seq_len(sequenceLength))
        } else if(!is.null(scorePositive) & !is.null(scoreNegative)){
        # both strands are specified
            if(strandRule == "sum"){
                scoreSet[[i]] <- scorePositive + scoreNegative
            } else if(strandRule =="mean"){
                scoreSet[[i]] <- (scorePositive + scoreNegative)/2
            } else{
                scoreSet[[i]] <- pmax(scorePositive,scoreNegative)
                IndexPositive[[i]] <- which(scorePositive ==
                    pmax(scorePositive,scoreNegative))
                IndexNegative[[i]] <- which(scoreNegative ==
                    pmax(scorePositive,scoreNegative))

            }
        } else {
            if(!is.null(scoreNegative)){
                scoreSet[[i]] <- scoreNegative
            } else{
                scoreSet[[i]] <- scorePositive
            }
        }
    }
    return(list(scoreSet,IndexPositive,IndexNegative))
}


# Validity check function for Genomic Profile Parameters
.is.genomicProfiles<- function(object){
    if(class(object) == "genomicProfiles"){
        return(TRUE)
    } else {
        return(FALSE)
    }
}

# Validity check function for occupancy Profile Parameters
.is.parameterOptions <- function(object){
    if(class(object) == "parameterOptions"){
        return(TRUE)
    } else {
        return(FALSE)
    }
}

.updateGenomicProfiles<-function(genomicProfiles,parameterOptions){
    slots<-slotNames(parameterOptions)
    localEnvir<-environment()
    lapply(slots,function(slots){

           if(!any(slot(genomicProfiles,slots)%in%slot(parameterOptions,slots))){
           slot(genomicProfiles,slots,check=TRUE)<-slot(parameterOptions,slots)
           assign("genomicProfiles",genomicProfiles,envir=localEnvir)
         }})
    return(genomicProfiles)
}

# Extracting and computing Base Pair frequency from BSGenome when
#contructing genomicProfileParamter
.computeBPFrequency <- function(object){
    if(class(object) == "BSgenome"){
    object <- getSeq(object)
    }
    if(class(object) == "DNAStringSet"){
    object <- object
    }
    if(length(object)>1){
    BPFrequency <- apply((alphabetFrequency(object,baseOnly=TRUE)[,1:4]),
    2,sum)
    BPFrequency <- BPFrequency/sum(as.numeric(BPFrequency))
    } else {
    BPFrequency <- (alphabetFrequency(object,baseOnly=TRUE)[,1:4])
    BPFrequency <- BPFrequency/sum(as.numeric(BPFrequency))
    }
    return(BPFrequency)
}
# Compute Thetha from MSE and Corr
#Generate chip Profile
.generateChIPProfileRcpp <- function(inputVector, mean, sd, smooth = NULL,
    norm = TRUE, peakSignificantThreshold=NULL){

    if(is.null(peakSignificantThreshold)){
        peakSignificantThreshold <- 0.0001
    }
    originalMax=max(inputVector);

    var = sd^2;
    shp = mean^2/var
    scl = var/mean
    l = length(inputVector)


    f = dgamma(0:length(inputVector), shape = shp, scale = scl)
    bigF = rev(cumsum(rev(f)))
    peakSignificantSize = min(which(bigF<peakSignificantThreshold))

    kernel = c(rev(bigF[seq(2,peakSignificantSize)]),
    bigF[seq_len(peakSignificantSize)])
    leftKernel=(floor(length(kernel)/2) - 1)
    rightKernel=length(kernel)-leftKernel-1

    rawVector = inputVector;
    rawVector[which(inputVector <= mean(inputVector))]=0
    rawVector = c(rep(0,times=leftKernel), rawVector, rep(0,times=rightKernel))

    peaks = roll_sum(rawVector, length(kernel), weights = kernel)

    if(!is.null(smooth)){
        leftKernel=(floor(smooth/2) - 1)
        rightKernel=smooth-leftKernel-1
        peaks = roll_mean(c(rep(0,times=leftKernel),peaks,
        rep(0,times=rightKernel)), smooth, weights = rep(1, smooth))
    }

    #print((kernel))

    if(norm && max(peaks)!=0){
        peaks=originalMax*peaks/max(peaks)
    }
    peaks <- c(peaks[2:length(peaks)],0)
    return(peaks)
}

#Generate chip Profile
.generateChIPProfile <- function(inputVector, mean, sd,
    smooth = NULL, norm = TRUE, quick = TRUE,peakSignificantThreshold=NULL){

    if(is.null(peakSignificantThreshold)){
        peakSignificantSize <- 1250
    }

    originalMax <- max(inputVector)

    var <- sd^2
    shp <- mean^2/var
    scl <- var/mean
    l <- length(inputVector)



    f <- dgamma(0:length(inputVector), shape = shp, scale = scl)
    gamma <- rev(cumsum(rev(f)))
    sp <- c(rev(gamma[seq(2,peakSignificantSize)]),
    gamma[seq_len(peakSignificantSize)])
    lp <- length(sp)
    hp <- (lp - 1)/2

    peak.centres <- which(inputVector > mean(inputVector))
    peaks <- vector("numeric", l)

    if(!quick){
        for(pc in peak.centres) {
            thisPeak <- vector("numeric", l)
            thisPeak[pc:l] <- gamma[1:(l-pc+1)]
            if(pc!=1){
                thisPeak[1:(pc-1)] <- gamma[pc:2]
            }
            peaks <- peaks + thisPeak * inputVector[pc]
        }
    } else {
        for(pc in peak.centres) {
            thisPeak <- sp
            left <- pc - hp
            right <- pc + hp
            cutLeft <- max(0, 0 - left)
            cutRight <- (-min(0, l - right))
            if(cutLeft != 0){
                thisPeak <- thisPeak[-(1:(cutLeft+1))]
            }
            if(cutRight != 0){
                thisPeak <- thisPeak[-((lp-cutRight+1):lp)]
            }
            left <- max(1, left)
            right <- left + length(thisPeak) - 1
            peaks[left:right] <- peaks[left:right] + thisPeak * inputVector[pc]
        }
    }

    if(!is.null(smooth)){
        if((smooth %% 2) == 0){
            smooth <- smooth - 1
        }
        mid <- round(smooth/2,0) + 1
        d <- smooth - mid
        for(i in mid:(length(peaks) - d)) {
            peaks[i] <- mean(peaks[(i-d):(i+d)])
        }
    }


    if(norm && max(peaks) != 0){
        peaks <- originalMax*peaks/max(peaks)
    }

    return(peaks)
}


## Search sites in occupancy and Chip if a lot of them
## wow that is some good english right there

searchSites <- function(Sites,lambdaPWM="all",
    BoundMolecules="all",Locus="all"){

    if(!is.null(names(Sites)) & all(names(Sites) %in%c("Optimal","Occupancy","ChIPProfiles","goodnessOfFit"))){

       bufferSites<-list("Optimal"=Sites[[1]],
                         "Occupancy"=searchSites(unname(Sites$Occupancy),lambdaPWM=lambdaPWM,
                                                 BoundMolecules=BoundMolecules,
                                                 Locus=Locus),
                         "ChIPProfiles"=searchSites(unname(Sites$ChIPProfile),lambdaPWM=lambdaPWM,
                                                  BoundMolecules=BoundMolecules,
                                                  Locus=Locus),
                          "goodnessOfFit"=searchSites(unname(Sites$goodnessOfFit),lambdaPWM=lambdaPWM,
                                                  BoundMolecules=BoundMolecules,
                                                  Locus=Locus))
       return(bufferSites)
    }else if(class(Sites)=="genomicProfiles" | class(Sites)=="list"){

        if(class(Sites)=="genomicProfiles"){
            Sites <- profiles(Sites)
        }






    #Setting Up for search

    lambda <- "lambda = "
    bound <- "boundMolecules = "

    buffer <- c()
    bufferSites <- Sites

    #Search for Scaling Factor
    if(all(lambdaPWM=="all")){
        bufferSites <- bufferSites
        buffer <- 0
    } else {
        localNames <- sapply(strsplit(sapply(strsplit(names(bufferSites)," &"),
        "[[",1),lambda),"[[",2)
        for( i in seq_along(lambdaPWM)){
            buffer <- c(buffer,grep(paste0("^",lambdaPWM[i],"$"),
            localNames))

        }

        if(length(buffer)>=1){
        bufferSites <- bufferSites[buffer]
        }
    }

    #Search for boundMolecules
    buffer <- c()
    if(all(BoundMolecules=="all")){
        bufferSites <-bufferSites
        buffer <- 0
    } else {
        localNames <- sapply(strsplit(names(bufferSites),bound),"[[",2)
        for( j in seq_along(BoundMolecules)){
            buffer <- c(buffer, grep(paste0("^",as.character(as.integer(BoundMolecules[j])),"$"),
            as.character(as.integer(localNames))))

        }
#browser()
        if(length(buffer)>=1){
            bufferSites <- bufferSites[buffer]
        }
    }
    #Search for Loci

    if(all(Locus == "all")){
        bufferSites <- bufferSites
    } else {
        if(class(bufferSites)=="list"){
        for( k in seq_along(bufferSites)){
            LocalLocus <- names(bufferSites[[k]])
            buffer <- which(LocalLocus==Locus)
            bufferSites[[k]] <- bufferSites[[k]][buffer]
        }
        } else {
            LocalLocus <- names(bufferSites)
            buffer <- which(Locus %in% LocalLocus)
            bufferSites <- bufferSites[buffer]
        }
    }
    return(bufferSites)
  } else{
    stop("Oops Something went wrong. We are not sure what you are parsing to Sites")
  }
}

### Extracting Non Accesible DNA
.AccessExtract<-function(subject,query,isCS=FALSE){
    setLocal<-vector("list",length(subject))

    for(i in seq_along(subject)){
        localIntersect<-setdiff(subject[i], query)
        if(isCS){
          setLocal[[i]]<-data.frame("chr"=as.character(seqnames(localIntersect)),
                                    "start"=start(localIntersect),
                                    "end"=end(localIntersect),
                                    "CS" = mcols(localIntersect)[,1])
        }else {
          setLocal[[i]]<-data.frame("chr"=as.character(seqnames(localIntersect)),
                                    "start"=start(localIntersect),
                                    "end"=end(localIntersect))
        }

    }
    names(setLocal)<-names(subject)
    return(setLocal)
}


#### building a skelton object for accuracy estimates

.cleanGoF <- function(genomicProfiles,ValidationSet,stepSize=10){
     #just in case it needs some reordering

     ValidationSet<-ValidationSet[match(names(genomicProfiles[[1]]),names(ValidationSet))]

     setUpGoF<-lapply(genomicProfiles,function(gp,chip,stepSize){

                      predicted <-lapply(gp,function(x){
                                         return(x$ChIP)})

                      idx<-lapply(gp,function(x){
                                  return(floor(seq(1,sum(width(x)),length.out=length(x))))})
                      validation<-mapply(function(x,idx){
                                  return(x[idx])},x=chip,idx=idx,SIMPLIFY=FALSE)
                      ## internalCheck
                      internalCheck <- all.equal(sapply(predicted,length),sapply(validation,length))
                      if(!internalCheck){
                         stop("predicted and valdiation set are not the same length")
                      }

                      paralleValues<-mapply(function(x,y){
                                     local<-list("prediction"=x,"validation"=y)},
                                     predicted,validation,SIMPLIFY=FALSE)
                      return(paralleValues)
       },ValidationSet,stepSize)

       return(setUpGoF)

}


.meanGoFScore <-function(GoF){
    tags<-names(GoF[[1]])
    idx<-seq_along(tags)

    meanGoF <- sapply(idx,function(idx,GoF){
                      res<-mean(sapply(GoF,"[[",idx),na.rm=TRUE)
                      return(res)
    },GoF=GoF)
    names(meanGoF)<-paste0(tags,"Mean")


    for(i in seq_along(GoF)){
       GoF[[i]]<-c(GoF[[i]],meanGoF)
    }
    return(GoF)
}



## Fscore computation for all regions
.peakExtractionFScore<-function(predicted,locusProfile,region=TRUE){
    # making sure that they are same length just for idx purposes
    if(length(predicted)!=length(locusProfile)){
        stop("precited Profile and locusProfile are not the same length")
    }
    ## threshold increments
    high<-max(max(predicted),max(locusProfile))
    low<-min(min(predicted),min(locusProfile))
    if(low==0){
        subs<-seq(low,high,length.out=21)
        subs<-sapply(subs,"^",2)[seq(2,21)]
    } else{
        subs<-seq(low,high,length.out=20)
        subs<-sapply(subs,"^",2)
    }

    subprof<-matrix(0,ncol=11,nrow=length(subs))

    #rownames(paste0("thresh=",subs))
    #browser()
    matpred<-matrix(0,ncol=length(subs), nrow=length(locusProfile))
    matloc<-matrix(0,ncol=length(subs), nrow=length(locusProfile))

    for(i in seq_along(subs)){

        localProfile<-rep(0,length(locusProfile))
        ## thresh extraction

        localProfile[locusProfile>=subs[i]]<-1
        if(all(localProfile==1)){
             localProfile[1]<-0
        }
        if(all(localProfile==0)){
             localProfile[1]<-1
        }
        matpred[,i]<-factor(predicted)
        matloc[,i]<-factor(localProfile)
    }

    ## Predictions and performance
    pred<-prediction(matpred,matloc)
    prec<-mean(sapply(performance(pred,"prec")@y.values,mean,na.rm=T))
    rec<-mean(sapply(performance(pred,"rec")@y.values,mean,na.rm=T))
    fscore<-mean(sapply(performance(pred,"f")@y.values,mean,na.rm=T))
    acc<-mean(sapply(performance(pred,"acc")@y.values,mean,na.rm=T))
    mcc<-mean(sapply(performance(pred,"mat")@y.values,mean,na.rm=T))

    auc<-mean(sapply(performance(pred,"auc")@y.values,mean,na.rm=T))


    return(c("precision"=prec,"recall"=rec,"f1"=fscore,"accuracy"=acc,"MCC"=mcc,"AUC"=auc))
}

##### geometricRatio

.geometricRatio<-function(predcited,locusProfile,step){
       diff<-abs(locusProfile-predcited)
       leftEdge<-diff[seq(1,length.out=length(diff)-1)]
       rightEdge<-diff[seq(2,length.out=length(diff)-1)]

       areaDiff<-rep(0,length(diff)-1)
       areaShared<-rep(0,length(diff)-1)
       area<-rep(0,length(diff)-1)

       for(i in seq_along(areaDiff)){
       ## Computing Diff and shared
          ## Diff
          areaDiff[i]<-step*((leftEdge[i]+rightEdge[i])/2)
          ## Shared
          if(locusProfile[i]>=predcited[i] & locusProfile[i+1]>=predcited[i+1]){
              areaShared[i]<-step*((predcited[i]+predcited[i+1])/2)
          } else {
              areaShared[i]<-step*((locusProfile[i]+locusProfile[i+1])/2)
          }
        }
        ## Considering zeroes
        if(sum(areaShared)!=0){
            area<-sum(areaDiff)/sum(areaShared)
        } else {

            area<-sum(areaDiff)
        }

    return(area)

}


### all metric extraction just to make things cleaner(should be using switch )

.allMetrics<-function(predicted,locusProfile,stepSize){
    # Checking for bullshit and doing some correlation stuff

    if((sd(predicted,na.rm=TRUE)==0) | (sd(locusProfile,na.rm=TRUE)==0)){
        corrP<-0
        corrS<-0
        corrK<-0
    } else {

        corrP<-cor(na.omit(predicted),na.omit(locusProfile),method="pearson")

        corrS<-cor(na.omit(predicted),na.omit(locusProfile),method="spearman")

        corrK<-cor(na.omit(predicted),na.omit(locusProfile),method="kendall")

    }

    ## ks distance
    ks<-ks.test(predicted,locusProfile)
    D<-unname(ks[[1]])

    ## Geometric
    geo<-.geometricRatio(predicted,locusProfile,stepSize)

    ## fscore
    AUC<-.peakExtractionFScore(predicted,locusProfile)

    metrics<-c("pearson"=corrP,
        "spearman"=corrS,
        "kendall"=corrK,
        "KsDist"=D,
        "geometric"=geo,
         AUC)
    return(metrics)
}



## rankBased method
.OptimalFormatConversion<-function(goodnessOfFit){
     ## for some reason arrays return this weird thing..
     ## things are reordered but not in the way i want them
     ## Im not entirely sure how they work
     ## For now we will use this method
     ## just easier to build
     fitVec<-seq_along(goodnessOfFit[[1]][[1]])
     lociVec<-seq_along(goodnessOfFit[[1]])
     paramVec<-seq_along(goodnessOfFit)

     convertedFormat<-lapply(fitVec,function(fitVec,lociVec,paramVec,goodnessOfFit){


                            param<-lapply(paramVec,function(paramVec,fitVec,lociVec,goodnessOfFit){
                                      loci<-sapply(goodnessOfFit[[paramVec]],"[[",fitVec)
                                      return(loci)

                            },fitVec,lociVec,goodnessOfFit)
                            mat<-do.call("rbind",param)
                            rownames(mat)<-names(goodnessOfFit)
                            return(mat)
     },lociVec,paramVec,goodnessOfFit)
     names(convertedFormat)<-names(goodnessOfFit[[1]][[1]])
     return(convertedFormat)
}


### Processing optimal matricies and parameters


.optimalExtraction <-function(goodnessOfFit,rank=FALSE){

    accu<-profiles(goodnessOfFit)
    bm<-boundMolecules(goodnessOfFit)
    lambda<-lambdaPWM(goodnessOfFit)

    ## converting format
    metrics<-.OptimalFormatConversion(accu)


    if(rank){
         metrics<-metrics[!grepl("Mean",names(metrics))]
         tag<-names(metrics)
         idx<-seq_along(tag)

         # extracting Rank based matrics
         metrics<-lapply(idx,function(idx,metrics,tag){
                              local<-metrics[[idx]]
                              localTag<-tag[idx]
                              internalIdx<-seq_len(ncol(local))
                              TopHits<-lapply(internalIdx,function(idx,met,tags){
                                              if(tags %in% c("geometric","MSE","KsDist")){
                                                 best<-which(met[,idx]==min(met[,idx]))
                                                 buffer<-as.vector(met[best,idx])
                                                 names(buffer)<-rownames(met)[best]


                                              }else{
                                                best<-which(met[,idx]==max(met[,idx]))
                                                buffer<-as.vector(met[best,idx])
                                                names(buffer)<-rownames(met)[best]
                                              }
                                              return(buffer)
                              },local,localTag)
                              #names(TopHits)<-colnames(local)
                              TopHits<-sort(table(names(unlist(TopHits))),decreasing=TRUE)
                              return(TopHits)},metrics,tag)
          ## extracting optimal parameter
          optimalParama<-mapply(function(met,tags){
                              unpacked<-.unpackMetrics(met)
                              if(tags %in% c("geometric","MSE","KsDist")){
                                  optimal<-unpacked[which(unpacked[,"score"]==min(unpacked[,"score"])),c("lambda","boundMolecules")]
                              } else{
                                  optimal<-unpacked[which(unpacked[,"score"]==max(unpacked[,"score"])),c("lambda","boundMolecules")]
                              }
                              return(optimal)

          },met=metrics,tags=tag,SIMPLIFY=FALSE)
          names(optimalParama)<-tag

          # building rank based matricies
          mattemp<-matrix(0,ncol=length(bm),nrow=length(lambda))
          rownames(mattemp)<-lambda
          colnames(mattemp)<-bm
          Loc<-lapply(metrics,function(met,mattemp){
                      unpacked<-.unpackMetrics(met)

                      idx<-seq_len(nrow(unpacked))


                      for(i in idx){
                        mattemp[as.character(unpacked[i,"lambda"]),as.character(unpacked[i,"boundMolecules"])]<-as.numeric(unpacked[i,"score"])
                      }

                      return(mattemp)},mattemp)
          names(Loc)<-tag

          FinalOptimalBuild<-list("OptimalParameters"=optimalParama,"OptimalMatrix"=Loc,"method"="rank")

    } else {
        metrics<-metrics[!grepl("Mean",names(metrics))]
        tag<-names(metrics)
        idx<-seq_along(tag)
        metrics<-lapply(metrics,function(met){
                        return(apply(met,1,mean))
        })

        ## Optimal Paramters
        optimalParama<-mapply(function(met,tag){
                              unpacked<-.unpackMetrics(met)
                              if(tag %in% c("geometric","MSE","KsDist")){
                                  optimal<-unpacked[which(unpacked[,"score"]==min(unpacked[,"score"])),c("lambda","boundMolecules")]
                              } else{
                                  optimal<-unpacked[which(unpacked[,"score"]==max(unpacked[,"score"])),c("lambda","boundMolecules")]
                              }
                              return(optimal) },met=metrics,tag=tag,SIMPLIFY=FALSE)
       ## building matricies
       mattemp<-matrix(0,ncol=length(bm),nrow=length(lambda))
       rownames(mattemp)<-lambda
       colnames(mattemp)<-bm
       Loc<-lapply(metrics,function(met,mattemp){
                   unpacked<-.unpackMetrics(met)

                   idx<-seq_len(nrow(unpacked))


                   for(i in idx){
                      mattemp[as.character(unpacked[i,"lambda"]),as.character(unpacked[i,"boundMolecules"])]<-as.numeric(unpacked[i,"score"])
                   }

                   return(mattemp)},mattemp)
       names(Loc)<-tag

       FinalOptimalBuild<-list("OptimalParameters"=optimalParama,"OptimalMatrix"=Loc,"method"="MeanScore")
    }

   return(FinalOptimalBuild)


}

.unpackMetrics<-function(metrics){

      lambda <- "lambda = "
      bound <- "boundMolecules = "
      lambdaLoc <- sapply(strsplit(sapply(strsplit(names(metrics)," &"),
      "[[",1),lambda),"[[",2)
      bmLoc <- sapply(strsplit(sapply(strsplit(names(metrics)," &"),
      "[[",2),bound),"[[",2)

      unpacked<-cbind("lambda"=as.numeric(lambdaLoc),"boundMolecules"=as.numeric(bmLoc),"score"=as.numeric(metrics))

      return(unpacked)
}




## cleaning function to drop unneccesary objects

.cleanUpAfterYourself<-function(...){
    args<-list(...)
    rm(args)
    gc()
}

### So for some reason unlist
.internalUnlist<-function(object){
    localList<-GRangesList()
    for(i in seq_along(object)){
      localList<-c(localList,object[[i]])
    }
    return(localList)
}



####

.what.is.predictedProfile<-function(predictedProfile){
    if(.is.genomicProfiles(predictedProfile)){
       if(.tags(predictedProfile)=="ChIPProfile"){
         predictedProfile <-profiles(predictedProfile)
    }
  }

    if(class(predictedProfile)=="list" &
              any(grepl("lambda",names(predictedProfile)))){
        stepSize<-unique(width(predictedProfile[[1]][[1]]))
        loci <- unique(unlist(GRangesList(lapply(predictedProfile[[1]], function(x){
                return(GRanges(seqnames=as.character(seqnames(x)),
                               ranges=IRanges(start(x)[1], end(x)[length(x)])))
        }))))

         loci<-rep(loci,length(predictedProfile))

         predictedProfile<-.internalUnlist(predictedProfile)
         predictedProfile<-lapply(predictedProfile, function(x){return(x$ChIP)})

         #warning("No Parameter Combination selected - We will just plot everything",immediate.=TRUE)
    } else if(class(predictedProfile)=="list" &
              any(!grepl("lambda",names(predictedProfile)))){
           stepSize<-unique(width(predictedProfile[[1]]))
           loci <- unique(unlist(GRangesList(lapply(predictedProfile, function(x){
                   return(GRanges(seqnames=as.character(seqnames(x)),
                                  ranges=IRanges(start(x)[1], end(x)[length(x)])))
           }))))
           predictedProfile <- lapply(predictedProfile, function(x){return(x$ChIP)})
    } else if(class(predictedProfile)=="GRanges"){
         stepSize<-unique(width(predictedProfile))
         loci<- GRanges(seqnames=as.character(predictedProfile),
                        ranges=IRanges(start(predictedProfile)[1],end(predictedProfile)[length(predictedProfile)]))
         predictedProfiles<-list(predictedProfile$ChIP)
    } else{
       stop("Oops Somthing went wrong. We are not sure what your are parsing to predictedProfile")
    }
    # building loci from predicted
    return(list("loci"=loci,"predictedProfile"=predictedProfile,"stepSize"=stepSize))
}


.what.is.occupancy<-function(occupancy,PWM=FALSE){
  if(.is.genomicProfiles(occupancy)){
     if(.tags(occupancy)=="Occupancy"){
       occupancy <-profiles(occupancy)
  }
}

    if(class(occupancy)=="list" &
       any(grepl("lambda",names(occupancy)))){
            occupancy<-.internalUnlist(occupancy)

           #warning("No Parameter Combination selected - We will just plot everything",immediate.=TRUE)
      } else if(class(occupancy)=="list" &
                any(!grepl("lambda",names(occupancy)))){


          occupancy-occupancy
      } else if(class(occupancy)=="GRanges"){

           occupancy<-list(occupancy)
      } else{
         stop("Oops Somthing went wrong. We are not sure what your are parsing to predictedProfile")
      }

    return(occupancy)
}



.what.is.ChIPScore <- function(ChIPScore){
    if(class(ChIPScore)=="ChIPScore"){

        ChIPScore<-scores(ChIPScore)


    }

      ## once un packed we can move twords checking the other elements
    if(class(ChIPScore)=="list"){
         ChIPScore<-ChIPScore
    } else if(class(ChIPScore)=="numeric"){
          ChIPScore<-list(ChIPScore)
    }else{
       stop("Oops Somthing went wrong. We are not sure what you are parsing to ChIPScore")
    }
    return(ChIPScore)
}


.what.is.goodnessOfFit<-function(goodnessOfFit){
  if(.is.genomicProfiles(goodnessOfFit)){
     if(.tags(goodnessOfFit)=="GoF"){
       goodnessOfFit <-profiles(goodnessOfFit)
  }
}

    if(class(goodnessOfFit)=="list" &
       any(grepl("lambda",names(goodnessOfFit)))){

                  goodnessOfFit<-unlist(goodnessOfFit,recursive=FALSE)

           #warning("No Parameter Combination selected - We will just plot everything",immediate.=TRUE)
      } else if(class(goodnessOfFit)=="list" &
                any(!grepl("lambda",names(goodnessOfFit)))){
          goodnessOfFit<-goodnessOfFit

      } else if(class(goodnessOfFit)=="numeric") {
           goodnessOfFit <-list(goodnessOfFit)
      } else{
         stop("Oops Somthing went wrong. We are not sure what your are parsing to predictedProfile")
      }
}

.what.is.chromatinState <- function(cs,lociLocal){
    
    if(class(cs) == "GRanges"){
        csList <- list()
        for(i in seq_along(lociLocal)){
            tmp <- cs[queryHits(findOverlaps(cs, lociLocal[i]))]
           
            start(tmp) <- pmax(start(tmp),start(lociLocal[i]))
            end(tmp) <- pmin(end(tmp),end(lociLocal[i]))
            if(ncol(mcols(tmp))==0){
                tmp$stateID <- "Inaccessible DNA"
            } else {
                # Making sure that it is correctly named 
                colnames(mcols(tmp))[1] <- "stateID"
            }
            csList[[i]] <- as.data.frame(tmp)
            
        }
    } else {
        stop("Oopss Somthing went wrong. Please provide GRanges for chromatinState")
    }
    return(csList)
}

.what.is.geneRef <- function(gr,lociLocal){
    if(class(gr) == "GRanges"){
        grList <- list()
        for(i in seq_along(lociLocal)){
           tmp <- gr[queryHits(findOverlaps(gr, lociLocal[i]))]
           start(tmp) <- pmax(start(tmp),start(lociLocal[i]))
           end(tmp) <- pmin(end(tmp),end(lociLocal[i]))
           tmp <- as.data.frame(tmp)
           grList[[i]] <- tmp[,c("seqnames","start","end","width","strand","type","gene_id")]
        }
    } else {
        stop("Oopss Somthing went wrong. Please provide GRanges for chromatinState")
    }
    return(grList)
}

#######################################################################
# Functions
#######################################################################


computeOccupancy <- function(genomicProfiles ,
     parameterOptions=NULL,norm=TRUE,verbose=TRUE) {
    # Validity checking
    if(!.is.parameterOptions(parameterOptions) &
    !is.null(parameterOptions)){
    stop(paste0(deparse(substitute(parameterOptions)),
    "is not an occupancyProfileParamaters Object."))
    }
    if (!.is.genomicProfiles(genomicProfiles)){
    stop(paste0(deparse(substitute(genomicProfiles)),
    " is not a Genomic Profile Paramter object."))
    }

    #Generating parameterOptions if not given by user.
    #All Value will be defaut settings

    if(!is.null(parameterOptions)){
        genomicProfiles<-.updateGenomicProfiles(genomicProfiles,parameterOptions)
    }
    # GenomicProfiles parameter Extraction
  
    PWMGRList <- GRangesList(profiles(genomicProfiles))
    DNALength <- as.numeric(DNASequenceLength(genomicProfiles))
    averageExpPWMScore <- averageExpPWMScore(genomicProfiles)
    lambda <- lambdaPWM(genomicProfiles)

    ploidy <- as.numeric(ploidy(genomicProfiles))
    boundMolecules <- boundMolecules(genomicProfiles)
    backgroundSignal <- backgroundSignal(genomicProfiles)
    maxSignal <- maxSignal(genomicProfiles)



    # Computing Occupancy at sites higher than threshold
    MultiParam <- vector("list", (length(lambda)*length(boundMolecules)))
    PWMScore <- vector("list", length(PWMGRList))

    ### Essentially making sure that if regions dont have accessible DNA
    ## They will still be kept it will make things easier later down the line
    ## Also you just return a big fat falt line anyway

    dropLoci<-drop(genomicProfiles)

    if(length(grep("No loci dropped",dropLoci))==0){
      widthDisplay<-round(options()$width*0.5)
      cat("No Accessible DNA in: ",paste(rep(" ",
         times=(widthDisplay-nchar("StepSize: ")-nchar(dropLoci[1]))),collapse=''),
         dropLoci,"\n","\n")
      chr<-sapply(strsplit(dropLoci,":"),"[[",1)
      start<-sapply(strsplit(sapply(strsplit(dropLoci,":"),"[[",2),"\\.."),"[[",1)
      end<-sapply(strsplit(sapply(strsplit(dropLoci,":"),"[[",2),"\\.."),"[[",2)
      LocalDrop<-GRanges(seqnames=chr,ranges=IRanges(as.numeric(start), as.numeric(end)),
                          PWMScore=rep(0,length(chr)),
                          DNAaffinity=rep(0,length(chr)),
                          Occupancy=rep(0,length(chr)))
      name<-c(rep(names(PWMGRList),times=sapply(PWMGRList, length)),dropLoci)
    } else{
      name<-rep(names(PWMGRList),times=sapply(PWMGRList, length))
    }


    # chromatinState if not continuous Data

    Occupancy <- vector("list",length(PWMGRList))
    #names(Occupancy) <- names(PWMGRList)
    result <- list()
    emptyGR <- GRanges()
    # Progress message when required
    if(verbose){
    message("Computing Occupancy at sites higher than threshold. \n")
    }

    counter <- 0
    ParaVal <- c()

    #Computing Occupancy
    for(k in seq_along(lambda)){
        for(j in seq_along(boundMolecules)){

            PWMScore <- unlist(PWMGRList)$PWMScore

            Access <- unlist(PWMGRList)$DNAaffinity

            Occupancy <- rep(0,length(PWMScore))
            Occupancy <- (Access*boundMolecules[j]*exp((1/lambda[k])*PWMScore))/
                (Access*boundMolecules[j]*exp((1/lambda[k])*PWMScore) +
                DNALength*ploidy*averageExpPWMScore[k])

            Occupancy <- backgroundSignal + Occupancy*(maxSignal-backgroundSignal)
    # Normalising Ocupancy Signal
            if(norm == TRUE){
                maxOccupancy <- max(c(maxSignal,max(Occupancy)))
                Occupancy <- Occupancy/maxOccupancy
                ZeroBackground <- backgroundSignal/maxOccupancy
            } else {
                ZeroBackground <- backgroundSignal
            }


            buffer <- unlist(PWMGRList)

            buffer$Occupancy <- Occupancy
            if(length(grep("No loci dropped",dropLoci))==0){
               buffer<-c(buffer,LocalDrop)
            }
    # Extracting and pasting names of Parameters
            names(buffer) <- name
            if(length(name > 1)){
                level <- factor(names(buffer),levels=unique(name))
                result <- split(buffer,level)

            } else {
                result <-  buffer
            }

            counter <- counter+1
            MultiParam[[counter]] <- result
            ParaVal <- c(ParaVal,paste0("lambda = ",lambda[k]," & ",
            "boundMolecules = ",boundMolecules[j]))
        }
    }

    # ReBuilding GenomicProfileParameters
    names(MultiParam) <- ParaVal

    .ZeroBackground(genomicProfiles)<- ZeroBackground
    .profiles(genomicProfiles)<-MultiParam
    .tags(genomicProfiles)<-"Occupancy"
    .paramTag(genomicProfiles)<-"Occupancy"
    return(genomicProfiles)
}

#######################################################################
# Functions profile Accuracy
#######################################################################


profileAccuracyEstimate <- function(genomicProfiles,ChIPScore,
    parameterOptions=NULL,method="all",cores=1){

      #Validity checking
      if(!.is.genomicProfiles(genomicProfiles)){
      stop(paste0(deparse(substitute(genomicProfiles)),
      " is not a Genomic Profiles Object"))
      }
      if(!.is.parameterOptions(parameterOptions) &
      !is.null(parameterOptions)){
      stop(paste0(deparse(substitute(parameterOptions)),
      " is not a parameterOptions Object."))
      }
      if(class(ChIPScore)!="ChIPScore" &
      !is.null(ChIPScore)){
      stop(paste0(deparse(substitute(ChIPScore)),
      " is not a ChIPScore Object."))
      }

      if(!is.null(parameterOptions)){
          genomicProfiles<-.updateGenomicProfiles(genomicProfiles,parameterOptions)
      }

      #If Sites are not accesible or have no overlapp with chipprofile
      dropLoci<-drop(genomicProfiles)
      if(length(grep("No loci dropped",dropLoci))==0){
        widthDisplay<-round(options()$width*0.5)
        cat("No Accessible DNA in: ",paste(rep(" ",
           times=(widthDisplay-nchar("StepSize: ")-nchar(dropLoci[1]))),collapse=''),
           dropLoci,"\n","\n")
      }

     ## Extract and reorder
     predictionSet<-profiles(genomicProfiles)

     ValidationSet<-scores(ChIPScore)

     stepSize <- stepSize(genomicProfiles)

     GoF<-.cleanGoF(predictionSet,ValidationSet,stepSize)
     ## paralle : choosing which one to split over

     if(length(predictionSet) > length(ValidationSet)){
        GoF<-parallel::mclapply(GoF,.GoFPred,method,step=stepSize,mc.cores=cores)
     }else{
        GoF <-lapply(GoF,.GoFLoci,method=method,step=stepSize, cores=cores)
     }

     ### computing mean over all regions
     GoF <- lapply(GoF,.meanGoFScore)

     .profiles(genomicProfiles)<-GoF
     .tags(genomicProfiles)<-"GoF"

     return(genomicProfiles)
}

plotOptimalHeatMaps<-function(optimalParam,contour=TRUE,col=NULL,main=NULL,layout=TRUE,overlay=FALSE){


    ## parsng data depending on what is being parser
    ## Dont know if i should just pars this to a genomic profile object or not.
    ## I feel that in this case it will be to redundant.
    ##

    if(all(names(optimalParam) %in% c("Optimal","Occupancy","ChIPProfiles","goodnessOfFit"))){
       optimalParam<-optimalParam[[1]][[2]]
    } else if(all(names(optimalParam) %in% c("OptimalParameters","OptimalMatrix","method"))){
       optimalParam<-optimalParam[[2]]
    } else if(class(optimalParam)=="list"){
       optimalParam<-optimalParam

    } else if(class(optimalParam)=="matrix"){
      optimalParam<-list(optimalParam)
    } else{
      stop("Oops Sonthing went wrong. Please enusre that you are parsing the right object.
      We are not sure what what to do now. ")

    }

    ## replacing NA or NAN by 0 because it messes things up for the plotting
    ## It be annoying

    nans<-lapply(optimalParam, function(x){return(which(is.na(x), arr.ind=T))})


    ## replacing NaN with min of max val
    namevec<-names(optimalParam)
    for(i in seq_along(optimalParam)){
        if(length(grep(pattern=namevec[i],x=c("MSE","geometric","ks"),ignore.case=TRUE))>0){
            optimalParam[[i]][nans[[i]]]<-max(optimalParam[[i]],na.rm=TRUE)
        }else {
            optimalParam[[i]][nans[[i]]]<-min(optimalParam[[i]],na.rm=TRUE)
        }
    }
    ## generting overlay
    if(overlay){
        if(!is.list(optimalParam)){
          stop("plotOptimalHeatMaps cannot overlay one matrix -
          Please Ensure that you have more than one matrix in a list")
        }
        over<-matrix(0,ncol=ncol(optimalParam[[1]]),nrow=nrow(optimalParam[[1]]))
        for(k in seq_along(optimalParam)){

            ## creating match idx vector
            buffer<-optimalParam[[k]]
            idx<-seq_along(as.vector(optimalParam[[k]]))


            # define top hits
            top<-head(idx,floor(length(idx)/10))

            # Top hits
            if(namevec[k] %in% c("geometricMean","MSEMean","ksMean","recallMean")){
                ord<-order(buffer,decreasing=F)
            } else{
                ord<-order(buffer,decreasing=T)
            }

            ##creating a ordered value matrix
            optimalMatrix<-matrix(match(idx,ord),ncol=ncol(optimalParam[[1]]), nrow=nrow(optimalParam[[1]]))

            ## Location of top hits in ordered value matrix
            topHits<-which(optimalMatrix<max(top),arr.ind=T)

            # Creating empty matrix
            mat<- matrix(0,ncol=ncol(optimalParam[[1]]),nrow=nrow(optimalParam[[1]]))

            ## Keep in mind that there are more Similarity methods
            ## This will pull it towards those optimal Parameters
            ## For better results balence it
            ## or only take two Parameters

            ## Overlaying top hits
            mat[topHits]<-1


            ## Adding top hits to matrix
            over<-over+mat

        }

        optimalParam$Overlay<-over
    }

    #Setting up some paramters
    if(class(optimalParam)!="list"){

        if(is.null(main)){
            mainTitle<-"Optimal Paramters"
        } else{
            mainTitle<-main
        }

        ylabs<-as.numeric(rownames(optimalParam))
        xlabs<-as.numeric(colnames(optimalParam))

        ifelse(!is.null(col),cols<-col,cols<-"#00979b")

        optimalParam<-list(optimalParam)
    } else {
        if(is.null(main) & length(main)>0){
            mainTitle<-names(optimalParam)
        } else{
            mainTitle<-names(optimalParam)
            mainTitle[seq_along(main)]<-main
        }
        ylabs<-as.numeric(rownames(optimalParam[[1]]))
        xlabs<-as.numeric(colnames(optimalParam[[1]]))
        ifelse(is.null(col),cols<-rainbow(length(optimalParam),s=0.7),cols<-col)
        if(length(cols)!=length(optimalParam)){
            cols<-rep(cols,ceiling(length(optimalParam)/length(cols)))
        }
    }

    ## plotting
    if(layout){
        layout(matrix(1:2,ncol=2,byrow=T), width = c(6,1),height = c(1,1))
    }

    for(i in seq_along(optimalParam)){
        #if(grepl("MSE",mainTitle[i])|grepl("geometric",mainTitle[i])|grepl("ks", mainTitle[i])){
            #colfunc<-colorRampPalette(c(cols[i],"white"))
        #}else{
            colfunc<-colorRampPalette(c("white",cols[i]))
      #  }

        Colors <- colfunc(20)
        legend_image<-as.raster(matrix(rev(Colors),ncol=1))
        par(mar=c(5.5,5.5,4.5, 0.5)+0.1)
        par(family="mono")

        graphics::image(1:length(xlabs),1:length(ylabs),t(optimalParam[[i]]),
            axes = FALSE, xlab=" ", ylab=" ",col=Colors)

        title(main=mainTitle[i],cex.main=1.8)
        title( ylab="Scaling Factor", line=3.5, cex.lab=1.2)
        title(xlab="Number of Bound Molecules",line=4.5, cex.lab=1.2)
        axis(1,at=seq_along(xlabs),labels=F)
        text(seq_along(xlabs),y =(-0.2), srt = 45, adj = 1,labels = xlabs, xpd = TRUE,cex=1.15)
        axis(LEFT <-2, at=1:length(ylabs), labels=ylabs,las= HORIZONTAL<-1,cex.axis=1.15)
        if(contour){
          contour(1:length(xlabs),1:length(ylabs), t(
          optimalParam[[i]]),nlevels=7, drawlabels=FALSE,
          add = TRUE, col = "black", lwd=1, labcex = 1.0)
        }

        # raster scacle
        par(mar=c(3,0.5,3.2,0.5))
        plot(c(0,2),c(0,1),type = 'n', axes = F,xlab = '', ylab = '')
        text(x=1.6, y =seq(0,1,l=5) , labels = round(seq(min(optimalParam[[i]]),max(optimalParam[[i]]),l=5),2),cex=0.95)
        rasterImage(legend_image, 0, 0, 1,1)
    }
}

##############################################
#############      S4 Methods    #############
##############################################



### initialize Genomic Profile by generating a PWM from a PFM
setMethod(".generatePWM","genomicProfilesInternal",
    function(object){
        if(object@noOfSites=="all"){
            object@noOfSites<-0
        }
        newPWM <- .computePWM(object@PFM,
            object@PWMpseudocount,
            object@BPFrequency,
            object@naturalLog,
            object@noOfSites)
        rownames(newPWM) <- c("A", "C", "G", "T")
        object@PWM <- newPWM
        return(object)
    }
)


setMethod(f="initialize",
    signature = "parameterOptions",
    definition = function(.Object,
        ploidy = .Object@ploidy,
        boundMolecules = .Object@boundMolecules,
        backgroundSignal = .Object@backgroundSignal,
        maxSignal = .Object@maxSignal,
        lociWidth = .Object@lociWidth,
        chipMean = .Object@chipMean,
        chipSd = .Object@chipSd,
        chipSmooth = .Object@chipSmooth,
        stepSize = .Object@stepSize,
        noiseFilter= .Object@noiseFilter,
        removeBackground = .Object@removeBackground,
        lambdaPWM=.Object@lambdaPWM,
        PWMpseudocount=.Object@PWMpseudocount,
        naturalLog=.Object@naturalLog,
        noOfSites=.Object@noOfSites,
        PWMThreshold=.Object@PWMThreshold,
        strandRule=.Object@strandRule,
        whichstrand=.Object@whichstrand
        ){

        if(length(ploidy)>0){
            if(class(ploidy)=="numeric"){
        NewPloidy<-ploidy
        .Object@ploidy <- NewPloidy
        validObject(.Object)
        } else {
        stop("ploidy is not numeric")}}
        if(length(lambdaPWM)>0){
            if(class(lambdaPWM)=="numeric"){
        NewLambda<-lambdaPWM
        .Object@lambdaPWM<-NewLambda
        validObject(.Object)
        } else {
        stop("lambdaPWM is not numeric
        or a vector of numeric values")
        }}
        if(length(boundMolecules)>0){
            if(class(boundMolecules)=="numeric"){
        NewboundMolecules<-boundMolecules
        .Object@boundMolecules <- NewboundMolecules
        validObject(.Object)
        } else {
        stop("boundMolecules is not numeric")}}

        if(length(backgroundSignal)>0){
            if(class(backgroundSignal)=="numeric"){
        NewbackgroundSignal<-backgroundSignal
        .Object@backgroundSignal <- NewbackgroundSignal
        validObject(.Object)
        } else {
        stop("backgroundSignal is not numeric")}}

        if(length(maxSignal)>0){
            if(class(maxSignal)=="numeric"){
        NewmaxSignal<-maxSignal
        .Object@maxSignal <- NewmaxSignal
        validObject(.Object)
        } else {
        stop("maxSignal is not numeric")}}

        if(length(lociWidth)>0){
            if(class(lociWidth)=="numeric"){
        NewmlociWidth<-lociWidth
        .Object@lociWidth <- NewmlociWidth
        validObject(.Object)
        } else {
        stop("maxSignal is not numeric")}}

        if(length(chipMean)>0){
            if(class(chipMean)=="numeric"){
        NewchipMean<-chipMean
        .Object@chipMean <- NewchipMean
        validObject(.Object)
        } else {
        stop("chipMean is not numeric")}}

        if(length(chipSd)>0){
            if(class(chipSd)=="numeric"){
        NewchipSd<-chipSd
        .Object@chipSd <- NewchipSd
        validObject(.Object)
        } else {
        stop("chipSd is not numeric")}}

        if(length(chipSmooth)>0){
            if(class(chipSmooth)=="numeric"){
        NewchipSmooth<-chipSmooth
        .Object@chipSmooth <- NewchipSmooth
        validObject(.Object)
        }else{
        stop("chipSmooth is not numeric")
        }}
        if(length(stepSize)>0){
            if(class(stepSize)=="numeric"){
        NewstepSize<-stepSize
        .Object@stepSize <- NewstepSize
        validObject(.Object)
        } else {
        stop("stepSize is not numeric")}}

        if(length(removeBackground)>0){
            if(class(removeBackground)=="numeric"){
        NewremoveBackground<-removeBackground
        .Object@removeBackground <- NewremoveBackground
        validObject(.Object)
        } else {
        stop("removeBackground is not numeric")}}
        if(length(PWMpseudocount)>0){
            if(class(PWMpseudocount)=="numeric"){
        Newpseudocount<-PWMpseudocount
        .Object@PWMpseudocount<-Newpseudocount
        validObject(.Object)
        } else {
        stop("PWMpseudocount is not numeric")
        }}

        if(length(naturalLog)>0 & is.logical(naturalLog)){
        NewnaturalLog<-naturalLog
        .Object@naturalLog<-NewnaturalLog
        validObject(.Object)
        }
        if(length(noOfSites)>0){
            if(class(noOfSites)=="numeric"|class(noOfSites)=="character"){
        NewnoOfSites<-noOfSites
        .Object@noOfSites<-NewnoOfSites
        validObject(.Object)
        } else {
        stop("noOfSites is not numeric or 'all' - for all sites")
        }}
        if(length(PWMThreshold)>0){
            if(class(PWMThreshold)=="numeric"){
        NewPWMThreshold<-PWMThreshold
        .Object@PWMThreshold<-NewPWMThreshold
        validObject(.Object)
        } else {
        stop("PWMThreshold is not numeric")
        }}

        if(length(strandRule)>0){
            if(class(strandRule)=="character"){
        NewStrandRule<-strandRule
        .Object@strandRule<-NewStrandRule
        validObject(.Object)
        } else {
        stop("strandRule is not a character string of one
        of the following: max, mean or sum")
        }}

        if(length(whichstrand)>0){
            if(class(whichstrand)=="character"){
        NewStrand<-whichstrand
        .Object@whichstrand<-NewStrand
        validObject(.Object)
        } else {
        stop("whichstrand is not a character string of one of the
        following: +-, -+ , - or +")
        }}
        if(length(noiseFilter)>0){
            if(class(noiseFilter)=="character"){

        .Object@noiseFilter<-noiseFilter
        validObject(.Object)
        } else {
        stop("noiseFilter is not a character string of one of the
        following: zero, mean, median or sigmoid")
        }}

    return(.Object)
    }
)



setMethod(f="initialize",
    signature = "ChIPScore",
    definition = function(.Object,
        scores = .Object@scores,
        loci = .Object@loci,
        maxSignal= .Object@maxSignal,
        backgroundSignal=.Object@backgroundSignal,
        lociWidth=.Object@lociWidth,
        paramTag=.Object@paramTag){

        if(length(scores)>0){

            .Object@scores <- scores

            validObject(.Object)
        }

        if(length(loci)>0){

            .Object@loci <- loci
            validObject(.Object)
        }
        if(length(maxSignal)>0){

            .Object@maxSignal <- maxSignal
            validObject(.Object)
        }
        if(length(backgroundSignal)>0){

            .Object@backgroundSignal <- backgroundSignal
            validObject(.Object)
        }
        if(length(paramTag)>0){

            .Object@paramTag <- paramTag
            validObject(.Object)
        }
        if(length(lociWidth)>0){

            .Object@lociWidth <- lociWidth
            validObject(.Object)
        }
        return(.Object)
    }
)

setMethod(f="initialize",
  signature = "genomicProfiles",
    definition = function(.Object,
    ploidy = .Object@ploidy,
    boundMolecules = .Object@boundMolecules,
    backgroundSignal = .Object@backgroundSignal,
    maxSignal = .Object@maxSignal,
    lociWidth = .Object@lociWidth,
    chipMean = .Object@chipMean,
    chipSd = .Object@chipSd,
    chipSmooth = .Object@chipSmooth,
    stepSize = .Object@stepSize,
    noiseFilter= .Object@noiseFilter,
    removeBackground = .Object@removeBackground,
    lambdaPWM=.Object@lambdaPWM,
    PWMpseudocount=.Object@PWMpseudocount,
    naturalLog=.Object@naturalLog,
    noOfSites=.Object@noOfSites,
    PWMThreshold=.Object@PWMThreshold,
    strandRule=.Object@strandRule,
    whichstrand=.Object@whichstrand,
    paramTags=.Object@paramTags,
    PFM=.Object@PFM,
    PWM=.Object@PWM,
    PFMFormat=.Object@PFMFormat,
    BPFrequency=.Object@BPFrequency,
    minPWMScore=.Object@minPWMScore,
    maxPWMScore=.Object@maxPWMScore,
    profiles = .Object@profiles,
    DNASequenceLength= .Object@DNASequenceLength,
    averageExpPWMScore=.Object@averageExpPWMScore,
    ZeroBackground=.Object@ZeroBackground,
    drop=.Object@drop,
    tags=.Object@tags){
      if(class(BPFrequency) != "vector" &
      (class(BPFrequency) == "BSgenome" |
      class(BPFrequency) == "DNAStringSet")){
      BPFrequency<-.computeBPFrequency(BPFrequency)
      .Object@BPFrequency<-BPFrequency
      } else if(!is.null(BPFrequency) & class(BPFrequency)=="vector") {
      NewBPFrequency<-BPFrequency
      .Object@BPFrequency<-NewBPFrequency
      validObject(.Object)
      }

      if(length(PFMFormat)>0){
          if(class(PFMFormat)=="character"){
      NewPFMFormat<-PFMFormat
      .Object@PFMFormat<-NewPFMFormat
      validObject(.Object)
      } else {
      stop("PFMFormat is not a character string of one of the following:
      raw, transfac, JASPAR, sequences or matrix")
      }}

      if(length(minPWMScore)>0){

      .Object@minPWMScore<-minPWMScore
      validObject(.Object)
      }

      if(length(maxPWMScore)>0){

      .Object@maxPWMScore<-maxPWMScore
      validObject(.Object)
      }
      if(!is.null(PFM)){
          if(class(PFM)!="matrix"){
      PFMmatrix<-.parsePFM(PFM,PFMFormat)
      .Object@PFM<-PFMmatrix
      validObject(.Object)
      } else {
      PFMMatrix<-PFM
      .Object@PFM<-PFMMatrix
      validObject(.Object)
      }}

      if(length(PFM)<1 & length(PWM)>0){
      NewPWM<-PositionWeightMatrix
      .Object@PWM<-NewPWM
      validObject(.Object)
      }
      if(length(PFM)>0 & length(PWM)<1){
      New<-.generatePWM(.Object)
      New<-New@PWM
      .Object@PWM<-New
      validObject(.Object)
      }
      if(length(profiles)>0){

      .Object@profiles<-profiles
      validObject(.Object)
      }

      if(length(DNASequenceLength)>0){

      .Object@DNASequenceLength<-DNASequenceLength
      validObject(.Object)
      }

      if(length(averageExpPWMScore)>0){

      .Object@averageExpPWMScore<-averageExpPWMScore
      validObject(.Object)
      }

      if(length(drop)>0){

      .Object@drop<-drop
      validObject(.Object)
      }

      if(length(tags)>0){

      .Object@tags<-tags
      validObject(.Object)
      }
      if(length(ploidy)>0){
          if(class(ploidy)=="numeric"){
      NewPloidy<-ploidy
      .Object@ploidy <- NewPloidy
      validObject(.Object)
      } else {
      stop("ploidy is not numeric")}}
      if(length(lambdaPWM)>0){
          if(class(lambdaPWM)=="numeric"){
      NewLambda<-lambdaPWM
      .Object@lambdaPWM<-NewLambda
      validObject(.Object)
      } else {
      stop("lambdaPWM is not numeric
      or a vector of numeric values")
      }}
      if(length(boundMolecules)>0){
          if(class(boundMolecules)=="numeric"){
      NewboundMolecules<-boundMolecules
      .Object@boundMolecules <- NewboundMolecules
      validObject(.Object)
      } else {
      stop("boundMolecules is not numeric")}}

      if(length(backgroundSignal)>0){
          if(class(backgroundSignal)=="numeric"){
      NewbackgroundSignal<-backgroundSignal
      .Object@backgroundSignal <- NewbackgroundSignal
      validObject(.Object)
      } else {
      stop("backgroundSignal is not numeric")}}

      if(length(maxSignal)>0){
          if(class(maxSignal)=="numeric"){
      NewmaxSignal<-maxSignal
      .Object@maxSignal <- NewmaxSignal
      validObject(.Object)
      } else {
      stop("maxSignal is not numeric")}}

      if(length(lociWidth)>0){
          if(class(lociWidth)=="numeric"){
      NewmlociWidth<-lociWidth
      .Object@lociWidth <- NewmlociWidth
      validObject(.Object)
      } else {
      stop("maxSignal is not numeric")}}

      if(length(chipMean)>0){
          if(class(chipMean)=="numeric"){
      NewchipMean<-chipMean
      .Object@chipMean <- NewchipMean
      validObject(.Object)
      } else {
      stop("chipMean is not numeric")}}

      if(length(chipSd)>0){
          if(class(chipSd)=="numeric"){
      NewchipSd<-chipSd
      .Object@chipSd <- NewchipSd
      validObject(.Object)
      } else {
      stop("chipSd is not numeric")}}

      if(length(chipSmooth)>0){
          if(class(chipSmooth)=="numeric"){
      NewchipSmooth<-chipSmooth
      .Object@chipSmooth <- NewchipSmooth
      validObject(.Object)
      }else{
      stop("chipSmooth is not numeric")
      }}
      if(length(stepSize)>0){
          if(class(stepSize)=="numeric"){
      NewstepSize<-stepSize
      .Object@stepSize <- NewstepSize
      validObject(.Object)
      } else {
      stop("stepSize is not numeric")}}

      if(length(removeBackground)>0){
          if(class(removeBackground)=="numeric"){
      NewremoveBackground<-removeBackground
      .Object@removeBackground <- NewremoveBackground
      validObject(.Object)
      } else {
      stop("removeBackground is not numeric")}}
      if(length(PWMpseudocount)>0){
          if(class(PWMpseudocount)=="numeric"){
      Newpseudocount<-PWMpseudocount
      .Object@PWMpseudocount<-Newpseudocount
      validObject(.Object)
      } else {
      stop("PWMpseudocount is not numeric")
      }}

      if(length(naturalLog)>0 & is.logical(naturalLog)){
      NewnaturalLog<-naturalLog
      .Object@naturalLog<-NewnaturalLog
      validObject(.Object)
      }
      if(length(noOfSites)>0){
          if(class(noOfSites)=="numeric"|class(noOfSites)=="character"){
      NewnoOfSites<-noOfSites
      .Object@noOfSites<-NewnoOfSites
      validObject(.Object)
      } else {
      stop("noOfSites is not numeric or 'all' - for all sites")
      }}
      if(length(PWMThreshold)>0){
          if(class(PWMThreshold)=="numeric"){
      NewPWMThreshold<-PWMThreshold
      .Object@PWMThreshold<-NewPWMThreshold
      validObject(.Object)
      } else {
      stop("PWMThreshold is not numeric")
      }}

      if(length(strandRule)>0){
          if(class(strandRule)=="character"){
      NewStrandRule<-strandRule
      .Object@strandRule<-NewStrandRule
      validObject(.Object)
      } else {
      stop("strandRule is not a character string of one
      of the following: max, mean or sum")
      }}

      if(length(whichstrand)>0){
          if(class(whichstrand)=="character"){
      NewStrand<-whichstrand
      .Object@whichstrand<-NewStrand
      validObject(.Object)
      } else {
      stop("whichstrand is not a character string of one of the
      following: +-, -+ , - or +")
      }}
      if(length(noiseFilter)>0){
          if(class(noiseFilter)=="character"){

      .Object@noiseFilter<-noiseFilter
      validObject(.Object)
      } else {
      stop("noiseFilter is not a character string of one of the
      following: zero, mean, median or sigmoid")
      }}

  return(.Object)


    }
)

#######################################################################
# Functions
#######################################################################


computeChIPProfile <- function(genomicProfiles,loci=NULL,
    parameterOptions = NULL,
    norm = TRUE, method = c("moving_kernel","truncated_kernel","exact"),
    peakSignificantThreshold = NULL,cores=1, verbose = TRUE){

    # Validity checking
    if(!is.null(loci)){
        if(class(loci)=="ChIPScore"){
          chipMean(genomicProfiles)<-chipMean(loci)
          chipSd(genomicProfiles)<-chipSd(loci)
          chipSmooth(genomicProfiles)<-chipSmooth(loci)
          maxSignal(genomicProfiles)<-maxSignal(loci)
          backgroundSignal(genomicProfiles)<-backgroundSignal(loci)
          loci<-loci(loci)


        } else if(class(loci)=="Granges") {
           loci <-loci
        }
    } else {
        stop(paste("Please provide a set of loci to be analysed \n",
                   "If you have used processingChIP, you can parse that object \n",
                   "Otherwise, you can provide your own loci as a GRanges. "))
    }
    if(!.is.genomicProfiles(genomicProfiles)){
    stop(paste0(deparse(substitute(genomicProfiles)),
    " is not a Genomic Profiles Object"))
    }
    if(!.is.parameterOptions(parameterOptions) &
    !is.null(parameterOptions)){
    stop(paste0(deparse(substitute(parameterOptions)),
    " is not an parameterOptions Object."))
    }

    if(!is.null(parameterOptions)){
        genomicProfiles<-.updateGenomicProfiles(genomicProfiles,parameterOptions)
    }

    # Extraction of Ocuupancy and associated values
    Occup <- profiles(genomicProfiles)
    ZeroBackground <- .ZeroBackground(genomicProfiles)

    #Extraction of Occupancy Profile Parameters
    stepSize <- stepSize(genomicProfiles)
    backgroundSignal <- backgroundSignal(genomicProfiles)
    removeBackground <- removeBackground(genomicProfiles)
    chipMean <- chipMean(genomicProfiles)
    chipSd <- chipSd(genomicProfiles)
    dropLoci<-drop(genomicProfiles)
    if(!is.null(chipSmooth(genomicProfiles))){
        chipSmooth <- chipSmooth(genomicProfiles)
    } else {
        chipSmooth <- NULL
    }
    maxSignal <- maxSignal(genomicProfiles)


    # Extracting names of sequences with no accesible DNA

   if(length(grep("No loci dropped",dropLoci))==0){
      widthDisplay<-round(options()$width*0.5)
      cat("No Accessible DNA in: ",paste(rep(" ",
         times=(widthDisplay-nchar("StepSize: ")-nchar(dropLoci[1]))),collapse=''),
         dropLoci,"\n","\n")
    }

    # loci fragmentation
    #Spliting loci for Chip PRofile computing
    if(!is.null(loci) & is.null(names(loci))){
			  names(loci)<-paste0(seqnames(loci),":",
				start(ranges(loci)),"..",end(ranges(loci)),sep="")
		}


    LocalSet <- split(loci, names(loci))
    LocalSet <-LocalSet[match(names(Occup[[1]]),names(LocalSet))]


    #Computing Chip like profile
    if(verbose){
        message("Computing ChIP Profile \n")
    }

    SplitGRList <-parallel::mclapply(LocalSet,.internalChIPLociSplit,stepSize,mc.cores=cores)

    names(SplitGRList) <- names(LocalSet)


    ##method set
    if(length(Occup)>length(Occup[[1]])){
        OccupancyVals <- parallel::mclapply(Occup,.internalChIPOccupValsParam,mc.cores=cores)

        profile <- parallel::mcmapply(.internalChIPParam,Occup=Occup,
        OccupancyVals=OccupancyVals,
        MoreArgs=list(SplitGRList=SplitGRList,LocalSet=LocalSet,
        chipMean=chipMean,chipSd=chipSd,
        stepSize=stepSize,norm=norm,chipSmooth=chipSmooth,
        peakSignificantThreshold=peakSignificantThreshold,
        ZeroBackground=ZeroBackground,
        removeBackground=removeBackground,method=method),
        mc.cores=cores,SIMPLIFY=FALSE)
    } else {
    profile <- vector("list", length(Occup))
    OccupancyVals <- vector("list", length(Occup))
    for(i in seq_along(Occup)){
        OccupancyVals[[i]]<- parallel::mclapply(Occup[[i]],.internalChIPOccupValsLoci,mc.cores=cores)

        profile[[i]]<-SplitGRList
        profile[[i]] <- parallel::mcmapply(.internalChIPLoci,
        profile=profile[[i]],Occup=Occup[[i]],LocalSet=LocalSet,
        OccupancyVals=OccupancyVals[[i]],
        MoreArgs=list(chipMean=chipMean,chipSd=chipSd,
        stepSize=stepSize,norm=norm,chipSmooth=chipSmooth,
        peakSignificantThreshold=peakSignificantThreshold,
        ZeroBackground=ZeroBackground,
        removeBackground=removeBackground,method=method), mc.cores=cores)

    }
    }
    ### GRlist output

    profile <-lapply(profile,GRangesList)
    names(profile)<-names(Occup)

    .profiles(genomicProfiles)<-profile
    .tags(genomicProfiles)<-"ChIPProfile"
    return(genomicProfiles)

}

################################################################################
##################### Compute genome Wide scores and metrics ###################
################################################################################


computeGenomeWideScores <- function(genomicProfiles,DNASequenceSet,
                                   chromatinState=NULL,parameterOptions=NULL,
                                   cores=1, verbose=TRUE)
  {
    # Validity Checking for each argument
    if(class(DNASequenceSet) != "BSgenome" &
    class(DNASequenceSet) != "DNAStringSet"){
    stop(paste0(deparse(substitute(DNASequenceSet)),
    " is not a BSgenome Object or a DNAStringSet"))
    }

    if(class(DNASequenceSet) == "BSgenome"){
    DNASequenceSet<-getSeq(DNASequenceSet)
    }

    if(!.is.genomicProfiles(genomicProfiles)){
    stop(paste0(deparse(substitute(genomicProfiles)),
    " is not a Genomic Profile Paramter object.
    Please set Genomic Profile Parameters."))
    }

    if(class(chromatinState) != "GRanges" & !is.null(chromatinState)){
    stop(paste0(chromatinState," must be a GRanges Object."))
    }

    if(!is.null(parameterOptions)){
        genomicProfiles<-.updateGenomicProfiles(genomicProfiles,parameterOptions)
    }
    # Extracting genomic Profile Parameters
    lambda <- lambdaPWM(genomicProfiles)
    PWMMat <- PositionWeightMatrix(genomicProfiles)
    strand <- whichstrand(genomicProfiles)
    strandRule <- strandRule(genomicProfiles)
    # Extracting DNA Accessibility in parallel (still dont know why it chrashes with hg19)
    if(!is.null(chromatinState)){
        ## Factor correction  and ID match

        DNASequenceSet<-DNASequenceSet[which(names(DNASequenceSet) %in% as.character(seqnames(chromatinState)))]
        ## Split by Chromosome
        DNA<-split(DNASequenceSet,names(DNASequenceSet))
        Access<-split(chromatinState, seqnames(chromatinState))

        ## Matching seqlevels
        Access<- Access[match(names(DNA), names(Access))]


        ## parallel Intersect for large genomes
        DNASequenceSet<-parallel::mcmapply(.internalDNASequenceFromAccess,DNA=DNA,Access=Access,mc.cores=cores)


        # Rebuilding DNASequenceSet
        if(length(DNASequenceSet)>1){
            buffer<-DNASequenceSet[[1]]
            for(sub in 2:length(DNASequenceSet)){
                buffer<-c(buffer,DNASequenceSet[[sub]])
            }
            DNASequenceSet<-buffer
        } else {
            DNASequenceSet<-DNASequenceSet[[1]]
        }

        DNASequenceSet <- DNASequenceSet[which(width(DNASequenceSet) > ncol(PWMMat))]

    }

    # Computing DNA sequance Length
    DNASequenceLength <- sum(as.numeric(width(DNASequenceSet)))

    # Progress Messages when required.
    if(verbose){
    message("Extracting genome wide scores \n")
        if(!is.null(chromatinState)){
        if(strand == "+") message("Considering Chromatin State ~ positive strand \n")
        if(strand == "-") message("Considering Chromatin State ~ negative strand \n")
        if(strand == "+-" | strand == "-+"){
        message("Considering Chromatin State ~ Both strands \n")
        }
      } else {
        if(strand == "+") message("Whole Genome ~ positive strand \n")
        if(strand == "-") message("Whole Genome ~ negative strand \n")
        if(strand == "+-" | strand == "-+"){
        message("Whole Genome ~ Both strands \n")
        }
      }
    }


    ### Custom DNSStringSet Split based on number of cores

    buffer <- .splitRanges(DNASequenceSet,cores)
    DNASequenceSet<-buffer$rangeSet
    cores<-buffer$cores

    ### Computing PWM Score parallel
    DNASequenceScoreSetTotalAcces <- parallel::mclapply(DNASequenceSet,
      .scoreDNAStringSet,PWM=PWMMat,
       strand=strand,strandRule=strandRule,mc.cores=cores)


    DNASequenceScoreSetTotalAcces <- unlist(lapply(DNASequenceScoreSetTotalAcces,"[[",1))

    #Message printing when required
    if(verbose){
    message("Computing Mean waiting time \n")
    }

    # Compute mean waiting time, max PWM score and min PWM score

    averageExpPWMScore <- rep(0,length(lambda))
    sumExpPWMScoreLocal <- rep(0,length(lambda))

    ## This is also a limiting part. parallel as well?
    ## Clean your parallel R script and comment it

    for(i in seq_along(lambda)){
        sumExpPWMScoreLocal[i] <- sum(exp(DNASequenceScoreSetTotalAcces * (1/lambda[i])))
        averageExpPWMScore[i] <- sumExpPWMScoreLocal[i]/DNASequenceLength
    }

    maxPWMScore <- max(DNASequenceScoreSetTotalAcces)
    minPWMScore <- min(DNASequenceScoreSetTotalAcces)

    #Updating GenomicProfileParameters object
    .maxPWMScore(genomicProfiles)<-maxPWMScore
    .minPWMScore(genomicProfiles)<-minPWMScore
    .averageExpPWMScore(genomicProfiles)<-averageExpPWMScore
    .DNASequenceLength(genomicProfiles)<-DNASequenceLength
    if(!is.null(chromatinState)){
    .tags(genomicProfiles)<-"genomeWideCS"
    .paramTag(genomicProfiles)<-"genomeWide"
  } else{
    .tags(genomicProfiles)<-"genomeWide"
    .paramTag(genomicProfiles)<-"genomeWide"
  }
    #genomicProfiles <-.maxPWMScoreReplace(genomicProfileParameters,
      #  maxPWMScore)
    #genomicProfiles <-.minPWMScoreReplace(genomicProfileParameters,
        #minPWMScore)
    #genomicProfiles <-.averageExpPWMScoreReplace(
        #genomicProfileParameters,averageExpPWMScore)
  #  DNASequenceLength(genomicProfileParameters) <- DNASequenceLength

    return(genomicProfiles)

}

####################################
### Paralelle internal functions ###
####################################

### General Functions ###

# splitting by number of cores
.splitRanges <- function(ranges,cores){

    if(cores>1 & cores<length(ranges)){
        SplitRanges <- floor(seq(1,length(ranges),length.out=cores+1))
        rangeSet<-vector("list",(cores))
        start <- SplitRanges[1:(length(SplitRanges)-1)]
        end <- c(SplitRanges[2:(length(SplitRanges)-1)]-1,SplitRanges[length(SplitRanges)])

        for(i in seq_len(cores)){
            rangeSet[[i]]<-ranges[start[i]:end[i]]
        }

  } else if(cores>1 & cores==length(ranges)) {
    idx<-seq_along(ranges)
    rangeSet<-vector("list",cores)
    for(i in seq_len(cores)){
        rangeSet[[i]]<-ranges[idx[i]]
    }
  } else if(cores>1 & cores>length(ranges)){
    idx<-seq_along(ranges)
    rangeSet<-vector("list",length(ranges))
    for(i in seq_along(ranges)){
        rangeSet[[i]]<-ranges[idx[i]]
    }
    cores<-length(ranges)


  }  else{
    rangeSet <-list(ranges)
  }
    return(list(rangeSet=rangeSet,cores=cores))
}


### processingChIP function ###

# extracting score from ChIP profiles at loci

.extractionChIP <- function(profile,loci,noiseFilter="sigmoid"){

    # build dem profiles
    # Extract the score
    idx<-seq_along(loci)
    localProfiles <- lapply(idx,.scoreReplace,loci, profile)

    ## Extracting noise filter threshold and assinging weights
    if(grepl("zero",noiseFilter,ignore.case=TRUE)){
        Background<-0
    }

	  if(grepl("mean",noiseFilter,ignore.case=TRUE)){
		    Background<-mean(sapply(localProfiles,mean),na.rm=T)
		}

		if(grepl("median",noiseFilter,ignore.case=TRUE)){
			  Background<-median(sapply(localProfiles,median),na.rm=T)
		}

		if(grepl("sigmoid",noiseFilter,ignore.case=TRUE)){

      Background<-0
			midpoint<-mean(sapply(localProfiles,quantile,0.95),na.rm=T)
			localProfiles<-lapply(localProfiles,.sigmoidWeight,midpoint=midpoint)

		}
    ## Actually applying the noise filter
    localProfiles<-lapply(localProfiles, function(x){x[x < Background]<-0;return(x)})
    if(is.null(names(loci))){
    names(localProfiles)<-paste0(as.character(seqnames(loci)),
                                 ":",start(loci),"..",end(loci))
    } else {
       names(localProfiles)<-names(loci)
    }
    return(localProfiles)
}
##### computePWMScore #####
#### Scores Above threshold

.internalPWMScoreExt<-function(loci,DNASequenceSet,chromatinState,PWM,PWMThresholdLocal,
    minPWMScore,maxPWMScore,strand,strandRule){

    ## Building storage lists
    BufferSequence <- vector("list", length(loci))

    ## Naming if names = NULL
    if(is.null(names(loci))){
        names(loci)<-paste0(as.character(seqnames(loci)),":",start(loci),"..",end(loci))
    }

    for(i in seq_along(loci)){

        ## ID matching
        localDNASequenceSet <- DNASequenceSet[unique(!is.na(match(as.character(seqnames(loci))[i],
            names(DNASequenceSet))))]

        ## Extracting Sequence
        #BufferSequence[[i]]<-.internalDNASequenceFromAccess(localDNASequenceSet,loci[i],PWM)
        BufferSequence[[i]] <- DNAStringSet(localDNASequenceSet[[
            which(names(localDNASequenceSet)==(as.character(seqnames(
                loci[i]))))]],start = start(loci[i]),end = end(loci[i]))

        ## Scoring Sequence with PWM
        BufferSequence[[i]] <- .scoreDNAStringSet(PWM, BufferSequence[[i]],
        strand=strand,strandRule=strandRule)
        ## Extracting Sites Above Threshold
        indexPWMThresholded <- .getIndexOfPWMThresholded(BufferSequence[[i]][[1]],PWMThresholdLocal)[[1]]

        ## Extracting strand Information for sites above threshold
        if(strand == "+-" | strand == "-+"){
            strandLocal <- rep("*", length(BufferSequence[[i]][[1]][[1]]))
            strandLocal[BufferSequence[[i]][[2]][[1]]] <- "+"
            strandLocal[BufferSequence[[i]][[3]][[1]]] <- "-"
        }
        if(strand == "+"){
            strandLocal <- rep("+",length(BufferSequence[[i]][[1]][[1]]))
        }
        if(strand == "-"){
            strandLocal <- rep("-",length(BufferSequence[[i]][[1]][[1]]))
        }

        ## Building GRanges from indexed PWMScore
        #if(length(indexPWMThresholded)>=1){
        GRLocal <- GRanges(seqnames = S4Vectors::Rle(unique(as.character(
            seqnames(loci[i]))),
                length(indexPWMThresholded)),
            ranges = IRanges::IRanges(start=(
                start(loci[i]) +
                indexPWMThresholded-1),
                end = (start(loci[i])+indexPWMThresholded-
                1 + ncol(PWM)-1)),
            strand = strandLocal[indexPWMThresholded],
            PWMScore=
            BufferSequence[[i]][[1]][[1]][indexPWMThresholded])

        names(GRLocal)<-rep(names(loci)[i],length(GRLocal))
        BufferSequence[[i]]<-GRLocal

        ## Intersection with DNA Accessibility
        if(!is.null(chromatinState)){
            AccessibleScore <- as.data.frame(findOverlaps(BufferSequence[[i]],chromatinState))


            BufferSequence[[i]]<-BufferSequence[[i]][AccessibleScore[,1]]

            BufferSequence[[i]]$DNAaffinity<-chromatinState$DNAaffinity[AccessibleScore[,2]]

        } else {
              BufferSequence[[i]]$DNAaffinity<-rep(1,length(BufferSequence[[i]]))
        }

    }
    names(BufferSequence)<-names(loci)
    return(BufferSequence)
}


####################################
#### Paralelle inner functions #####
####################################

##### computeChipProfile #####
### Looping over Loci###
.internalChIPLoci <- function(profile,Occup,LocalSet,OccupancyVals,chipMean=chipMean,chipSd=chipSd,
  stepSize=stepSize,norm=norm,chipSmooth=chipSmooth,peakSignificantThreshold=peakSignificantThreshold,ZeroBackground=ZeroBackground,removeBackground=removeBackground,method=method){
  #browser()

    stepIndex<-seq(from=1, to=width(LocalSet), by=stepSize)
    occupancyAbundanceChIPLocal<-rep(ZeroBackground,width(LocalSet))

    occupancyAbundanceChIPLocal[(start(Occup) - start(LocalSet) + 1)] <- OccupancyVals

    occupancyAbundanceChIPLocal[which(occupancyAbundanceChIPLocal <
        removeBackground)] <- 0

    if(any(method=="exact")){
        occupancyAbundanceChIPLocal <- .generateChIPProfile(
        occupancyAbundanceChIPLocal,chipMean,chipSd,
        chipSmooth,norm=norm, quick=FALSE,
        peakSignificantThreshold=peakSignificantThreshold)
    }else if(any(method=="truncated_kernel")){
        occupancyAbundanceChIPLocal <- .generateChIPProfile(
        occupancyAbundanceChIPLocal,chipMean,chipSd,
        chipSmooth,norm=norm, quick=TRUE,
        peakSignificantThreshold=peakSignificantThreshold)
    } else if(any(method=="moving_kernel")){
        occupancyAbundanceChIPLocal <- .generateChIPProfileRcpp(
        occupancyAbundanceChIPLocal, chipMean, chipSd, chipSmooth,
        norm = norm,
        peakSignificantThreshold=peakSignificantThreshold)
    }
    profile$ChIP<-occupancyAbundanceChIPLocal[stepIndex]
    return(profile)
}
##### computeChipProfile #####
### Looping over Parameters ###
.internalChIPParam <- function(SplitGRList,Occup,LocalSet,OccupancyVals,chipMean=chipMean,chipSd=chipSd,
  stepSize=stepSize,norm=norm,chipSmooth=chipSmooth,peakSignificantThreshold=peakSignificantThreshold,ZeroBackground=ZeroBackground,removeBackground=removeBackground,method=method){

  ## Honestly you could do this as an lapply as well
  ## No excuse PAtrick!
  ## yeah but time is my excuse


  for(j in seq_along(Occup)){

      stepIndex<-seq(from=1, to=width(LocalSet[[j]]), by=stepSize)
      occupancyAbundanceChIPLocal<-rep(
          ZeroBackground,width(LocalSet[[j]]))
      occupancyAbundanceChIPLocal[(start(Occup[[j]]) -
          start(LocalSet[[j]]) + 1)] <- OccupancyVals[[j]]
      occupancyAbundanceChIPLocal[which(occupancyAbundanceChIPLocal <
          removeBackground)] <- 0
      if(any(method=="exact")){
      occupancyAbundanceChIPLocal <- .generateChIPProfile(
          occupancyAbundanceChIPLocal,chipMean,chipSd,
          chipSmooth,norm=norm, quick=FALSE,
          peakSignificantThreshold=peakSignificantThreshold)
      }else if(any(method=="truncated_kernel")){
      occupancyAbundanceChIPLocal <- .generateChIPProfile(
          occupancyAbundanceChIPLocal,chipMean,chipSd,
          chipSmooth,norm=norm, quick=TRUE,
          peakSignificantThreshold=peakSignificantThreshold)
      } else if(any(method=="moving_kernel")){
      occupancyAbundanceChIPLocal <- .generateChIPProfileRcpp(
          occupancyAbundanceChIPLocal, chipMean, chipSd, chipSmooth,
          norm = norm,
          peakSignificantThreshold=peakSignificantThreshold)
      }
      SplitGRList[[j]]$ChIP<-occupancyAbundanceChIPLocal[stepIndex]

  }

  return(SplitGRList)
}

##### computeChipProfile #####
### Split setSequence for parallel processing in computeChipProfile
.internalChIPLociSplit<- function(LocalSet,stepSize){

  stepIndex <- seq(from=1, to=width(LocalSet), by=stepSize)
  SplitSeq <- GRanges(seqnames=S4Vectors::Rle(as.character(
      seqnames(LocalSet)),
      length(stepIndex)),
      ranges = IRanges::IRanges(start = start(LocalSet)+
          stepIndex-1,end =start(LocalSet)+stepIndex-1+(stepSize-1)),
      strand = "*", ChIP=rep(0,length(stepIndex)))

  names(SplitSeq) <- rep(names(LocalSet), length(SplitSeq))
  return(SplitSeq)
}

##### computeChipProfile #####
### Extracting Occupancy in parallel computeChipProfile if using Parameters
.internalChIPOccupValsParam <- function(Occup){
    OccupVals <- lapply(Occup, function(x){
        x<-x$Occupancy})
    return(OccupVals)
}

##### computeChipProfile #####
### Extracting Occupancy in parallel computeChipProfile if using Loci
.internalChIPOccupValsLoci <- function(Occup){
    OccupVals <- Occup$Occupancy
    return(OccupVals)
}









##### computeGenomeWidePWMScore #####
## DNASequenceSet subset from Access
.internalDNASequenceFromAccess<-function(DNA,Access){

    ## Drop unneccesary levels
    ## surprise surprise it was a factor problem
    drop<-seqlevels(Access)[which(!seqlevels(Access) %in% seqnames(Access))]
    Access<-dropSeqlevels(Access,drop)


    ## Extract DNASequenceSet with respect to Accessibility
    sub<-getSeq(DNA,Access)
    names(sub)<-as.character(seqnames(Access))


    return(sub)
}



#### Accuracy Estimate #####
.intMSE<-function(gp,chip){
     mse <- sum((1/length(gp))*(gp-chip)^2)
     return(mse)
}

.GoFCheck<-function(gp,chip){
    gpsd<-sd(gp,na.rm=TRUE)==0
    chipsd<-sd(chip,na.rm=TRUE)==0
    gp[which(is.na(gp))]<-0
    chip[which(is.na(chip))]<-0
    return(list("zeroCheck"=c(gpsd,chipsd),"predicted"=gp,"validation"=chip))
}

.GoFPred<-function(GoF,method="all",step=10){
    localGoF<-lapply(GoF,function(x,method,step){
                     return(.methodSwitchGoF(x$prediction,x$validation,method,step=step))
    },method=method,step=step)
    return(localGoF)
}

.GoFLoci <-function(GoF,method="all",step=10,cores=1){
  localGoF<-parallel::mclapply(GoF,function(x,method,step){
                   return(.methodSwitchGoF(x$prediction,x$validation,method,step))
  },method=method,step=step,mc.cores=cores)
  return(localGoF)
}

.methodSwitchGoF <- function(gp,chip,method,step){

     if(any(grepl(method, c("recall","precesion","fscore","MCC","Accuracy","AUC"),ignore.case=T))){
        method<-"all"
     }
     if(grepl("pearson", method)){
         check <- .GoFCheck(gp,chip)
         if(length(which(check$zeroCheck==FALSE))>0){
           local<-c(0,.intMSE(gp,chip))
         }else{
           local<-c("pearson"=cor(check$predicted,check$validation,method="pearson"),"MSE"=.intMSE(check$predicted,check$validation))
         }

     } else if(grepl("spearman",method)){

       check <- .GoFCheck(gp,chip)
       if(length(which(check$zeroCheck==FALSE))>0){
         local<-c(0,.intMSE(gp,chip))
       }else{
         local<-c("spearman"=cor(check$predicted,check$validation,method="spearman"),"MSE"=.intMSE(check$predicted,check$validation))
       }
     } else if(grepl("kendall",method)){
       check <- .GoFCheck(gp,chip)
       if(length(which(check$zeroCheck==FALSE))>0){
         local<-c(0,.intMSE(gp,chip))
       }else{
         local<-c("kendall"=cor(check$predicted,check$validation,method="kendall"),"MSE"=.intMSE(check$predicted,check$validation))
       }
     } else if(grepl("ks",method)){
       check <- .GoFCheck(gp,chip)
         local<-c("K-S"=ks.test(check$predicted,check$validation)[[1]],"MSE"=.intMSE(check$predicted,check$validation))
     } else if(grepl("binary",method)){
       check <- .GoFCheck(gp,chip)
         local <-c(.peakExtractionFScore(check$predicted,check$validation),"MSE"=.intMSE(check$predicted,check$validation))
         ## need to check what this goinmg to return
     } else if(grepl("geometric",method)){
         check <- .GoFCheck(gp,chip)
         local<-c("geometric"=.geometricRatio(check$predicted,check$validation,step),"MSE"=.intMSE(check$predicted,check$validation))
     } else if(grepl("all",method)){
          check <- .GoFCheck(gp,chip)

          local <- c(.allMetrics(check$predicted,check$validation,step),"MSE"=.intMSE(check$predicted,check$validation))
     } else if(grepl("MSE",method)){
          check <- .GoFCheck(gp,chip)
          local<-c("MSE"=.intMSE(check$predicted,check$validation))
     }else{
        stop("Make sure that your goodness of fit method is one the available ones \n")
     }
     return(local)
}

# Cleaner plotting function for occupancy profiles. 

## Plotting occupency main function 

plotOccupancyProfile <- function(predictedProfile,
    ChIPScore = NULL,
    chromatinState = NULL,
    occupancy = NULL,
    goodnessOfFit = NULL,
    PWM = FALSE,
    geneRef = NULL,
    addLegend = TRUE,
    ...){
    ## First we check that all objects contain what they need to contain 
    ### handling paramter checks and building up object for plotting
    buffer<- .what.is.predictedProfile(predictedProfile)
    lociLocal<-buffer$loci
    predictedProfileLocal<-buffer$predictedProfile
    stepSize<-buffer$stepSize
    .cleanUpAfterYourself(buffer)

    ## Extracting Chromosome information
    chromosome <- as.character(seqnames(lociLocal))
    startPoint <- start(lociLocal)
    #ranges <- ranges(lociLocal)
    endPoint <- end(lociLocal)
    

    ## Exrtracting Occupancy if present 
    if(!is.null(occupancy)){
        occupancyLocal<-.what.is.occupancy(occupancy)
        occup <- TRUE
    } else {
        occup <- FALSE
    }
    
    ## Extracting ChIPscore if present 
    if(!is.null(ChIPScore)){
        ChIPScoreLocal <- .what.is.ChIPScore(ChIPScore)
        ChIPScoreLocal <- rep(ChIPScoreLocal,
            length(predictedProfileLocal)/length(ChIPScoreLocal))
        chip <- TRUE
    } else {
        chip <- FALSE
    }
    ## Extrating GoF score if present 
    if(!is.null(goodnessOfFit)){
        goodnessOfFitLocal<-.what.is.goodnessOfFit(goodnessOfFit)
        gof <- TRUE
    } else {
        gof <- FALSE
    }

    ## Extracting chromatin states if present 
    if(!is.null(chromatinState)){
        chromaState <- .what.is.chromatinState(chromatinState,lociLocal)
        states <- sort(unique(unlist(sapply(chromaState,function(x){return(x$stateID)}))))
        cs <- TRUE
    } else {
        cs <- FALSE
    }

    ## Extracting geneRef if present 
    if(!is.null(geneRef)){
        genes <- .what.is.geneRef(geneRef,lociLocal)
        types <- unique(unlist(sapply(genes,function(x){return(x$type)})))
        gr <- TRUE
    } else {
        gr <- FALSE
    }

    # Get elipsis arguments 
    graphical <- list(...)
    ### Looping over profiles 
    for(i in seq_along(predictedProfileLocal)){
        # Get local graphical paramters 
        param <- .dispatchGraphical(graphical,
            xlim = c(startPoint[i],endPoint[i]),
            chr = chromosome[i],
            cs = cs,
            geneRef = gr,
            occupancy = occup,
            gof = gof,
            legend = addLegend)
        # Extracting data to be plotted 
        stepIndex <- seq(1, width(lociLocal[i]),by=stepSize)
        localPosition<-seq(start(lociLocal[i]), end(lociLocal[i]),by=stepSize)
        localPosition<-c(localPosition[1]-1,localPosition,localPosition[length(localPosition)]+1)
        localPredcitedPropfile <- predictedProfileLocal[[i]]
        localPredcitedPropfile <- c(0,localPredcitedPropfile,0)

        ## Plot empty window 
        .drawBackground(param)

         ## Adding ChIPscore 
        if(chip){
            chipProfile<-ChIPScoreLocal[[i]]
            localchipProfile <- c(0,chipProfile[stepIndex],0)
            .drawChIP(localPosition,localchipProfile,param)
        }
        ## Adding Occupancy 
        if(occup){
            .drawOccup(occupancyLocal[[i]],param,PWM)
        }
        ## Adding Predicted 
        .drawPrediction(localPosition,localPredcitedPropfile,param)

         ## Adding chromatin states 
        if(cs){
            chroma <- .prepCS(chromaState[[i]],states,param)
            .drawCS(chroma)
        }

        ## Adding gene reference 
        if(gr){
            genelist <- .prepGR(genes[[i]],types,param)
            .drawGeneRef(genelist)
        }

        if(addLegend){
           
           leg <- .prepLegend(chip = chip,
                occup = occup,
                cs = ifelse(cs,list(chroma),"empty"),
                gof = ifelse(gof,goodnessOfFitLocal[i],"empty"),
                gr = ifelse(gr,list(genelist),"empty"),
                param)
            .drawLegend(leg)
        }
    }

    
}




## Creating param table/list for new plots and segment plots 
# we just want to make it easier and cleaner to add colors and what not
.dispatchGraphical <- function(graph,
    xlim = NULL,
    chr = NULL,
    cs = FALSE,
    geneRef = FALSE,
    occupancy = FALSE,
    gof = FALSE,
    legend = FALSE){
    ## First set up parameters for empty plot.
    param <- list()

    ## Expanding if legened needs to be added
    if(legend & cs & gof){
        param$xpd <- TRUE 
        param$mar <- c(6,8,4,20)
    } else if(legend & !cs & gof){
        param$xpd <- TRUE 
        param$mar <- c(6,8,4,10)
    } else if(legend & !cs & !gof){
        param$xpd <- TRUE 
        param$mar <- c(6,2,4,10)
    } else if(legend & !cs & geneRef){
        param$xpd <- TRUE 
        param$mar <- c(6,8,4,10)
    }
    ## Expanding ylim to have space for geneRef and/or CS
    if(cs & geneRef){
        param$ylim <- c(-1.2,1)
    }else if((cs & !geneRef)){
        param$ylim <- c(-0.3,1)
    }else if(!cs & geneRef){
        param$ylim <- c(-0.9,1)
    }else {
        param$ylim <-c(0,1)
    }
    # Adding xlims to param 
    param$xlim <- xlim
    # Dispatching font size 
    param$cex <- ifelse(any(names(graph) == "cex"),graph$cex,1)
    param$cex.lab <- ifelse(any(names(graph) == "cex.lab"),graph$cex.lab,1)
    # Dispatch main title font 
    param$cex.main <- ifelse(any(names(graph) == "cex.main"),graph$cex.main,1)
    # Dispatch prediction line width 
    param$lwd <- ifelse(any(names(graph) == "lwd"),graph$lwd,1)
    # Dispatch CS density 
    param$densityCS <- ifelse(any(names(graph) == "densityCS"),graph$densityCS,50)
    # Dispatch geneRef Density 
    param$densityGR <- ifelse(any(names(graph) == "densityGR"),graph$densityGR,50)
    # Dispatch pred color 
    param$colPred <- ifelse(any(names(graph) == "colPred"),graph$colPred,"#E69F00")
    # Dispatch ChIPcolor 
    param$colChIP <- ifelse(any(names(graph) == "colChIP"),graph$colChIP,"#999999")
    # Dispatch occup color 
    param$colOccup <- ifelse(any(names(graph) == "colOccup"),graph$colChIP,"#56B4E9")
    # Dispatch CS color
    if (any(names(graph) == "colCS")) {
        param$colCS <- graph$colCS
    } else {
        param$colCS <- colorRampPalette(c("#F0E442","#999999","#E69F00", "#56B4E9", "#009E73",
            "#0072B2", "#D55E00", "#CC79A7"))
    }
    # Dispatch Gene Ref color
    if (any(names(graph) == "colGR")) {
        param$colGR <- graph$colGR
    } else {
        param$colGR <- colorRampPalette(brewer.pal(8, "Accent"))
    }

    # Dispatch xlab names 
    param$xlab <- ifelse(any(names(graph) == "xlab"),graph$xlab,
        paste("Occupancy at Position",chr,paste(xlim[1],":",xlim[2],sep=""),sep=" "))
    # Dispatch ylab 
    param$ylab <- ifelse(any(names(graph) == "ylab"),graph$ylab," ")
    # Dispatch Main 
    param$main <- ifelse(any(names(graph) == "main"),graph$main," ")
    # Dispatch axis ticks 
    param$n_axis_ticks <- ifelse(any(names(graph) == "n_axis_ticks"),
        list(round(seq(from=xlim[1],to=xlim[2], length.out=graph$n_axis_ticks))),
        list(round(seq(from=xlim[1],to=xlim[2], length.out=10))))
    
    return(param)

}



.drawBackground <- function(param){
    ## setting up empty plotting window only using the relevant parameters.
    ## Checking if the legend needs to be plotted 
    
    par(xpd = param$xpd)
    par(mar = param$mar)
    
    plot(0, type = "n",
        axes = FALSE,
        xlab = "", ylab = "",
        ylim = param$ylim,
        xlim = param$xlim)
    axis(side=BELOW<-1,at=param$n_axis_ticks[[1]],labels=param$n_axis_ticks[[1]],cex.axis=param$cex)
    title(xlab = param$xlab , cex.lab = param$cex.lab)
    title(ylab = param$ylab , cex.lab = param$cex.lab)
    title(main = param$main , cex = param$cex.main)
}

.prepCS <- function(CS,states, param){
    CS$y0 <- -0.3
    CS$y1 <- -0.1
    CS$density <- param$densityCS

    if (is(param$colCS,"vector")) {
        
        CS$col <- param$colCS[match(CS$stateID, states)]
    } else {
        col_local <- param$colCS(length(states))
        names(col_local) <- states
        CS$col <- col_local[match(CS$stateID,states)]
    }
    
    
    return(CS)
}

.drawCS <- function(CS){
    # looping over blocks 
    for(block in seq_len(nrow(CS))){
        rect(CS$start[block],
            CS$y0[block],
            CS$end[block],
            CS$y1[block],
            density = CS$density[block],
            col = CS$col[block])
    }
}

.drawChIP <- function(x,y,param){
    polygon(x,
        y,
        col = param$colChIP,
        border = NA,
        density = param$densityChIP)
}

.drawPrediction <- function(x,y,param){
    lines(x,
        y,
        type = "l",
        lwd = param$lwd,
        col = param$colPred)
}

.drawOccup <- function(occupancy,param,PWM){
    if(PWM){
        PWMScaling <- occupancy[head(order(occupancy$PWMScore,decreasing=T), 
            round(0.9*length(occupancy$PWMScore)))]
        ReScale<-((PWMScaling$PWMScore+abs(min(PWMScaling$PWMScore)))/
            (max(PWMScaling$PWMScore)+abs(min(PWMScaling$PWMScore))))*(param$ylim[2]*0.5)
        lines(x=start(PWMScaling),y=ReScale,type="h",col = param$colOccup,lwd =2)
    }else{
        OccupScaling <- occupancy[head(order(occupancy$Occupancy,decreasing=T), 
            round(0.9*length(occupancy$Occupancy)))]
        ReScale<-(OccupScaling$Occupancy/max(OccupScaling$Occupancy))*
            (param$ylim[2]*0.5)
        lines(x=start(OccupScaling),y=ReScale,type="h",col = param$colOccup,lwd =2)

    }
}

.prepGR <- function(gr, types,param){
    elem<- data.frame("chr" = "chr",
            "x0" = param$xlim[1],
            "x1" = param$xlim[2],
            "width" = param$xlim[2] - param$xlim[1],
            "strand" = "*",
            "type" = "line",
            "gene_id" = "None")
    if(!is.null(nrow(gr))){
        colnames(gr) <- c("chr","x0","x1","width","strand","type","gene_id")
        gr <- rbind(elem,gr)
        
    }else {
        gr <- elem
    }
   
   
   elemY0 <- param$ylim[1]
   elemY0[gr$strand == "*"] <- param$ylim[1] + 0.35
   elemY0[gr$strand == "+"] <- param$ylim[1] + 0.4
   elemY0[gr$strand == "-"] <- param$ylim[1] + 0.15

   elemY1 <- param$ylim[1]
   elemY1[gr$strand == "*"] <- param$ylim[1] + 0.35
   elemY1[gr$strand == "+"] <- param$ylim[1] + 0.55
   elemY1[gr$strand == "-"] <- param$ylim[1] + 0.3

   gr$y0 <- elemY0
   gr$y1 <- elemY1

    ## Setting colours
    
    if (is(param$colGR,"vector")) {
        gr$col <- param$colGR[match(gr$type,types)]
    } else {
        types <- as.character(types)
        col_local <- param$colGR(length(types))
        names(col_local) <- types
        gr$col <- col_local[match(gr$type,types)]
    }
   
   
   gr$cex <-c(param$cex.lab,(rep(gr$cex,nrow(gr)-1)*0.5))
   return(gr)
}

.getGeneStarts  <- function(gr){
    genes <- gr[gr$type == "transcript",]
    if(!is.null(nrow(genes))){
       
        genes <- split(genes, genes$gene_id)
        genes <- lapply(genes,function(x)return(min(x$x0)))
        return(genes)
    }
}

.drawGeneRef  <- function(gr){
    # getting start pos of GR 
    genes <- .getGeneStarts(gr)
    for(seg in seq_len(nrow(gr))){
        
        if(gr$type[seg] == "line"){
            
            lines(c(gr$x0[seg],gr$x1[seg]),
                c(gr$y0[seg],gr$y0[seg]),
                col = "black",
                lwd=1)
            text(gr$x1[seg] + gr$width[seg] * 0.015,
                 gr$y0[seg] + 0.2,
                "+",
                col = "black",
                cex = gr$cex[seg])
            text(gr$x1[seg] + gr$width[seg] * 0.015,
                gr$y1[seg] - 0.2,
                "-",
                col = "black",
                cex = gr$cex[seg])
        }else if(gr$type[seg] == "exon"){
             lines(c(gr$x0[seg],gr$x1[seg]),
                c(gr$y0[seg],gr$y0[seg]),
                col = gr$col[seg])
        } else if(gr$type[seg] == "transcript"){
            rect(gr$x0[seg],
                gr$y0[seg],
                gr$x1[seg],
                gr$y1[seg],
                col = gr$col[seg])
            loc <- genes[[gr$gene_id[seg]]]
            if(loc == gr$x0[seg] & gr$strand[seg] == "-"){
                text(gr$x0[seg],
                gr$y0[seg] - 0.08,
                gr$gene_id[seg],
                col = "black",
                cex = gr$cex[seg] * 0.5)
            } else if(loc == gr$x0[seg] & gr$strand[seg] == "+"){
                text(gr$x0[seg],
                gr$y1[seg] + 0.08,
                gr$gene_id[seg],
                col = "black",
                cex = gr$cex[seg] * 0.5)
            }
            
        } else {
            rect(gr$x0[seg],
                gr$y0[seg],
                gr$x1[seg],
                gr$y1[seg],
                col = gr$col[seg])
            
        }
    }
}

.reorder <- function(cs,dat = "cs"){
    if(dat == "cs"){
        states <- unique(cs$stateID)
        cols <- rep(NA,length(states))
        for(i in seq_along(states)){
            cols[i] <- unique(cs$col[cs$stateID == states[i]])
        }
        return(list("stateID" = states, "col" = cols))
    }else{
        types <- unique(cs$type)
        cols <- rep(NA,length(types))
        for(i in seq_along(types)){
            cols[i] <- unique(cs$col[cs$type == types[i]])
        }
        return(list("type" = types, "col" = cols))
    }
    
}

.prepLegend <- function(chip,
    occup,
    cs,
    gof,
    gr,
    param){
    leg <- list()
    leg$pred <- list("x" = param$xlim[2],
        "y" = 0.5,
        "legend" = "Predicted Profile",
        "col" = param$colPred,
        "fill" = NA,
        "border" = NA,
        "cex" = param$cex)
    if(chip){
        leg$chip <- list("x" = param$xlim[2],
        "y" = 0.75,
        "legend" = "ChIP Profile",
        "col" = NA,
        "fill" = param$colChIP,
        "border" = NA,
        "cex" = param$cex)
    }
    if(occup){
        leg$occup <- list("x" = param$xlim[2],
        "y" = 0.25,
        "legend" = "Binding Site",
        "col" = param$colOccup,
        "fill" = NA,
        "border" = NA,
        "cex" = param$cex)
    }
    if(any(gof != "empty")){
        gof <- gof[[1]]
        tmp <- gof[names(gof) %in% c("MSE","AUC","pearson")]
        leg$gof <- list("x" = param$xlim[1] -((param$xlim[2] - param$xlim[1]) * 0.02),
        "y" = 1,
        "legend" = paste(paste(names(tmp),"=",signif(tmp,4)),collapse = "\n"),
        "col" = "black",
        "fill" = NA,
        "border" = NA,
        "cex" = param$cex)
    }
    if(any(cs != "empty")){
        cs <- cs[[1]]
        cs <- .reorder(cs,dat = "cs")
        leg$cs <- list("x" = param$xlim[2] +((param$xlim[2] - param$xlim[1]) * 0.2),
        "y" = 0.5,
        "legend" = cs$stateID,
        "col" = NA,
        "fill" = cs$col,
        "border" = NA,
        "cex" = param$cex)
    }
    if(any(gr != "empty")){
        gr <- gr[[1]]
        gr <- gr[gr$type != "line",]
        gr <- .reorder(gr,dat="gr")
        leg$gr <- list("x" = param$xlim[1] -((param$xlim[2] - param$xlim[1]) * 0.2),
        "y" = -0.3,
        "legend" = gr$type,
        "col" = NA,
        xjust = 1,
        "fill" = gr$col,
        "border" = NA,
        "cex" = param$cex)
        
    }
    
    return(leg)

}
.drawLegend <- function(leg){
    for(l in seq_along(leg)){
        if(names(leg)[l] == "gof"){
            
            text(x = leg[[l]]$x,
            y = leg[[l]]$y,
            labels = leg[[l]]$legend,
            adj = c(1,0),
            col = leg[[l]]$col,
            cex = leg[[l]]$cex)
        }else {
            legend(x = leg[[l]]$x,
            y = leg[[l]]$y,
            legend = leg[[l]]$legend,
            bty = "n",
            col = leg[[l]]$col,
            fill = leg[[l]]$fill,
            border = leg[[l]]$border,
            lwd = 2,
            xjust = 0,
            yjust = 0.5,
            cex = leg[[l]]$cex)

        }
       
    }
}

##########################################
#############  S4 Generics   #############
##########################################



#### Genomic Profile Parameters ####

#setGeneric(".initialize",
    #function(object) standardGeneric(".initialize"))

setGeneric(".generatePWM",
    function(object) standardGeneric(".generatePWM"))

setGeneric("PositionWeightMatrix",
    function(object) standardGeneric("PositionWeightMatrix"))

setGeneric("PositionWeightMatrix<-",
    function(object, value) standardGeneric("PositionWeightMatrix<-"))

setGeneric("PositionFrequencyMatrix",
    function(object) standardGeneric("PositionFrequencyMatrix"))

setGeneric("PositionFrequencyMatrix<-",
    function(object, value) standardGeneric("PositionFrequencyMatrix<-"))

setGeneric("PFMFormat",
    function(object) standardGeneric("PFMFormat"))

setGeneric("PFMFormat<-",
    function(object, value) standardGeneric("PFMFormat<-"))

setGeneric("lambdaPWM",
    function(object) standardGeneric("lambdaPWM"))

setGeneric("lambdaPWM<-",
    function(object, value) standardGeneric("lambdaPWM<-"))

setGeneric("noOfSites",
    function(object) standardGeneric("noOfSites"))

setGeneric("noOfSites<-",
    function(object, value) standardGeneric("noOfSites<-"))

setGeneric("PWMpseudocount",
    function(object) standardGeneric("PWMpseudocount"))

setGeneric("PWMpseudocount<-",
    function(object, value) standardGeneric("PWMpseudocount<-"))

setGeneric("BPFrequency",
    function(object) standardGeneric("BPFrequency"))

setGeneric("BPFrequency<-",
    function(object, value) standardGeneric("BPFrequency<-"))

setGeneric("naturalLog",
    function(object) standardGeneric("naturalLog"))

setGeneric("naturalLog<-",
    function(object, value) standardGeneric("naturalLog<-"))

setGeneric("minPWMScore",
    function(object) standardGeneric("minPWMScore"))
setGeneric(".minPWMScore<-",
      function(object,value)standardGeneric(".minPWMScore<-"))

setGeneric("maxPWMScore",
    function(object) standardGeneric("maxPWMScore"))
setGeneric(".maxPWMScore<-",
     function(object,value)standardGeneric(".maxPWMScore<-"))

setGeneric(".tags",
      function(object) standardGeneric(".tags"))
setGeneric(".tags<-",
      function(object,value) standardGeneric(".tags<-"))

setGeneric("PWMThreshold",
    function(object) standardGeneric("PWMThreshold"))

setGeneric("PWMThreshold<-",
    function(object, value) standardGeneric("PWMThreshold<-"))

setGeneric("profiles",
    function(object) standardGeneric("profiles"))
setGeneric(".profiles<-",function(object,value)standardGeneric(".profiles<-"))



setGeneric("DNASequenceLength",
    function(object) standardGeneric("DNASequenceLength"))

setGeneric(".DNASequenceLength<-",
    function(object, value) standardGeneric(".DNASequenceLength<-"))

setGeneric("averageExpPWMScore",
    function(object) standardGeneric("averageExpPWMScore"))
setGeneric(".averageExpPWMScore<-",
    function(object,value) standardGeneric(".averageExpPWMScore<-"))


setGeneric("strandRule",
    function(object) standardGeneric("strandRule"))

setGeneric("strandRule<-",
    function(object,value) standardGeneric("strandRule<-"))

setGeneric("whichstrand",
    function(object) standardGeneric("whichstrand"))

setGeneric("whichstrand<-",
    function(object,value) standardGeneric("whichstrand<-"))



setGeneric(".ZeroBackground",
    function(object) standardGeneric(".ZeroBackground"))
setGeneric(".ZeroBackground<-",
    function(object,value) standardGeneric(".ZeroBackground<-"))

setGeneric(".drop<-",
    function(object,value) standardGeneric(".drop<-"))

setGeneric("drop",
    function(object) standardGeneric("drop"))




setGeneric("ploidy",
    function(object) standardGeneric("ploidy"))

setGeneric("ploidy<-",
    function(object, value) standardGeneric("ploidy<-"))

setGeneric("boundMolecules",
    function(object) standardGeneric("boundMolecules"))

setGeneric("boundMolecules<-",
    function(object, value) standardGeneric("boundMolecules<-"))

setGeneric("maxSignal",
    function(object) standardGeneric("maxSignal"))

setGeneric("maxSignal<-",
    function(object, value) standardGeneric("maxSignal<-"))

setGeneric("backgroundSignal",
    function(object) standardGeneric("backgroundSignal"))

setGeneric("backgroundSignal<-",
    function(object, value) standardGeneric("backgroundSignal<-"))

setGeneric("chipMean",
    function(object) standardGeneric("chipMean"))

setGeneric("chipMean<-",
    function(object, value) standardGeneric("chipMean<-"))

setGeneric("chipSd",
    function(object) standardGeneric("chipSd"))

setGeneric("chipSd<-",
    function(object, value) standardGeneric("chipSd<-"))

setGeneric("chipSmooth",
    function(object) standardGeneric("chipSmooth"))

setGeneric("chipSmooth<-",
    function(object, value) standardGeneric("chipSmooth<-"))

setGeneric("removeBackground",
    function(object) standardGeneric("removeBackground"))

setGeneric("removeBackground<-",
    function(object, value) standardGeneric("removeBackground<-"))


setGeneric("stepSize",
    function(object) standardGeneric("stepSize"))

setGeneric("stepSize<-",
    function(object, value) standardGeneric("stepSize<-"))

setGeneric("lociWidth",
        function(object) standardGeneric("lociWidth"))

setGeneric("lociWidth<-",
        function(object, value) standardGeneric("lociWidth<-"))

setGeneric("noiseFilter",
          function(object) standardGeneric("noiseFilter"))

setGeneric("noiseFilter<-",
        function(object, value) standardGeneric("noiseFilter<-"))

setGeneric(".paramTag",
      function(object) standardGeneric(".paramTag"))
setGeneric(".paramTag<-",
      function(object,value) standardGeneric(".paramTag<-"))


setGeneric("loci",
      function(object) standardGeneric("loci"))
setGeneric(".loci<-",
      function(object,value) standardGeneric(".loci<-"))

setGeneric("scores",
      function(object) standardGeneric("scores"))
setGeneric(".scores<-",
      function(object,value) standardGeneric(".scores<-"))

##################################################
########## Analaysis function ####################
##################################################



#### Running GA For n generations


evolve <- function(population,DNASequenceSet,ChIPScore,
                   genomicProfiles,parameters=NULL,generations=100,mutationProbability=0.3,
                   offsprings=5,chromatinState=NULL,
                   method="geometric", lambda=TRUE,checkpoint=TRUE,
                   filename=NULL, cores=1){

    ## setting up population
    if(is.numeric(population) & !is.null(parameters)){
      population <- generateStartingPopulation(population,parameters)
    }


      ## setting up chromatinState from starting population
    if(!is.null(chromatinState) & length(grep("cs",names(population[[1]]),ignore.case=T))>1){
        CS <- setChromatinStates(population,chromatinState)
    } else if(!is.null(chromatinState) & length(grep("cs",names(population[[1]]),ignore.case=T))==1){
        CS<-list(chromatinState)
    } else{
        CS<-vector("list", length(population))
    }

    ## building starting database
    database <- as.data.frame(matrix(0,ncol=length(population[[1]])))

    colnames(database)<-names(population[[1]])


    ## setting lambda data based
    if(lambda==TRUE){
        message("Generating Lambda DataBase")
        lambdas <- .lambdas(1,c("lambda"))[[1]]
        lambdaPWM(genomicProfiles)<-unlist(lambdas)
        lambdaDB <- computeGenomeWideScores(genomicProfiles,DNASequenceSet,CS[[1]], cores=cores, verbose=FALSE)
        lambdaDB <-cbind(lambdaPWM(lambdaDB),
            rep(maxPWMScore(lambdaDB),length(lambdas)),
            rep(minPWMScore(lambdaDB),length(lambdas)),
            averageExpPWMScore(lambdaDB),
            rep(DNASequenceLength(lambdaDB),length(lambdas)))
    }

    ## checkpoint saves
    if(checkpoint & lambda){
        if(!is.null(filename)){
            save(lambdaDB,file=paste0(filename,"_",method,"_LambdaDBTraining.Rda"))
        } else {
            save(lambdaDB,file=paste0(method,"_LambdaDBTraining.Rda"))

         }
    }
    ### vec for fittyMacFitFace
    GenFit<-vector("list", generations)

    ## time for some evolution
    for(i in seq_len(generations)){

        message(paste0("Generation: ",i))
        # checking if solution exists or building databe on first generation

        buffer <- .buildDatabase(population,database,generation=i)
        database <- buffer[[1]]
        # removing duplicated enteries when necessary.. we are not going to bother with the computed ones
        #if(length(buffer[[2]])!=0){
          #ComputedPopulation <- buffer[[2]][!duplicated(.collapseParam(buffer[[2]]))]
        #} else{
          ComputedPopulation <- buffer[[2]]
        #}

        ToBeComputedPop <- buffer[[3]]
        




        if(length(ToBeComputedPop)!=0){
          ## re set Chromatin States
          if(!is.null(chromatinState) & length(grep("cs",names(ToBeComputedPop[[1]]),ignore.case=T))>1){
              CS <- setChromatinStates(ToBeComputedPop,chromatinState)
          } else if(!is.null(chromatinState) & length(grep("cs",names(ToBeComputedPop[[1]]),ignore.case=T))==1){
              CS<-list(chromatinState)
          } else{
              CS<-vector("list", length(ToBeComputedPop))
          }
        # Compute fitness of idividual

        if(lambda==TRUE){

            ToBeComputedPop <- parallel::mcmapply(.individualSurvival,ToBeComputedPop,CS,
            MoreArgs=list(genomicProfiles,DNASequenceSet,
            ChIPScore=ChIPScore,fitness=method,lambdaDB=lambdaDB),SIMPLIFY=FALSE,mc.cores=cores)
        } else {
            ToBeComputedPop <- parallel::mcmapply(.individualSurvival,ToBeComputedPop,CS,
            MoreArgs=list(genomicProfiles,DNASequenceSet,
            ChIPScore=ChIPScore,fitness=method,lambdaDB=NULL),SIMPLIFY=FALSE,mc.cores=cores)
        }


        # update database

        database <- .buildDatabase(ToBeComputedPop,database,new=TRUE,generation=i)
        database <- database[!duplicated(.collapseParam(database)),]
        }
        # Rebuilding population with both "pre/post" computed

        population<-c(ComputedPopulation,ToBeComputedPop)

        # Best performance
        GenFit<-.fittyMacFitFace(population,method,GenFit,i)




        message(paste0("Generation Fitness: ",GenFit[[i]]))
        ## checkpoint saving this is messy af
        # shame shame shame Patrick
        if(checkpoint){
            if(!is.null(filename)){
                fileCheckPop<-paste0(filename,"_",method,"_population.csv")
             }else{
                fileCheckPop<-paste0(filename,"_",method,"_population.csv")
             }
            if(i>1){
                out <- .revert_to_class(do.call("rbind",population))
                out$gen <- i
                write.table(out,
                    file = fileCheckPop,
                    sep = ",",
                    col.names = FALSE,
                    row.names = FALSE,
                    append = TRUE )
            } else {
                out <- .revert_to_class(do.call("rbind",population))
                write.table(out,
                    file = fileCheckPop,
                    sep = ",",
                    col.names= TRUE, 
                    row.names = FALSE,
                    append = FALSE)
            }

        }

        # create new population
        if(i != generations){
        ## check for odd stuff

        population <- .generateNewPopulation(population,parameters,
            mutationProbability=mutationProbability,
            offsprings=offsprings, method=method,gen=i)



        }
    }

    ## When generation are over return databse and last population
    return(list("database"=as.data.frame(apply(database,2,unlist)),
                "population"=population,
                "fitest"=GenFit))

}

getHighestFitnessSolutions<-function(population,child=2,method="geometric"){

    ## checking if you have the right method
    if(length(grep(method,c("geometric","ks","MSE","pearson","spearman","kendall",
    "recall","precesion","fscore","MCC","Accuracy","AUC"),ignore.case=T))<1){
        stop("Selected method is not part of the following:
        geometric,ks,MSE,pearson,spearman,kendall,
        recall,precesion,fscore,MCC,Accuracy,AUC")
    }


    ## We are just going to consider a interger value for children. we can add that option somewhere else
    ## in the create new pop function
        
        UFit<-unlist(sapply(population,"[[","fitness"))

        if(grepl("ks",method,ignore.case=T) |
            grepl("geometric",method,ignore.case=T)|
            grepl("MSE",method,ignore.case=T)){
            TopFit<-order(UFit,decreasing=F)[seq_len(child)]
        }else{
            TopFit<-order(UFit,decreasing=T)[seq_len(child)]
        }

    #return(population[TopFit])
    return(TopFit)
}

singleRun <- function(indiv,DNAAffinity,
    genomicProfiles,DNASequenceSet,
    ChIPScore,fitness="all"){

    if(length(indiv) ==1 & class(indiv)=="list"){
      indiv <- indiv[[1]]
    }else {
      stop("Oops somthing went wrong. Not sure what your indiv object is")
    }
        lambdaPWM(genomicProfiles)<-unlist(indiv[
            grepl("ScalingFactor",names(indiv),ignore.case=T)|
            grepl("Scaling Factor",names(indiv),ignore.case=T)|
            grepl("lambda",names(indiv),ignore.case=T)])
        # Setting PWMThreshold from GA population
        PWMThreshold(genomicProfiles)<-unlist(indiv[
            grepl("PWMThreshold",names(indiv),ignore.case=T)|
            grepl("PWM Threshhold",names(indiv),ignore.case=T)])
        # Setting Number of bound molecules from GA population

        boundMolecules(genomicProfiles)<- unlist(indiv[
            grepl("boundMolecules",names(indiv),ignore.case=T)|
            grepl("Bound molecules",names(indiv),ignore.case=T)|
            grepl("^N$",names(indiv),ignore.case=T)])

        ### compitng prediction from GA population
        ## genome wide scoring
        genomeWide <- computeGenomeWideScores(genomicProfiles,DNASequenceSet,
            DNAAffinity,verbose=FALSE)

        ## compute PWMscores
        pwmScores <- computePWMScore(genomeWide,DNASequenceSet,
            ChIPScore,DNAAffinity, verbose=FALSE)

        ## compute occupancy
        occup <- computeOccupancy(pwmScores,verbose=FALSE)

        ## computing ChIP profiles
        chip <- computeChIPProfile(occup,ChIPScore,verbose=FALSE)

        ## setting the right method
        if(length(grep(fitness,c("fscore","AUC","recall","precision","accuracy","MCC"),ignore.case=TRUE))>0){
            internalMethod<-"fscore"
        } else {
            internalMethod <- fitness
        }
       
        ## Goodness of fit
        GoF <- profileAccuracyEstimate(chip,ChIPScore,method=internalMethod)


      return(list("occupancy"=occup,"ChIP"=chip,"gof"=GoF))
}


setChromatinStates <- function(population,chromatinStates){
    ## probably could do with some validity checks but thats for later

    ## Let's assume that chromatin states come in the form as GRanges
    ## same form as you ahve atm

    # Right for now this will just set the built affinities to a GRanges
    affinities<- lapply(population,function(x){x[grep(pattern="cs",names(x),ignore.case=T)]})

    # selecting score in chromatin states GR
    if(length(grep(x=chromatinStates$name,pattern="cs",ignore.case=T))<1){
        stateNames<-
        chromatinStates$name <- paste0("CS",chromatinStates$name)
    }
    #### NOTE this is a problem! your CS that you are adding wont always match
    #### NEED to find a better way of assinging names. A more robust a universal way of doing it
    #### Run code as is for now BUT IT NEEDS TO BE CHANGED
    chromatinStates<-chromatinStates[which(chromatinStates$name %in% names(affinities[[1]]))]
    # Removing levels
    chromatinStates<-GRanges(seqnames=as.character(seqnames(chromatinStates)),
        ranges=IRanges(start(chromatinStates), end(chromatinStates)),
        stateID=chromatinStates$name,
        DNAaffinity=rep(0,length(chromatinStates)))

    # reorder
    states <- match(names(affinities[[1]]),unique(chromatinStates$stateID))
    states <- names(affinities[[1]])[!is.na(states)]

    # replae affinity score in CS granges object
    GRStates<-vector("list", length(affinities))
    for(i in seq_along(GRStates)){
        GRStates[[i]]<-chromatinStates
        for(j in states){
            GRStates[[i]]$DNAaffinity[which(GRStates[[i]]$stateID == j)] <- affinities[[i]][[which(names(affinities[[i]])==j)]]
        }

    }

    return(GRStates)


}


## Generating a template for starting population
## with population being the number of individuals
## parameters the parameters you are interested in using
generateStartingPopulation<-function(population,parameters,names=NULL){
    ## first lets build the list squeleton with the appropriate values
    pop<-vector("list",population)

    if(!is.null(names)){names(pop)<-names}

    if(!is.list(parameters)){
        pop<-lapply(pop,function(x){x<-vector("list",length(parameters))
                                names(x)<-parameters
                                return(x)})
    } else{
        pop<-lapply(pop,function(x){x<-parameters})
    }

    # Then lets assign values to each parameter
    pop<-.initiateGASolutions(pop)

    # Then lets sample one of these one of these pre defined parameter
    # Note that there will be somme issue if you use random values
    pop<-.generateRandomGASolution(pop)

    #return final population
    return(pop)
}

####################################
##### Pre-processing Functions #####
####################################

## ChIP-seq Pre-processing


processingChIP <- function(profile,loci=NULL,reduce=NULL,
     peaks=NULL,chromatinState=NULL,parameterOptions=NULL,cores=1){

     #### Validity checking
     ## will do after , first need to know how to do this
     ## also make some god damn test units


     ## Loading ChIP profile
     ## check if RDA files as well

     if(class(profile)=="character"){
       if(!grepl(".Rda",profile)){
        fileFormat<-unlist(strsplit(profile,"\\."))
        fileFormat<-fileFormat[length(fileFormat)]
        # Just in case
        # File format are sometimes inconsistent
        # Might need to add more of these,only one i know of atm
        if(fileFormat %in% c("bdg")){
            fileFormat<-"bedGraph"
        }

        profile<-import(profile,format=fileFormat)
        seqlevelsStyle(profile) <- "UCSC"
      } else if(grepl(".Rda",profile)){
        profile<-get(load(profile))
        seqlevelsStyle(profile) <- "UCSC"
      }
     }else if(is(profile, "data.frame")|is(profile,"matrix")){

        profile<-.formatCheck(profile,type="ChIP")


     } else if( class(profile)=="GRanges") {

        profile<-profile
        seqlevelsStyle(profile) <- "UCSC"

     } else {
        stop("Profile: unsuported format")
     }

     # Extracting raw signal metrics
     if(is.null(parameterOptions)){
         parameterOptions<-parameterOptions()
         maxSignal(parameterOptions)<-max(profile$score)
         backgroundSignal(parameterOptions)<-mean(profile$score)

     }else{
         maxSignal(parameterOptions)<-max(profile$score)
         backgroundSignal(parameterOptions)<-mean(profile$score)
     }

     noiseFilter<-noiseFilter(parameterOptions)
    ## Loading peaks
    if(!is.null(peaks)){
        if(class(peaks)=="GRanges"){
            peaks<-peaks
            seqlevelsStyle(peaks) <- "UCSC"
        }else if(class(peaks)=="character"){
          if(!grepl(".Rda",peaks)){
              fileFormat<-unlist(strsplit(peaks,"\\."))
              fileFormat<-fileFormat[length(fileFormat)]
       # Just in case
       # File format are sometimes inconsistent
       # Might need to add more of these,only one i know of atm
              if(fileFormat %in% c("bdg")){
                  fileFormat<-"bedGraph"
                }

                peaks<-import(peaks,format=fileFormat)
                seqlevelsStyle(peaks) <- "UCSC"
          }else if(grepl(".Rda",peaks)){
              peaks<-get(load(peaks))
              seqlevelsStyle(peaks) <- "UCSC"
        }
      } else if(is(peaks, "data.frame")|is(peaks,"matrix")){
          peaks<-.formatCheck(peaks,type="peaks")
          seqlevelsStyle(peaks) <- "UCSC"
      }else{

          stop("Peaks: unsuported format")

      }
        peakParam<-.peakParametersExt(peaks)
        chipMean(parameterOptions)<-peakParam[1]
        chipSd(parameterOptions)<-peakParam[2]
    }

    ## Loading access
    if(!is.null(chromatinState)){
      if(class(chromatinState)=="GRanges"){
        chromatinState<-chromatinState
        seqlevelsStyle(chromatinState) <- "UCSC"
      } else if(class(chromatinState)=="character" ){
          if(!grepl(".Rda",chromatinState)){
             fileFormat<-unlist(strsplit(chromatinState,"\\."))
             fileFormat<-fileFormat[length(fileFormat)]
       # Just in case
       # File format are sometimes inconsistent
       # Might need to add more of these,only one i know of atm
             if(fileFormat %in% c("bdg")){
                 fileFormat<-"bedGraph"
             }

             chromatinState<-import(chromatinState,format=fileFormat)
             seqlevelsStyle(peaks) <- "UCSC"
       }else if(grepl(".Rda",chromatinState)){
             chromatinState<-get(load(chromatinState))
             seqlevelsStyle(chromatinState) <- "UCSC"
       }else if(class(chromatinState)== "data.frame"| class(chromatinState)=="matrix"){
         chromatinState<-.formatCheck(chromatinState,type="peaks")
         seqlevelsStyle(chromatinState) <- "UCSC"
        }
      } else {
          stop("chromatinState: unsuported format")

      }
    }
    ## Creating set loci if none are provided
    ## will need to make change to OPP as well
    if(is.null(loci)){
        if(is.null(parameterOptions)){
            parameterOptions<-parameterOptions()
            lociWidth<-lociWidth(parameterOptions)
        } else {
            lociWidth<-lociWidth(parameterOptions)
        }

        localRanges<-split(profile,seqnames(profile))
        # building range per chromosome
        # tiling is easier
        localRanges<-lapply(localRanges,function(x){
            x<-GRanges(seqnames=unique(as.character(seqnames(x))),
                       ranges=IRanges(min(start(x)),max(end(x))))
            return(x)
        })

        loci<-GRanges()
        for(i in seq_along(localRanges)){
            loci<-suppressWarnings(c(loci, unlist(tile(localRanges[[i]],width=lociWidth))))
        }
        .cleanUpAfterYourself(localRanges)
    }  else if(class(loci)=="GRanges"){
       loci <-loci
     } else if(class(loci)=="character" & !grepl(".Rda", loci )){
        loci<-import(loci)
        seqlevelsStyle(loci) <- "UCSC"

    } else if(class(loci)=="character" & grepl(".Rda",loci)){
        loci <-get(load(loci))
        seqlevelsStyle(loci) <- "UCSC"

    } else{
      stop("Loci: unsuported format.")
    }

    # cores change if required
    if(length(loci)<cores){
      cores<-length(loci)
      warning("Number of cores requested higher than number of loci provided - some cores will be dropped")
    }



    ## Alright lets get this extraction going
    ChIPProfile <- .internalChIPExtraction(profile=profile,
                                          loci=loci,
                                          peaks=peaks,
                                          chromatinState=chromatinState,
                                          reduce=reduce,
                                          parameterOptions=parameterOptions,
                                          noiseFilter=noiseFilter,
                                          cores=cores)



    if(!is.null(reduce)){
        ChIPProfile<-.ChIPScore(scores=ChIPProfile[[1]],loci=ChIPProfile[[2]],
                               maxSignal=max(sapply(ChIPProfile[[1]],max)),
                               backgroundSignal=mean(sapply(ChIPProfile[[1]],mean)),
                               lociWidth=lociWidth(parameterOptions),
                               paramTag="ChIPExt")

    } else{
      ChIPProfile<-.ChIPScore(scores=ChIPProfile,loci=loci,
                             maxSignal=max(sapply(ChIPProfile,max)),
                             backgroundSignal=mean(sapply(ChIPProfile[[1]],mean)),
                             lociWidth=lociWidth(parameterOptions),
                             paramTag="ChIPExt")
    }
    ### crate new Class for custom show method
    ##

    return(ChIPProfile)

}

##############################################
#############      S4 Methods    #############
##############################################

########### Show Methods ##########
setMethod("show",
    signature = "genomicProfiles",
    definition = function(object){
        widthDisplay<-round(options()$width*0.75)
        if(object@tags == "empty"){
          cat(rep("_", widthDisplay),"\n","\n")
          title <- as.character("genomicProfiles object with no internal data")
          titleWidth<-nchar(title, type="byte")
          cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
          cat(rep("_", widthDisplay),"\n")
          slots <- slotNames(object)[1:4]

          line1<-paste("Suggested Slots : ",paste(rep(" ",
            times=(widthDisplay-nchar("Suggested Slots : ")-nchar(slots[1]))),collapse=''),
            slots[1],"\n")
          line2<-paste("Suggested Slots : ",paste(rep(" ",
            times=(widthDisplay-nchar("Suggested Slots : ")-nchar(slots[2]))),collapse=''),
            slots[2],"\n")
          line3<-paste("Suggested Slots : ",paste(rep(" ",
            times=(widthDisplay-nchar("Suggested Slots : ")-nchar(slots[3]))),collapse=''),
            slots[3],"\n")
          line4<-paste("Suggested Slots : ",paste(rep(" ",
              times=(widthDisplay-nchar("Suggested Slots : ")-nchar(slots[4]))),collapse=''),
              slots[4],"\n")
          cat("",line1,line2,line3,line4)
        }else  if(object@tags == "PWM_stage"){
          cat(rep("_", widthDisplay),"\n","\n")
          title <- as.character("genomicProfiles object: Position Weight Matrix")
          titleWidth<-nchar(title, type="byte")
          cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
          cat(rep("_", widthDisplay),"\n","\n")
          bpf <- object@BPFrequency
          names(bpf)<-c("A" ,"C" ,"G" ,"T")

          cat("Position Weight Matrix (PWM): \n","\n")
          print(object@PWM)
          cat(rep("_", widthDisplay),"\n","\n")
          cat("Base pairs frequency for PWM weighting : \n","\n")
          print(bpf)
          cat(rep("_", widthDisplay),"\n","\n")
          cat("PWM built from (PFM - Format ",object@PFMFormat, ") : \n","\n")
          print(object@PFM)
          cat("\n",rep("_", widthDisplay),"\n")

        }else  if(grepl("genomeWide",object@tags)){
          cat(rep("_", widthDisplay),"\n","\n")
          if(grepl("CS",object@tags)){
              title <- as.character("genomicProfiles object: Accessible Chromatin Score")
          } else{
              title <- as.character("genomicProfiles object: Genome Wide Score")
          }
          titleWidth<-nchar(title, type="byte")
          cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
          cat(rep("_", widthDisplay),"\n","\n")

          cat("","Position Weight Matrix (PWM): \n","\n")
          print(object@PWM)
          cat(rep("_", widthDisplay),"\n","\n")
          cat("",paste0("maxPWMScore: ",paste(rep(" ",
            times=(widthDisplay-nchar("maxPWMScore: ")-nchar(object@maxPWMScore))),collapse=''),
            object@maxPWMScore,"\n"))

          cat("",paste0("minPWMScore: ",paste(rep(" ",
            times=(widthDisplay-nchar("minPWMScore: ")-nchar(object@minPWMScore))),collapse=''),
            object@minPWMScore,"\n"))

          cat("",paste0("averageExpPWMScore: ",paste(rep(" ",
            times=(widthDisplay-nchar("averageExpPWMScore: ")-nchar(paste0(object@averageExpPWMScore[1],"(lambda = ",object@lambdaPWM[1],")")))),collapse=''),
            object@averageExpPWMScore," (lambda = ",object@lambdaPWM,")\n"))

          cat("",paste0("DNASequenceLength: ",paste(rep(" ",
             times=(widthDisplay-nchar("DNASequenceLength: ")-nchar(object@DNASequenceLength))),collapse=''),
             object@DNASequenceLength,"\n"))
         cat(rep("_", widthDisplay),"\n","\n")

       }else if(grepl("PWMScore",object@tags)){
         cat(rep("_", widthDisplay),"\n","\n")
         title <- as.character("genomicProfiles object: PWM scores above Threshold")
         titleWidth<-nchar(title, type="byte")
         cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
         cat(rep("_", widthDisplay),"\n","\n")
         profile<-object@profiles

         if(length(profile)<2){
             cat("","Scores above Threshold in locus: ","\n")
             print(profile)
         }else{
             cat("","Scores above Threshold in locus: ","\n")
             print(profile[[1]])
             cat("\n")
             cat("",length(profile)-1," remaining loci","\n")
             cat("",paste0("Locus: ",paste(rep(" ",
               times=(widthDisplay-nchar("Locus: ")-nchar(paste0(names(profile)[1],"(length = ",length(profile[[1]]),")")))),collapse=''),
               names(profile)[2:length(profile)]," (length = ",sapply(profile, length)[2:length(profile)],")\n"))

         }
         cat(rep("_", widthDisplay),"\n","\n")
         title <- as.character("Associated parameters")
         titleWidth<-nchar(title, type="byte")
         cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
         cat(rep("_", widthDisplay),"\n","\n")
         cat("",paste0("minPWMScore: ",paste(rep(" ",
           times=(widthDisplay-nchar("minPWMScore: ")-nchar(object@minPWMScore))),collapse=''),
           object@minPWMScore,"\n"))
         cat("",paste0("maxPWMScore: ",paste(rep(" ",
           times=(widthDisplay-nchar("minPWMScore: ")-nchar(object@maxPWMScore))),collapse=''),
           object@maxPWMScore,"\n"))
         cat("",paste0("lambdaPWM: ",paste(rep(" ",
           times=(widthDisplay-nchar("lambdaPWM: ")-nchar(object@lambdaPWM[1]))),collapse=''),
           object@lambdaPWM,"\n"))
         cat("",paste0("PWMThreshold: ",paste(rep(" ",
             times=(widthDisplay-nchar("PWMThreshold: ")-nchar(object@PWMThreshold))),collapse=''),
             object@PWMThreshold,"\n"))
      }else if(grepl("Occupancy",object@tags)){
        cat(rep("_", widthDisplay),"\n","\n")
        title <- as.character("genomicProfiles object: Occupancy at sites above Threshold")
        titleWidth<-nchar(title, type="byte")
        cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
        cat(rep("_", widthDisplay),"\n","\n")
        profile<-object@profiles

        if(length(profile)<2){
            cat("","Parameter combination: ",names(profile),"\n","\n")
            print(profile)
        }else{
            cat("","Parameter combination: ",names(profile)[1],"\n","\n")
            print(profile[[1]])
            cat("\n")
            cat("",length(profile)-1," remaining combinations","\n","\n")
            cat("",paste0("Parameter combination: ",paste(rep(" ",
              times=(widthDisplay-nchar(paste0(names(profile)[1],"(loci = ",length(profile[[1]]),")")))),collapse=''),
              names(profile)[2:length(profile)]," (loci = ",sapply(profile, length)[2:length(profile)],")\n"))

        }
        cat(rep("_", widthDisplay),"\n","\n")
        title <- as.character("Associated parameters")
        titleWidth<-nchar(title, type="byte")
        cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
        cat(rep("_", widthDisplay),"\n","\n")

        cat("",paste0("lambdaPWM: ",paste(rep(" ",
          times=(widthDisplay-nchar("lambdaPWM: ")-nchar(object@lambdaPWM[1]))),collapse=''),
          object@lambdaPWM,"\n"))
        cat("",paste0("boundMolecules: ",paste(rep(" ",
          times=(widthDisplay-nchar("boundMolecules: ")-nchar(object@boundMolecules[1]))),collapse=''),
          object@boundMolecules,"\n"))

     }else if(grepl("ChIPProfile",object@tags)){
       cat(rep("_", widthDisplay),"\n","\n")
       title <- as.character("genomicProfiles object: ChIP like Profiles")
       titleWidth<-nchar(title, type="byte")
       cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
       cat(rep("_", widthDisplay),"\n","\n")
       profile<-object@profiles

       if(length(profile)<2){
           cat("","Parameter combination: ",names(profile),"\n","\n")
           print(profile)
       }else{
           cat("","Parameter combination: ",names(profile)[1],"\n","\n")
           print(profile[[1]])
           cat("\n")
           cat("",length(profile)-1," remaining combinations","\n","\n")
           cat("",paste0("Parameter combination: ",paste(rep(" ",
             times=(widthDisplay-nchar(paste0(names(profile)[1],"(loci = ",length(profile[[1]]),")")))),collapse=''),
             names(profile)[2:length(profile)]," (loci = ",sapply(profile, length)[2:length(profile)],")\n"))

       }
       cat(rep("_", widthDisplay),"\n","\n")
       title <- as.character("Associated parameter Options")
       titleWidth<-nchar(title, type="byte")
       cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
       cat(rep("_", widthDisplay),"\n","\n")

       cat("",paste0("lambdaPWM: ",paste(rep(" ",
         times=(widthDisplay-nchar("lambdaPWM: ")-nchar(object@lambdaPWM[1]))),collapse=''),
         object@lambdaPWM,"\n"))
       cat("",paste0("boundMolecules: ",paste(rep(" ",
         times=(widthDisplay-nchar("boundMolecules: ")-nchar(object@boundMolecules[1]))),collapse=''),
         object@boundMolecules,"\n"))
        cat("",paste0("stepSize: ",paste(rep(" ",
             times=(widthDisplay-nchar("stepSize: ")-nchar(object@stepSize))),collapse=''),
             object@stepSize,"\n"))
        cat("",paste0("backgroundSignal: ",paste(rep(" ",
           times=(widthDisplay-nchar("backgroundSignal: ")-nchar(object@backgroundSignal))),collapse=''),
           object@backgroundSignal,"\n"))
        cat("",paste0("maxSignal: ",paste(rep(" ",
           times=(widthDisplay-nchar("maxSignal: ")-nchar(object@maxSignal))),collapse=''),
           object@maxSignal,"\n"))
        cat("",paste0("removeBackground: ",paste(rep(" ",
           times=(widthDisplay-nchar("removeBackground: ")-nchar(object@removeBackground))),collapse=''),
           object@removeBackground,"\n"))
        cat("",paste0("chipMean: ",paste(rep(" ",
            times=(widthDisplay-nchar("chipMean: ")-nchar(object@chipMean))),collapse=''),
            object@chipMean,"\n"))
        cat("",paste0("chipSd: ",paste(rep(" ",
             times=(widthDisplay-nchar("chipSd: ")-nchar(object@chipSd))),collapse=''),
             object@chipSd,"\n"))
        cat("",paste0("chipSmooth: ",paste(rep(" ",
            times=(widthDisplay-nchar("chipSmooth: ")-nchar(object@chipSmooth))),collapse=''),
            object@chipSmooth,"\n"))

    } else if(grepl("GoF",object@tags)){
      cat(rep("_", widthDisplay),"\n","\n")
      title <- as.character("genomicProfiles object: Goodness of Fit ")
      titleWidth<-nchar(title, type="byte")
      cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
      cat(rep("_", widthDisplay),"\n","\n")
      profile<-object@profiles

      metrics<- names(profile[[1]][[1]])[!grepl("Mean",names(profile[[1]][[1]]))]
      cat("","Selected Goodness of Fit metrics: ","\n")
      for(i in seq_along(metrics)){
         cat("",metrics[i],"\n")
      }
      cat(rep("_", widthDisplay),"\n","\n")
      cat("",paste(length(profile),"parameter combinations for",length(profile[[1]]),"loci"),"\n")
      cat(rep("_", widthDisplay),"\n","\n")
      if(length(profile)<2){
          cat("","Parameter combination: ",names(profile),"\n","\n")
          print(profile[[1]][[1]][grep("Mean",names(profile[[1]][[1]]))])
          cat("\n",paste(names(profile[[1]]),"\n"))
          cat("\n")
            cat(rep("_", widthDisplay),"\n","\n")
      }else{
          cat("","Parameter combination: ",names(profile)[1],"\n","\n")
          print(profile[[1]][[1]][grep("Mean",names(profile[[1]][[1]]))])
          cat("\n",paste(names(profile[[1]]),"\n"))
          cat("\n")
          cat("",length(profile)-1," remaining combinations","\n","\n")
          cat("",paste0("Parameter combination: ",paste(rep(" ",
            times=(widthDisplay-nchar(paste0(names(profile)[1],"(loci = ",length(profile[[1]]),")")))),collapse=''),
            names(profile)[2:length(profile)]," (loci = ",sapply(profile, length)[2:length(profile)],")\n"))
            cat(rep("_", widthDisplay),"\n","\n")
      }

    }
    }
)


setMethod("show",
    signature = "parameterOptions",
    definition = function(object){
        widthDisplay<-round(options()$width*0.75)
        line1<-class(object)
        line2<-paste("Ploidy: ",paste(rep(" ",
          times=(widthDisplay-nchar("Ploidy: ")-nchar(object@ploidy))),collapse=''),
          object@ploidy,"\n")

        line3<-paste("boundMolecules: ",paste(rep(" ",
          times=(widthDisplay-nchar("boundMolecules: ")-nchar(object@boundMolecules[1]))),collapse=''),
          object@boundMolecules,"\n")

        line4<-paste("maxSignal: ",paste(rep(" ",
          times=(widthDisplay-nchar("maxSignal: ")-nchar(object@maxSignal))),collapse=''),
          object@maxSignal,"\n")

        line5<-paste("backgroundSignal: ",paste(rep(" ",
           times=(widthDisplay-nchar("backgroundSignal: ")-nchar(object@backgroundSignal))),collapse=''),
           object@backgroundSignal,"\n")

        line6<-paste("chipMean: ",paste(rep(" ",
           times=(widthDisplay-nchar("chipMean: ")-nchar(object@chipMean))),collapse=''),
           object@chipMean,"\n")

        line7<-paste("chipSd: ",paste(rep(" ",
            times=(widthDisplay-nchar("chipSd: ")-nchar(object@chipSd))),collapse=''),
            object@chipSd,"\n")

        line8<-paste("chipSmooth:",paste(rep(" ",
           times=(widthDisplay-nchar("chipSmooth:")-nchar(object@chipSmooth))),collapse=''),
           object@chipSmooth,"\n")

        line9<-paste("stepSize: ",paste(rep(" ",
           times=(widthDisplay-nchar("StepSize: ")-nchar(object@stepSize))),collapse=''),
           object@stepSize,"\n")
        line10<-paste("lociWidth: ",paste(rep(" ",
           times=(widthDisplay-nchar("lociWidth: ")-nchar(object@lociWidth))),collapse=''),
           object@lociWidth,"\n")
        line11<-paste("removeBackground: ",paste(rep(" ",
           times=(widthDisplay-nchar("removeBackground: ")-nchar(object@removeBackground))),collapse=''),
          object@removeBackground,"\n")
        line12<-paste("noiseFilter: ",paste(rep(" ",
           times=(widthDisplay-nchar("noiseFilter: ")-nchar(object@noiseFilter))),collapse=''),
           object@noiseFilter,"\n")
        line13<-paste("naturalLog: ",paste(rep(" ",
           times=(widthDisplay-nchar("naturalLog: ")-nchar(object@naturalLog))),collapse=''),
           object@naturalLog,"\n")
        line14<-paste("noOfSites: ",paste(rep(" ",
           times=(widthDisplay-nchar("noOfSites: ")-nchar(object@noOfSites))),collapse=''),
           object@noOfSites,"\n")
        line15<-paste("PWMThreshold: ",paste(rep(" ",
          times=(widthDisplay-nchar("PWMThreshold: ")-nchar(object@PWMThreshold))),collapse=''),
          object@PWMThreshold,"\n")
        line16<-paste("strandRule: ",paste(rep(" ",
          times=(widthDisplay-nchar("strandRule: ")-nchar(object@strandRule))),collapse=''),
          object@strandRule,"\n")
        line17<-paste("whichstrand: ",paste(rep(" ",
           times=(widthDisplay-nchar("whichstrand: ")-nchar(object@whichstrand))),collapse=''),
           object@whichstrand,"\n")
        line18<-paste("PWMpseudocount: ",paste(rep(" ",
           times=(widthDisplay-nchar("PWMpseudocount: ")-nchar(object@PWMpseudocount))),collapse=''),
           object@PWMpseudocount,"\n")
       line19<-paste("lambdaPWM: ",paste(rep(" ",
          times=(widthDisplay-nchar("lambdaPWM: ")-nchar(object@lambdaPWM[1]))),collapse=''),
         object@lambdaPWM,"\n")

      ### conditional prinint
      if(object@paramTag=="empty"){
        cat(rep("_", widthDisplay),"\n")
        title <- line1
        titleWidth<-nchar(title, type="byte")

        cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
        cat(rep("_", widthDisplay),"\n")

        cat("",paste("processingChIP options","\n","\n"),line6,line7,
          line8, line10,line12,"\n")
          cat(rep("_", widthDisplay),"\n")
        cat("",paste("processingChIP options Updated","\n","\n"),line4,line5,"\n")
        cat(rep("_", widthDisplay),"\n")
        cat("",paste("Position Weight Matrix Options","\n","\n"),line13,line14,line18,"\n")
        cat(rep("_", widthDisplay),"\n")
        cat("",paste("Genome Wide Score options","\n","\n"),line16,line17,line19,"\n")
        cat(rep("_", widthDisplay),"\n")
        cat("",paste("PWM Scores above Threshold options","\n","\n"),line16,line17,"\n")
        cat(rep("_", widthDisplay),"\n")
        cat("",paste("Occupancy options","\n","\n"),line2,line19,line3,line4,line5,"\n")
        cat(rep("_", widthDisplay),"\n")
        cat("",paste("ChIP Profile options","\n","\n"),line6,line7,line8,line9,"\n")
        cat(rep("_", widthDisplay),"\n")

      }




    }
)



setMethod("show",
    signature = "ChIPScore",
    definition = function(object){

    widthDisplay<-round(options()$width*0.75)


        scores<-object@scores
        cat(rep("_", widthDisplay),"\n")
        title <- as.character(paste("ChIP score from", length(scores),"regions"))
        titleWidth<-nchar(title, type="byte")

      cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
        cat(rep("_", widthDisplay),"\n")

        if(length(scores)>6){
          topScore <- c(paste(round(scores[[1]][1:6],digits=3),sep='',collapse=' '),
                        paste(round(scores[[2]][1:6],digits=3),sep='',collapse=' '),
                        paste(round(scores[[3]][1:6],digits=3),sep='',collapse=' '))
          len<-length(scores)
          bottomScore <- c(paste(round(scores[[len-2]][1:6],digits=3),sep='',collapse=' '),
                        paste(round(scores[[len-1]][1:6],digits=3),sep='',collapse=' '),
                        paste(round(scores[[len]][1:6],digits=3),sep='',collapse=' '))

           cat("",paste("[",1:3,"] ",head(names(scores),3)," : ",topScore,"...\n"),
               paste("     . . .","\n"),
               paste("     . . .","\n"),
               paste("     . . .","\n"),
               paste("[",(len-2):len,"] ",tail(names(scores),3)," : ",bottomScore,"...\n")
               )
        } else{
           cat(paste("[",seq_along(scores),"] ",names(scores)),"\n")
        }
        cat(rep("_", widthDisplay),"\n","\n")

        cat(rep("_", widthDisplay),"\n","\n")
        title <- paste("Top ", length(object@loci)," regions")
        titleWidth<-nchar(title, type="char")
        cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
        cat(rep("_", widthDisplay),"\n")
        print(object@loci)
        cat(rep("_", widthDisplay),"\n","\n")

        cat(rep("_", widthDisplay),"\n","\n")
        title <- "Associated Options"
        titleWidth<-nchar(title, type="byte")
        cat(rep(" ",ceiling((widthDisplay)/5)),title,"\n")
        cat(rep("_", widthDisplay),"\n")
        line<-paste("","backgroundSignal: ",paste(rep(" ",
          times=(widthDisplay-nchar("backgroundSignal: ")-nchar(object@backgroundSignal))),collapse=''),
          object@backgroundSignal,"\n")
        line2<-paste("maxSignal: ",paste(rep(" ",
          times=(widthDisplay-nchar("maxSignal: ")-nchar(object@maxSignal))),collapse=''),
          object@maxSignal,"\n")
        line3<-paste("chipMean: ",paste(rep(" ",
          times=(widthDisplay-nchar("chipMean: ")-nchar(object@chipMean))),collapse=''),
          object@chipMean,"\n")
        line4<-paste("chipSd: ",paste(rep(" ",
          times=(widthDisplay-nchar("chipSd: ")-nchar(object@chipSd))),collapse=''),
          object@chipSd,"\n")
        line5<-paste("chipSmooth: ",paste(rep(" ",
            times=(widthDisplay-nchar("chipSmooth: ")-nchar(object@chipSmooth))),collapse=''),
            object@chipSmooth,"\n")
        line6<-paste("lociWidth: ",paste(rep(" ",
          times=(widthDisplay-nchar("lociWidth: ")-nchar(object@lociWidth))),collapse=''),
          object@lociWidth,"\n")
        cat(line,line2,line3,line4,line5,line6)
        cat(rep("_", widthDisplay),"\n")

      }

)

##############################################
#############      S4 Methods    #############
##############################################

### Genomic Profiles internal MEthods
setMethod("PositionWeightMatrix","genomicProfilesInternal",
    function(object) object@PWM
)


setReplaceMethod("PositionWeightMatrix",
    signature(object="genomicProfilesInternal",
        value="matrix"),
    function(object, value){
        object@PWM<-value
    return(object)
    }
)


setMethod("PositionFrequencyMatrix","genomicProfilesInternal",
    function(object) object@PFM
)

setReplaceMethod("PositionFrequencyMatrix",
    signature(object="genomicProfilesInternal",
        value="matrix"),
    function(object, value){
        object@PFM<-value
    return(object)
    }
)


setReplaceMethod("PositionFrequencyMatrix",
    signature(object="genomicProfilesInternal",
        value="character"),
    function(object,value){
        value <- .parsePFM(value,object@PFMFormat)
        object@PFM<-value
    return(object)
    }
)

setMethod("PFMFormat","genomicProfilesInternal",
    function(object) object@PFMFormat
)

setReplaceMethod("PFMFormat",
    signature(object="genomicProfilesInternal",
        value="character"),
    function(object, value){
        object@PFMFormat<-value
    return(object)
    }
)




setMethod("BPFrequency","genomicProfilesInternal",
    function(object) object@BPFrequency
)

setReplaceMethod("BPFrequency",
    signature(object="genomicProfilesInternal",
        value="vector"),
    function(object, value){
        object@BPFrequency<-value
    return(object)
    }
)


setReplaceMethod("BPFrequency",
    signature(object="genomicProfilesInternal",
        value="DNAStringSet"),
    function(object, value){
        value <- .computeBPFrequency(value)
        object@BPFrequency<-value
    return(object)
    }
)

setMethod("naturalLog","parameterOptions",
    function(object) object@naturalLog
)

setReplaceMethod("naturalLog",
    signature(object="parameterOptions",
        value="logical"),
    function(object, value){
        object@naturalLog<-value
    return(object)
    }
)


setMethod("minPWMScore","genomicProfilesInternal",
    function(object) object@minPWMScore
)
setReplaceMethod(".minPWMScore", signature(object="genomicProfilesInternal",
       value="vector"),
       function(object,value){
           object@minPWMScore<-value
           return(object)
         }
  )

setMethod("maxPWMScore","genomicProfilesInternal",
    function(object) object@maxPWMScore)

setReplaceMethod(".maxPWMScore", signature(object="genomicProfilesInternal",
    value="vector"),
       function(object,value){

           object@maxPWMScore<-value
           return(object)
         }
  )
setMethod("profiles","genomicProfilesInternal",
    function(object) object@profiles
)
setReplaceMethod(".profiles", signature(object="genomicProfilesInternal",
     value="GRList"),
     function(object,value){
       object@profiles<-value
       return(object)
     }
)


setMethod("DNASequenceLength","genomicProfilesInternal",
    function(object) object@DNASequenceLength
)

setReplaceMethod(".DNASequenceLength",
    signature(object="genomicProfilesInternal",
        value="vector"),
    function(object, value){
        object@DNASequenceLength<-value
    return(object)
    }
)

setMethod("averageExpPWMScore","genomicProfilesInternal",
    function(object) object@averageExpPWMScore
)

setReplaceMethod(".averageExpPWMScore",signature(object= "genomicProfilesInternal",
     value="numeric"),
    function(object,value){
       object@averageExpPWMScore<-value
       return(object)
    }
)

setMethod("drop","genomicProfilesInternal",
    function(object) object@drop
)

setReplaceMethod(".drop",signature(object= "genomicProfilesInternal",
    value="vector"),
    function(object, value){
       object@drop <- value
       return(object)
    }
)

setMethod(".tags","genomicProfilesInternal",
    function(object) object@tags
)

setReplaceMethod(".tags",
    signature(object="genomicProfilesInternal",
        value="character"),
    function(object, value){

        object@tags<-value

    return(object)
    }
)




## parameterOption methods

setMethod("PWMThreshold","parameterOptions",
    function(object) object@PWMThreshold
)

setReplaceMethod("PWMThreshold",
    signature(object="parameterOptions",
        value="numeric"),
    function(object, value){
        object@PWMThreshold<-value
    return(object)
    }
)


setMethod("strandRule","parameterOptions",
    function(object) object@strandRule
)

setReplaceMethod("strandRule",
    signature(object="parameterOptions",
        value="character"),
    function(object, value){
        object@strandRule<-value
    return(object)
    }
)


setMethod("whichstrand","parameterOptions",
    function(object) object@whichstrand
)

setReplaceMethod("whichstrand",
    signature(object="parameterOptions",
        value="character"),
    function(object, value){
        object@whichstrand<-value
    return(object)
    }
)




setMethod("lambdaPWM", "parameterOptions",
    function(object) object@lambdaPWM
)

setReplaceMethod("lambdaPWM",
    signature(object="parameterOptions",
        value="vector"),
    function(object,value){
        object@lambdaPWM<-value
    return(object)
    }
)

setMethod("noOfSites", "parameterOptions",
    function(object) object@noOfSites
)

setReplaceMethod("noOfSites",
    signature(object="parameterOptions",
        value="numeric"),
    function(object,value){
        object@noOfSites<-value
    return(object)
    }
)
setReplaceMethod("noOfSites",
    signature(object="parameterOptions",
        value="character"),
    function(object,value){
        object@noOfSites<-value
    return(object)
    }
)

setMethod("PWMpseudocount","parameterOptions",
    function(object) object@PWMpseudocount
)

setReplaceMethod("PWMpseudocount",
    signature(object="parameterOptions",
        value="numeric"),
    function(object, value){
        object@PWMpseudocount<-value
    return(object)
    }
)


setMethod("ploidy","parameterOptions",
    function(object) object@ploidy
)

setReplaceMethod("ploidy",
    signature(object="parameterOptions",
        value="numeric"),
    function(object, value){
        object@ploidy<-value
    return(object)
    }
)

setMethod("boundMolecules","parameterOptions",
    function(object) object@boundMolecules
)

setReplaceMethod("boundMolecules",
    signature(object="parameterOptions",
        value="vector"),
    function(object, value){
        object@boundMolecules<-value
    return(object)
    }
)

setMethod("maxSignal","parameterOptions",
    function(object) object@maxSignal
)

setReplaceMethod("maxSignal",
    signature(object="parameterOptions",
        value="numeric"),
    function(object, value){
        object@maxSignal<-value
    return(object)
    }
)

setMethod("backgroundSignal","parameterOptions",
    function(object) object@backgroundSignal
)

setReplaceMethod("backgroundSignal",
    signature(object="parameterOptions",
        value="numeric"),
    function(object, value){
        object@backgroundSignal<-value
    return(object)
    }
)

setMethod("chipMean","parameterOptions",
    function(object) object@chipMean
)

setReplaceMethod("chipMean",
    signature(object="parameterOptions",
        value="numeric"),
    function(object, value){
        object@chipMean<-value
    return(object)
    }
)

setMethod("chipSd","parameterOptions",
    function(object) object@chipSd
)

setReplaceMethod("chipSd",
    signature(object="parameterOptions",
        value="numeric"),
    function(object, value){
        object@chipSd<-value
    return(object)
    }
)

setMethod("chipSmooth","parameterOptions",
    function(object) object@chipSmooth
)

setReplaceMethod("chipSmooth",
    signature(object="parameterOptions",
        value="vector"),
    function(object, value){
        object@chipSmooth<-value
    return(object)
    }
)

setMethod("removeBackground","parameterOptions",
    function(object) object@removeBackground
)

setReplaceMethod("removeBackground",
    signature(object="parameterOptions",
        value="vector"),
    function(object, value){
        object@removeBackground<-value
    return(object)
    }
)


setMethod(".ZeroBackground","parameterOptions",
    function(object) object@ZeroBackground
)

setReplaceMethod(".ZeroBackground",
    signature(object="parameterOptions",
        value="vector"),
    function(object, value){
        object@ZeroBackground<-value
    return(object)
    }
)


setMethod("stepSize","parameterOptions",
    function(object) object@stepSize
)

setReplaceMethod("stepSize",
    signature(object="parameterOptions",
        value="numeric"),
    function(object, value){
        object@stepSize<-value
    return(object)
    }
)

setMethod("lociWidth","parameterOptions",
    function(object) object@lociWidth
)



setReplaceMethod("lociWidth",
    signature(object="parameterOptions",
        value="numeric"),
    function(object, value){
        object@lociWidth<-value
    return(object)
    }
)
setReplaceMethod("noiseFilter",
    signature(object="parameterOptions",
        value="character"),
    function(object, value){

        object@noiseFilter<-value

    return(object)
    }
)

setMethod("noiseFilter","parameterOptions",
    function(object) object@noiseFilter
)



setMethod(".paramTag","parameterOptions",
    function(object) object@paramTag
)

setReplaceMethod(".paramTag",
    signature(object="parameterOptions",
        value="character"),
    function(object, value){

        object@paramTag<-value

         return(object)
    }
)


setMethod("loci","ChIPScore",
    function(object) object@loci
)

setReplaceMethod(".loci",
    signature(object="ChIPScore",
        value="loci"),
    function(object, value){

        object@loci<-value

         return(object)
    }
)

setMethod("scores","ChIPScore",
    function(object) object@scores
)

setReplaceMethod(".scores",
    signature(object="ChIPScore",
        value="list"),
    function(object, value){

        object@scores<-value

         return(object)
    }
)

---
title: "The ChIPanalyser User's Guide"
author: "Patrick Martin"
output:
    pdf_document: null
    keep_tex: yes
    number_sections: no
    html_document: default
package: '`ChIPanalyser'''
vignette: |
    %\VignetteIndexEntry{ChIPanalyser User's Guide}
    %\VignetteEncoding{UTF-8}
    %\VignetteEngine{knitr::rmarkdown}
---

# Introduction - What is this package?
ChIPanalyser provides a quick an easy method to predict and explain TF binding. The package uses a statistical thermodynamic framework to model the bidning of proteins to DNA.
ChIPanalyser makes the assumption that the probability that any given sites along the genome is bound by a TF can be explained by four main factors: DNA accessibility, Binding energy, a scaling factor 
modulating binding energy ($\lambda$) and number of TF bound ($N$) to DNA. Both $N$ and $\lambda$ are inferred internally by maximisng (or  minimising) a goodness of fit metric between 
predictions and actual ChIP-data. The package will produce a ChIP like profile at a base pair level. As opposed to machine learning type frameworks, if these paramters are known by other means (experimentally), ChIPanalyser does require any training to produce ChIP like profiles. Estimated values can directly be plugged into the model. Furthermore, ChIPanalyser helps gain an understanding of the mechanims behind TF binding as described by (Zabet et al 2015 & Martin and Zabet 2019).

# Methods - The Model

As described above, ChIPAnalyser is based on an approximation of statistical
thermodynamics. The core formula describing TF binding is given by :
$$P(N,a,\lambda,\omega)_{j} = \frac{N \cdot a_{j} \cdot e^{(\frac{1}{\lambda}
\cdot \omega_{j})}}{N \cdot a_{j} \cdot e^{(\frac{1}{\lambda}
\cdot \omega_{j})}+ L \cdot n \cdot [a_{i} \cdot e^{(\frac{1}
\lambda \cdot \omega_j)}]_ {i}} $$
with

* N , the number of TF molecules bound to DNA
* a , DNA accessibility
* $\lambda$ , a parameter scaling the specificity of a given TF
* $\omega$ , a Position Weight Matrix.



# Work Flow
The next section will be split between the following subsections

* **Loading Data** - Description of internal Data. We will use this data for our
work flow example.
* **Quick Start** - We will give quick start example. Only core functionalities
and work flow will be described in this section.
* **Advanced Work** - We will describe a more indepth work flow.
* **Parameter Description** - We will give an in depth description of each
parameter used in ChIPAnalyser

## Loading Data

Before going through the inner workings of the package and the work flow,
this section will quickly demonstrate how to load example datasets
stored in the package. This data represents a minimal workable examples for
the different functions. All data is derived from real biological data
in *Drosophila melanogaster* (The *Drosophila melanogaster*
genome can be found as a `BSgenome` ).

```{r, eval=TRUE, warnings = FALSE, echo=TRUE,message=FALSE}

library(ChIPanalyser)

#Load data
data(ChIPanalyserData)


# Loading DNASequenceSet from BSgenome object
# We recommend using the latest version of the genome 
# Please ensure that all your data is aligned to the same version of the genome

library(BSgenome.Dmelanogaster.UCSC.dm6)

DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)



#Loading Position Frequency Matrix

PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")

#Checking if correctly loaded
ls()

```
The global environment should now contain a few new variables:
DNASequenceSet, PFM, Access, geneRef, top, chip.

* `DNASequenceSet` is DNAStringSet extracted from the
*Drosophila melanogaster* genome (BSgenome). It is advised to
use a full genome sequence for this object.

* `PFM` is a path to file. In this case, it is a Position Frequency Matrix
derived from the Bicoid Transcription factor in *Drosophila melanogaster*in _RAW_ format.
we provide loading support for JASPAR, Transfac and RAW. If you wish to use any other format,
we suggest to use the MotifDb package (or load PFM as matrix into R) and parse the matrix to ChIPanalyser.
In this scenario, `PFMFormat` argument should be set to _matrix_ (see below for more information).

* `Access` is a `GRanges` object containing accessible DNA for
the sequence above.

* `geneRef` is a `GRanges` containing gene reference annotations. 

* `top` is a `GRanges` object with 4 genomic regions containing BEAF-32 binding.

* `chip` is a `GRanges` with ChIP score for the BEAF-32 Transcription Factor.

**IMPORTANT:** Data sets provided in the package have been currated to meet the
size requirements for Bioconductor packages. Please read the instruction below 
carefully as we will describe how to incorportate your own data into the pipe line.

**NOTE** You can download gene reference from (Genome UCSC website)[https://genome.ucsc.edu/]

## Quick Start

### Step 1 - Extracting Normalised ChIP scores from ChIP-seq datasets

ChIPAnalyser requires ChIP data in order to infer the optimal set of values
that will be assigned to bound Molecules and lambda.
The package will maximise (or minimise) a goodness of fit metric between the predictions and ChIP data.

If you have inferred or approximated the values to be assigned to $N$ and $\lambda$ by other means,
skip this step and go directly to **Advanced Work**.

`chip` can be a connection to your ChIP data, a GRanges of your ChIP
or data frame (_bed_ format style)
`loci` is a GRanges object containing loci of interest. Default set as NULL
(see **Advanced Work**)

```{r,eval=TRUE, warnings = FALSE}
chip <- processingChIP(profile = chip,
                      loci = top,
                      cores = 1)
chip
```
The output of `processingChIP` returns a `ChIPScore` object containing
extracted and normalised ChIP scores, your loci of interest and internal
parameters associated to the ChIP extractions process.

### Step 2 - Computing a PWMs
The model relies on a Postion Weight Matrix. `genomicProfiles` serve as a way
of storing important paramters. More importantly, this object stores intermediate 
results as you make your way through the analysis pipeline.

From a Position Frequency Matrix:

```{r, eval =TRUE}
# PFMs are automatically converted to PWM when build genomicProfiles
GP <- genomicProfiles(PFM = PFM, PFMFormat = "JASPAR")
GP
```

From a Position Weight Matrix:

```{r, eval=FALSE}
GP <- genomicProfiles(PWM=PositionWeightMatrix)
```

### Step 3 - Computing Optimal Parameters
As described above, ChIPanalyser infers the optimal combination of bound molecules
and lambda that will maximise (or minimise) a goodness of fit metric.
The following function computes the optimal set of parameters and returns intermediate steps of
the analysis pipeline. To do so, we will be parsing the follwing: a DNA sequence,
a Position Weight Matrix (contained in a genomicProfiles), chromatin States (Accessible DNA - This is optional), 
and extracted/normalised experimental ChIP score (result of the `processingChIP` function).

```{r,eval=TRUE,warnings=FALSE}
## surpress dependency warnings
optimal <- suppressWarnings(computeOptimal(genomicProfiles = GP,
                        DNASequenceSet = DNASequenceSet,
                        ChIPScore = chip,
                        chromatinState = Access))
```
NOTE Default Optimal parameters are provided internally as the following:

```{r, eval=TRUE, echo=TRUE}
 ## Lambda Values
 seq(0.25,5,by=0.25)

 ## Bound Molecule Values
 c(1, 10, 20, 50, 100,
    200, 500,1000,2000, 5000,10000,20000,50000, 100000,
    200000, 500000, 1000000)
```

NOTE To change these parameters see __Advanced Work__

### Step 4 - Extracting Optimal Paramters (Prelim)
Once computed, we will extract the optimal set of parameters.

```{r, eval =T}
optimalParam <- optimal$Optimal
optimalParam$OptimalParameters
```
We can see the opitmal set of parameters suggested by ChIPanalyser.


### Step 5 - Plotting Optimal Set of Parameters
Despite ChIPanalyser returning suggested optimal parameters, you may wish to
visualise the optimal parameters for each paramter combination and choose your
own set of parameters. To this effect, we have implemented an Optimal parameter
plotting fucntion.


```{r, eval=TRUE, warnings = FALSE, fig.width=10, fig.height=8}
# Plotting Optimal heat maps
par(oma=c(0,0,3,0))
layout(matrix(1:8,ncol=4, byrow=T),width=c(6,1.5,6,1.5),height=c(1,1))
plotOptimalHeatMaps(optimalParam,layout=FALSE)

```

### Step 6 - Extracting Optimal Set of Parameters with associated data
Once satisfied with your choice of optimal parameters, you can extracted the data
associated to those parameters. You can select more that one parameter however 
the values assigned to each argument must be one of the values used for computing the 
optimal set of parameters. 

```{r,eval=TRUE}
optimalParam <- searchSites(optimal,lambdaPWM = 1.25,BoundMolecules = 10000)
```

### Step 7 - Plotting ChIP_seq like profiles
The final step is to plot the computed predicted profiles. We provide a plotting
function to produce predicted profile plots.

```{r, eval=TRUE,fig.width=15, fig.height=8}
plotOccupancyProfile(predictedProfile = optimalParam$ChIPProfiles,
                     ChIPScore = chip,
                     chromatinState = Access,
                     occupancy = optimalParam$Occupancy,
                     goodnessOfFit = optimalParam$goodnessOfFit,
                     geneRef = geneRef)
```

## Advanced Work
In this section we will describe a more in depth work flow. This will include
parameter tweakin, annexe functions and some insights into the outputs of each functions.

### Step 1 - Parameter Set Up
Some parameters can be changed between each step of the pipeline. These parameters
will enable you to tweak and improve the quality of your analysis.

There are many parameters to choose from. These parameters already have default value assigned to them.

```{r, eval =TRUE}
## Suggested Parameters to start with.
parameterOptions()

## Changing parameters
PO <- parameterOptions(noiseFilter="sigmoid",chipSd=150,chipMean=150,lociWidth=30000)
```
NOTE If you wish to do so, you can change all your parameters at this step.
These parameters will be parsed through the different steps of the pipeline as long as you parse this object to each step of the analysis. 

### Step 2 - Extracting Normalised ChIP scores.
In some case you will not have a pre-determined idea of which loci you wish to look at.
The `processingChIP` function offers a few possibilities to work around this issue.

```{r,eval=FALSE}
## Top 50 loci based on ChIP score
processingChIP(profile = "/path/to/ChIP",
               loci = NULL,
               reduce = 50,
               parameterOptions = PO)

## Top 50 loci ALSO containing peaks
processingChIP(profile = "/path/to/ChIP",
               loci = NULL,
               reduce = 50,
               peaks = "/path/to/peaks",
               parameterOptions=PO)

## Top 50 loci containing BOTH peaks and Accessible DNA
processingChIP(profile = "/path/to/ChIP",
               loci = NULL,
               reduce = 50,
               peaks = "/path/to/peaks",
               chromatinState = "/path/to/chromatinState",
               parameterOptions = PO)

```

Loci will be computed internally based on the ChIP score provided. ChIP Scores will be tilled into bins of width equals to the value assigned to the `lociWidth`
argument in the `parameterOptions` object (see above). The default loci width is set at
20 kbp. Top regions are selected based on ordered ChIP scores.

**Most genomic formats are supported by ChIPanalyser (wig, bed, bedGraph, bigWig, bigBed). The "path/to/file" may also be a GRanges object. **

`processingChIP` function returns extracted/Normalised ChIP scores (list of numeric vectors), the loci of inetrest (GRanges), and associated paramters that have been extracted (such as maxSignal and backgroundSignal). The loci are the top _n_ regions as selected by the reduce argument. Using the `loci()` accessor applied on a ChIPScore object will return a GRanges of selected loci. The `scores()` accessors applied on a `ChIPScore` object will return the normalised scores associated to each Locus. 

NOTE This function also supports multi core computing.

### Step 3 - Position Weight Matrix and Associated Paramters
Computing the PWM from PFMs can be tweaked by using some additional parameters.
PWMs depend on Base Pair Frequency in the genome of interest. Either you can provide
a vector containing the base pair frequency (A C T G in order) or the `genomicProfiles`
object will compute it internally if you provide a BSgenome/DNAStringSet.

```{r, eval=TRUE}
str(genomicProfiles())

GP <- genomicProfiles(PFM=PFM, PFMFormat="JASPAR", BPFrequency=DNASequenceSet)
GP
```

The `genomicProfiles` object also contains all parameters described
in `parameterOptions`. This makes the parsing of parameters straight forward between each step of
the analysis pipeline. The `genomicProfiles` object will be updated internally as you provided More
parameters. This object will also be the main object that you will parse through each step of the analysis.
There are a few different ways to add new paramters:

```{r, eval=FALSE}
## Parsing pre computed parameters (processingChIP function)
GP <- genomicProfiles(PFM = PFM, 
                     PFMFormat = "JASPAR",
                     BPFrequency = DNASequenceSet,
                     ChIPScore = ChIPScore)

## Parsing pre assigned function (parameterOptions)
parameterOptions <- parameterOptions(lambdaPWM = c(1,2,3),
                                     boundMolecules = c(5,50,500))
GP <- genomicProfiles(PFM = PFM, 
                     PFMFormat = "JASPAR", 
                     BPFrequency = DNASequenceSet,
                     parameterOptions = parameterOptions)

## Direct parameter assignement

GP <- genomicProfiles(PFM = PFM, 
                     PFMFormat = "JASPAR", 
                     BPFrequency = DNASequenceSet, 
                     lambdaPWM = c(1,2,3),
                     boundMolecules = c(4,500,8000))
```

NOTE `parameterOptions` object can be parsed to any function of the analysis pipeline if parameters need to be changed along the way.

### Step 4 - Computing Optimal Set of Parameters
The optimal set of parameters can be computed on custom set of values for $N$ and $\lambda$. As described above, 
there a few ways to modify parameter Options.  If you were to assign more than two values to both of these slots, these new values will be used as "Optimal Parameters Combinations".
NOTE `parameterOptions` is inherited by `genomicProfiles` hence why you can also assign those paramters to the `genomicProfiles` contructor. 


The `computeOptimal` function offers a few more options that we will briefly describe here.

```{r, eval=FALSE}
## Setting custom parameters
OP <- parameterOptions(lambdaPWM = seq(1,10,by=0.5), 
                      boundMolecules = seq(1,100000, length.out=20))

## Computing ONLY Optimal Parameters and MSE as goodness Of Fit metric
optimal <- computeOptimal(genomicProfiles = GP,
                         DNASequenceSet = DNASequenceSet,
                         ChIPScore = chip,
                         chromatinState = Access,
                         parameterOptions = OP,
                         optimalMethod = "MSE",
                         returnAll = FALSE)

### Computing ONLY Optimal Parameters and using Rank slection method
optimal <- computeOptimal(genomicProfiles = GP,
                         DNASequenceSet = DNASequenceSet,
                         ChIPScore = chip,
                         chromatinState = Access,
                         parameterOptions = OP,
                         optimalMethod = "all",
                         rank=TRUE)

```

When the `returnAll` argument is set to _FALSE_, only the optimal parameters Will
be return. No internal Data will be returned.

Optimal Parameters are determined by selecting the best perfomring combination of paremeters. The goodness of fit score for each combination is averaged over all regions considered. When the `rank` argument is set to _TRUE_, the optimal parameters will be based on which combination of parameters showed the best performance for each regions individually. Parameter combinations are ranked based on how many individual regions performed best with that specific set of parameters.

Finally, `optimalMethod` argument will enbale you to selected the goodness Of Fit method you wish to use. 


### Step 5 - Extracting and Plotting Optimal Parameters
Now that you have selected custom parameters, you will want to plot the associated heat maps.

```{r, eval=FALSE}
## Extracted Optimal Parameters
optimalParam <- optimal$Optimal

## Plotting heat maps
plotOptimalHeatMaps(optimalParam,overlay=TRUE)
```

It is possible to plot an overlay of the optimal set of paramters of all goodness Of Fit methods.
Using the `overlay` argument in the plotting function will plot overlay the top 10% of optimal parameters as selected by each Goodness of fit metric. 

### Step 6 - Computing individual parameter combinations
Let's imagine that when looking at the optimal parameter heat maps, you would like to run a combination of parameters that is not in the ones that had been provided but you do not want to re-compute optimal parameters. Or Let us imagine that you have already an estimate of number of bound molecules. ChIPanalyser provides functions that will enable you to run the piple line on
individual parameter combinations. The steps are described as following:

```{r,eval=TRUE,warnings=FALSE}

## Creating genomic Profiles object with PFMs and associated parameters
GP <- genomicProfiles(PFM = PFM,
                      PFMFormat = "JASPAR",
                      BPFrequency = DNASequenceSet,
                      lambdaPWM = 1, 
                      boundMolecules = 58794)

## Computing Genome Wide Score required
GW <- computeGenomeWideScores(genomicProfiles = GP,
                              DNASequenceSet = DNASequenceSet,
                              chromatinState = Access)
GW
## Computing PWM score above threshold
pwm <- computePWMScore(genomicProfiles = GW,
                       DNASequenceSet = DNASequenceSet,
                       loci = chip,
                       chromatinState = Access)
pwm
## Computing Occupancy of sites above threshold

occup <- computeOccupancy(genomicProfiles = pwm)
occup
## Compute ChIP seq like profiles

pred <- computeChIPProfile(genomicProfiles = occup,
                          loci = chip)
pred
## Compute goodness Of Fit of model
accu <- profileAccuracyEstimate(genomicProfiles = pred,
                                ChIPScore = chip)
accu

```

NOTE These functions can compute multiple parameter combinations if needed. `computeOptimal`
is essentially a combination of these functions with a little more magic to it.

For more information on these functions see **Parameters Discription**

### Step 7 - Plotting Single combination

Finally, you can plot your newly computed profiles.

```{r, eval=TRUE,fig.width=12, fig.height=4.5}

plotOccupancyProfile(predictedProfile=pred,
                     ChIPScore=chip,
                     chromatinState=Access,
                     occupancy=occup,
                     goodnessOfFit=accu,
                     geneRef=geneRef)
```

In this case we have also added a gene reference object. This object is a GRanges
object containing the postion of various _genetic elements_ such as 3'UTR, 5'UTR, introns , etc

NOTE `plotOccupancyProfile` offers the possibility to customise graphical parameters. Unfortunately, `plotOptimalHeatMaps` offers limited graphical parameter customisation.


## Parameter Description 

In the following section, we will describe the different parameters present in both `parameterOptions` and `genomicProfiles`. 
Information concerning arguments to functions are described in the manual pages for each function. 

As a reminder, here are the parameter options for the `parameterOptions` object. 
Parameters are divided into different categories depending on when they are required internally.

```{r, eval=TRUE,echo=TRUE}
parameterOptions()
```

* **chipMean**: Average ChIP peak width. Peak width is used during the smoothing of ChIP data.
* **chipSd**: Standard deviation of peak width. SD of peak width is used during the smoothing of ChIP data.
* **chipSmooth**: Window width used for ChIP data smoothing.
* **lociWidth**: When no loci are provided, ChIPanalyser will split ChIP data into bins of width equals to lociWidth.
* **noiseFilter**: Noise filter applied to ChIP data. ChIPanalyser provides four filters (zero, mean, median and sigmoid).
Zero assigns 0 to any score below zero. Mean  and median assign 0 to any score below the mean or median score. 
Sigmoid applies a weight to each ChIP score based on a logistic distribution. Scores above the 95th quantile will be weighted 
with a score between 1 and 2. Scores below the 95th quantile will be weighted with a score between 1 and 0.
* **maxSignal**: Maximum ChIP score after normalisation. Required in later step of the analysis. However, this score is computed internally 
and stored into the `ChIPscore` object , result of `processingChIP`.
* **backgroundSignal**: Average ChIP score after normalisation. Required in later step of the analysis. However, this score is computed internally 
and stored into the `ChIPscore` object , result of `processingChIP`.
* **naturalLog**: Log transform to be applied to PFM to PWM conversion. If `TRUE`, natural log will be used otherwise log2 will be used.
* **noOfSites**: Number of sites in the PWM that will be used for analysis. Default is set at "all" meaning all sites will be used. In the case 
that this argument is changed, ChIPanalyser requires a numeric value describing the number of sites selected (from first site).
* **PWMpseudocount**: Pseudo-count used during PFM to PWM conversion. 
* **strandRule**: PWM score computation mode. `max` returns the highest PWM score regardless of strand. `sum` returns the sum of PWM scores over both strands.
`mean` returns the average PWM score oer both strands. It should be noted that this argument is only relevant when both strands are considered. See below.
* **whichstrand**: Strand that should be used for analysis. Options are: both `+-` or `-+`, plus only `+` or negative only `-`.
* **lambdaPWM**: Value to be assigned to $\lambda$ . Positive numeric value. 
* **ploidy**: Ploidy level of the organim used during analysis.
* **boundMolecules**: Number of molecules used to run analysis. Positive numeric value. 

As you can see, some of these parameters are used during multiple steps of the analysis. If these paremeters have been changed in either a `parameterOptions` object 
or `genomicProfiles` object, please ensure that you parse these objects to each function. Each function will extract the values you have assigned to each parameter
and use those values for analysis. It is possible to update, these parameters between each step of the analysis however, we recommend to set all parameters beforehand
to avoid unwanted parameter mismatch.

Next, we will describe the content of `genomicProfiles` objects. As a reminder, `genomicProfiles` object have the following structure:

```{r, eval=T, echo=T}
str(genomicProfiles())
```

As you can see, we are using the structure function to show all internal slots. The `genomicProfiles` object inherit from `parameterOptions`, 
contain slots that are not user updatetable and finally the show method applied to `genomicProfiles` varies with each step of the analysis. 
This is intended to reduce information overload when "looking" at an object. 

* **PWM**: A Position Weight Matrix. Either directly user provided or will be built internally if a Position Frequency Matrix is provided. 
* **PFM**: A Position Frequency Matrix. This argument can either be a path towards a file containing the PFM (RAW, JASPAR or Transfac format) 
or a matrix with rows being A, C, T, G and columns being PFM sites. 
* **PFMFormat**: Format of provided PFM. `PFMFormat` can be one of the following: RAW, JASPAR, transfac or matrix. Matrix format is used if the provided
PFM is an R matrix. 
* **BPFrequency**: Genome alphabet Frequency. This parameter can be user provided in the form of a numeric vector (Frequency of each base pair in the following order A, C, T, G).
For convenience, ChIPanalyser will automatically compute genome wide base pair frequency if a `DNAStringSet` object or `BSgenome` object is provided to this argument. 
* **minPWMScore**: minimum PWM score over entire genome. Internally updated.
* **maxPWMScore**: maximum PWM score over entire genome. Internally updated.
* **profiles**: Storage slot for PWM scores above threshold, Occupancy, ChIP like profiles and Goodness of Fit. This slot holds the results each step of the analysis. Updated internally.
* **DNASequenceLength**: Length of DNA sequence used for analysis. Updated internally but can be provided by user. 
* **averageExpPWMScore**: Average Exponetial PWM score. Updated Internally.
* **drop**: Regions that did not contain any accessible DNA or did not contain sites above threshold. 

All other parameters have either been explained above or are part of the internal working of the package. These parameters are mainly used to keep track of the advancement of the analysis 
between each step. They should not be changed by user. 



Finally, we provide a list of setter/getter functions for each slot:
```{r, eval=F, echo=T}
    ## Accessors and Setters for parameterOptions and genomicProfiles
    avrageExpPWMScore(obj)
    backgroundSignal(obj)
    backgroundSignal(obj)<-value
    boundMolecules(obj)
    boundMolecules(obj)<-value
    BPFrequency(obj)
    BPFrequency(obj)<-value
    chipMean(obj)
    chipMean(obj)<-value
    chipSd(obj)
    chipSd(obj)<-value
    chipSmooth(obj)
    chipSmooth(obj)<-value
    DNASequenceLength(obj)
    drop(obj)
    lambdaPWM(obj)
    lambdaPWM(obj)<-value
    lociWidth(obj)
    lociWidth(obj)<-value
    maxPWMScore(obj)
    maxSignal(obj)
    maxSignal(obj)<-value
    minPWMScore(obj)
    naturalLog(obj)
    naturalLog(obj)<-value
    noiseFilter(obj)
    noiseFilter(obj)<-value
    noOfSites(obj)
    noOfSites(obj)<-value
    PFMFormat(obj)
    PFMFormat(obj)<-value
    ploidy(obj)
    ploidy(obj)<-value
    PositionFrequencyMatrix(obj)
    PositionFrequencyMatrix(obj)<-value
    PositionWeightMatrix(obj)
    PositionWeightMatrix(obj)<-value
    profiles(obj)
    PWMpseudocount(obj)
    PWMpseudocount(obj)<-value
    PWMThreshold(obj)
    PWMThreshold(obj)<-value
    removeBackground(obj)
    removeBackground(obj)<-value
    stepSize(obj)
    stepSize(obj)<-value
    strandRule(obj)
    strandRule(obj)<-value
    whichstrand(obj)
    whichstrand(obj)<-value
    ## ChIPScore slots accessors 
    loci(obj)
    scores(obj)
```


## Session Info 

```{r,eval=T}
sessionInfo()
```


## References

Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

---
title: "The ChIPanalyser User's Guide"
author: "Patrick Martin"
output:
    pdf_document: null
    keep_tex: yes
    number_sections: no
    html_document: default
    code_folding: show
package: '`ChIPanalyser'''
vignette: |
    %\VignetteIndexEntry{ChIPanalyser User's Guide for Genetic Algorithms}
    %\VignetteEncoding{UTF-8}
    %\VignetteEngine{knitr::rmarkdown}
---

# Introduction - What is this package?
ChIPanalyser provides a quick an easy method to predict and explain TF binding.
The package uses a statistical thermodynamic framework to model the binding of
proteins to DNA.

The model assumes that there are four main driver to TF binding:

* Chromatin State affinity
* Binding Energy
* Number of bound Molecules
* Scaling Factor modulating binding affinity

While binding energy is given by PWM matrices, the other parameters will be
inferred by maximizing or minimizing a goodness of fit score between ChIP
data and ChIPanalyser predictions. To do so, ChIPanalyser provides a genetic
algorithm to infer optimal values for each parameter.

# Methods - The Chromatin State Model

The chromatin state model is described by the following equation derived from statistical thermodynamics:

$$P(N,a,\lambda,\omega)_j = \frac{N \cdot a_{j} \cdot e^{(\frac{1}{\lambda} \cdot \omega_{j})}}{N \cdot a_{j} \cdot e^{(\frac{1}{\lambda} \cdot \omega_{j})}+ L \cdot n \cdot [a_{i} \cdot e^{(\frac{1}{\lambda} \cdot \omega_{j})}]_ {i}} $$


* $N$ , the average number of bound molecules
* $a_{j}$ , chromatin state affinity at site j
* $\omega$ , the binding energy required for a TF to bind to site $j$ - in the form of a Position Weight Matrix Score
* $\lambda$ , a scaling factor for the Position Weight Matrix score
* $L$ , the length of the genome of interest
* $n$ , the ploidy level of the organism  


Chromatin state affinity is defined as the following:

$$a_{j} = \sum_{k} \alpha_k \cdot c_{j}^k$$

with $\alpha$ the chromatin state affinity scores for a given TF and $c$ the chromatin state at site $j$.

Shortly, the model above generates ChIP like profiles and describes the affinity of a TF to chromatin states. 
The affinity scores $a$, the number of bound molecules $N$, and lambda $\lambda$ are inferred by optimising the fit between 
predicted profiles and ChIP data using a genetic algortihm. 

# Using ChIPanalyser 

## Loading data
To demonstrate the use of ChIPanalyser and the genetic algorithm, we provide some internal data sets. We complement this data with 
external data source such a DNA sequence sets taken from the `BSgenome`package suit. 

### ChIPanalyser 
First, we load ChIPanlyser and the internal data 
```{r loading_ChIPanalyser, eval = TRUE, echo = TRUE}
library(ChIPanalyser)
# Input data 
data(ChIPanalyserData)
# PFM Matrix 
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")


```

### External Data 
To reduce the size of the internal data size, we complement our data with the _Drosophila_ DNA sequence taken from the BSgenome package suit. 
```{r bsgenome, eval = TRUE, echo = TRUE}
library(BSgenome.Dmelanogaster.UCSC.dm6)

DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)

```

### Input data : What is it? 
Now we that have loaded some data, what exactly are we looking at? The environment should contain the following new objects:

* *chip* - GRanges object containing ChIP scores. 
Essentially, ChIP data that will be used to _train_ our model. 

* *cs* - GRanges object containing Chromatin State (CS) information. 
Essentially, where each CS can be found in the genome. 

* *top* - GRanges object containing regions of interest. 
Esssentially, the genomic regions we will use for training and testing. 

* *PFM* - Path to file containing the Position Frequency Matrix. 
Essentially, this represents the binding affinity of our TF (here we are using BEAF-32)

* *DNASequenceSet* - DNAStringSet containing the DNASequenceSet of the organism we are looking at. 

## Setting Parameters
The next step consitst in setting initial parameters to run the genetic algorithm. 
```{r GA_params, eval = TRUE, echo = TRUE}
# Number of individuals per generation 
pop <- 10 

# Number of generations 
gen <- 2

# Mutation Probability 
mut <- 0.3

# Children - Number of ofspring passed to the next generation 
child <- 2 

# Method - Goodness of fit metric used to optimise the Genetic algorithm 
method <- "MSE"

```

Please note that the parameters presented here are for the sake of the vignette. We recommend using the following parameters for a first 
trial with your own data. Please be advised that these parameters will depend on the nature of the data you are using. 

```{r GA_params_recom, class.source = 'fold-hide' ,eval = FALSE, echo = TRUE}
# Number of individuals per generation 
pop <- 100 

# Number of generations 
gen <- 50

# Mutation Probability 
mut <- 0.3

# Children - Number of ofspring passed to the next generation 
child <- 10

# Method - Goodness of fit metric used to optimise the Genetic algorithm 
method <- "MSE"

```


We can also define which parameters we wish to optimise. In this example, we will optimise the number of bound molecules ($N$),
lambda ($\lambda$), the PWM Threshold and 11 different chromatin states. 
```{r opti_params, eval = TRUE, echo = TRUE}
# Parameters to optimised
params <- c("N","lambda","PWMThreshold", paste0("CS",seq(1:11)))
```

Alternatively, we can also set custom ranges for the parameters.
We will use custom ranges here to reduce computational time.
```{r opti_params2,eval = FALSE,echo= TRUE}
params_custom <- vector("list", 14)
names(params_custom) <- c("N","lambda","PWMThreshold", paste0("CS",seq(1:11)))

# vector in the format of min value, max value and number of values 
params_custom$N <- c(1,1000000,5)

params_custom$lambda <- c(1,5,5)

# Bound between 0 and 1 
params_custom$PWMThreshold <- c(0.1,0.9,5)

# Bound between 0 and 1 
CS <- c(0,1,5)
CS_loc <- grep("CS",names(params_custom))
for(i in CS_loc){
    params_custom[[i]] <- CS
}
```

## Initializing ChIPanalyser
### Building Initial objects 
The first step of any ChIPanalyser anaylsis is to create parameter object. These object contain input paramters and hold basic data. 
Here, we will load the PFM as PWM and compute the Base Pair Frequency from the DNASequenceSet. 

```{r gpp, eval = TRUE, echo = TRUE}
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR", BPFrequency=DNASequenceSet)

```

### Generating a starting population 
For clairty, we will show what a starting population looks like. This step is not stricly required as the `evolve` function can take the 
number of individuals in the poppulation (defined above by `pop`) and the parameters to be optimised (defined above by `params` or `params_custom`).
```{r generateStartingPopulation, class.source = 'fold-hide', eval = TRUE, echo = TRUE}
start_pop <- generateStartingPopulation(pop, params_custom)
```

### Pre-processing ChIP data
We will pre-proccess the ChIP data by reducing noise and converting GRanges to a ChIPscore object. This object contains normalised and smoothed
ChIP scores that will be used to train and test the model. 

```{r preprocess, eval = TRUE, echo = TRUE}
chipProfile <- processingChIP(chip,loci = top)

# Splitting data into training and testing
# We recommend setting dist to 20/80. However, here we only have 4 loci. 
splitdata <- splitData(chipProfile,dist = c(50,50),as.proportion = TRUE)

trainingSet <- splitdata$trainingSet
testingSet <- splitdata$testingSet
```
    
## Evolution 
We can run the Genetic algorithm provided by ChIPanalyser using a single function. 
The function  will generate intermediate files that allow you to check the status of the algorithm while it is running. 
It should be noted that the intermediate files are updated at each generation. This method also provides a lambda database. 
This allows for a faster run time on larger data sets as all values for lambda are pre-computed. 

If you do not want intermediate files, set the `checkpoint` argument to `FALSE`.

If you do not want to pre-compute lambda values, set the `lambda` argument to `FALSE`.

For the purpose of this vignette, we will not save intermediate files.

```{r evolve, eval = FALSE, echo = TRUE}
evo <- evolve(population = pop,
    DNASequenceSet = DNASequenceSet,
    ChIPScore = trainingSet,
    genomicProfiles = GPP,
    parameters = params_custom,
    mutationProbability = mut,
    generations = gen,
    offsprings = child,
    chromatinState = cs,
    method = method,
    filename = "This_TF_is_Best_TF",
    checkpoint = TRUE,cores= 1)

```

The output of this function returns a list of 3 elements: 

* *database* - a data frame with all parameters that have been computed through out each generation 
* *poppulation* - list containing the last generated population 
* *fitest* - list containing goodness of metric for best perfomring individuals

## Fitest of them all 
Once we have the best perfomring paramters, we can plug them into a single run of ChIPanalyser and use these parameters on a tesing set. 

### Get fitest individual
The first step is to extract the best performing individual and its associated traits from the population. 

```{r getFit, echo = TRUE, eval = TRUE}
SuperFit <- getHighestFitnessSolutions(evo$population,child=1,method=method)
single<-evo[["population"]][SuperFit]
```
### Running ChIPanalyser with fitest individual
We can use these parameters as input to the `singleRun` function to obtain the ChIP like profiles. This run represents the predicted run and 
TF binding affinity of our TF of choice. We will set fitness to `all`. This means that the function will return all 
goodness of fit metrics available. 

```{r singleRun, eval = TRUE, echo = TRUE}
# Set chromatin states for single run - create CS Granges with affinity scores
cs_single <- setChromatinStates(single,cs)[[1]]

superFit <- singleRun(indiv = single,
    DNAAffinity = cs_single,
    genomicProfiles = GPP,
    DNASequenceSet = DNASequenceSet,
    ChIPScore = testingSet,
    fitness = "all")

```

This final sections returns a list containing 3 elements: 

* *occupnacy* - genomicProfiles object containing occupancy scores for each region
* *ChIP* - genomicProfiles object containing ChIP like scores for each region 
* *gof* - goodness of fit scores for each regions and mean scores over all regions. 

## Plotting 
Finally, we plot the resulting profiles.

```{r plotOccup, eval = TRUE, echo = TRUE,fig.height= 12, fig.width=10,fig.show=TRUE}
pdf("test.pdf",height=12,width=10)
par(mfrow = c(5,1))
plotOccupancyProfile(predictedProfile = superFit$ChIP,
    ChIPScore = testingSet,
    chromatinState = cs_single,
    occupancy = superFit$occupancy,
    goodnessOfFit = superFit$gof,
    addLegend = TRUE)
dev.off()
```
    

\name{PWMThreshold}


\alias{PWMThreshold}
\title{
Accessor method for the \code{PWMThreshold} slot in  a
\code{\link{parameterOptions}} object
}
\description{
Accessor method for the \code{PWMThreshold} slot in  a
\code{\link{parameterOptions}} object
}
\usage{
PWMThreshold(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object
    }
}
\details{
The \code{computePWMScore} function requires a so-called PWM Threshold.
This threshold represents the Threshold at which PWM Score should be selected.
The \code{PWMThreshold} is a positive numeric value (between 0 and 1.
If set at 0, all sites will be selected. If set at 0.7 (Default value),
then 70 \% of PWM Score (and by extension binding sites) will be IGNORED.
The top 30 \% will be selected.
}
\value{
Returns the value assinged to the \code{PWMThreshold} slot in a
\code{\link{parameterOptions}} object
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
GPP <- parameterOptions(PWMThreshold=0.7)
#Accessing Value for  PWMThreshold
PWMThreshold(GPP)
}

\name{PositionWeightMatrix<--methods}
\docType{methods}

\alias{PositionWeightMatrix<--methods}
\title{ ~~ Methods for Function \code{PositionWeightMatrix<-}  ~~}
\description{
Setter Method for the \code{PositionWeightMatrix} slot in a
\code{\link{genomicProfiles}} object
}
\section{Methods}{
\describe{

\item{\code{PositionWeightMatrix(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{GRList-class}
\Rdversion{1.1}
\docType{class}
\alias{GRList-class}
\title{Class \code{"GRList"}}
\description{
Virutal Class to handle multiple data types for one slot
( \code{\link{profiles}})
}
\section{Objects from the Class}{A virtual Class:
No objects may be created from it.}
\section{Methods}{
    \describe{
    \item{\code{\link{GRList-class}}}{
    The purpose of this virtual classe is to store data of
    two different formats in  one slot: GRangesList and Lists}
    }
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}

\examples{
showClass("GRList")
}
\keyword{classes}

\name{plotOptimalHeatMaps}
\alias{plotOptimalHeatMaps}

\title{
Heat Map of optimal Parameters
}
\description{
\code{plotOptimalHeatMaps} will plot heat maps of optimal
Parameters and highlight the optimal combination of
\code{\link{lambdaPWM}} and \code{\link{boundMolecules}}
}

\usage{
plotOptimalHeatMaps(optimalParam,contour=TRUE,col=NULL,main=NULL,layout=TRUE,overlay=FALSE)
}
\arguments{
    \item{optimalParam}{
    \code{optimalParam} is a list containing containing optimal matricies
    (or only one if only one paramter was selected). These matricies are the
    result of the \code{computeOptimal} function
    }
    \item{contour}{
    \code{parameter} is logical. Should contour lines be plotted?
    }
    \item{col}{
    \code{col} vector of colours to be used for each heat map.
    If none are specified, rainbow colours will be used. NOTE: colour
    vector will be recyled if not enough colours are provided.
    }
    \item{main}{\code{main} title.}
    \item{layout}{\code{layout} is either TRUE or FALSE specifying if stadard
    layout should be used or not. If TRUE, each heat map will be plotted on
    an individual page with a heat map scale of the right side.}
    \item{overlay}{\code{overlay} is either TRUE or FALSE specifying if an
    overlay plot should be produced. The overlay plot takes the top 10 percent
    of best performing parameters per scoring metric and overlays them in a
    single plot. The resulting plots shows the optimal set of paramters for all
    metrics combined.}
}
\details{
Once the optimal set of Parameters ( \code{\link{lambdaPWM}}
and \code{\link{boundMolecules}} ), it is possible to plot the results
in the form of a heat map. Each heat map will be plotted in a seperate page if
layout = TRUE, If layout= FALSE, it is up to the user to define how they wish
to layout there heat maps.
}
\value{
Returns a heat map of optimal combinations of \code{\link{lambdaPWM}}
and \code{\link{boundMolecules}}. The x axis represents the different
value assigned to lambda ( \code{\link{lambdaPWM}} )
and the y axis represents the different values to boundMolecules
( \code{\link{boundMolecules}} ).
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>

}

\examples{

#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
    }
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)

#Building data objects
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR",BPFrequency=DNASequenceSet)

#Computing Optimal set of Parameters
optimalParam <- computeOptimal(genomicProfiles = GPP,
    DNASequenceSet = DNASequenceSet,
    ChIPScore = chip,
    chromatinState = Access,
    parameterOptions = OPP,
    parameter = "all",
    peakMethod="moving_kernel")
plotOptimalHeatMaps(optimalParam)
}
}

\name{getHighestFitnessSolutions}
\alias{getHighestFitnessSolutions}

\title{
Get Highest Fitness Solutions
}
\description{
\code{getHighestFitnessSolutions} extract best solution from a ChIPanalyser GA/evolve Run.
}
\usage{
getHighestFitnessSolutions(population,child=2,method="geometric")
}

\arguments{
    \item{population}{
    Population list as output by the \code{evolve} function.
    }
    \item{child}{
    numeric describing the number of solution to be extracted from Population list.
    }
    \item{method}{
    character string describing which scoring method should be used and selected from
    "geometric","ks","MSE","pearson","spearman","kendall",
    "recall","precesion","fscore","MCC","Accuracy" or "AUC".
    }

}
\details{
This function only serves as a way of extracting data from the poppulation list.
Ultimately - it is just a wrapper for some indexing.
}

\value{
Return the index of the top "child" solutions.

}

\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}


\examples{

library(ChIPanalyser)
data(ChIPanalyserData)
# See GA vignette for usage 

}

\name{searchSites}
\alias{searchSites}


\title{
Searching function for Sites above threshold and predicted ChIP-seq Profiles
}
\description{
\code{searchSites} is function enabling quick extraction and search for
parameter combinations and/or loci in any \code{\link{genomicProfiles}} object
from computeOccupancy onwards.
}
\usage{
searchSites(Sites,lambdaPWM="all",BoundMolecules="all", Locus="all")
}

\arguments{
    \item{Sites}{
    \code{Sites} is either a \code{\link{genomicProfiles}} or the result of \code{computeOptimal}
    }
    \item{lambdaPWM}{
    \code{lambdaPWM} is a numeric vector describing the ScalingFactors
    that should be searched within \code{Sites}.
    }
    \item{BoundMolecules}{
    \code{BoundMolecules} is a numeric vector describing the BoundMolecules
    that should be searched within \code{Sites}.
    }
    \item{Locus}{
    \code{Locus} is a character vector describing the Loci that should be
    searched within Sites.
    }
}
\details{
When testing numerous combinations of lambdaPWM and boundMolecules on top of many loci, it can
become challenging to navigate the large data output
\code{searchSites} will make searching in this slot a lot easier.
If all arguments are left at their default value of "all", then all Parameters
will be searched thus returning the full list of Sites above
threshold. If a value for lambdaPWM is user provided then only this lambdaPWM will be selected (all boundMolecules and loci will also be selected).
\code{searchSites} also works on the result of \code{computeOptimal}.
}
\value{
Returns object of same time as parsed to this function with only the parameters and/or loci selected.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}
\examples{

#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
  if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
      if (!requireNamespace("BiocManager", quietly=TRUE))
          install.packages("BiocManager")
      BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
      }
  library(BSgenome.Dmelanogaster.UCSC.dm6)
  DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
  # Building genomicProfiles object
  GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR", BPFrequency=DNASequenceSet)


  # Computing Genome Wide
  GenomeWide <- computeGenomeWideScore(genomicProfiles = GPP,
      DNASequenceSet = DNASequenceSet)

  #Compute PWM Scores
  PWMScores <- computePWMScore(genomicProfiles = GenomeWide,
       DNASequenceSet = DNASequenceSet, loci = top, chromatinState = Access)
  #Compute Occupnacy
  Occupancy <- computeOccupancy(genomicProfiles = PWMScores)
  searchSites(Occupancy,ScalingFactor=c(1,4), BoundMolecules = c(1,100),
      Locus="eve")

  #Compute ChIP profiles
  chipProfile <- computeChIPProfile(genomicProfiles=Occupancy,loci=top)
  searchSites(chipProfile,ScalingFactor=c(1,4), BoundMolecules = c(1,100),
      Locus="eve")

optimalParam <- computeOptimal(genomicProfiles = GPP,
        DNASequenceSet = DNASequenceSet,
        ChIPScore = chip,
        chromatinState = Access,
        parameterOptions = OPP,
        parameter = "all",
        peakMethod="moving_kernel")

searchSites(optimalParam,ScalingFactor=c(1,4), BoundMolecules = c(1,100),
    Locus="eve")

}
}

\name{computeOptimal}
\alias{computeOptimal}

\title{
compute Optimal Parameters
}
\description{
\code{ChIPanalyser} contains a set of functions some of which require two
parameters known as \code{\link{lambdaPWM}} and as
\code{\link{boundMolecules}}. These two paramters are not always known.
\code{computeOptimal} will compute these values by maximising the
correlation and minimising the Mean Squared Error between a predicted
ChIP-seq-like profile and a real ChIP-seq profile for a given loci.
}
\usage{
computeOptimal(genomicProfiles,DNASequenceSet, ChIPScore,chromatinState = NULL,
    parameterOptions = NULL, optimalMethod = "all",rank=FALSE,returnAll=TRUE,
    peakMethod="moving_kernel",cores=1)
}

\arguments{
     \item{genomicProfiles}{
     \code{genomicProfiles} is a \code{\link{genomicProfiles}}
     object containing at least a Postion Frequency Matrix or a
     Position Weight Matrix. It is strongly advised to customize this object to
     increase goodness of fit of the model when compared to real ChIP-seq data.
     }
    \item{DNASequenceSet}{
    \code{DNASequenceSet} is a \code{\link[Biostrings]{DNAStringSet}} or
    a \code{BSgenome} of the full sequence of the organism of interest.
    }

    \item{ChIPScore}{
    \code{ChIPScore} is a named list containing ChIP-seq enrichements for
    each Loci of interest. This Profile should be normalised to a base
    pair level. In other words, there should be an enrichement score for
    each base pair of a given Locus.
    }


    \item{chromatinState}{
    \code{chromatinState} is a \code{\link[GenomicRanges]{GRanges}} object
    containing either accesible sites or DNA affinity scores.
    }

    \item{parameterOptions}{
    \code{\link{parameterOptions}} is a
    \code{\link{parameterOptions}} object.
    If this object is not provided (parameterOptions = NULL),
    a new object will be created internally.
    However, it is strongly advised to tailor this object to maximise the
    goodness of fit of the model when compared to ChIP-seq data.
    }
    \item{optimalMethod}{
    \code{optimalMethod} is a character string which determines which
    method for optimal parameter selection should be selected. optimalMethod
    can be one of the following:
    pearson, spearman, kendall, ks, fscore, geometric,MSE, or all. Default is set
    to all.
    }
    \item{rank}{
    \code{rank} is a logical value indicating if optimal parameters should be
    based on rank (parameter combination occuring the most over all regions) or
    avaerage score (best perfomring combination of paramters on average over all
    regions selected). DEFAULT = FALSE
    }
    \item{returnAll}{
    \code{returnAll} is a logical value indicating if all internal objects
    should be returned. DEFAULT = TRUE. Internal objects are the following:
    Occupancy Scores, ChIP like profiles, goodness of fit metrics and optimal
    paramters. If set to FALSE, \code{computeOptimal} will only return the optimal
    parameters.
    }
    \item{peakMethod}{
    \code{peakMethod} is a character string  of one of the following:
    c("moving_kernel","truncated_kernel","exact"). If set to moving_kernel,
    the peaks will be approximated using Rcpp (Default).
    If set to truncated_kernel, the peaks will be approximated
    however this method does not require Rcpp. If set to exact, the peaks will
    not be approximated.

    }
    \item{cores}{
    \code{cores} is the number cores that will be used to compute optimal
    set of parameters.
    }
}
\details{
In order to backward infer the values of \code{\link{lambdaPWM}}
and \code{\link{boundMolecules}}, it is possible to use the
\code{computeOptimal} to find these parameters.
It should be noted that this functions requires a ChIP-seq data input.
\code{ChIPScore} (ChIP-seq data). This should be the output of the \code{\link{processingChIP}} function.
}
\value{
\code{computeOptimal} returns a list respectivly described as the optimal
set of Parameters (lambda - \code{\link{lambdaPWM}} and
\code{\link{boundMolecules}}), the optimal matrix (a matrix containing
accuracy estimates dependant on the parameter chosen), and finally the
chosen parameter. If the parameter that was chosen was "all",
then each element of this list will contain the optimal set of
parameters, optimal matricies for all of the aforementioned paramters (see \code{optimalMethod}).
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}

\examples{

#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
    }
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
chip<-processingChIP(chip,top)
#Building data objects
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR",BPFrequency=DNASequenceSet)
OPP <- parameterOptions()
#Computing Optimal set of Parameters
optimalParam <- computeOptimal(genomicProfiles = GPP,
    DNASequenceSet = DNASequenceSet,
    ChIPScore = chip,
    chromatinState = Access,
    parameterOptions = OPP,
    parameter = "all",
    peakMethod="moving_kernel")
}
}

\name{chipMean<-}


\alias{chipMean<-}

\title{
Access methods for \code{chipMean} slot in
\code{\link{parameterOptions}} object.
}
\description{
Access methods for \code{chipMean} slot in
\code{\link{parameterOptions}} object.
}
\usage{
chipMean(object)<-value
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object.}
    \item{value}{
    \code{value} is a positive numeric value that will be assigned to the
    \code{chipMean} slot.
    \code{chipMean} describes the average size of a
    ChIP-seq peak in base pairs.
    }
}
\details{
Default vlaue : 150
When computing ChIP-seq like profiles (\code{\link{computeChIPProfile}},
the occupancy values given by \code{computeOccupancy} are
transformed into ChIP-seq like profiles.
The average size of a ChIP-seq peak was described by Kaplan
(Kaplan et al. , 2011). It is advised to use the average
width of ChIP peaks from actual ChIP-seq data.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.

}
\value{
Returns a \code{\link{parameterOptions}} object with an updated
value for \code{chipMean} slot.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

Kaplan T.,Li X.-Y.,Sabo P.J.,Thomas S.,Stamatoyannopoulos J.A.,
Biggin M.D.,EisenM.B.
Quantitative models of the mechanisms that control genome-wide patterns of
transcription factor binding during early Drosophila development,
PLoS Genet.,2011, vol. 7 pg. e1001290

}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}
\examples{
# Building parameterOptions object
OPP <- parameterOptions()
# Setting new value for slot
chipMean(OPP) <- 250
}

\name{scores-methods}
\docType{methods}

\alias{scores-methods}
\title{ ~~ Methods for Function \code{scores}  ~~}
\description{
Accessor method for \code{scores} slot in a \code{ChIPScore} object.
}
\section{Methods}{
\describe{

\item{\code{scores(object)}}{
Extracted and normalised ChIP scores at loci of interest.
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{PositionFrequencyMatrix<--methods}
\docType{methods}

\alias{PositionFrequencyMatrix<--methods}

\title{ ~~ Methods for Function \code{PositionFrequencyMatrix<-}  ~~}
\description{
Setter method for the \code{PFM} slot in a
\code{\link{genomicProfiles}} object
}
\section{Methods}{
\describe{

\item{\code{PositionFrequencyMatrix(object)<-"path/to/file/"}}{
%%  ~~describe this method here~~
}

\item{\code{PositionFrequencyMatrix(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{PWMpseudocount<--methods}
\docType{methods}

\alias{PWMpseudocount<--methods}

\title{ ~~ Methods for Function \code{PWMpseudocount<-}  ~~}
\description{
Setter Method for the \code{pseudocount} slot in a
\code{\link{parameterOptions}} object
}
\section{Methods}{
\describe{

\item{\code{PWMpseudocount(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{lociWidth<--methods}
\docType{methods}

\alias{lociWidth<--methods}
\title{ ~~ Methods for Function \code{lociWidth<-}  ~~}
\description{
Setter method for the \code{loci} slot in \code{\linkS4class{ChIPScore}}
}
\section{Methods}{
\describe{

\item{\code{lociWidth(Object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{PWMpseudocount<-}


\alias{PWMpseudocount<-}

\title{
Setter Method for the \code{pseudocount} slot in a
\code{\link{parameterOptions}} object
}
\description{
Setter Method for the \code{pseudocount} slot in a
\code{\link{parameterOptions}} object
}
\usage{
PWMpseudocount(object) <- value
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object
    }
    \item{value}{
    \code{value} is a numeric value that will be assigned to the
    \code{pseudocount} slot. Defualt is set at 1
    }
}
\details{
In the context of Position Weight Matricies, the pseudocount is used to
avoid 0 probabilities during the transformation of Position Frequency Matrix
to a Position Probability Matrix and finally to a Postion Weight Matrix.
It is essentially a sample correction that is added in the case of small
sample size. The effect of the base pair to which a pseudocount was
assigned will not influence the model nor will create mathematical issues
such as infinities or zero division.
}
\value{
Returns a \code{parameterOptions} object with an updated value for
the \code{pseudocount} slot.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
GPP <- parameterOptions( PWMpseudocount=0)
#Setting Value for new PWMpseudocount
PWMpseudocount(GPP) <- 1
}

\name{generateStartingPopulation}
\alias{generateStartingPopulation}

\title{
Generate Starting population for ChIPanalyser Genetic algortihm
}
\description{
\code{generateStartingPopulation} generates a starting population with random
traits for each individual
}
\usage{
generateStartingPopulation(population,parameters,names=NULL)
}

\arguments{
    \item{population}{
    numeric value describing the number of individuals in the starting population.
    }
    \item{parameters}{
    vector or list containing each parameter that should be added to the chromosome.
    }
    \item{names}{
    character describing names that should be added to each individual.
    }
}
\details{
\code{generateStartingPopulation} generates a starting poppulation to be used
in the genetic algortihm implemented in ChIPanalyser. There are two main ways a
starting population can be generated:
  \enumerate{
      \item{by name}{
          Using names of each parameter that should be parse to each "chromosome".
          The possible paramters are N, lambda, PWMThreshold, CS
          ( DNAAffinity or DNAAccessibility also works). CS values should also contain
          a numeric value associated to each chromatin state you wish to parse.
          e.g CS1 ... CS14
          This will generate a value by sampling from a set of predefined value
          for each paramters.
      }
      \item{by value range}{
          Using a named list (names for each parameters). Each element of the list
          should contain three numeric values : length of range, min value, max value.
          (Internally - values are parse to \code{runif})
      }
  }
}

\value{
Returns a list of individuals with a random traits

}

\author{
Patrick C.N. Martin
}


\examples{

## by name
param <- c("N","lambda","PWMThreshold","CS1","CS2","CS3")

pop <- generateStartingPopulation(20,param, names = NULL)

# by range 
paramValue <- list(c(10,1,1000),c(10,0,5),c(10,0,0.9),c(10,0,1),c(10,0,1),c(10,0,1))

pop <- generateStartingPopulation(20,paramValue,names= param)

}

\name{boundMolecules}
\alias{boundMolecules}



\title{
Accessor methods for \code{boundMolecules} slot in
\code{\link{parameterOptions}} object.
}
\description{
Extract or Access \code{boundMolecules} slot in
\code{\link{parameterOptions}} object.}
\usage{
boundMolecules(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object.
    }
}
\details{
Defaut value: 1000

When computing occupancy (\code{\link{computeOccupancy}}), a value for the
number of bound Molecules to DNA is needed.
This value can be updated and set in a
\code{\link{parameterOptions}} object.
If the number of molecules is unknown,it is possible to infer this value with
\code{\link{computeOptimal}}.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.

}
\value{
Returns \code{boundMolecules} slot in
\code{\link{parameterOptions}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}
\examples{
# Building parameterOptions object
OPP <- parameterOptions()
#Checking single value by slot accessor
boundMolecules(OPP)


}

\name{noiseFilter<--methods}
\docType{methods}

\alias{noiseFilter<--methods}

\title{ ~~ Methods for Function \code{noiseFilter<-}  ~~}
\description{
Setter method for \code{noiseFilter}
}
\section{Methods}{
\describe{

\item{\code{noiseFilter(object)<-value}}{
Noise Filter that will be applied to ChIP scores
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{ChIPScore-class}
\Rdversion{1.1}
\docType{class}

\alias{ChIPScore-class}
\alias{loci,ChIPScore-method}
\alias{scores,ChIPScore-method}


\title{Class \code{"ChIPScore"}}
\description{
 \code{ChIPScore} is the result of the \code{\link{processingChIP}} function. This object contains the extracted ChIP Score from ChIP data, the loci of interest and optional paramters associated to ChIPanalyser. The loci of interest will either be user provided or the top n regions as defined by the reduce argument im \code{processingChIP}. This object has the sole purpose of aiding the storage and parsing of data and parameters.
}
\section{Objects from the Class}{
Object of this class are created internaly and will be parsed to other objects as is.
}
\section{Slots}{
  \describe{
    \item{\code{scores}:}{Object of class \code{"list"} List of extracted ChIP scores }
    \item{\code{loci}:}{Object of class \code{"loci"} GRanges containing loci of interest  }
    \item{\code{ploidy}:}{Object of class \code{"numeric"} Ploidy level of the organism }
    \item{\code{boundMolecules}:}{Object of class \code{"vector"} Number of Bound molecules to the DNA }
    \item{\code{backgroundSignal}:}{Object of class \code{"numeric"} ChIP background signal (average ChIP score) }
    \item{\code{maxSignal}:}{Object of class \code{"numeric"} max ChIP signal }
    \item{\code{lociWidth}:}{Object of class \code{"numeric"} Width of loci if reduce is used and no loci are provided }
    \item{\code{chipMean}:}{Object of class \code{"numeric"} Average ChIP peak width  }
    \item{\code{chipSd}:}{Object of class \code{"numeric"} Standard Deviation of ChIP peak width  }
    \item{\code{chipSmooth}:}{Object of class \code{"vector"} Smoothing window width for ChIP score  }
    \item{\code{stepSize}:}{Object of class \code{"numeric"} Defining resolution size of ChIP like profiles (10bp = signal will be only considered every 10bp) }
    \item{\code{removeBackground}:}{Object of class \code{"numeric"} Signal Threshold to be removed. Default removes all negative scores}
    \item{\code{noiseFilter}:}{Object of class \code{"character"} Type of noise filter to be used on ChIP data.}
    \item{\code{PWMThreshold}:}{Object of class \code{"numeric"} Threshold of PWM scores that will be selected }
    \item{\code{strandRule}:}{Object of class \code{"character"} Rule to compute strand score (max, mean or sum) }
    \item{\code{whichstrand}:}{Object of class \code{"character"} Which strand should be used to compute PWM scores.}
    \item{\code{lambdaPWM}:}{Object of class \code{"vector"} Lambda value - Scaling factor to the PWM }
    \item{\code{naturalLog}:}{Object of class \code{"logical"} PFM to PWM conversion log transform ( natural log or log2) }
    \item{\code{noOfSites}:}{Object of class \code{"nos"} Number of Sites in the PWM that should be used to compute PWM scores. }
    \item{\code{PWMpseudocount}:}{Object of class \code{"numeric"} PWM pseudocount value for PFM to PWM conversion. }
    \item{\code{paramTag}:}{Object of class \code{"character"} Internal Tag - Code progression }
  }
}
\section{Extends}{
Class \code{"\linkS4class{parameterOptions}"}, directly.
}
\section{Methods}{
  \describe{
    \item{.loci<-}{\code{signature(object = "ChIPScore", value = "loci")}: ... }
    \item{.scores<-}{\code{signature(object = "ChIPScore", value = "list")}: ... }
    \item{initialize}{\code{signature(.Object = "ChIPScore")}: ... }
    \item{loci}{\code{signature(object = "ChIPScore")}: ... }
    \item{scores}{\code{signature(object = "ChIPScore")}: ... }
    \item{show}{\code{signature(object = "ChIPScore")}: ... }
	 }
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin
}



\seealso{
\code{\link{processingChIP}}
}
\examples{
showClass("ChIPScore")
}
\keyword{classes}

\name{backgroundSignal<--methods}
\docType{methods}
\alias{backgroundSignal<--methods}

\title{ ~~ Methods for Function \code{backgroundSignal<-}  ~~}
\description{
 ~~ Methods for function \code{backgroundSignal<-}  ~~
}
\section{Methods}{
\describe{

\item{\code{backgroundSignal(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{whichstrand-methods}
\docType{methods}

\alias{whichstrand-methods}
\title{ ~~ Methods for Function \code{whichstrand}  ~~}
\description{
Accessor method for the \code{whichstrand} slot in a
\code{\linkS4class{parameterOptions}} object
}
\section{Methods}{
\describe{

\item{\code{whichstrand(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{stepSize-methods}
\docType{methods}

\alias{stepSize-methods}
\title{ ~~ Methods for Function \code{stepSize}  ~~}
\description{
Accessor method of the \code{stepSize} slot in
\code{\linkS4class{parameterOptions}} object
}
\section{Methods}{
\describe{

\item{\code{stepSize(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{maxSignal<-}


\alias{maxSignal<-}

\title{
Setter method for \code{maxSignal} slot in a
\code{\link{parameterOptions}} object.
}
\description{
Setter method for \code{maxSignal} slot in a
\code{\link{parameterOptions}} object.

}
\usage{
maxSignal(object) <- value
}
\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object.
    }
    \item{value}{
    \code{value} is a numerical value to be assigned to the
    \code{maxSignal} slot.
    }
}
\details{
In the context of \code{ChIPanalyser}, \code{maxSignal} represents the
maximum normalised ChIP-Seq signal of a given Transcription factor
(or DNA binding protein). Although, A default value of 1 has been assigned to
this slot, we strongly recommend to tailor this value accordingly.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.
}
\value{
Returns a \code{\link{parameterOptions}} with an updated
value for \code{maxSignal}.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C.N. Martin <p.martin@essex.ac.uk>
}
\examples{
# Building parameterOptions object
OPP <- parameterOptions()
#Setting new Value for maxSignal
maxSignal(OPP) <- 1.8

}

\name{initialize-methods}
\docType{methods}
\alias{initialize-methods}
\alias{initialize,ChIPScore-method}
\alias{initialize,genomicProfiles-method}
\alias{initialize,parameterOptions-method}
\title{ ~~ Methods for Function \code{initialize}  ~~}
\description{
 ~~ Methods for function \code{initialize}  ~~
}
\section{Methods}{
\describe{

\item{\code{signature(.Object = "ChIPScore")}}{
Initialize ChIPScore
}

\item{\code{signature(.Object = "genomicProfiles")}}{
Initialize genomicProfiles
}

\item{\code{signature(.Object = "parameterOptions")}}{
Initialize parameterOptions
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{computeChIPProfile}
\alias{computeChIPProfile}

\title{
Computing ChIP-seq like profiles from Occupancy data.
}
\description{
\code{computeChIPProfile} compute ChIP-seq like profile from occupancy data.
Occupancy data is computed using \code{\link{computeOccupancy}}.
}
\usage{
computeChIPProfile(genomicProfiles, loci, parameterOptions = NULL,
    norm = TRUE, method = c("moving_kernel","truncated_kernel","exact"),
    peakSignificantThreshold= NULL,cores=1, verbose = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{genomicProfiles}{
    \code{genomicProfiles} is the result of \code{\link{computeOccupancy}}.
    This object should be a \code{\link{genomicProfiles}} object.
    }
    \item{loci}{
    \code{loci} is either a \code{\link{GRanges}} or \code{\linkS4class{ChIPScore}}
    object. ChIPScore-class will be the result of \code{\link{processingChIP}}.
    This object represents the set of Loci you are interested in analysing.
    If you have followed the full ChIPanalyser pipe line, you would have used
    the processingChIP function that would return a ChIPScore-class object containing
    your loci of interest. GRanges are also supported if you are only using
    part of the pipeline.
    }
    \item{parameterOptions}{
    \code{parameterOptions} is a \code{\link{parameterOptions}} object.
    This object is used to store the numerous paramters offered by ChIPanalyser.
    This argument is optional as all arguments are also parse in both ChIPScore-class
    and genomicProfiles objects. If you wanted to make some last minute changes,
    \code{\link{parameterOptions}} is the way to go. We recomend that you set
    your desired options before hand.
    }
    \item{norm}{
    \code{norm} is a logical value. If TRUE, the ChIP-seq like profile will be
    normalised towards maximum Occupancy.
    If FALSE, the profile will be left as is.
    }
    \item{method}{
    \code{method} is a character string  of one of the following:
    c("moving_kernel","truncated_kernel","exact"). If set to moving_kernel,
    the peaks will be approximated using Rcpp (Default).
    If set to truncated_kernel, the peaks will be approximated
    however this method does not require Rcpp. If set to exact, the peaks will
    not be approximated.

    }
    \item{peakSignificantThreshold}{
    \code{peakSignificantThreshold} is a threshold at which peaks will be
    selected. IMPORTANT: if you select "moving_kernel" as described in
    \code{method} then this threshold is a numeric value describing the
    peak tail hight cutoff value (Default = 0.001).
    In the case of "truncated_kernel" and "exact", the threhsold represents
    a distance in base pair from the peak summit at which the peak
    should be cut (Default = 1250). The default is set to NULL in this
    function. This just means that either the value is provided bu user with
    the appropriate method. If not, the default will be selected depending
    on the method selected.
    }
    \item{cores}{
    \code{cores} is the number of cores that will be used to compute
    ChIP profiles.
    }
    \item{verbose}{
    \code{verbose} is a logical value. If TRUE, progress messages will be
    displayed in console.
    If FALSE, no progress messages will be dispalyed in console.
    }
}
\details{
\code{computeChIPProfile} converts Transcription Factor occuapncy to a profile
resembling the one of a ChIP-seq profile. Internally a few paramters are required
to build a ChIP like profile. These parameters are either defined and stored in
a \code{\linkS4class{ChIPScore}} object (Paramters are updated based on
your ChIP data ), a \code{\link{genomicProfiles}} (user defined at the
start of the analysis) or a \code{\link{parameterOptions}} (if you want to
update values as you go along)
}
\value{
Returns a \code{\link{genomicProfiles}} objec containing all ChIP-seq like
profile for every combination of \code{\link{lambdaPWM}} and \code{\link{boundMolecules}} provided by the user.

}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}


\examples{

#Extracting Data
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
    }
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
# Building genomicProfiles object
GPP <- genomicProfiles(PFM=PFM, PFMFormat="JASPAR",BPFrequency=DNASequenceSet)


# Computing Genome Wide
GenomeWide <- computeGenomeWideScores(genomicProfiles = GPP,
    DNASequenceSet = DNASequenceSet)

#Compute PWM Scores
PWMScores <- computePWMScore(genomicProfiles = GenomeWide,
     DNASequenceSet = DNASequenceSet, loci = top, chromatinState = Access)
#Compute Occupnacy
Occupancy <- computeOccupancy(genomicProfiles = PWMScores)

#Compute ChIP profiles
chipProfile <- computeChIPProfile(genomicProfiles=Occupancy,loci=top)
chipProfile
}
}

\name{nos-class}
\Rdversion{1.1}
\docType{class}
\alias{nos-class}

\title{Class \code{"nos"}}
\description{
Virtual class to handle Number of Sites
}
\section{Objects from the Class}{A virtual Class: No objects may be created from it.}
\section{Methods}{
No methods defined with class "nos" in the signature.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>

}
\examples{
showClass("nos")
}
\keyword{classes}

\name{show-methods}
\docType{methods}
\alias{show-methods}
\alias{show,ChIPScore-method}
\alias{show,genomicProfiles-method}
\alias{show,parameterOptions-method}
\title{ ~~ Methods for Function \code{show}  ~~}
\description{
Show methods for various objects
}
\section{Methods}{
\describe{

\item{\code{signature(object = "ChIPScore")}}{
%%  ~~describe this method here~~
}

\item{\code{signature(object = "genomicProfiles")}}{
%%  ~~describe this method here~~
}

\item{\code{signature(object = "parameterOptions")}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{noOfSites<-}


\alias{noOfSites<-}

\title{
Setter Method for the \code{noOfSites} slot in a
\code{\link{parameterOptions}} object.
}
\description{
Setter Method for the \code{noOfSites} slot in a
\code{\link{parameterOptions}} object.

}
\usage{
noOfSites(object) <- value
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object.
    }
    \item{value}{
    \code{value} is a positive integer that will be assigned to the
    \code{noOfSites} slot.
    }
}
\details{
While computing Position Weight Matricies (PWM) from
Position Frequency Matricies (PFM), it is possible to restrict the number
of sites that will be used to compute the PWM. The default is set at "all".
In this case, all sites will be used to compute the PWM.
}
\value{
Returns a \code{\link{parameterOptions}} object with an updated
value for the \code{noOfSites} slot.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <p.martin@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
GPP <- parameterOptions(noOfSites=0)
#Setting new Value for naturalLog
noOfSites(GPP) <- 8

}

\name{PositionFrequencyMatrix<-}


\alias{PositionFrequencyMatrix<-}

\title{
Setter method for the \code{PFM} slot in a
\code{\link{genomicProfiles}} object
}
\description{
Setter method for the \code{PFM} slot in a
\code{\link{genomicProfiles}} object
}
\usage{
PositionFrequencyMatrix(object)<- value
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}} object
    }
    \item{value}{
    \code{value} can be of two forms. Either a matrix in the form of a
    Position Frequency Matrix or a path/to/file character string.
    }
}
\details{
The Position Frequency Matrix is one of the fundamental object that needs
to be supplied to  a \code{\link{genomicProfiles}}.
If after building a \code{\link{genomicProfiles}},
only the Position Frequency Matrix needs to be modified then it is
possible to manually update the value of this matrix using the function above.
There are two options for the type of data that may be supplied to the
\code{PFM} slot: a matrix in the form of a Position Frequency Matrix
(matrix with four rows - one for each base pair (ACTG) and a number of
columns equal to the number of sites in the binding site), or it is
possible (also recommended) to provide a path to the file containing the
Position Frequency Matrix. This Position Frequency Matrix file may come
in multiple form such as RAW, Transfac or JASPAR.
WARNING: if a genomicProfiles object has already been created
and only the PFM is supplied/updated ,
then the Positon Weight Matrix will automatically updated as well.
}
\value{
Returns a \code{\link{genomicProfiles}} with an updated \code{PFM}
slot (as described above this will lead to an updated PositionWeightMatrix).
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>}

\examples{
#Loading data
data(ChIPanalyserData)
#Loading PFM files
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#Building genomicProfiles object
# NOT ADVISED!!!! PLEASE PARSE PFM AND PFMFormat together
GPP<-genomicProfiles(PFMFormat = "JASPAR")
#Setting PFM
PositionFrequencyMatrix(GPP) <- PFM
}

\name{parameterOptions}
\alias{parameterOptions}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
parameter Options object
}
\description{
\code{parameterOptions} is an object used to store and parse the various parameters
needed throughout this analysis pipeline.
}
\usage{
parameterOptions(ploidy = 2, boundMolecules = 1000, backgroundSignal = 0, maxSignal = 1, lociWidth = 20000, chipMean = 200, chipSd = 200, chipSmooth = 250, stepSize = 10, removeBackground = 0, noiseFilter = "zero", naturalLog = TRUE, noOfSites = "all", PWMThreshold = 0.7, strandRule = "max", whichstrand = "+-", PWMpseudocount = 1, lambdaPWM = 1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
\item{ploidy}{ \code{\link{ploidy}}:
A numeric Value descibing the ploidy of the organism. Default: 2}
\item{boundMolecules}{ \code{\link{boundMolecules}}:
A vector (or single value) containing the number of bound Molecules
(bound Transcription Factors): Default: 1000}
\item{backgroundSignal}{ \code{\link{backgroundSignal}}:
A numeric value descibing the ChIP-seq background Signal
(average signal from real ChIP seq data). Default: 0}
\item{maxSignal}{ \code{\link{maxSignal}}:
A numeric value describing the highest ChIP-seq signal
(from real ChIP-seq data). Default: 1}
\item{lociWidth}{ \code{\link{lociWidth}}:
A numeric value describing the width of the bins used to split ChIP profiles
parsed to \code{\link{processingChIP}}. Default = 20000}
\item{chipMean}{ \code{\link{chipMean}}:
A numeric value describing the mean width of a ChIP- seq peak: Default:200}
\item{chipSd}{ \code{\link{chipSd}}:
A numeric value describing the standard deviation of ChIP-seq peaks.
Default: 200 }
\item{chipSmooth}{ \code{\link{chipSmooth}}:
A numeric value describing the width of the window used to smooth
Occupancy profiles into ChIP profiles. Default:250}
\item{stepSize}{ \code{\link{stepSize}}:
A numeric value describing the step Size (in base pairs)
between each ChIP-seq score. Default:10 (Scored every 10 base pairs)}
\item{removeBackground}{ \code{\link{removeBackground}}:
A numeric value describing the value at which score should be removed.
Defualt:0 (If negative scores then remove) }
  \item{noiseFilter}{\code{\link{noiseFilter}}:
  A character string of one of the following: Zero, Mean, Median, or Sigmoid.
  Noise filter that will be applied to the ChIP Score during the \code{processingChIP} step.

}
\item{naturalLog}{ \code{\link{naturalLog}}:
A logical value describing if natural Log will be used to compute
the PWM (if FALSE then log2 will be used). Default: TRUE
}
\item{noOfSites}{ \code{\link{noOfSites}}:
A Positive integer descibing number of sites (in base pair) should
be used from the PFM to compute PWM. Default =0 (Full width of binding
site will be used when set to 0)
}

\item{PWMThreshold}{ \code{\link{PWMThreshold}}:
Threshold at which PWM Score should be selected
(only sites above threshold will be selected - between 0 and 1)
}

\item{strandRule}{ \code{\link{strandRule}}:
`mean', `max' or `sum'  will dertermine how strand should be
handle for computing PWM Scores. Default : `max'
}
\item{whichstrand}{ \code{\link{whichstrand}}: `+',`-' or `+-'
on which strand should PWM Score be computed. Default: `+-'
}

\item{PWMpseudocount}{ \code{\link{PWMpseudocount}}:
A numeric value describing a PWMpseudocount for PWM computation. Default:1
}
\item{lambdaPWM}{
A vector (or single value) contaning values for the ScalingFactorPWM
(Also known as lambda).Default:1
}
}
\details{
ChIPanalyser requires a lot of parameters. \code{parameterOptions} was created with the intent
of storing and parsing these numerous arguments to the different functions. All parameters in this object are optional although strongly recommend. Some parameters are extracted and updated from
function along the pipeline e.g. maxSignal and backgroundSignal are extracted during the
\code{processingChIP} step. These paramters will be automatically parsed. If you do not which to use them ( or any other parameter) simply parse a new parameterOptions object with your desired
paramters.
}
\value{
Returns a \code{parameterOptions} with updated values.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C. N. Martin  <p.martin@essex.ac.uk>
}

\seealso{
\code{\linkS4class{genomicProfiles}}

}
\examples{
#
parameterOptions(ploidy = 2, boundMolecules = 1000, backgroundSignal = 0,
    maxSignal = 1, lociWidth = 20000, chipMean = 200, chipSd = 200,
    chipSmooth = 250, stepSize = 10, removeBackground = 0, noiseFilter = "zero",
    naturalLog = TRUE, noOfSites = "all", PWMThreshold = 0.7,
    strandRule = "max", whichstrand = "+-", PWMpseudocount = 1,
    lambdaPWM = 1)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }% use one of  RShowDoc("KEYWORDS")
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{computePWMScore}
\alias{computePWMScore}

\title{
Compute PWM Scores of sites above threshold.
}
\description{
\code{computePWMScore} will compute and extract all sites that exhibit a
PWM Score higher than a threshold.
This threshold (see \code{\link{PWMThreshold}}) will determine the percentage
of total sites that should NOT be considered.
}
\usage{
computePWMScore(genomicProfiles,DNASequenceSet,
    loci = NULL, chromatinState = NULL,parameterOptions=NULL,cores=1, verbose = TRUE)
}

\arguments{
    \item{DNASequenceSet}{
    \code{DNASequenceSet} is a \code{\link[Biostrings]{DNAStringSet}} or a
    \code{BSgenome} containing the full sequence of the organism of interest.
    }
    \item{genomicProfiles}{
    \code{genomicProfiles} is a \code{\link{genomicProfiles}}
    object resulting from the \code{\link{computeGenomeWideScores}} function.
    }
    \item{loci}{
    \code{loci} is a \code{\link[GenomicRanges]{GRanges}}
    object containing the Loci of interest or a \code{\linkS4class{ChIPScore}} object
    result of \code{\link{processingChIP}} function.
    }
    \item{parameterOptions}{
    \code{parameterOptions} is a \code{\link{parameterOptions}}
    object containing parameters that you wish to parse/change when computing
    PWMScores.
    }
    \item{chromatinState}{
    \code{chromatinState} is a \code{\link[GenomicRanges]{GRanges}}
    object sites of accessible DNA or DNA affinity scores.
    }
    \item{cores}{
    \code{cores} is the number of cores used to compute PWM Scores.
    }
    \item{verbose}{
    \code{verbose} is a logical value indicating if progress messages
    should be printed or not.
    }
}
\details{
After determining genome wide scores, it is possible to only compute and
extract high affinity sites (in the sense that they have a high PWM Score).
If a \code{\link{PWMThreshold}} is not set by user,
the default value is set at 0.7.
This means that 70 \% of sites will NOT be selected.
Only the top 30 \% will be computed and extracted.
If one is interested in all PWM Scores at a genome wide scale
( or accessible DNA ), this is possible by setting
\code{\link{PWMThreshold}} to zero.
}
\value{
\code{\link{computePWMScore}} will return a
\code{\link{genomicProfiles}} object.
The \code{\link{profiles}} slot will have been updated.
This slot will now contain a \code{\link[GenomicRanges]{GRangesList}}
with each element being a \code{\link[GenomicRanges]{GRanges}}.
This GRanges will contain postion of each sites
(start, end and strand) and the PWMScore associated to that site.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}
\examples{

#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
    }
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
chip<-processingChIP(chip,top)
#Building data objects
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR",BPFrequency=DNASequenceSet)


# Computing Genome Wide
GenomeWide <- computeGenomeWideScores(DNASequenceSet = DNASequenceSet,
    genomicProfiles = GPP)

#Compute PWM Scores
PWMScores <- computePWMScore(DNASequenceSet = DNASequenceSet,
    genomicProfiles = GenomeWide,
    loci  = chip, chromatinState = Access)
PWMScores
}
}

\name{whichstrand}


\alias{whichstrand}
\title{
Accessor method for the \code{whichstrand} slot in a
\code{\linkS4class{parameterOptions}} object
}
\description{
Accessor method for the \code{whichstrand} slot in a
\code{\linkS4class{parameterOptions}} object
}
\usage{
whichstrand(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\linkS4class{parameterOptions}} object
    }
}
\details{
PWM Score may be computed on either the positive strand ("+"),
the negative strand ("-") or on both strands ("+-").
}
\value{
Returns on which strand PWM Scores should be computed
( \code{whichstrand} in a \code{\linkS4class{parameterOptions}} object)
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}
\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
GPP <- parameterOptions( whichstrand="+-")
#Setting New Value for whichstrand
whichstrand(GPP)
}

\name{PFMFormat}


\alias{PFMFormat}

\title{
Accesor method for the \code{PFMFormat} slot in a
\code{\link{genomicProfiles}} object
}
\description{
Accesor method for the \code{PFMFormat} slot in a
\code{\link{genomicProfiles}} object
}
\usage{
PFMFormat(object)


}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}} object
    }

}
\details{
If loading a
\code{\link{PositionFrequencyMatrix}} from a file, the format
of the file should be specified. Default is raw. Please keep in mind that
this argument is used when parsing the
\code{\link{PositionFrequencyMatrix}} file. IF this argument is changed
after building the \code{\link{genomicProfiles}} with
a PositionFrequencyMatrix file, this
will not influence the parsing of the file.
\code{PFMFormat} can be one of the following:
"raw","transfac","JASPAR" or "sequences"
}
\value{
Returns the value assigned to the \code{PFMFormat} slot a
\code{\link{genomicProfiles}}
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)
#Loading PFM files
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#Building data objects
#### THIS IS THE PREFFERED METHOD FOR SETTING PFMFormat
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR")
#Setting New value for PFMFormat
PFMFormat(GPP)
}

\name{BPFrequency<-}

\alias{BPFrequency<-}




\title{
Setter method for \code{BPFrequency} slot in a
\code{\link{genomicProfiles}} object.
}
\description{
Setter method for \code{BPFrequency} slot in a
\code{\link{genomicProfiles}} object.
If base pair frequency is unknown, \code{BPFrequency} will compute base pair
frequency from a DNA sequence.
}

\usage{
BPFrequency(object)<-value
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}} object.
    }
    \item{value}{
    \code{value} can three different objects:


    A vector of length 4 containing the probability of occurrence of each base
    pair (A,C,G,T) in order.
    Default value is c(0.25,0.25,0.25,0.25).


    A \code{BSgenome} of the organism of interest. The base pair frequency will
    automatically be computed and updated in
    \code{\link{genomicProfiles}}.


    A \code{\link[Biostrings]{DNAStringSet}} of the organisme of interest.
    The base pair frequency will automatically be computed and updated
    in \code{\link{genomicProfiles}} (Prefered method).
    }
}


\details{
Default value is c(0.25,0.25,0.25,0.25)
When generating a Postion Weight Matrix from a Position Frequency Matrix,
the probability of occurrence of each base pair (Base Pair Frequency) is
necessary (as originally described by Gary Stormo). It is possible to
set custom values for \code{BPFrequency} with a vector of length 4
containing the probability of occurrence of each base pair (A,C,G,T) in order.
If Base pair frequency is unknown, \code{BPFrequency} will compute base pair
frequency from a DNA sequence when building a
\code{\link{genomicProfiles}} object.
The nature of this sequence can be a\code{BSgenome} object or a
\code{\link[Biostrings]{DNAStringSet}}. In order to decrease run time,
it is advised to use \code{\link[Biostrings]{DNAStringSet}}.
}
\value{
Returns a \code{\link{genomicProfiles}} object with an updated
value for \code{BPFrequency}.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}

\examples{

data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
    }
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
# Building genomicProfiles object
GPP <- genomicProfiles(PFM=PFM,PFMFormat = "JASPAR", BPFrequency=DNASequenceSet)
# Updating BPFrequency
## !! Note!! BPFrequency is used to compute PWM from PFM
## IF updated after building GPP, then it will not influence PWM
## Advised to build with BPFrequency directly
BPFrequency(GPP) <- DNASequenceSet
BPFrequency(GPP) <- c(0.25,0.25,0.25,0.25)
}
}

\name{chipSmooth<-}


\alias{chipSmooth<-}

\title{
Setter method for \code{chipSmooth} slot in
\code{\link{parameterOptions}} object.
}
\description{
Setter method for \code{chipSmooth} slot in
\code{\link{parameterOptions}} object.}
\usage{
chipSmooth(object) <- value
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object.
    }
    \item{value}{
    \code{value} is the positive numeric value to be assigned to the
    \code{chipSmooth} slot in \code{\link{parameterOptions}}
    Default value is 250 base pairs.
    }
}
\details{
When computing ChIP-seq like (\code{\link{computeChIPProfile}}) profile
from occupancy data (see \code{\link{computeOccupancy}}),
the profiles are smoothed using a window of a given size.
The default value is set at 250 base pairs.If \code{chipSmooth}
is set to 0 then the profile will not be smoothed.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.
}
\value{
Returns a \code{\link{parameterOptions}} object with an updated
value for \code{chipSmooth} slot.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C.N Martin <pm16057@essex.ac.uk>
}

\examples{
# Building parameterOptions object
OPP <- parameterOptions()
# Setting new value for chipSd slot
chipSmooth(OPP) <-  250
}

\name{ploidy<--methods}
\docType{methods}

\alias{ploidy<--methods}

\title{ ~~ Methods for Function \code{ploidy<-}  ~~}
\description{
Setter Method for the \code{ploidy} slot in an
\code{\link{parameterOptions}} object
}
\section{Methods}{
\describe{

\item{\code{ploidy(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{setChromatinStates}
\alias{setChromatinStates}

\title{
setChromatinStates
}
\description{
\code{setChromatinStates} sets chromatin state affinity values to a GRanges object.
}
\usage{
  setChromatinStates(population,chromatinStates)
}

\arguments{
    \item{population}{
    Population list containing all individuals and associated parameter. Must
    contain chromatin state affinity values. See \code{generateStartingPopulation}.
    }
    \item{chromatinStates}{
    GRanges object containing chromatin state locations.
    }

}
\details{
Chromatin states can be loaded into R as a GRanges object. Each range represents
the extent of a certain chromatin state and the chromatin state type should be
assigned to a meta data column called "name". The affinity values names should be
set accordingly.

}

\value{
Returns a GRange object with affinity scores for each chromatin state range.
Affinity scores are placed in the DNAAffinity meta data column.

}

\author{
Patrick C.N. Martin
}


\examples{
library(ChIPanalyser)
# Input data 
data(ChIPanalyserData)

pop <- 10
params <- c("N","lambda","PWMThreshold", paste0("CS",seq(1:11)))
start_pop <- generateStartingPopulation(pop, params)

cs <- setChromatinStates(start_pop,cs)

}

\name{PFMFormat-methods}
\docType{methods}

\alias{PFMFormat-methods}

\title{ ~~ Methods for Function \code{PFMFormat}  ~~}
\description{
Accesor method for the \code{PFMFormat} slot in a
\code{\link{genomicProfiles}} object
}
\section{Methods}{
\describe{

\item{\code{PFMFormat(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{plotOccupancyProfile}
\alias{plotOccupancyProfile}

\title{
Plot Occupancy Profiles
}
\description{
\code{plotOccupancyProfile} plots the predicted profiles.
If provided, this functions will also plot ChIP-seq profiles,
PWMScores (or Occupancy), chromatin States, Goodness of Fit estimates and gene information.
}
\usage{
  plotOccupancyProfile(predictedProfile, ChIPScore = NULL,chromatinState = NULL,
    occupancy = NULL,goodnessOfFit = NULL,PWM=FALSE,
    geneRef = NULL,addLegend = TRUE,...)
}

\arguments{
    \item{predictedProfile}{
    \code{predictedProfile} is a either \code{\link[GenomicRanges]{GRanges}}
     containing the predicted profiles for one loci, all loci selected for one paramter,
     or all loci selected for all parameter combinations selected. (see \code{\link{searchSites}})
    }
    \item{ChIPScore}{
    \code{ChIPScore} is a \code{ChIPscore} object containing ChIPscore (or
    a list of numeric values representing ChIP scores (Experimental ChIP))
    }
    \item{chromatinState}{
    \code{chromatinState} is a \code{\link[GenomicRanges]{GRanges}}
    containing accesible DNA sites or chromatin States.
    }
    

    \item{occupancy}{
    \code{occupancy} is a \code{\link[GenomicRanges]{GRanges}} or a \code{genomicProfiles}
    object contaning PWM scores and Occupancy ( see \code{computeOccupancy})
    }
    \item{goodnessOfFit}{ \code{goodnessOfFit} results of the
    \code{\link{profileAccuracyEstimate}} function.}

    \item{PWM}{
    \code{PWM} is a logical value that in the case \code{occupancy} is
    provided which of occupancy scores of PWM scores hsould be plotted.
    Default set at FALSE
    }

    \item{geneRef}{
    \code{geneRef} is a \code{\link[GenomicRanges]{GRanges}}
    containing gene information on exons,introns, UTR's, enhancers or any
    other genetic element to be plotted.
    }
    \item{addLegend}{
    \code{addLegend} is a logical value defining if the legend should be added.
    The legend will add all elements provided. See details. 
    }
    
    \item{...}{
    Any other graphical Parameter of the following : cex, cex.lab, cex.main, 
    densityCS , densityGR , ylab, xlab, main, colPred,
    colChIP, colOccup, colCS, colGR, n_axis_ticks. See details. 
    }

}
\details{
Once the predicted ChIP-seq like profiles have been computed,
it is possible to plot these profiles.

This functions allows to control graphical parameters. In short:

* col = color values - exact number of colors or colors that will 
be used in a colorRampPalettte.

* cex = font sizes - for text, axis labels and main 

* Density = fill density for chromatin state and/or geneRef blocks

Pred = predictedProfile
ChIP = ChIP score (Experimental ChIP data)
CS = Chromatin States
GR = Gene reference 
Occup = Occupnacy locations
}
\value{
Returns a profile plot with "Occupancy" on the y axis and DNA position on
the the X- axis.

}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) 
Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}

\examples{

#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
    }
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
#Building data objects
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR", BPFrequency=DNASequenceSet)


# Computing Genome Wide
GenomeWide <- computeGenomeWideScores(DNASequenceSet = DNASequenceSet,
    genomicProfiles = GPP)

#Compute PWM Scores
PWMScores <- computePWMScore(DNASequenceSet = DNASequenceSet,
    genomicProfiles = GenomeWide,
    loci = top, chromatinState = Access)
#Compute Occupnacy
Occupancy <- computeOccupancy(genomicProfiles = PWMScores)

#Compute ChIP profiles
chipProfile <- computeChipProfile(loci = top,
    genomicProfiles = Occupancy)


#Plotting Profile
plotOccupancyProfile(predictedProfile=chipProfile,
    ChIPScore = chip,
    chromatinState = Access,
    occupancy = Occupancy,
    geneRef =geneRef)

plotOccupancyProfile(predictedProfile=chipProfile,
    ChIPScore = chip,
    chromatinState = Access,
    occupancy = Occupancy,
    geneRef = geneRef,
    colCS = c("red","blue"),
    densityGR = 60)


}
}

\name{maxSignal-methods}
\docType{methods}

\alias{maxSignal-methods}

\title{ ~~ Methods for Function \code{maxSignal}  ~~}
\description{
Accessor method for \code{maxSignal}
}
\section{Methods}{
\describe{

\item{\code{maxSignal(object)}}{
Maximum ChIP signal extracted from ChIP data (see \code{processingChIP})
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{ploidy<-}


\alias{ploidy<-}

\title{
Setter Method for the \code{ploidy} slot in an
\code{\link{parameterOptions}} object
}
\description{
Setter Method for the \code{ploidy} slot in an
\code{\link{parameterOptions}} object
}

\usage{
ploidy(object)<- value
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object
    }
    \item{value}{
    \code{value} is a positive integer that describes the ploidy of the
    organism of interest.
    }
}
\details{
Default value for \code{ploidy} is set a 2. It should be mentioned that
ChIPanalyser is based on a model that also considers the ploidy of the
organism however this only considers simple polyploidy (or haploidy). T
he model does not consider hybrids such as wheat.
}
\value{
Returns a \code{\link{parameterOptions}} object with an updated
value for the \code{ploidy} slot.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}
\examples{
# Building parameterOptions object
OPP <- parameterOptions()
#Setting new Value for maxSignal
ploidy(OPP) <- 2

}

\name{drop}


\alias{drop}

\title{
Accessor Method for the \code{drop} slot in a
\code{\link{genomicProfiles}} object.
}
\description{
Accessor Method for the \code{drop} slot in a
\code{\link{genomicProfiles}} object.
}
\usage{
drop(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}} object.
    }
}
\details{
During certain computations, it is possible that the Loci of interest
do no show any overlap with accesible DNA. If this were to be the case,
a warning message will appear in the console but these inaccessible Loci
will be stored in this slot. It is also for these reasons that it is
imperative for Loci of interest to be named
(in this case, a named \code{\link[GenomicRanges]{GRanges}}).
}
\value{
Returns a character string with loci containing no accesible DNA.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C.N. Martin <p.martin@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)
#Loading PFM files
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#Building data objects
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR")

# Loci with no acces - a warning message will be issued
#if loci do no contain accesible DNA
# Otherwise this slot will remain empty

drop(GPP)
}

\name{noiseFilter<-}

\alias{noiseFilter<-}


\title{
Setter Method for the \code{noiseFilter} slot in a
\code{\link{parameterOptions}} object
}
\description{
Setter Method for the \code{noiseFilter} slot in a
\code{\link{parameterOptions}} object

}
\usage{
noiseFilter(object) <- value
}
\arguments{
    \item{object}{
    \code{object} is \code{\link{parameterOptions}} object
    }
    \item{value}{\code{value} is the value to be assigned to the
    \code{noiseFilter} slot (zero - mean - median -sigmoid)}
}
\details{
Noise filtering method that
should be used on ChIP-seq data. Four methods are available: Zero, Mean,
Median and Sigmoid. Zero removes all ChIP-seq scores bellow zero, mean under
the mean score, median under median score and sigmoid assignes a weight
to each score based on a logistic regression curve. Mid point is set at 95
95 quantile of ChIP-seq scores. Below midpoint will receive a score between
0 and 1 , everything above will receive a score between 1 and 2

}
\value{
Returns the value assigned to the \code{noiseFilter} slot in a
\code{\link{parameterOptions}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
GPP <- parameterOptions(noiseFilter="sigmoid")
#Setting new Value for noiseFilter
noiseFilter(GPP) <-"zero"


}

\name{lambdaPWM<--methods}
\docType{methods}

\alias{lambdaPWM<--methods}
\title{ ~~ Methods for Function \code{lambdaPWM<-}  ~~}
\description{
Setter method for the \code{lambdaPWM} slot in the \code{parameterOptions}
}
\section{Methods}{
\describe{

\item{\code{lambdaPWM(object)<-value}}{

}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{ploidy-methods}
\docType{methods}

\alias{ploidy-methods}

\title{ ~~ Methods for Function \code{ploidy}  ~~}
\description{
Accessor method for the \code{ploidy} slot in a
\code{\link{parameterOptions}} object
}
\section{Methods}{
\describe{

\item{\code{ploidy(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{lambdaPWM-methods}
\docType{methods}

\alias{lambdaPWM-methods}

\title{ ~~ Methods for Function \code{lambdaPWM}  ~~}
\description{
 ~~ Methods for function \code{lambdaPWM}  ~~
}
\section{Methods}{
\describe{

\item{\code{lambdaPWM(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{lociWidth-methods}
\docType{methods}

\alias{lociWidth-methods}
\title{ ~~ Methods for Function \code{lociWidth}  ~~}
\description{
Accessor method for the \code{loci} slot in \code{\linkS4class{ChIPScore}}
}
\section{Methods}{
\describe{

\item{\code{lociWidth(object)}}{
Setting width of regions when using the reduce argument and NOT providing your
own loci when using the \code{processingChIP} function.
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{chipSd-methods}
\docType{methods}

\alias{chipSd-methods}

\title{ ~~ Methods for Function \code{chipSd}  ~~}
\description{
 ~~ Methods for function \code{chipSd}  ~~
}
\section{Methods}{
\describe{

\item{\code{chipSd(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{chipSmooth<--methods}
\docType{methods}

\alias{chipSmooth<--methods}

\title{ ~~ Methods for Function \code{chipSmooth<-}  ~~}
\description{
 ~~ Methods for function \code{chipSmooth<-}  ~~
}
\section{Methods}{
\describe{

\item{\code{signature(object = "parameterOptions", value = "vector")}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{getTrainingData}
\alias{getTrainingData}

\title{
Extract training data from ChIPscore object
}
\description{
\code{getTrainingData} extracts selected regions from ChIPScore object to be used as training set.
}
\usage{
getTrainingData(ChIPscore,loci = 1)
}

\arguments{
    \item{ChIPscore}{
    ChIPscore object as returned by \code{processingChIP}
    }
    \item{loci}{
    numeric describing index of loci to be used as training data. 
    }
   
}


\value{
Returns ChIPscore object with the selected training loci.
 
}



\author{
Patrick C.N. Martin <pcnmartin@gmail.com
}


\examples{

library(ChIPanalyser)
data(ChIPanalyserData)
# See GA vignette for usage 
test <- processingChIP(chip,top)
test <- getTrainingData(test, 1:2)

}

\name{loci-class}
\Rdversion{1.1}
\docType{class}
\alias{loci-class}


\title{Class \code{"loci"}}
\description{
Setter for Loci of interest parsed to or extracted from the ChIPScore object
}
\section{Objects from the Class}{A virtual Class: No objects may be created from it.}
\section{Methods}{
  \describe{
    \item{.loci<-}{\code{signature(object = "ChIPScore", value = "loci")}: ... }
	 }
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>

}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\linkS4class{ChIPScore}}
}
\examples{
showClass("loci")
}
\keyword{classes}

\name{maxSignal<--methods}
\docType{methods}

\alias{maxSignal<--methods}
\title{ ~~ Methods for Function \code{maxSignal<-}  ~~}
\description{
Setter method for \code{maxSignal}
}
\section{Methods}{
\describe{

\item{\code{maxSignal(Object)<-value}}{
Maximum ChIP signal extracted from ChIP data (see \code{processingChIP})
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{profileAccuracyEstimate}
\alias{profileAccuracyEstimate}

\title{
Estimating Accuracy of predicted Profiles
}
\description{
\code{profileAccuracyEstimate} will compare the predicted ChIP-seq-like
profile to real ChIP-seq data and return a set of metrics describing how
accurate the predicted model is compared to real data.
}
\usage{
  profileAccuracyEstimate(genomicProfiles,ChIPScore,
      parameterOptions=NULL,method="all",cores=1)
}

\arguments{
    \item{genomicProfiles}{
    \code{genomicProfiles} is the result of \code{\link{computeChIPProfile}}
    }
    \item{ChIPScore}{
    \code{ChIPScore} is the result of \code{processingChIP}. Extracted/Normalised
    experimental ChIP scores.

    }
    \item{parameterOptions}{
    \code{parameterOptions} is a
    \code{\link{parameterOptions}} object for paramter specification.
    }
    \item{method}{\code{method} is the method that will be used to assess model
    quality agianst ChIP-seq data. Method can be one of the following:
    pearson, spearman, kendall, ks, geometric,fscore, MSE,or all.Fscore contains f-score, precision,recall, MCC,
    Accuracy and AUC ROC.}
    \item{cores}{
    \code{cores} is the number of cores used to extract ChIP scores. Default = 1
    }
}
\details{
In order to assess the quality of the model against experimental ChIP-seq data,
ChIPanalyser offers a wide range of method to choose from. These methods are
also used when computing optimal paramters.
}
\value{
Returns list of goodness of fit metrics for each loci and each parameter selected.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}
\examples{

#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
  if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
      if (!requireNamespace("BiocManager", quietly=TRUE))
          install.packages("BiocManager")
      BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
      }
  library(BSgenome.Dmelanogaster.UCSC.dm6)
  DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
  # Building genomicProfiles object
  GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR", BPFrequency=DNASequenceSet)


  # Computing Genome Wide
  GenomeWide <- computeGenomeWideScore(genomicProfiles = GPP,
      DNASequenceSet = DNASequenceSet)

  #Compute PWM Scores
  PWMScores <- computePWMScore(genomicProfiles = GenomeWide,
       DNASequenceSet = DNASequenceSet, loci = top, chromatinState = Access)
  #Compute Occupnacy
  Occupancy <- computeOccupancy(genomicProfiles = PWMScores)

  #Compute ChIP profiles
  chipProfile <- computeChIPProfile(genomicProfiles=Occupancy,loci=top)
#Estimating accuracy estimate
AccuracyEstimate <- profileAccuracyEstimate(genomicProfiles = chipProfile,
    ChIPScore = chip,
    occupancyProfileParameters = OPP)
}
}

\name{PositionWeightMatrix-methods}
\docType{methods}

\alias{PositionWeightMatrix-methods}
\title{ ~~ Methods for Function \code{PositionWeightMatrix}  ~~}
\description{
Accessor Method for the \code{PWM} slot in a
\code{\link{genomicProfiles}} object
}
\section{Methods}{
\describe{

\item{\code{PositionWeightMatrix(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{DNASequenceLength-methods}
\docType{methods}
\alias{DNASequenceLength-methods}

\title{ ~~ Methods for Function \code{DNASequenceLength}  ~~}
\description{
 ~~ Methods for function \code{DNASequenceLength}  ~~
}
\section{Methods}{
\describe{

\item{\code{signature(object = "genomicProfilesInternal")}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{noOfSites-methods}
\docType{methods}

\alias{noOfSites-methods}

\title{ ~~ Methods for Function \code{noOfSites}  ~~}
\description{
 ~~ Methods for function \code{noOfSites}  ~~
}
\section{Methods}{
\describe{

\item{\code{signature(object = "parameterOptions")}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{boundMolecules<-}


\alias{boundMolecules<-}


\title{
Setter method for the \code{boundMolecules} slot in a
\code{\link{parameterOptions}} object.
}
\description{
Setter method for the \code{boundMolecules} slot in a
\code{\link{parameterOptions}} object.
}
\usage{
boundMolecules(object)<-value
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object.
    }
    \item{value}{
    \code{value} is a positive integer or vector of positive
    integers describing the number ofmolecules bound to DNA.
    Defaut value is 1000.
    }
}
\details{
Default value: 1000
When computing occupancy (\code{\link{computeOccupancy}}),
a value for the number of bound Molecules to DNA is needed.
This value can be updated and set in a
\code{\link{parameterOptions}} object.
If the number of molecules is unknown,
it is possible to infer this value with \code{\link{computeOptimal}}.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.
}
\value{
Returns a \code{\link{parameterOptions}} object with an updated
value for \code{boundMolecules}.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}

\examples{
# Building parameterOptions object
OPP <- parameterOptions()
# Setting new boundMolecules value in OPP
boundMolecules(OPP) <- 5000
#Checking value in whole object
OPP
#Checking single value by slot accessor
boundMolecules(OPP)

}

\name{ChIPanalyser-package}

\alias{ChIPanalyser}
\docType{package}
\title{
\packageTitle{ChIPanalyser}
}
\description{
\packageDescription{ChIPanalyser}
}
\details{

The DESCRIPTION file:
\packageDESCRIPTION{ChIPanalyser}
\packageIndices{ChIPanalyser}

}
\author{
Patrick C.N. Martin <pm16057@essex.ac.uk>

And

Nicolae Radu Zabet <nzabet@essex.ac.uk>

Maintainer: \packageMaintainer{ChIPanalyser}
}


\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}

\keyword{ package }

\examples{
\donttest{
#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome

if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
}
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
#Building data objects
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR",BPFrequency=DNASequenceSet)

chip<-processingChIP(chip,top)
# Computing Genome Wide
GenomeWide <- computeGenomeWideScores(DNASequenceSet = DNASequenceSet,
    genomicsProfiles = GPP)

#Compute PWM Scores
PWMScores <- computePWMScore(genomicsProfiles = GenomeWide,
    DNASequenceSet = DNASequenceSet,
    loci = top, chromatinState = Access)
#Compute Occupnacy
Occupancy <- computeOccupancy(genomicsProfiles = PWMScores,
    parameterOptions = OPP)

#Compute ChIP profiles
chipProfile <- computeChIPProfile(genomicProfiles = Occupancy,
     loci = top,
    parameterOptions = OPP)
#Estimating accuracy estimate
AccuracyEstimate <- profileAccuracyEstimate(genomicProfiles = chipProfile,
     ChIPScore = chip,
     parameterOptions = OPP)

    }
}

\name{averageExpPWMScore}
\alias{averageExpPWMScore}


\title{
Accessor for \code{averageExpPWMScore} slot in a
\code{\link{genomicProfiles}} object.
}
\description{
Extract or Access \code{averageExpPWMScore} slot in a
\code{\link{genomicProfiles}}
}
\usage{
averageExpPWMScore(object)
}
\arguments{
    \item{object}{
    \code{object} is a \code{genomicProfiles}
    }
}
\details{
As a general rule, \code{averageExpPWMScore} is computed and updated
internally by \code{\link{computeGenomeWideScores}}.
Idealy, this slot should not be updated by user.
The \code{averageExpPWMScore} is the sum of the exponential of every PWM score
for a given DNA sequence and divided by the length of the said DNA sequence
(\code{\link{DNASequenceLength}}). This can either be the full
length sequence or only the accessible sequence
(see \code{\link{computeGenomeWideScores}}).

}
\value{
Returns the \code{averageExpPWMScore} of a
\code{\link{genomicProfiles}} when computed.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}

\examples{
# Accessing Data
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
# Building genomicProfiles object
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR")
# Extracting AllSitesAboveThreshold slot
averageExpPWMScore(GPP)

## Note this slot is now empty as nothing has yet been computed
}

\name{singleRun}
\alias{singleRun}

\title{
singleRun
}
\description{
\code{singleRun} runs ChIPanalyser after optimal paramters have been found by the
evolve function.
}
\usage{
  singleRun(indiv,DNAAffinity,
            genomicProfiles,DNASequenceSet,
            ChIPScore,fitness="all")
}

\arguments{
    \item{indiv}{
    Population list containing the top scoring individual. Note that this should be
    a list of length 1 containing another list with all parameter values.
    }
    \item{DNAAffinity}{
    GRanges object as outputed by the \code{setchromatinStates}.
    }
    \item{genomicProfiles}{
    genomicProfiles object containing PWM scores and other desired metrics. Note
    that PWMThreshold, lambda and N will be overwritten using values from indiv.
    }
    \item{DNASequenceSet}{
    DNA string set object containing DNA sequence of interest.
    }
    \item{ChIPScore}{
    ChIPScore object as outputed by the \code{processingChIP} function.
    }
    \item{fitness}{
    character string describing which metric should be used to assess fitness and
    should be one of the following:"geometric","ks","MSE","pearson","spearman","kendall",
    "recall","precesion","fscore","MCC","Accuracy" or "AUC".
    }

}
\details{
Once the genetic algorithm has been optimised, the top individual may be run
on its own to get predicted ChIP profiles. The use of this function requires a
few extract steps in order to predict ChIP profiles.

First, the index of the top individual should be extracted (see \code{getHighestFitnessSolutions}).
Second, using this index, subset top individual from GA population. Note this
should be done using "[]" single bracket notation as, a list of length 1 containing
another list with all parameter values is required for the next steps. Yes, this
is might seem annoying but the functions were design for list structures...
Third, setchromatinStates using the top individual list. This will add chromatin
affinity values to your chromatinState GRanges. Use this new chromatinState object
as your new chromatinState object.
Fourth, parse your indiv list object to \code{singleRun}.


}

\value{
Return a list with three elements.
First element contains a genomicProfiles object with occupancy scores.
Second element contains a genomicProfiles objecy with ChIP profile scores.
Third element contains a goodness of fit metrics.

}

\author{
Patrick C.N. Martin <pcnmartin@gmail.com
}


\examples{
library(ChIPanalyser)
data(ChIPanalyserData)
# See GA vignette for usage 
}

\name{ChIPanalyserData}
\alias{ChIPanalyserData}
\alias{Access}
\alias{cs}
\alias{top}
\alias{chip}
\alias{geneRef}
\docType{data}
\title{
ChIPanalyserData
}
\description{
\code{ChIPanalyserData} is derived from real biological data.
The source organism is \emph{Drosophila melanogaster}.
The data can be described as genomic data as it contains DNA sequences,
loci, genetic information, DNA accessibility data and ChIP-seq data.
}
\usage{
    data(ChIPanalyserData)
}
\format{
\enumerate{

    \item{\code{Access}}{is \code{\link[GenomicRanges]{GRanges}}
    containing DNA Accesibility data for the sequences described above.}
    \item{\code{cs}}{is \code{\link[GenomicRanges]{GRanges}}
    containing Chromatin State data for the sequences described above.}
    \item{\code{top}}{is \code{\link[GenomicRanges]{GRanges}}
    containing a locus of interest.
    In this case \emph{eve strip Locus} on
    chromosome 2R in \emph{Drosophila melanogaster}}
    \item{\code{chip}}{is a GRanges containing ChIP score of the eve
    strip locus in \emph{Drosophila melanogaster}. }
    \item{\code{geneRef}}{is a \code{\link[GenomicRanges]{GRanges}}
    containing UCSC gene reference information}
    }

}
\value{
Returns a set of Rdata objects as described above.
}
\source{
Transcription Factor PFM:
Berkeley Drosophila Transcription Network Project (bdtnp.lbl.gov)

}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}

\examples{
data(ChIPanalyserData)
}

\name{scores}

\alias{scores}


\title{
Accessor Method for the \code{scores} slot in a
\code{\linkS4class{ChIPScore}} object
}
\description{
Setter Method for the \code{scores} slot in a
\code{\linkS4class{ChIPScore}} object

}
\usage{
scores(object)
}
\arguments{
    \item{object}{
    \code{object} is \code{\linkS4class{ChIPScore}} object
    }

}
\details{
    When using the \code{\link{processingChIP}}, this functions will return a
    name list of normalised ChIP scores at loci of interest. This functions enalbles
    you to extract those scores from the \code{\linkS4class{ChIPScore} object.}

}
\value{
Returns the value assigned to the \code{scores} slot in a
\code{\linkS4class{ChIPScore}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

chip<-processingChIP(chip,top)
str(scores(chip))



}

\name{computeOccupancy}
\alias{computeOccupancy}

\title{
Compute Occupancy values from PWM Scores based on model.
}
\description{
\code{computeOccupancy} will compute the Occupancy from PWM Scores.
As described in detail in the vignette,
\code{ChIPanalyser} uses PWM Scores, DNA Accessibility data, the number of
bound molecules and a sclaing factor of Transcription Factor specificty.
This function will compute occupancy using the
values assigned to each variable.
}
\usage{
computeOccupancy(genomicProfiles,parameterOptions = NULL,
    norm = TRUE, verbose = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{genomicProfiles}{
    \code{genomicProfiles} is a a \code{\link{genomicProfiles}}
    object resulting from \code{\link{computePWMScore}}.
    IT is important to use this resulting object as the occuapancy will only be
    computed for sites above a threshold.
    }
    \item{parameterOptions}{
    \code{parameterOptions} is a
    \code{\link{parameterOptions}} object containing the adequate
    values assigned to each Parameter. If not Supplied
    (\code{parameterOptions} = NULL), a new object will be created
    internally using default values.
    }
    \item{norm}{

    \code{norm} a logical value which determines
    if the occupancy should be normalised or not.
    }
    \item{verbose}{
    \code{verbose} a logical value which determines
    if progress messages are printed or not.
    }
}
\details{
\code{computeOccupancy} will compute the Occupancy from PWM Scores.
As described in detail in the vignette,
\code{ChIPanalyser} uses PWM Scores, DNA Accessibility data,
the number of bound molecules and a sclaing factor of
Transcription Factor specificty.
This function will compute occupancy using the values assigned
to each variable. It should also be noted that the
\code{\link{parameterOptions}}
object contains a set of parameters used to compute Occupancy
(not only restricted to this ). These parameters are often dependant on
real ChIP-Seq data and will influence
the goodness of fit between the predicted model an real ChIP-seq data.
We strongly advise that the values assigned to each parameter should be
customiszed in order to increase the model ageement with
real world biological data.

}
\value{
\code{computeOccupancy} will return a \code{\link{genomicProfiles}}.
The main difference will reside in the
\code{\link{profiles}} slot.
This slot is generally a list or \code{\link[GenomicRanges]{GRangesList}}.
Within these list type structures are enclosed
\code{\link[GenomicRanges]{GRanges}} containing the positions of site
above threshold, PWMScores and Occupancy for each site.
The series of GRanges  will depend on the number of loci that are
tested and the number of element in the list will depend on the various
combinations of \code{lambdaPWM} and \code{boundMolecules}.


}
\references{

Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
}

\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}

\examples{

#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
    }
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)

#Building data objects
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR",BPFrequency=DNASequenceSet)
OPP <- parameterOptions()
# Computing Genome Wide
GenomeWide <- computeGenomeWideScores(genomicProfiles = GPP,
    DNASequenceSet = DNASequenceSet)

#Compute PWM Scores
PWMScores <- computePWMScore(genomicProfiles = GenomeWide,
    DNASequenceSet = DNASequenceSet,
    loci = top,
    chromatinState = Access)
#Compute Occupnacy
Occupancy <- computeOccupancy(genomicProfiles = PWMScores,
    parameterOptions = OPP)
Occupancy

}
}

\name{averageExpPWMScore-methods}
\docType{methods}
\alias{averageExpPWMScore-methods}

\title{ ~~ Methods for Function \code{averageExpPWMScore}  ~~}
\description{
 ~~ Methods for function \code{averageExpPWMScore}  ~~
}
\section{Methods}{
\describe{

\item{\code{signature(object = "genomicProfilesInternal")}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{naturalLog<-}


\alias{naturalLog<-}

\title{
Setter method for the \code{naturalLog} slot in a
\code{\link{parameterOptions}} object.
}
\description{
Setter method for the \code{naturalLog} slot in a
\code{\link{parameterOptions}} object.
}
\usage{
naturalLog(object)<- value
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object.
    }
    \item{value}{
    \code{value} is a logical value that will determine if the natural log or
    log2 should be used for the computation of the Position Weight Matrix.
    }
}
\details{
During the computation of a Postion Weight Matrix, the
Position Probability Matrix (derived from a Position Frequency Matrix)
is log transformed. This parameter provides whcih "log transform" will be used.
If TRUE, the Natural Log will bu used (ln). If FALSE, log2 will be used.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.
}
\value{
Returns \code{\link{parameterOptions}} object with an updated
value for the \code{naturalLog} slot.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <p.martin@essex.ac.uk>
}
\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
OPP <- parameterOptions(naturalLog=TRUE)
#Setting new Value for naturalLog
naturalLog(OPP) <- FALSE

}

\name{removeBackground}


\alias{removeBackground}
\title{
Accessor Method for the \code{removeBackground} slot in a
\code{\link{parameterOptions}} object
}
\description{
Accessor Method for the \code{removeBackground} slot in a
\code{\link{parameterOptions}} object
}
\usage{
removeBackground(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object
    }
}
\details{
A numeric value describing a threshold at which Occupancy signals must be
removed (Default is set at 0). The removal of Occupancy signals will occur
when computing \code{\link{computeOccupancy}}
(see \code{\link{computeOccupancy}} function)
}
\value{
Returns the value assigned to the \code{removeBackground} slot in a
\code{\link{parameterOptions}} object
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>

}
\examples{
#Building parameterOptions object
OPP <- parameterOptions()
#Accessing  Value for removeBackground
removeBackground(OPP)

}

\name{loci-methods}
\docType{methods}
\alias{loci-methods}


\title{ ~~ Methods for Function \code{loci}  ~~}
\description{
Accessor method for the \code{loci} slot in \code{\linkS4class{ChIPScore}}
}
\section{Methods}{
\describe{

\item{\code{loci{Object}}}{
Loci of interest parsed to or extracted from the ChIPScore object
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{loci}

\alias{loci}


\title{
Accessor Method for the \code{loci} slot in a
\code{\linkS4class{ChIPScore}} object
}
\description{
Setter Method for the \code{loci} slot in a
\code{\linkS4class{ChIPScore}} object

}
\usage{
loci(object)
}
\arguments{
    \item{object}{
    \code{object} is \code{\linkS4class{ChIPScore}} object
    }

}
\details{
    When using the \code{\link{processingChIP}}, this functions will return a
    name GRanges with the loci of interest. These loci will either result from
    user input or extracted from the ChIP profiles (see \code{processingChIP}
    and \code{lociWidth}). This functions enalbles
    you to extract those loci from the \code{\linkS4class{ChIPScore} object.}

}
\value{
Returns the value assigned to the \code{loci} slot in a
\code{\linkS4class{ChIPScore}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

chip<-processingChIP(chip,top)
loci(chip)



}

\name{backgroundSignal-methods}
\alias{backgroundSignal-methods}

\docType{methods}

\title{ ~~ Methods for Function \code{backgroundSignal}  ~~}
\description{
 ~~ Methods for function \code{backgroundSignal}  ~~
}
\section{Methods}{
\describe{

\item{\code{signature(object = "parameterOptions")}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{minPWMScore-methods}
\docType{methods}

\alias{minPWMScore-methods}
\title{ ~~ Methods for Function \code{minPWMScore}  ~~}
\description{
Accessor for \code{minPWMScore}
}
\section{Methods}{
\describe{

\item{\code{minPWMScore(object)}}{
Minimum PWM score computed during the \code{computeGenomeWideScores} step.
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{DNASequenceLength}


\alias{DNASequenceLength}

\title{
Accessor method for \code{DNASequenceLength} slot in a
\code{\link{genomicProfiles}}
}
\description{
Accessor method for \code{DNASequenceLength} slot in a
\code{\link{genomicProfiles}}

}
\usage{
DNASequenceLength(object)
}

\arguments{
    \item{object}{
    \code{object} is  a \code{\link{genomicProfiles}}
    }
}
\details{
The model on which is based \code{ChIPanalyser} requires the length of the
DNA sequence used to compute scores. In this circustance,
this DNA Length is the total length of the DNA of the organism of interest
or the the Accessible DNA at a genome wide scale.
}
\value{
Returns \code{DNASequenceLength} slot in a
\code{\link{genomicProfiles}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}
\examples{

#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
}
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)

#Building genomicProfiles object
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR",BPFrequency=DNASequenceSet)
# Computing Genome Wide
GenomceWide <- computeGenomeWideScores(DNASequenceSet = DNASequenceSet,
    genomicProfiles = GPP)

DNASequenceLength(GenomceWide)

}
}

\name{removeBackground<-}


\alias{removeBackground<-}

\title{
Setter Method for the \code{removeBackground} slot in a
\code{parameterOptions} object
}
\description{
Setter Method for the \code{removeBackground} slot in a
\code{parameterOptions} object
}
\usage{
removeBackground(object) <-value
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{object}{
    \code{object} is  an \code{\link{parameterOptions}} object
    }
    \item{value}{
    \code{value} is positive numerical value to be assigned to the
    \code{removeBackground} slot in a \code{\link{parameterOptions}}
    object. Default is set a 0.
    }
}
\details{
A numeric value describing a threshold at which Occupancy signals must be
removed (Default is set at 0). The removal of Occupancy signals will occur
when computing \code{\link{computeOccupancy}}
(see \code{\link{computeOccupancy}} function)
}
\value{
Returns an \code{\link{parameterOptions}} object  with an updated
value for the \code{removeBackground} slot
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}

\examples{
#Building parameterOptions object
OPP <- parameterOptions()
#Setting new Value for removeBackground
removeBackground(OPP) <- 0.1
}

\name{strandRule}


\alias{strandRule}
\title{
Accessor Method for the \code{strandRule} slot in a
\code{\linkS4class{parameterOptions}} object
}
\description{
Accessor Method for the \code{strandRule} slot in a
\code{\linkS4class{parameterOptions}} object
}
\usage{
strandRule(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\linkS4class{parameterOptions}} object
    }
}
\details{
When computing the PWM Scores and if \code{\link{whichstrand}}
is set to "+-", \code{strandRule} will determine how to handle both strands
( one of three options : "mean", "max", "sum"). If set to "mean",
the average PWM Score of both strand will be computed. If set to "max",
the highest PWM score between each strand will be selected and finally "sum"
will sum both score together.  Default set at "max"
}
\value{
Returns the value assigned to \code{strandRule} slot (one of three options :
"mean", "max", "sum") in a \code{\linkS4class{parameterOptions}} object
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
GPP <- parameterOptions( strandRule="max")
#Accesssing Value for strandRule
strandRule(GPP)
}

\name{naturalLog<--methods}
\docType{methods}

\alias{naturalLog<--methods}
\title{ ~~ Methods for Function \code{naturalLog<-}  ~~}
\description{
Setter method for the \code{naturalLog} slot in a
\code{\link{parameterOptions}} object.
}
\section{Methods}{
\describe{

\item{\code{naturalLog(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{maxSignal}


\alias{maxSignal}

\title{
Accessor method for the \code{maxSignal} slot in a
\code{\link{parameterOptions}} object.
}
\description{
Accessor method for the \code{maxSignal} slot in a
\code{\link{parameterOptions}} object.
}
\usage{
maxSignal(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object.
    }
}
\details{
In the context of \code{ChIPanalyser}, \code{maxSignal} represents the
maximum normalised ChIP-Seq signal of a given Transcription factor
(or DNA binding protein). Although, A default value of 1 has been assigned to
this slot, we strongly recommend to tailor this value accordingly.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.

}
\value{
Returns the value assigned to the \code{maxSignal} slot in a
\code{\link{parameterOptions}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <p.martin@essex.ac.uk>
}

\examples{
# Building parameterOptions object
OPP <- parameterOptions()
#Setting new Value for maxSignal
maxSignal(OPP)

}

\name{PositionFrequencyMatrix-methods}
\docType{methods}

\alias{PositionFrequencyMatrix-methods}
\title{ ~~ Methods for Function \code{PositionFrequencyMatrix}  ~~}
\description{
Accessor method for the \code{PFM} slot in a
\code{genomicProfiles} object
}
\section{Methods}{
\describe{

\item{\code{PositionFrequencyMatrix(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{boundMolecules<--methods}
\docType{methods}
\alias{boundMolecules<--methods}

\title{ ~~ Methods for Function \code{boundMolecules<-}  ~~}
\description{
 ~~ Methods for function \code{boundMolecules<-}  ~~
}
\section{Methods}{
\describe{

\item{\code{signature(object = "parameterOptions", value = "vector")}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{PFMFormat<--methods}
\docType{methods}

\alias{PFMFormat<--methods}
\title{ ~~ Methods for Function \code{PFMFormat<-}  ~~}
\description{
Setter method for the \code{PFMFormat} slot in a
\code{\link{genomicProfiles}} object
}
\section{Methods}{
\describe{

\item{\code{PFMFormat(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{strandRule-methods}
\docType{methods}

\alias{strandRule-methods}
\title{ ~~ Methods for Function \code{strandRule}  ~~}
\description{
Accessor Method for the \code{strandRule} slot in a
\code{\linkS4class{parameterOptions}} object
}
\section{Methods}{
\describe{

\item{\code{strandRule(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{strandRule<--methods}
\docType{methods}

\alias{strandRule<--methods}
\title{ ~~ Methods for Function \code{strandRule<-}  ~~}
\description{
Setter method for the \code{strandRule} slot in a
\code{\linkS4class{parameterOptions}} object.
}
\section{Methods}{
\describe{

\item{\code{strandRule(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{removeBackground<--methods}
\docType{methods}

\alias{removeBackground<--methods}
\title{ ~~ Methods for Function \code{removeBackground<-}  ~~}
\description{
Setter Method for the \code{removeBackground} slot in a
\code{parameterOptions} object
}
\section{Methods}{
\describe{

\item{\code{removeBackground(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{genomicProfiles-class}
\Rdversion{1.1}
\docType{class}
\alias{genomicProfiles-class}



\title{Class \code{"genomicProfiles"}}
\description{
\code{genomicProfiles} is an S4 object serving two purposes: (i) storing internal computed data and (ii) storing paramter options. This object is parsed through the different steps of the pipeline
to facilitate that parsing and changing of paramters.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{genomicProfiles(ploidy, boundMolecules, backgroundSignal, maxSignal, lociWidth, chipMean, chipSd, chipSmooth, stepSize, noiseFilter, removeBackground, lambdaPWM, PWMpseudocount, naturalLog, noOfSites, PWMThreshold, strandRule, whichstrand, PFM, PWM, PFMFormat, BPFrequency, minPWMScore, maxPWMScore, profiles, DNASequenceLength, averageExpPWMScore)}.
%%  ~~ describe objects here ~~
}
\section{Slots}{
  \describe{
  \item{\code{PWM}:}{Object of class \code{"matrix"}:
  A Position Weight Matrix (either supplied or internally computed if
  PFM is provided)}
  \item{\code{PFM}:}{Object of class \code{"matrix"}:
  A Position Frequency Matrix (may also be a path to file containing PFM) }
  \item{\code{PFMFormat}:}{Object of class \code{"character"}:
  A character string of one of the following: raw, transfac,JASPAR or
  sequences}
  \item{\code{BPFrequency}:}{Object of class \code{"vector"}:
  Base Pair Frequency in the genome (if a DNA sequence is provided
  (as a \code{\link[Biostrings]{DNAStringSet}} or \code{BSgenome}),
  will be automatically computed internally). Default:c(0.25,0.25,0.25,0.25)}
  \item{\code{minPWMScore}:}{Object of class \code{"vector"}:
  Lowest PWM score accros the genome (computed and updated internally) }
  \item{\code{maxPWMScore}:}{Object of class \code{"vector"}:
  Highest PWM score across the genome (computed and updated internally) }
    \item{\code{profiles}:}{Object of class \code{"GRList"}:
    Containins GRanges with sites above threshold and associated metrics
    (PWMscore and Occupancy) - Computed Internally}
    \item{\code{DNASequenceLength}:}{Object of class \code{"vector"}:
    Length of the Genome (or accesible genome) - computed internally }
    \item{\code{averageExpPWMScore}:}{Object of class \code{"vector"}:
    Average exponential PWM score across the genome
    (or accesible genome) - computed internally }
    \item{\code{ZeroBackground}:}{Object of class \code{"vector"}:
    Internal background value (computed internally)}
    \item{\code{drop}:}{Object of class \code{"vector"}:
    Stores Loci that do contain accesible DNA if it were to be the case
    (computed and updated internally) }
    \item{\code{tags}:}{Object of class \code{"character"} ~Internal Tags~ }
    \item{\code{ploidy}:}{Object of class \code{"numeric"}:
    A numeric Value descibing the ploidy of the organism. Default: 2 }
    \item{\code{boundMolecules}:}{Object of class \code{"vector"}:
    A vector (or single value) containing the number of bound Molecules
    (bound Transcription Factors): Default: 1000 }
    \item{\code{backgroundSignal}:}{Object of class \code{"numeric"}:
    A numeric value descibing the ChIP-seq background Signal
    (average signal from real ChIP seq data). Default: 0}
    \item{\code{maxSignal}:}{Object of class \code{"numeric"}:
    A numeric value describing the highest ChIP-seq signal
    (from real ChIP-seq data). Default: 1}
    \item{\code{lociWidth}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{chipMean}:}{Object of class \code{"numeric"}:
    A numeric value describing the mean width of a ChIP- seq peak.
    Default:150 }
    \item{\code{chipSd}:}{Object of class \code{"numeric"}:
    A numeric value describing the standard deviation of ChIP-seq peaks.
    Default: 150 }
    \item{\code{chipSmooth}:}{Object of class \code{"vector"}:
    A numeric value describing the width of the window used to smooth
    Occupancy profiles into ChIP profiles. Default:250 }
    \item{\code{stepSize}:}{Object of class \code{"numeric"}:
    A numeric value describing the step Size (in base pairs) between
    each ChIP-seq score. Default:10 (Scored every 10 base pairs)}
    \item{\code{removeBackground}:}{Object of class \code{"numeric"}:
    A numeric value describing the value at which score should be removed.
    Defualt:0 (If negative scores then remove) }
    \item{\code{noiseFilter}:}{Object of class \code{"character"} ~Describes the
    noiseFilter method that will be applied to ChIP data (Zero, mean, median,
    sigmoid)~ }
    \item{\code{PWMThreshold}:}{Object of class \code{"numeric"}:
    Threshold at which PWM Score should be selected (only sites above
    threshold will be selected - between 0 and 1) }
    \item{\code{strandRule}:}{Object of class \code{"character"}:
    "mean", "max" or "sum"  will dertermine how strand should be handle
    for computing PWM Scores. Default : "max" }
    \item{\code{whichstrand}:}{Object of class \code{"character"}:
    "+","-" or "+-" on which strand should PWM Score be computed.
    Default: "+-" }
    \item{\code{lambdaPWM}:}{Object of class \code{"vector"} A vector (or single value) contaning values for lambdaPWM Default:1}
    \item{\code{naturalLog}:}{Object of class \code{"logical"}:
    A logical value describing if natural Log will be used to compute
    the PWM (if FALSE then log2 will be used). Default: TRUE }
    \item{\code{noOfSites}:}{Object of class \code{"nos"} A Positive integer descibing number of sites (in base pair) should
    be used from the PFM to compute PWM. Default =0 (Full width of
    binding site will be used when set to 0) }
    \item{\code{PWMpseudocount}:}{Object of class \code{"numeric"}:
    A numeric value describing a PWMpseudocount for PWM computation.
    Default:1 }
    \item{\code{paramTag}:}{Object of class \code{"character"} ~Internal~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{genomicProfilesInternal}"}, directly.
Class \code{"\linkS4class{parameterOptions}"}, directly.
}
\section{Methods}{
  \describe{
    \item{initialize}{\code{signature(.Object = "genomicProfiles")}: ... }
    \item{show}{\code{signature(object = "genomicProfiles")}: ... }
	 }
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Partick C. N. Martin <p.martin@essex.ac.uk>
}


\seealso{
\code{\link{genomicProfiles}}
\code{\link{parameterOptions}}
}
\examples{
showClass("genomicProfiles")
}
\keyword{classes}

\name{computeGenomeWideScores}
\alias{computeGenomeWideScores}

\title{
Computing Genome Wide scores
}
\description{
\code{computeGenomeWideScores} compute the max and min PWM score over the entire genome.
}
\usage{
computeGenomeWideScores(genomicProfiles, DNASequenceSet, chromatinState = NULL, parameterOptions = NULL, cores = 1, verbose = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{genomicProfiles}{
  \code{genomicProfiles} is a \code{genomicProfiles} object containing the PFM, PWM of interest.
}
  \item{DNASequenceSet}{
  \code{DNASequenceSet} is a BSgenome or DNAStringSet containing the sequence of the organism of interest.
}
  \item{chromatinState}{
  \code{chromatinState} is a GRanges object containing the chromatin States. This can either represent regions of accessible DNA or Chromatin state affinities.
}
  \item{parameterOptions}{
   \code{parameterOptions} is a \code{parameterOptions} object containing parameters that you wish to change. The genomicProfiles object will be updated using the values assigned to \code{parameterOptions}
}
  \item{cores}{
 \code{cores} is the number or cores that will be used (Numeric value - Default = 1 )
}
  \item{verbose}{
  \code{verbose} is a logical value that will determine if internal progress message will be printed.
}
}
\details{
\code{computeGenomeWideScores} function computes PWM scores over the entire genome (or accessible Genome if chromatin State are provided ). Genome wide scores are used to determine the maximum and minimum PWM score as well as the average exponential score. These scores will in turn be used to determine which score are above the PWM theshold. The average exponential score is an integrale part of the equation used to compute Occupancy. Using defualt settings, ChIPanalyser will only compute occupancy on the top 70\% of PWM scores. This threshold can be changed. See \code{\link{PWMThreshold}}
}
\value{
Returns a \code{genomicsProfiles} object with updated values for max score, min score and averageExpPWMScore.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N Martin <pm16057@essex.ac.uk>
}

\examples{

  \donttest{
  if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
      if (!requireNamespace("BiocManager", quietly=TRUE))
          install.packages("BiocManager")
      BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
      }
  library(BSgenome.Dmelanogaster.UCSC.dm6)
  DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
  # Building genomicProfiles object
  GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR", BPFrequency=DNASequenceSet)


  # Computing Genome Wide
  GenomeWide <- computeGenomeWideScores(genomicProfiles = GPP,
      DNASequenceSet = DNASequenceSet)
  }

}

\name{chipSmooth}

\alias{chipSmooth}


\title{
Accessor methods for \code{chipSmooth} slot in a
\code{\link{parameterOptions}} object.
}
\description{
Access or Extract \code{chipSmooth} slot in a
\code{\link{parameterOptions}} object.
}
\usage{
chipSmooth(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}} object.
    }
}
\details{
When computing ChIP-seq like (\code{\link{computeChIPProfile}}) profile
from occupancy data (see \code{\link{computeOccupancy}}),
the profiles are smoothed using a window of a given size.
The default value is set at 250 base pairs. If \code{chipSmooth}
is set to 0 then the profile will not be smoothed.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.
}
\value{
Returns the \code{chipSmooth} slot in an
\code{\link{parameterOptions}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}
\examples{
# Building parameterOptions object
OPP <- parameterOptions()
# Accessing chipSd slot
chipSmooth(OPP)
}

\name{maxPWMScore-methods}
\docType{methods}

\alias{maxPWMScore-methods}

\title{ ~~ Methods for Function \code{maxPWMScore}  ~~}
\description{
Accessor method for \code{maxPWMScore}
}
\section{Methods}{
\describe{

\item{\code{maxPWMScore(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{chipMean}


\alias{chipMean}


\title{
Accessor method for \code{\link{chipMean}} slot in a
\code{\link{parameterOptions}} object.
}
\description{
Accessor method for \code{\link{chipMean}} slot in a
\code{\link{parameterOptions}} object.

}
\usage{
chipMean(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{parameterOptions}}
    }
}
\details{
Default vlaue : 150
When computing ChIP-seq like profiles (\code{\link{computeChIPProfile}},
the occupancy values given by \code{computeOccupancy} are transformed
into ChIP-seq like profiles.
The average size of a ChIP-seq peak was described by Kaplan
(Kaplan et al. , 2011). It is advised to use the average
width of ChIP peaks from actual ChIP-seq data.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.
}

\value{
Returns \code{chipMean} slot from a
\code{\link{parameterOptions}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

Kaplan T.,Li X.-Y.,Sabo P.J.,Thomas S.,Stamatoyannopoulos J.A., Biggin M.D.,
EisenM.B.
Quantitative models of the mechanisms that control genome-wide patterns of
transcription factor binding during early Drosophila development,
PLoS Genet.,2011, vol. 7 pg. e1001290

}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}

\examples{
# Building parameterOptions object
OPP <- parameterOptions()
#Accessing chipMean slot in OPP
chipMean(OPP)

}

\name{lociWidth<-}

\alias{lociWidth<-}


\title{
Setter Method for the \code{lociWidth} slot in a
\code{\link{parameterOptions}} object
}
\description{
Setter Method for the \code{lociWidth} slot in a
\code{\link{parameterOptions}} object

}
\usage{
lociWidth(object)<-value
}
\arguments{
    \item{object}{
    \code{object} is \code{\link{parameterOptions}} object
    }
    \item{value}{
    \code{value} is the numeric value to be assigned to the lociWidth slot.
    Default set at 1.
    }
}
\details{
    When using the \code{\link{processingChIP}} function, the provided ChIP
    scores will be split into bins of a given size. lociWidth determines the Size
    of that bin. Default is set at 20 000 bp.
    This mean that the ChIP profiles provided will be split into bins of 20 000 bp
    over the entire profile provided if no loci of interest is provided.

}
\value{
Returns the value assigned to the \code{lociWidth} slot in a
\code{\link{parameterOptions}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
GPP <- parameterOptions(lociWidth=20000)
#Setting new Value for lociWidth
lociWidth(GPP) <- 30000


}

\name{evolve}
\alias{evolve}

\title{
Running the ChIPanalyser implementation of a Genetic algorithm.
}
\description{
\code{evolve} pushes a starting population to evolve in a genetic algorithm.
}
\usage{
evolve(population,DNASequenceSet,ChIPScore,
       genomicProfiles,parameters=NULL,generations=100,mutationProbability=0.3,
       offsprings=5,chromatinState=NULL,
       method="geometric", lambda=TRUE,
       checkpoint=TRUE,
       filename=NULL, cores=1)
}

\arguments{
    \item{population}{
    numeric value describing the number of individuals in the starting population.
    Alternatively - a starting population list as returned by \code{generateStartingPopulation}.
    NOTE: if numeric - the parameter argument is also required.
    }
    \item{DNASequenceSet}{
    DNAStringSet object containing DNA sequences of interest (Extracted from BSgenome)
    }
    \item{ChIPScore}{
    ChIPScore object  as returned by the \code{processingChIP}function
    }
    \item{genomicProfiles}{
    genomicProfiles object containing minimal information (such as the PWM)
    }
    \item{parameters}{
    vector or list containing each parameter that should be added to the chromosome.
    See \code{generateStartingPopulation}
    }
    \item{generations}{
    numeric describing the number of generation before the Genetic algorithm
    should halt.
    }
    \item{mutationProbability}{
    numeric descrbining the rate of mutations for each surviving individual
    }
    \item{offsprings}{
    numeric descrbining the number of individuals surviving to the next generation
    }
    \item{chromatinState}{
    GRanges object containing chromatin state information. Each state should be
    labled in a meta data column named "name". It is advised to use numeric values
    for each state name.
    }
    \item{method}{
    character string describing the scoring metric that should be used.
    ChIPanalyser offers twelve different metrics: correlation coefficients
     (Pearson, Spearman and Kendall), Mean Squared Error (MSE),
     Kolmogorov–Smirnov Distance, precision, recall, accuracy, F-score,
     Matthew’s correlation coefficient (MCC) and
     Area Under Curve Receiver Operator Characteristic (AUC ROC or just AUC)
    }
    \item{lambda}{
    logical describing if lambda value should be pre-computed. Setting to TRUE
    increases the speed of the algorithm.
    }
    \item{checkpoint}{
    logical describing if population parameters at each generations should be 
    saved. 
    }

    \item{filename}{
    character string that will serve as a prefix to the saved intermediate files.
    }
    \item{cores}{
    numeric describing the number of cores used to run the GA.
    }
}
\details{
ChIPanalyser offers a way of finding optimal solution by using a genetic algorithm.
Instead of running the stadard analysis, TF binding affinities to chromatin states
can be extracted via this more complex method. It should be noted that this
method is better suited for the analysis of chromatin states. While the algorithm
still works with simple DNA Accessibility,
it would potentially take more time for accuracy minor gains.


}

\value{
Returns a named list with three elements.
  \itemize{
  \item{database}{ saves the data frame containing all
  scores for each individual since generation 1}
  \item{population}{ saves the last population with
  chromosome values}
  \item{fitest}{saves the fittest individual
   for a given generation}
  }

}



\author{
Patrick C.N. Martin <pcnmartin@gmail.com
}


\examples{

library(ChIPanalyser)
data(ChIPanalyserData)
# See GA vignette for usage 

}

\name{stepSize<-}


\alias{stepSize<-}
\title{
Setter Method for the \code{stepSize} slot in a
\code{\linkS4class{parameterOptions}}
}
\description{
Setter Method for the \code{stepSize} slot in a
\code{\linkS4class{parameterOptions}}
}
\usage{
stepSize(object) <- value
}

\arguments{
    \item{object}{
    \code{object} is a \code{\linkS4class{parameterOptions}} object
    }
    \item{value}{
    \code{value} is a positive numeric value that will be assigned to the
    \code{stepSize} slot in a \code{\linkS4class{parameterOptions}} object.
    Default is set at 10 base pairs.
    }
}
\details{
It possible to restrict the size of the ChIP-seq-like profile produced by
\code{\link{computeChIPProfile}}. Instead of returning ChIP-seq like score
for each base pair, it is possible to skip base pairs and only return the
predicted enrichement score for every "n" base pair
(n is the value assigned to stepSize). This will reduce the size of the
output data (unless step size is very large, this will not affect the
accuracy of the model). Default is set at 10 base pairs.
}
\value{
Returns a \code{parameterOptions} object with an updated value
for the \code{stepSize} slot.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>

}

\examples{
# Building parameterOptions  object
OPP <- parameterOptions()
#Setting new Value for maxSignal
stepSize(OPP) <- 20

}

\name{splitData}
\alias{splitData}

\title{
Get Training and Testing data from ChIPscore objects 
}
\description{
\code{splitData} splits processed ChIP data into training and testing sets. 
}
\usage{
splitData(ChIPscore,dist = c(80,20), as.proportion = TRUE)
}

\arguments{
    \item{ChIPscore}{
    ChIPscore object as returned by \code{processingChIP}
    }
    \item{dist}{
    If \code{as.proportion} is to TRUE, split the data into 
    desired proportions. Default sets 80\% training and 
    20\% testing.
    If \code{as.proportion} is to FALSE,a vector of 4 numeric 
    values describing start and end of training and testing 
    respectively. 
    }
    \item{as.proportion}{
    Logical describing if values provided to \code{dist} should
    be treated as \% of training and testing or if \code{dist}
    should be  considered as start and end of loci selected for 
    training and testing respectively.
    }
   
}


\value{
Returns a named list of ChIPScore objects

* trainingSet = ChIPscore containing training set
* testingSet = ChIPscore containing testing set.  
}



\author{
Patrick C.N. Martin <pcnmartin@gmail.com
}


\examples{

library(ChIPanalyser)
data(ChIPanalyserData)
# See GA vignette for usage 
test <- processingChIP(chip,top)
usingDist <- splitData(test, dist = c(50,50),as.proportion = TRUE )
usingIndex <- splitData(test, dist = c(1,2,3,4),as.proportion = FALSE )

}

\name{parameterOptions-class}
\Rdversion{1.1}
\docType{class}
\alias{parameterOptions-class}
\alias{.paramTag,parameterOptions-method}
\alias{.paramTag<-,parameterOptions,character-method}
\alias{.ZeroBackground,parameterOptions-method}
\alias{.ZeroBackground<-,parameterOptions,vector-method}
\alias{backgroundSignal,parameterOptions-method}
\alias{backgroundSignal<-,parameterOptions,numeric-method}
\alias{boundMolecules,parameterOptions-method}
\alias{boundMolecules<-,parameterOptions,vector-method}
\alias{chipMean,parameterOptions-method}
\alias{chipMean<-,parameterOptions,numeric-method}
\alias{chipSd,parameterOptions-method}
\alias{chipSd<-,parameterOptions,numeric-method}
\alias{chipSmooth,parameterOptions-method}
\alias{chipSmooth<-,parameterOptions,vector-method}
\alias{lambdaPWM,parameterOptions-method}
\alias{lambdaPWM<-,parameterOptions,vector-method}
\alias{lociWidth,parameterOptions-method}
\alias{lociWidth<-,parameterOptions,numeric-method}
\alias{maxSignal,parameterOptions-method}
\alias{maxSignal<-,parameterOptions,numeric-method}
\alias{naturalLog,parameterOptions-method}
\alias{naturalLog<-,parameterOptions,logical-method}
\alias{noiseFilter,parameterOptions-method}
\alias{noiseFilter<-,parameterOptions,character-method}
\alias{noOfSites,parameterOptions-method}
\alias{noOfSites<-,parameterOptions,character-method}
\alias{noOfSites<-,parameterOptions,numeric-method}
\alias{ploidy,parameterOptions-method}
\alias{ploidy<-,parameterOptions,numeric-method}
\alias{PWMpseudocount,parameterOptions-method}
\alias{PWMpseudocount<-,parameterOptions,numeric-method}
\alias{PWMThreshold,parameterOptions-method}
\alias{PWMThreshold<-,parameterOptions,numeric-method}
\alias{removeBackground,parameterOptions-method}
\alias{removeBackground<-,parameterOptions,vector-method}

\alias{stepSize,parameterOptions-method}
\alias{stepSize<-,parameterOptions,numeric-method}
\alias{strandRule,parameterOptions-method}
\alias{strandRule<-,parameterOptions,character-method}
\alias{whichstrand,parameterOptions-method}
\alias{whichstrand<-,parameterOptions,character-method}

\title{Class \code{"parameterOptions"}}
\description{
\code{parameterOptions} is an object used to store and parse the various parameters
needed throughout this analysis pipeline.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{parameterOptions(ploidy, boundMolecules, backgroundSignal, maxSignal, lociWidth, chipMean, chipSd, chipSmooth, stepSize, noiseFilter, removeBackground, lambdaPWM, PWMpseudocount, naturalLog, noOfSites, PWMThreshold, strandRule, whichstrand)}.
%%  ~~ describe objects here ~~
}
\section{Slots}{
  \describe{
  \item{\code{ploidy}:}{Object of class \code{"numeric"}:
  A numeric Value descibing the ploidy of the organism. Default: 2 }
  \item{\code{boundMolecules}:}{Object of class \code{"vector"}:
  A vector (or single value) containing the number of bound Molecules
  (bound Transcription Factors): Default: 1000 }
  \item{\code{backgroundSignal}:}{Object of class \code{"numeric"}:
  A numeric value descibing the ChIP-seq background Signal
  (average signal from real ChIP seq data). Default: 0}
  \item{\code{maxSignal}:}{Object of class \code{"numeric"}:
  A numeric value describing the highest ChIP-seq signal
  (from real ChIP-seq data). Default: 1}
  \item{\code{lociWidth}:}{Object of class \code{"numeric"}:
  A numeric value describing bin size when splitting ChIP seq scores). Default: 20 000}
  \item{\code{chipMean}:}{Object of class \code{"numeric"}:
  A numeric value describing the mean width of a ChIP- seq peak.
  Default:150 }
  \item{\code{chipSd}:}{Object of class \code{"numeric"}:
  A numeric value describing the standard deviation of ChIP-seq peaks.
  Default: 150 }
  \item{\code{chipSmooth}:}{Object of class \code{"vector"}:
  A numeric value describing the width of the window used to smooth
  Occupancy profiles into ChIP profiles. Default:250 }
  \item{\code{stepSize}:}{Object of class \code{"numeric"}:
  A numeric value describing the step Size (in base pairs) between
  each ChIP-seq score. Default:10 (Scored every 10 base pairs)}
  \item{\code{removeBackground}:}{Object of class \code{"numeric"}:
  A numeric value describing the value at which score should be removed.
  Defualt:0 (If negative scores then remove) }
    \item{\code{noiseFilter}:}{Object of class \code{"character"} Describes
    noiseFilter method applied to ChIP scores}
    \item{\code{PWMThreshold}:}{Object of class \code{"numeric"}:
    Threshold at which PWM Score should be selected (only sites above
    threshold will be selected - between 0 and 1) }
    \item{\code{strandRule}:}{Object of class \code{"character"}:
    "mean", "max" or "sum"  will dertermine how strand should be handle
    for computing PWM Scores. Default : "max" }
    \item{\code{whichstrand}:}{Object of class \code{"character"}:
    "+","-" or "+-" on which strand should PWM Score be computed.
    Default: "+-" }
    \item{\code{lambdaPWM}:}{Object of class \code{"vector"} A vector (or single value) contaning values for lambdaPWM Default:1}
    \item{\code{naturalLog}:}{Object of class \code{"logical"}:
    A logical value describing if natural Log will be used to compute
    the PWM (if FALSE then log2 will be used). Default: TRUE }
    \item{\code{noOfSites}:}{Object of class \code{"nos"} A Positive integer descibing number of sites (in base pair) should
    be used from the PFM to compute PWM. Default =0 (Full width of
    binding site will be used when set to 0) }
    \item{\code{PWMpseudocount}:}{Object of class \code{"numeric"}:
    A numeric value describing a PWMpseudocount for PWM computation.
    Default:1 }
    \item{\code{paramTag}:}{Object of class \code{"character"} ~Internal~ }
  }
}
\section{Methods}{
  \describe{
    \item{.paramTag}{\code{signature(object = "parameterOptions")}: ... }
    \item{.paramTag<-}{\code{signature(object = "parameterOptions", value = "character")}: ... }
    \item{.ZeroBackground}{\code{signature(object = "parameterOptions")}: ... }
    \item{.ZeroBackground<-}{\code{signature(object = "parameterOptions", value = "vector")}: ... }
    \item{backgroundSignal}{\code{signature(object = "parameterOptions")}: ... }
    \item{backgroundSignal<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{boundMolecules}{\code{signature(object = "parameterOptions")}: ... }
    \item{boundMolecules<-}{\code{signature(object = "parameterOptions", value = "vector")}: ... }
    \item{chipMean}{\code{signature(object = "parameterOptions")}: ... }
    \item{chipMean<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{chipSd}{\code{signature(object = "parameterOptions")}: ... }
    \item{chipSd<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{chipSmooth}{\code{signature(object = "parameterOptions")}: ... }
    \item{chipSmooth<-}{\code{signature(object = "parameterOptions", value = "vector")}: ... }
    \item{initialize}{\code{signature(.Object = "parameterOptions")}: ... }
    \item{lambdaPWM}{\code{signature(object = "parameterOptions")}: ... }
    \item{lambdaPWM<-}{\code{signature(object = "parameterOptions", value = "vector")}: ... }
    \item{lociWidth}{\code{signature(object = "parameterOptions")}: ... }
    \item{lociWidth<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{maxSignal}{\code{signature(object = "parameterOptions")}: ... }
    \item{maxSignal<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{naturalLog}{\code{signature(object = "parameterOptions")}: ... }
    \item{naturalLog<-}{\code{signature(object = "parameterOptions", value = "logical")}: ... }
    \item{noiseFilter}{\code{signature(object = "parameterOptions")}: ... }
    \item{noiseFilter<-}{\code{signature(object = "parameterOptions", value = "character")}: ... }
    \item{noOfSites}{\code{signature(object = "parameterOptions")}: ... }
    \item{noOfSites<-}{\code{signature(object = "parameterOptions", value = "character")}: ... }
    \item{noOfSites<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{ploidy}{\code{signature(object = "parameterOptions")}: ... }
    \item{ploidy<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{PWMpseudocount}{\code{signature(object = "parameterOptions")}: ... }
    \item{PWMpseudocount<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{PWMThreshold}{\code{signature(object = "parameterOptions")}: ... }
    \item{PWMThreshold<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{removeBackground}{\code{signature(object = "parameterOptions")}: ... }
    \item{removeBackground<-}{\code{signature(object = "parameterOptions", value = "vector")}: ... }
    \item{show}{\code{signature(object = "parameterOptions")}: ... }
    \item{stepSize}{\code{signature(object = "parameterOptions")}: ... }
    \item{stepSize<-}{\code{signature(object = "parameterOptions", value = "numeric")}: ... }
    \item{strandRule}{\code{signature(object = "parameterOptions")}: ... }
    \item{strandRule<-}{\code{signature(object = "parameterOptions", value = "character")}: ... }
    \item{whichstrand}{\code{signature(object = "parameterOptions")}: ... }
    \item{whichstrand<-}{\code{signature(object = "parameterOptions", value = "character")}: ... }
	 }
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Partick C. N. Martin <p.martin@essex.ac.uk>
}

\seealso{
\code{\linkS4class{genomicProfiles}}
}
\examples{
showClass("parameterOptions")
}
\keyword{classes}

\name{PositionFrequencyMatrix}


\alias{PositionFrequencyMatrix}

\title{
Accessor method for the \code{PFM} slot in a
\code{genomicProfiles} object
}
\description{
Accessor method for the \code{PFM} slot in a
\code{genomicProfiles} object
}
\usage{
PositionFrequencyMatrix(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}} object
    }
}
\details{
After creating a \code{\link{genomicProfiles}} object,
it is possible to access the Position Frequency Matrix slot.
However this slot will be empty if the \code{\link{genomicProfiles}}
object was built using directly a Position Weight Matrix.
See \code{\link{genomicProfiles}}
}
\value{
Returns the Position Frequency Matrix (\code{PFM} slot) used to compute the
\code{\link{PositionWeightMatrix}} in a
\code{\link{genomicProfiles}} object
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>

}


\examples{
#Loading data
data(ChIPanalyserData)
#Loading PFM files
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#Building genomicProfiles object
GPP<-genomicProfiles(PFM=PFM,PFMFormat="JASPAR")
# Accessing Slot
PositionFrequencyMatrix(GPP)
}

\name{PWMpseudocount-methods}
\docType{methods}

\alias{PWMpseudocount-methods}
\title{ ~~ Methods for Function \code{PWMpseudocount}  ~~}
\description{
Accessor Method for a \code{PWMpseudocount} slot in a
\code{\link{parameterOptions}}
}
\section{Methods}{
\describe{

\item{\code{PWMpseudocount(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{stepSize<--methods}
\docType{methods}

\alias{stepSize<--methods}
\title{ ~~ Methods for Function \code{stepSize<-}  ~~}
\description{
Setter Method for the \code{stepSize} slot in a
\code{\linkS4class{parameterOptions}}
}
\section{Methods}{
\describe{

\item{\code{stepSize(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{getTestingData}
\alias{getTestingData}

\title{
Extract testing data from ChIPscore object
}
\description{
\code{getTestingData} extracts selected regions from ChIPscore object to be used as testing set.
}
\usage{
getTestingData(ChIPscore,loci = 1)
}

\arguments{
    \item{ChIPscore}{
    ChIPscore object as returned by \code{processingChIP}
    }
    \item{loci}{
    numeric describing index of loci to be used as testing data. 
    }
   
}


\value{
Returns ChIPscore object with the selected testing loci.
 
}



\author{
Patrick C.N. Martin <pcnmartin@gmail.com
}


\examples{

library(ChIPanalyser)
data(ChIPanalyserData)
# See GA vignette for usage 
test <- processingChIP(chip,top)
test <- getTestingData(test, 1:2)

}

\name{chipSd<-}


\alias{chipSd<-}

\title{
Setter methods for \code{chipSd} slot in a
\code{\link{parameterOptions}} object.
}
\description{
Setter methods for \code{chipSd} slot in a
\code{\link{parameterOptions}} object.
}
\usage{
chipSd(object)<-value
}

\arguments{
    \item{object}{
    \code{object} is \code{\link{parameterOptions}} object.
    }
    \item{value}{
    \code{value} is a positive nurmeric value that will be assigned to
    \code{chipSd} slot.
    Default value is 150.
    }
}
\details{
When computing ChIP-seq like profiles (\code{\link{computeChIPProfile}},
the occupancy values given by \code{computeOccupancy} are transformed into
ChIP-seq like profiles.
The average size of a ChIP-seq peak was described by Kaplan
(Kaplan et al. , 2011). The average peak size is subject to
variation. This variation is accounted for with \code{chipSd}.
It is advised to use the standard deviation
of ChIP peak width from actual ChIP-seq data.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.

}
\value{
Returns a \code{\link{parameterOptions}} object with an updated
value for \code{chipSd}.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

Kaplan T.,Li X.-Y.,Sabo P.J.,Thomas S.,Stamatoyannopoulos J.A., Biggin M.D.,
Eisen M.B.
Quantitative models of the mechanisms that control genome-wide patterns of
transcription factor binding during early Drosophila development,
PLoS Genet.,2011, vol. 7 pg. e1001290
}

\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}

\examples{
# Building parameterOptions object
OPP <- parameterOptions()
# Setting new value for chipSd slot
chipSd(OPP) <-  250
}

\name{BPFrequency<--methods}

\alias{BPFrequency<--methods}
\docType{methods}

\title{ ~~ Methods for Function \code{BPFrequency<-}  ~~}
\description{
 ~~ Methods for function \code{BPFrequency<-}  ~~
}
\section{Methods}{
\describe{

\item{\code{signature(object = "genomicProfilesInternal", value = "DNAStringSet")}}{
%%  ~~describe this method here~~
}

\item{\code{signature(object = "genomicProfilesInternal", value = "vector")}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{processingChIP}
\alias{processingChIP}

\title{
Pre-processing ChIP-seq data
}
\description{
\code{processingChIP}
will process and extract ChIP scores at a set of loci of interest.
}

\usage{
processingChIP(profile,loci=NULL,reduce=NULL,
     peaks=NULL,chromatinState=NULL,parameterOptions=NULL,
     cores=1)
}

\arguments{
    \item{profile}{
    \code{profile} is a path to a UCSC format file, a GRanges or data frame. The input data  should contain 4 columns:chromosome, start , end and score.
    }
    \item{loci}{
    \code{loci} is \code{\link[GenomicRanges]{GRanges}} describing the loci
    at which ChIP scores should be extracted.
    If NULL, a set of Loci will extracted from \code{profile}. The data provided will then be split into bins of width equal to \code{lociWidth} (Default 20kbp)
     Default=NULL
    }
    \item{reduce}{
    \code{reduce} is a the top regions to select based on the mean ChIP score.
    If \code{peaks} are provided, regions overlappling with known peaks will be
    selected based on highest ChIP score. If NULL, all regions will
    be considered. Default=NULL

    }
    \item{parameterOptions}{
    \code{parameterOptions} is an
    \code{\link{parameterOptions}} object containing chip
    Parameters to be parsed for ChIP score extraction. If NULL,
    \code{\link{parameterOptions}} will be built internally with
    default ChIP extraction parameters (see  \code{\link{chipSmooth}},
    \code{\link{chipSd}} and \code{\link{chipMean}})  Default=NULL
    }
    \item{peaks}{
    \code{peaks} is a path to UCSC format file or a GRanges object containing
    location of ChIP peaks.  Default=NULL
    }
    \item{chromatinState}{
    \code{chromatinState} is a \code{\link[GenomicRanges]{GRanges}} containing
    Accessible DNA or chromatin States If provided, regions will be selected only if they
    contain accessible DNA.  Default=NULL
    }

    \item{cores}{
    \code{cores} is the number of cores used to extract ChIP scores. Default = 1
    }
}
\details{
When using \code{\link{computeOptimal}}, it is required to supply real ChIP
data in order to have a point of comparison. The corralation and MSE Scores are
computed based of how well the model fits biological data.
\code{processingChIP} will extract this data from ChIP data at loci
of interest. When using the \code{reduce} option, this function will only
select the top regions based on peak height or mean ChIP score.
\code{processingChIP} will also extract maxSignal and backgroundSignal from
ChIP data and parse it to an \code{\link{parameterOptions}} object.
}
\value{
Returns a ChIPScore object containing extracted (and normalised) ChIP scores, the loci
of interest and newly extracted Parameters(e.g. maxSignal)
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}
\examples{


#Data extraction
data(ChIPanalyserData)

## Extracting ChIP scores at loci of interest

ChIP<-processingChIP(profile=chip, loci=top)

}

\name{removeBackground-methods}
\docType{methods}

\alias{removeBackground-methods}
\title{ ~~ Methods for Function \code{removeBackground}  ~~}
\description{
Accessor Method for the \code{removeBackground} slot in a
\code{\link{parameterOptions}} object
}
\section{Methods}{
\describe{

\item{\code{removeBackground(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{PositionWeightMatrix<-}


\alias{PositionWeightMatrix<-}

\title{
Setter Method for the \code{PositionWeightMatrix} slot in a
\code{\link{genomicProfiles}} object
}
\description{
Setter Method for the \code{PositionWeightMatrix} slot in a
\code{\link{genomicProfiles}} object
}
\usage{
PositionWeightMatrix(object) <- value
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}} object
    }
    \item{value}{
    \code{value} is a matrix in the form of a Position Weight Matrix.
    }
}
\details{
If a Position Weight Matrix is readily available, it is possible to directly
assign this matrix to the \code{PWM} slot. However, this is only possible
if a \code{\link{genomicProfiles}} object has already been created.
In that case, we advise to first create a
\code{\link{genomicProfiles}} object. It should be noted
that this Position Weight Matrix will be automatically computed from a
Position Frequency Matrix. If no Position Frequency Matrix are available,
then a Position Weight Matrix can be directly assigned to this slot.
}
\value{
Returns a \code{\link{genomicProfiles}} object with an updated
value for the \code{PWM} slot
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}


\examples{
#Building genomicProfiles object
GPP <- genomicProfiles()
#Setting PWM to PositionWeightMatrix slot
PWM <- matrix(runif(32,-10,20), ncol=8)
rownames(PWM) <- c("A","C","T","G")
PositionWeightMatrix(GPP) <- PWM
}

\name{PositionWeightMatrix}


\alias{PositionWeightMatrix}
\title{
Accessor Method for the \code{PWM} slot in a
\code{\link{genomicProfiles}} object
}
\description{
Accessor Method for the \code{PWM} slot in a
\code{\link{genomicProfiles}} object
}
\usage{
PositionWeightMatrix(object)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}}
    }
}
\details{
After creating a \code{\link{genomicProfiles}} object,
it is possible to access the Position Weight Matrix stored in this slot.
This slot should always contain something. This slot is either supplied by
user or directly computed from a Position Frequency Matrix when supplied.
}
\value{
Returns a matrix in the form of a Position Weight Matrix
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}

\examples{
#Loading data
data(ChIPanalyserData)
#Loading PFM files
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#Building genomicProfiles object
GPP<-genomicProfiles(PFM=PFM,PFMFormat="JASPAR")
# Accessing Slot
PositionWeightMatrix(GPP)
}

\name{backgroundSignal}


\alias{backgroundSignal}


\title{
Accessor method for the \code{backgroundSignal} slot in a
\code{\link{parameterOptions}} object.
}
\description{
Extract or access the \code{backgroundSignal} slot in a
\code{\link{parameterOptions}} object.
}
\usage{
backgroundSignal(object)
}

\arguments{
    \item{object}{
    \code{object} is an \code{\link{parameterOptions}}
    }
}
\details{
Default Value: 0

When computing \code{\link{computeOccupancy}}, a ChIP-seq background
signal is used to scale Occupancy by considering both a
\code{backgroundSignal} and a \code{\link{maxSignal}}.
The \code{backgroundSignal}
is also used to nomalise occupancies against maxOccupancy.
The \code{backgroundSignal} usually comes from
experimental data and is provided by user. As a general rule,
if ChIP-seq data is available and will be used in
\code{\link{computeChIPProfile}}
, \code{\link{profileAccuracyEstimate}} or \code{\link{plotOccupancyProfile}},
it is advised to use the \code{backgroundSignal} from this data.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.
}
\value{
Returns a \code{backgroundSignal} of a
\code{\link{parameterOptions}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}
\examples{
# Building occupancyProfileParameters object
OPP <- parameterOptions()
#Viewing single value in object
backgroundSignal(OPP)


}

\name{backgroundSignal<-}


\alias{backgroundSignal<-}
\title{
Setter method for \code{backgroundSignal} slot in a
\code{\link{parameterOptions}}
}
\description{
Setter method for \code{backgroundSignal} slot in a
\code{\link{parameterOptions}}

}
\usage{
backgroundSignal(object)<-value
}

\arguments{
    \item{object}{
    \code{object} is an \code{\link{parameterOptions}} object.
    }
    \item{value}{
    \code{value} is the value to be assigned to the \code{backgroundSignal}
    slot in
    \code{\link{parameterOptions}}.
    \code{backgroundSignal} should be a positive value.
    Defualt value is 0.
    }
}
\details{
Defualt value: 0.
When computing \code{\link{computeOccupancy}}, a ChIP-seq background
signal is used to
scale Occupancy by considering both a \code{backgroundSignal} and a
\code{\link{maxSignal}}. The \code{backgroundSignal}
is also used to nomalise occupancies to maxOccupancy.
The \code{backgroundSignal} usually comes from
experimental data and is provided by user. As a general rule,
if ChIP-seq data is available and will be used in
\code{\link{computeChIPProfile}}
, \code{\link{profileAccuracyEstimate}} or
\code{\link{plotOccupancyProfile}}, it is advised to use
the \code{backgroundSignal} from this data.
We strongly encourage to set values when building a
\code{\link{parameterOptions}} object.
}
\value{
Returns a \code{\link{parameterOptions}} object with a new
\code{value} assigned to the \code{backgroundSignal} slot.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}

\examples{
# Building occupancyProfileParameters object
OPP <- parameterOptions()
# Setting new value for backgroundSignal
backgroundSignal(OPP) <- 0.2
# Viewing whole object with new updated value
OPP
#Viewing single value in object
backgroundSignal(OPP)

}

\name{noOfSites}

\alias{noOfSites}


\title{
Accessor Method for the \code{noOfSites} slot in a
\code{\link{parameterOptions}} object
}
\description{
Accessor Method for the \code{noOfSites} slot in a
\code{\link{parameterOptions}} object

}
\usage{
noOfSites(object)
}
\arguments{
    \item{object}{
    \code{object} is \code{\link{parameterOptions}} object
}
}
\details{
While computing Position Weight Matricies (PWM) from
Position Frequency Matricies (PFM), it is possible to restrict the
number of sites that will be used to compute the PWM.
The default is set at "all". In this case, all sites will be used to
compute the PWM.

}
\value{
Returns the value assigned to the \code{noOfSites} slot in a
\code{\link{parameterOptions}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
GPP <- parameterOptions(noOfSites="all")
#Setting new Value for naturalLog
noOfSites(GPP)


}

\name{lambdaPWM}

\alias{lambdaPWM}


\title{
Accessor Method for the \code{lambdaPWM} slot in a
\code{\link{parameterOptions}} object
}
\description{
Accessor Method for the \code{lambdaPWM} slot in a
\code{\link{parameterOptions}} object

}
\usage{
lambdaPWM(object)
}
\arguments{
    \item{object}{
    \code{object} is \code{\link{parameterOptions}} object
}
}
\details{
    The model underlying ChIPanalyser internally infers two paramters: number
    of bound molecules and lambda. Lambda represents a scaling factor for the
    Position weight matrix (PWM). This can be described as how well does a TF
    discriminate between high affinity and very high affinity sites.

}
\value{
Returns the value assigned to the \code{lambdaPWM} slot in a
\code{\link{parameterOptions}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}

\examples{
# Loading data
data(ChIPanalyserData)

#Building data objects
GPP <- parameterOptions(lambdaPWM=1)
#Setting new Value for lambdaPWM
lambdaPWM(GPP)


}

\name{genomicProfilesInternal-class}
\Rdversion{1.1}
\docType{class}
\alias{genomicProfilesInternal-class}
\alias{.averageExpPWMScore<-,genomicProfilesInternal,numeric-method}
\alias{.DNASequenceLength<-,genomicProfilesInternal,vector-method}
\alias{.drop<-,genomicProfilesInternal,vector-method}
\alias{.generatePWM,genomicProfilesInternal-method}
\alias{.maxPWMScore<-,genomicProfilesInternal,vector-method}
\alias{.minPWMScore<-,genomicProfilesInternal,vector-method}
\alias{.profiles<-,genomicProfilesInternal,GRList-method}
\alias{.tags,genomicProfilesInternal-method}
\alias{.tags<-,genomicProfilesInternal,character-method}
\alias{averageExpPWMScore,genomicProfilesInternal-method}
\alias{BPFrequency,genomicProfilesInternal-method}
\alias{BPFrequency<-,genomicProfilesInternal,DNAStringSet-method}
\alias{BPFrequency<-,genomicProfilesInternal,vector-method}
\alias{DNASequenceLength,genomicProfilesInternal-method}
\alias{drop,genomicProfilesInternal-method}
\alias{maxPWMScore,genomicProfilesInternal-method}
\alias{minPWMScore,genomicProfilesInternal-method}
\alias{PFMFormat,genomicProfilesInternal-method}
\alias{PFMFormat<-,genomicProfilesInternal,character-method}
\alias{PositionFrequencyMatrix,genomicProfilesInternal-method}
\alias{PositionFrequencyMatrix<-,genomicProfilesInternal,character-method}
\alias{PositionFrequencyMatrix<-,genomicProfilesInternal,matrix-method}
\alias{PositionWeightMatrix,genomicProfilesInternal-method}
\alias{PositionWeightMatrix<-,genomicProfilesInternal,matrix-method}
\alias{profiles,genomicProfilesInternal-method}

\title{Class \code{"genomicProfilesInternal"}}
\description{
Non exported class. Represents the stripped down version of genomicProfiles.
}
\section{Objects from the Class}{
Created Internally.
}
\section{Slots}{
  \describe{
    \item{\code{PWM}:}{Object of class \code{"matrix"} ~~ }
    \item{\code{PFM}:}{Object of class \code{"matrix"} ~~ }
    \item{\code{PFMFormat}:}{Object of class \code{"character"} ~~ }
    \item{\code{BPFrequency}:}{Object of class \code{"vector"} ~~ }
    \item{\code{minPWMScore}:}{Object of class \code{"vector"} ~~ }
    \item{\code{maxPWMScore}:}{Object of class \code{"vector"} ~~ }
    \item{\code{profiles}:}{Object of class \code{"GRList"} ~~ }
    \item{\code{DNASequenceLength}:}{Object of class \code{"vector"} ~~ }
    \item{\code{averageExpPWMScore}:}{Object of class \code{"vector"} ~~ }
    \item{\code{ZeroBackground}:}{Object of class \code{"vector"} ~~ }
    \item{\code{drop}:}{Object of class \code{"vector"} ~~ }
    \item{\code{tags}:}{Object of class \code{"character"} ~~ }
  }
}
\section{Methods}{
  \describe{
    \item{.averageExpPWMScore<-}{\code{signature(object = "genomicProfilesInternal", value = "numeric")}: ... }
    \item{.DNASequenceLength<-}{\code{signature(object = "genomicProfilesInternal", value = "vector")}: ... }
    \item{.drop<-}{\code{signature(object = "genomicProfilesInternal", value = "vector")}: ... }
    \item{.generatePWM}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{.maxPWMScore<-}{\code{signature(object = "genomicProfilesInternal", value = "vector")}: ... }
    \item{.minPWMScore<-}{\code{signature(object = "genomicProfilesInternal", value = "vector")}: ... }
    \item{.profiles<-}{\code{signature(object = "genomicProfilesInternal", value = "GRList")}: ... }
    \item{.tags}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{.tags<-}{\code{signature(object = "genomicProfilesInternal", value = "character")}: ... }
    \item{averageExpPWMScore}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{BPFrequency}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{BPFrequency<-}{\code{signature(object = "genomicProfilesInternal", value = "DNAStringSet")}: ... }
    \item{BPFrequency<-}{\code{signature(object = "genomicProfilesInternal", value = "vector")}: ... }
    \item{DNASequenceLength}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{drop}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{maxPWMScore}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{minPWMScore}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{PFMFormat}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{PFMFormat<-}{\code{signature(object = "genomicProfilesInternal", value = "character")}: ... }
    \item{PositionFrequencyMatrix}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{PositionFrequencyMatrix<-}{\code{signature(object = "genomicProfilesInternal", value = "character")}: ... }
    \item{PositionFrequencyMatrix<-}{\code{signature(object = "genomicProfilesInternal", value = "matrix")}: ... }
    \item{PositionWeightMatrix}{\code{signature(object = "genomicProfilesInternal")}: ... }
    \item{PositionWeightMatrix<-}{\code{signature(object = "genomicProfilesInternal", value = "matrix")}: ... }
    \item{profiles}{\code{signature(object = "genomicProfilesInternal")}: ... }
	 }
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>

}

\seealso{
\code{\link{genomicProfiles}}

\code{\link{parameterOptions}}

}
\examples{
showClass("genomicProfilesInternal")
}
\keyword{classes}

\name{genomicProfiles}
\alias{genomicProfiles}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Genomic Profile object
}
\description{
\code{genomicProfiles} is an S4 object serving two purposes: (i) storing internal computed data and (ii) storing paramter options. This object is parsed through the different steps of the pipeline
to facilitate that parsing and changing of paramters.
}
\usage{
genomicProfiles(..., parameterOptions = NULL, genomicProfiles = NULL, ChIPScore = NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{\dots}{
  Any of the user available slots in genomicProfiles.
}
  \item{parameterOptions}{
  If some parameters were already previously computed or stored in a parameterOptions,
  parsing this object will use those values instead of the default ones.
}
  \item{genomicProfiles}{
  If some parameters were already previously computed or stored in a genomicProfiles,
  parsing this object will use those values instead of the default ones.
}
  \item{ChIPScore}{
  If some parameters were already previously computed or stored in a ChIPScore,
  parsing this object will use those values instead of the default ones.
}
}
\details{
 The \code{genomicProfiles} object serves the purpose of storing, and parsing paramters and computed data between the different steps of the pipeline. When creating a \code{genomicProfiles}
 object it is possible to use previously computed values by simply parsing the object to the constructor function.
}
\value{
Returns a \code{genomicsProfiles} object with updated slots for all paramters parsed.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.
Patrick C.N. Martin and Nicolae Radu Zabe (2020) Dissecting the binding mechanisms of transcription factors to DNA using a statistical thermodynamics framework. CSBJ, 18, 3590-3605.
}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>

}

\seealso{
\code{\link{genomicProfiles}}

\code{\link{parameterOptions}}

}
\examples{
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
genomicProfiles()
genomicProfiles(PFM=PFM,PFMFormat="JASPAR")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }% use one of  RShowDoc("KEYWORDS")
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{chipMean-methods}
\docType{methods}
\alias{chipMean-methods}

\title{ ~~ Methods for Function \code{chipMean}  ~~}
\description{
 ~~ Methods for function \code{chipMean}  ~~
}
\section{Methods}{
\describe{

\item{\code{chipMean(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{minPWMScore}
\alias{minPWMScore}


\title{
Accessor method the \code{minPWMScore} slot in a
\code{\link{genomicProfiles}} object
}
\description{
Accessor method the \code{minPWMScore} slot in a
\code{\link{genomicProfiles}} object
}
\usage{
minPWMScore(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}} object.
    }
}
\details{
\code{minPWMScore} can be described as the lowest PWM score computed at
a genome wide scale. Although it is possible to assigne a value
to \code{minPWMScore}, we strongly advise to use the value
computed and assigned internally. This value is computed in the
\code{\link{computeGenomeWideScores}} function.
}
\value{
Returns the value assigned to the \code{minPWMScore} slot in a
\code{\link{genomicProfiles}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}
\examples{

#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
}
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
#Building data objects
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR")

# Computing Genome Wide
GenomceWide <- computeGenomeWideScores(DNASequenceSet = DNASequenceSet,
    genomicProfiles = GPP)
minPWMScore(GenomceWide)

## If used before computeGenomeWidePWMScore, will return NULL

}
}

\name{noOfSites<--methods}
\docType{methods}

\alias{noOfSites<--methods}

\title{ ~~ Methods for Function \code{noOfSites<-}  ~~}
\description{
Setter method for \code{noOfSites}
}
\section{Methods}{
\describe{

\item{\code{noOfSites(object)<-"all" }}{
%%  ~~describe this method here~~
}

\item{\code{noOfSites(object)<-value}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{drop-methods}
\docType{methods}

\alias{drop-methods}
\title{ ~~ Methods for Function \code{drop}  ~~}
\description{
 ~~ Methods for function \code{drop}  ~~
}
\section{Methods}{
\describe{

\item{\code{signature(object = "genomicProfilesInternal")}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{profiles-methods}
\docType{methods}
\alias{profiles}
\title{ ~~ Methods for Function \code{profiles}  ~~}
\description{
Accessor method for \code{profiles} in a \code{\link{genomicProfiles}} object
}
\section{Methods}{
\describe{

\item{\code{profiles(oject)}}{
Computed PWM scores, Occupancy or ChIP-seq like profiles for loci of interest and
paramter combination of interest.
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{ploidy}


\alias{ploidy}

\title{
Accessor method for the \code{ploidy} slot in a
\code{\link{parameterOptions}} object
}
\description{
Accessor method for the \code{ploidy} slot in a
\code{\link{parameterOptions}} object

}
\usage{
ploidy(object)
}

\arguments{
    \item{object}{
    \code{object} is  a \code{\link{parameterOptions}} object
    }
}
\details{
Default value for \code{ploidy} is set a 2. It should be mentioned that
ChIPanalyser is based on a model that also considers the ploidy of the
organism of interest however this only considers simple polyploidy
(or haploidy). The model does not consider hybrids such as wheat.

}
\value{
Returns the value assigned to the \code{ploidy} slot in a
\code{\link{parameterOptions}} object
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.}
\author{
Patrick C. N. Martin <pm16057@essex.ac.uk>
}

\examples{
# Building parameterOptions object
OPP <- parameterOptions()
#Setting new Value for maxSignal
ploidy(OPP)
}

\name{BPFrequency}

\alias{BPFrequency}


\title{
Accessor method for \code{BPFrequency} slot in a
\code{\link{genomicProfiles}} object.
}
\description{
Extract or Access \code{BPFrequency} slot in a
\code{\link{genomicProfiles}} object.
}
\usage{
BPFrequency(object)
}

\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}}
    }
}
\details{
Default value is c(0.25,0.25,0.25,0.25)
When generating a Postion Weight Matrix from a Position Frequency Matrix,
the probability
of occurrence of each base pair (Base Pair Frequency) is necessary
(as originally described by Gary Stormo). It is possible to
set custom values for \code{BPFrequency} with a vector of length 4
containing the probability of occurrence of each base pair (A,C,G,T) in order.
If Base pair frequency is unknown, \code{BPFrequency} will compute base pair
frequency from a DNA sequence. The nature of this sequence can be a
\code{BSgenome} or a \code{\link[Biostrings]{DNAStringSet}}.
In order to decrease run time, it is advised to use
\code{\link[Biostrings]{DNAStringSet}}
}
\value{
Returns \code{BPFrequency} slot in
\code{\link{genomicProfiles}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C.N. Martin <pcnmartin@gmail.com>
}
\examples{
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
# Building genomicProfiles object
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR")
#Extracting BPFrequency slot
BPFrequency(GPP)
}

\name{PWMThreshold-methods}
\docType{methods}

\alias{PWMThreshold-methods}

\title{ ~~ Methods for Function \code{PWMThreshold}  ~~}
\description{
Accessor method for the \code{PWMThreshold} slot in  a
\code{\link{parameterOptions}} object
}
\section{Methods}{
\describe{

\item{\code{PWMThreshold(object)}}{
%%  ~~describe this method here~~
}
}}
\keyword{methods}
\keyword{ ~~ other possible keyword(s) ~~ }

\name{maxPWMScore}


\alias{maxPWMScore}


\title{
Accessor function for \code{maxPWMScore} slot in a
\code{\link{genomicProfiles}} object.
}
\description{
Accessor function for \code{maxPWMScore} slot in a
\code{\link{genomicProfiles}} object.
}
\usage{
maxPWMScore(object)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{object}{
    \code{object} is a \code{\link{genomicProfiles}} object.
    }
}
\details{
\code{maxPWMScore} is a numerical value that can be described as the
highest PWM score computed at a genome wide scale.
This value is computed and updated in the
\code{\link{genomicProfiles}} object after using the
\code{\link{computeGenomeWideScores}}.
}
\value{
Returns the value of assigned to the \code{maxPWMScore} slot in a
\code{\link{genomicProfiles}} object.
}
\references{
Zabet NR, Adryan B (2015) Estimating binding properties of transcription
factors from genome-wide binding profiles. Nucleic Acids Res., 43, 84–94.

}
\author{
Patrick C. N. Martin <p.martin@essex.ac.uk>
}
\examples{

# Loading data
#Data extraction
data(ChIPanalyserData)
# path to Position Frequency Matrix
PFM <- file.path(system.file("extdata",package="ChIPanalyser"),"BEAF-32.pfm")
#As an example of genome, this example will run on the Drosophila genome
\donttest{
if(!require("BSgenome.Dmelanogaster.UCSC.dm6", character.only = TRUE)){
    if (!requireNamespace("BiocManager", quietly=TRUE))
        install.packages("BiocManager")
    BiocManager::install("BSgenome.Dmelanogaster.UCSC.dm6")
}
library(BSgenome.Dmelanogaster.UCSC.dm6)
DNASequenceSet <- getSeq(BSgenome.Dmelanogaster.UCSC.dm6)
#Building data objects
GPP <- genomicProfiles(PFM=PFM,PFMFormat="JASPAR")

# Computing Genome Wide
GenomeWide <- computeGenomeWideScores(DNASequenceSet = DNASequenceSet,
    genomicProfiles = GPP)
maxPWMScore(GenomeWide)
## If used before computeGenomeWidePWMScore, will return NULL
}
}
